#	Revised: 12/27/96
# EUV Data include file

#	Almost all EUV data structure are arrays of type long.
#	These macros are used to emphasize this.
define	VEC_SIZE	Meml[($1)+0]
define	VEC_ELEMENT	Meml[($1)+($2)]

define	VEC_LENGTH	(($1)+1)

#	Strings are stored in vector elements as pointers.
define	VEC_STRING	Memc[VEC_ELEMENT($1,$2)]
define	VEC_RANGE_OK	(($2) > 0 && ($2) <= VEC_SIZE($1))

#	Some (poorly) choose offsets during initial program
#	development.
define	ED_ROOT_ID	1
define	ED_DIR_ID	2
define	ED_SUBCL_ID	3
define	ED_CL_ID	4
define	ED_LABEL_ID	5
define	ED_NAME_ID	6
define	ED_SRC_LEN	long(ED_NAME_ID)

#	This is a list of special column name indirections used by the
#	EGOSVR program.  Actual columns names are reference by finding
#	the name bound to these names.  Ugly.

define	SPC_DICT	",PhotonD,PhotonX,PhotonY,PhotonW,PhotonS,PhotonZ,PhotonT,AspectW,AspectX,AspectY,AspectZ,AspectT,PositionX,PositionY,PositionZ"

#	There are 7 EUV detectors.  Some times its just simpler to
#	waste some space.

define	MAX_DETECTORS	10

#	Offsets in special column list.

define	ED_PHT_DET_ID	1
define	ED_PHT_X_ID	2
define	ED_PHT_Y_ID	3
define	ED_PHT_W_ID	4
define	ED_PHT_S_ID	5
define	ED_PHT_Z_ID	6
define	ED_PHT_T_ID	7
define	ED_ASP_W_ID	8
define	ED_ASP_X_ID	9
define	ED_ASP_Y_ID	10
define	ED_ASP_Z_ID	11
define	ED_ASP_T_ID	12
define	ED_POS_X_ID	13
define	ED_POS_Y_ID	14
define	ED_POS_Z_ID	15
define	ED_SPC_LEN	long(ED_POS_Z_ID)

#	EUV Data structure
define	ED_TABLES	Meml[($1)+0]	# list of tables used
define	ED_SOURCE	Meml[($1)+1]	# obs data source information
define	ED_COLUMN	Meml[($1)+2]	# column list
define	ED_START	Meml[($1)+3]	# obs start time
define	ED_FINISH	Meml[($1)+4]	# obs end time
define	ED_SPC_TBL	Meml[($1)+5]	# special column table ids
define	ED_SPC_COL	Meml[($1)+6]	# special column column pointers
define	ED_TBL_REF	Meml[($1)+7]	# column location in table list
define	ED_TIMES	Meml[($1)+8]	# list of table time column names
define	ED_DETECTORS	Meml[($1)+9]	# valid detector list
# run time part
define	ED_ASPECT	Meml[($1)+10]	# aspect runtime information
define	ED_TABLE_PTR	Meml[($1)+11]	# list of table pointers
define	ED_PHTBUF	Meml[($1)+12]	# pointer to event buffer
define	ED_SRCPOS	Meml[($1)+13]	# pointer to source position structure

define	ED_LENGTH	14

#	Type of evaluation during table lookup
define	EVAL_PREV	1
define	EVAL_NEXT	2
define	EVAL_LINEAR	3

#	Silly error checking macros.
define	EE_FAIL		if (!($1)) {call eerror($2)}

define	CHK_INDBUF	EE_FAIL($1, EES_INDBUF)
define	CHK_DIRBUF	EE_FAIL($1, EES_DIRBUF)
define	CHK_EXISTPTR	EE_FAIL($1, EES_EXTPTR)
define	CHK_NEXISTPTR	EE_FAIL($1, EES_NEXTPTR)
define	CHK_VALFIELD	EE_FAIL($1, EES_VALFLD)
define	CHK_INDLIST	EE_FAIL($1, EES_INDLIST)
define	CHK_NINDLIST	EE_FAIL($1, EES_NINDLIST)
define	CHK_TRUNCLIST	EE_FAIL($1, EES_TRUNCLIST)
define	ERR_CORRFULL	EES_CORRFULL


#	Quaternion fields

define	W	1
define	X	2
define	Y	3
define	Z	4

#	Handle name mapping problems

define	er_aspfirst	er_asp1
define	er_asprot	er_asp2
define	er_phtfirst	er_pht1
define	er_phtnext	er_pht2
define	er_aspnext	er_asp3

#	Calculation types

define		EA_DICT	",Add,Subtract,Multiply,Set,Modulo,Divide,Random"
define		EA_ADD	1
define		EA_SUB	2
define		EA_MULT	3
define		EA_SET	4
define		EA_MOD	5
define		EA_DIV	6
define		EA_RND	7

define		EA_COL	1
define		EA_NUM	2

#	Generalize tables

define	GT_BAD	0
define	GT_STBT	1
define	GT_QPOE	2

define	GT_TYPE	VEC_ELEMENT($1,1)	# ST, QPOE, etc
define	GT_PTR	VEC_ELEMENT($1,2)	# private pointer
define	GT_QPIO	VEC_ELEMENT($1,3)	# QPIO pointer
define	GT_QPBUF VEC_ELEMENT($1,4)	# QPIO event buffer
define	GT_INDEX VEC_ELEMENT($1,5)	# QPIO event index
define	GT_EOF	VEC_ELEMENT($1,6)	# EOF flag
define	GT_QPLEN VEC_ELEMENT($1,7)	# QPIO buffer length
define	GT_NROWS VEC_ELEMENT($1,8)	# rows in table

define	GT_SIZE	9
