# qpeuv.h -- QPOE structures needed by the euv package
#
# @(#)qpeuv.h	1.6 10/13/97  UCB CEA EGO

# NOTE: These symbolic constant values are needed by certain routines
# in the euv package, which, unfortunately, were written to depend on
# internal (private) QPOE include files.  The values here are the same 
# as in qpoe.h in IRAF v2.11, but if those values change in the future, 
# this file will need to be updated so that the euv routines will not break.
############################################################################
define	SPPTYPES	"bcsilrdx"      # index is SPP TY_xxx type code
define	TY_MACRO	15              # datafile local macro define
define	TY_OPAQUE	16              # opaque (typeless) binary type
define	TY_USER		17              # some user defined type

# Magic values used to represent open ranges :N and N:.  From qpex.h.
define  EUVLEFTI           -MAX_INT
define  EUVRIGHTI           MAX_INT
define  EUVLEFTR           -MAX_REAL
define  EUVRIGHTR           MAX_REAL
define  EUVLEFTD           -MAX_DOUBLE
define  EUVRIGHTD           MAX_DOUBLE

define  IS_EUVLEFTI        (($1) == -MAX_INT)
define  IS_EUVRIGHTI       (($1) ==  MAX_INT)
define  IS_EUVLEFTR        (($1) <= -MAX_REAL)
define  IS_EUVRIGHTR       (($1) >=  MAX_REAL)
define  IS_EUVLEFTD        (($1) <= -MAX_DOUBLE)
define  IS_EUVRIGHTD       (($1) >=  MAX_DOUBLE)


# Domain descriptor structure.
############################################################################
define  LEN_EUVDDDES       110
define  EUVDD_STRUCTLEN    Memi[$1]        # structure length, su
define  EUVDD_NFIELDS      Memi[$1+1]      # number of fields in user structure
define  EUVDD_XFIELD       Memi[$1+2]      # field assigned to coordinate "x"
define  EUVDD_YFIELD       Memi[$1+3]      # field assigned to coordinate "y"
define  EUVDD_FOFFSET      Memi[$1+10+$2-1]# array of field offsets
define  EUVDD_FTYPE        Memi[$1+60+$2-1]# array of field datatypes
