# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ceplookup.x
# 	Author	:  ericco
# 	Date	:  12/06/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) ceplookup.x -r1.1 12/06/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/06/92   ericco	date and time created 92/12/06 15:03:27 by ericco
# H-
# 
#

#	Revised: 12/6/92

include <edata.h>
include "../eb/ebuffer.h"
include "../er/ercol.h"
include "clu.h"

#	Get lookup record from a text database

procedure	clu_read (dt, rec, ptr, ob,ed) #E
pointer		dt		#I text database
int		rec		#I record id
pointer		ptr		#O print data
pointer		ob		#B an output buffer
pointer		ed		#B EUV data

int		cpid

pointer		clu
pointer		sp
pointer		buf
pointer		time
bool		flag
int		tn
int		col
pointer		tp
pointer		gn
pointer		cn

begin
  call smark(sp)
  call salloc(buf, 1024, TY_CHAR)
  call salloc(gn, 2, TY_POINTER)

  call clu_malloc(clu)

  call dtgstr(dt, rec, "Column", Memc[buf], 1024)
  call edgtc(ed, Memc[buf], tn, col)
#  CLU_TB(clu) = VEC_ELEMENT(ED_TABLE_PTR(ed), tn)
#  CLU_CP(clu) = VEC_ELEMENT(ED_COLUMN(ed), col)
  tp = VEC_ELEMENT(ED_TABLE_PTR(ed), tn)
  cn = ED_COLUMN(ed)
  time = VEC_ELEMENT(ED_TIMES(ed), tn)
  Meml[gn]   = VEC_ELEMENT(cn, col)
  Meml[gn+1] = VEC_ELEMENT(cn, time)
  call er_gopen(tp, Meml[gn], long(2), 2, CLU_GROUP(clu))
  call er_gfirst(CLU_GROUP(clu))
  call er_gcopy(CLU_GROUP(clu), EC_HI_OFFSET, EC_LO_OFFSET)
  call er_gnext(CLU_GROUP(clu), flag)

  call dtgstr(dt, rec, "Field", Memc[buf], 1024)
  call eb_fieldid(Memc[buf], cpid)
  call eb_gcolumn(ob, cpid, CLU_OFFSET(clu))

  call eb_alloc(ptr)
  call eb_addfield(ptr, Memc[buf])
  call eb_headernew(ptr, ob)
  call eb_addbuffer (ptr, EBG_LENGTH(ob))

  CLU_EVBUF(clu) = ptr
  ptr = clu

  call sfree(sp)
end

#	Release lookup record

procedure	clu_close(clu)	#E
pointer		clu		#B lookup data

begin
  if (clu == 0) return

  call er_gclose(CLU_GROUP(clu))
  call eb_free(CLU_EVBUF(clu))
  call clu_free(clu)
  clu = 0
end

#	Lookup a buffer of events

procedure	clu_proc (clu, eb) #E
pointer		clu		#I state pointer
pointer		eb		#B data pointer

pointer		ob

begin
  ob = CLU_EVBUF(clu)
  call eb_lookup(CLU_GROUP(clu), CLU_OFFSET(clu), eb, ob)
  eb = ob
end
