# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  cepprint.x
# 	Author	:  ericco
# 	Date	:  12/04/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) cepprint.x -r1.3 12/04/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/13/97   mabbott	removed an unused function declr.
# 	10/13/97   mabbott	removed condition field code
# 	12/04/92   ericco	date and time created 92/12/04 14:56:36 by ericco
# H-
# 
#

#	Revised: 10/13/97

#
#  NOTE - MJA 10/13/97
#
#     I removed all the code supporting condition fields.  We can no
#   longer permit this option because the call to qpex_parsed is
#   illegal - this is a private QPEX function.
#
#   Any "When" field present in the print record is ignored.
#

include <edata.h>
include "cp.h"

#	Get print record from a text database

procedure	cp_read (dt, rec, ptr, ob)	# read a time
pointer		dt				#I text database
int		rec				#I record id
pointer		ptr				#O print data
pointer		ob				#I/O an output buffer

int		len
int		cpid
int		i

pointer		cp
pointer		sp
pointer		flist
int		open()
pointer		buf
pointer		tmp

#int		qpex_parsed()
errchk		dtgstr()

begin
  call smark(sp)
  call salloc(buf, 1024, TY_CHAR)
  call salloc(tmp, 1024, TY_CHAR)

  call cp_malloc(cp)
  iferr {call dtgstr(dt, rec, "Output", Memc[buf], 1024)} then {
    CP_FD(cp) = STDOUT
  } else {
    ifnoerr {call dtgstr(dt, rec, "OverWrite", Memc[tmp], 1024)} then {
      iferr{call delete(Memc[buf])} then ;
    }
    CP_FD(cp) = open(Memc[buf], NEW_FILE, TEXT_FILE)
  }

  iferr {call dtgstr(dt, rec, "When", Memc[tmp], 1024)} then {
    CP_CND_FIELD_OFFSET(cp) = -1
    CP_CND_XS_LEN(cp) = 0
    CP_CND_XE_LEN(cp) = 0
  } else {
    CP_CND_FIELD_OFFSET(cp) = -1
    CP_CND_XS_LEN(cp) = 0
    CP_CND_XE_LEN(cp) = 0
#    call sscan(Memc[tmp])
#    call gargwrd(Memc[buf], 1024)
#    call eb_fieldid(Memc[buf], cpid)
#    call eb_gcolumn(ob, cpid, CP_CND_FIELD_OFFSET(cp))
#    call gargwrd(Memc[buf], 1024)
#    CP_CND_XS_LEN(cp) = 1
#    call malloc(CP_CND_XS_PTR(cp), CP_CND_XS_LEN(cp), TY_DOUBLE)
#    call malloc(CP_CND_XE_PTR(cp), CP_CND_XS_LEN(cp), TY_DOUBLE)
#    CP_CND_XE_LEN(cp) = qpex_parsed(Memc[buf],
#		     CP_CND_XS_PTR(cp), CP_CND_XE_PTR(cp), CP_CND_XS_PTR(cp))
#    CP_CND_XS_LEN(cp) = CP_CND_XE_LEN(cp)
  }
  call dtgvstr(dt, rec, "FieldList", flist)
  len = VEC_SIZE(flist)
  CP_OFFSET_LEN(cp) = len
  CP_FORMAT_LEN(cp) = len
  call malloc(CP_OFFSET_PTR(cp), len, TY_INT)
  call malloc(CP_FORMAT_PTR(cp), len, TY_INT)

  do i = 1, len {
    call sscan(VEC_STRING(flist,i))
    call gargwrd(Memc[buf], 1024)
    call eb_fieldid(Memc[buf], cpid)
    call eb_gcolumn(ob, cpid, CP_OFFSET(cp,i))
    call gargwrd(Memc[buf], 1024)
    call eu_newstr(Memc[buf], CP_FORMAT(cp,i))
  }

  call eb_copybuffer(CP_EVBUF(cp), ob, 0)
  ob = CP_EVBUF(cp)
  ptr = cp

  call sfree(sp)
end

#	Release print record

procedure	cp_close(cp)	#E
pointer		cp		#B time data

int		i

begin
  if (cp == 0) return

  if (CP_FD(cp) != STDOUT) call close(CP_FD(cp))

  do i = 1, CP_FORMAT_LEN(cp) {
    call mfree(CP_FORMAT(cp,i), TY_CHAR)
  }
  if (CP_CND_XS_LEN(cp) != 0) call mfree(CP_CND_XS_PTR(cp), TY_DOUBLE)
  if (CP_CND_XE_LEN(cp) != 0) call mfree(CP_CND_XE_PTR(cp), TY_DOUBLE)
  call mfree(CP_OFFSET_PTR(cp), TY_INT)
  call mfree(CP_FORMAT_PTR(cp), TY_INT)
  call eb_free(CP_EVBUF(cp))
  call cp_free(cp)
  cp = 0
end

#	Print a buffer of events

procedure	cp_proc (cp, eb) #E
pointer		cp		#I state pointer
pointer		eb		#B data pointer

pointer		offsets
pointer		formats
pointer		ob

int		fd
int		len

begin
  fd = CP_FD(cp)
  ob = CP_EVBUF(cp)
  offsets = CP_OFFSET_PTR(cp)
  formats = CP_FORMAT_PTR(cp)
  len = CP_OFFSET_LEN(cp)
  call eb_print(fd, Memi[offsets], Meml[formats], len,
		CP_CND_FIELD_OFFSET(cp),
		CP_CND_XS(cp,1), CP_CND_XE(cp,1), CP_CND_XS_LEN(cp),
		eb, ob)
  eb = ob
end
