# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eblookup.x
# 	Author	:  ericco
# 	Date	:  12/06/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) eblookup.x -r1.2 12/06/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/17/92   ericco	added empty output check
# 	12/06/92   ericco	date and time created 92/12/06 14:58:16 by ericco
# H-
# 
#

#	Revised: 12/17/92

#	EUV buffer lookup operations

include	<edata.h>
include	"../eb/ebuffer.h"
include	"../er/ercol.h"

#	Event lookup

procedure	eb_lookup(grp, offset, eb, ob) #E
pointer		grp		#I table pointer
int		offset		#I field offset
pointer		eb		#B input events
pointer		ob		#B output events

long		index
pointer		ptr

int		firsttime
pointer		tc
double		v
pointer		ec
double		tlo, thi, time
int		rlo, rhi
pointer		ti

begin
  firsttime = 1
  ec = VEC_ELEMENT(grp, 1)
  tc = EC_TIME_CP(ec)
  ti = EBE_TIME(eb)

  EB_FROMFIRST(index, eb) {
    ptr = EB_POINTER(eb, index)
    time = EB_VALUE(ptr, ti)

    if (firsttime == 1 || tlo < time || time > thi) {
      firsttime = 0
      call er_gdelim(grp, time)
      call er_gcopy(grp, EC_LO_OFFSET, EC_TMP_OFFSET)
      call er_ghilo(grp, tlo, thi, rlo, rhi)
      if (rlo == rhi) {
	tlo = -INDEFD
	thi = INDEFD
      } else {
	tlo = Memd[EC_LO_DATA(tc)]
	thi = Memd[EC_HI_DATA(tc)]
      }
      # get the immediately preceding value
      # could be interpolated or following value also
      call er_getd(grp, 1, EC_TMP_OFFSET, v)
    }
    call eb_copye(eb, index, ob, index) # general event copy
    ptr = EB_POINTER(ob, index)
    EB_VALUE(ptr, offset) = v
  }
  EBG_USED(ob) = EBG_USED(eb)
  EBG_USED(eb) = 0
  if (EBG_USED(ob) == 0) ob = 0
end
