# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  binop.x
# 	Author	:  tnk
# 	Date	:  10/19/95
# 	Synopsis:  
# 	Keywords:
# 		@(#) binop.x -r1.1 10/19/95 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/19/95   tnk	date and time created 95/10/19 09:31:04 by tnk
# H-
# 
#


#       Version: @(#)binop.x	1.1 10/19/95 UCB CEA EGO

include	"bo.h"

#
# bo_open()
#

pointer	procedure	bo_open(df) #E

pointer	df			#I discrete function

pointer	bo			# binary operation structure
bool	df_gdelta()

begin
	call bo_malloc(bo)
        BO_DF(bo) = df
	call df_gx0(df, BO_OLD_X(bo))
	BO_STORAGE(bo) = FALSE
	BO_IS_DELTA(bo) = df_gdelta(df, BO_GAP(bo), BO_DELTA(bo), BO_BASE(bo))
	return bo
end


#
# bo_close()
#

procedure	bo_close(bo) #E
pointer	bo			#I bin op get
begin
	call bo_free(bo)
end


#
# bo_dgetd()
#

int	procedure	bo_dgetd(bo, x, y) #E

pointer	bo			#I bin op get
double	x			#O next x value
double	y			#O next y value

int	df_dgetd()

begin
	if(!BO_IS_DELTA(bo))
	     return df_dgetd(BO_DF(bo), x, y, 1)

	if(BO_STORAGE(bo)) {
		x = BO_X(bo)
		y = BO_Y(bo)
		BO_OLD_X(bo) = x
		BO_STORAGE(bo) = FALSE
		return 1
	}

	if(df_dgetd(BO_DF(bo), x, y, 1) == 0)
		return 0

	if(x - BO_OLD_X(bo) > BO_GAP(bo)) {

		BO_STORAGE(bo) = TRUE
		BO_X(bo) = x
		BO_Y(bo) = y
		x = x - BO_DELTA(bo)
		y = BO_BASE(bo)
	}

	BO_OLD_X(bo) = x

	return 1

end


#
# bo_interp()
#

double	procedure	bo_interp(nx, ny, ox, oy, gap, base, x) #I

double	nx			#I new x
double	ny			#I new y
double	ox			#I old x
double	oy			#I old y
double	gap			#I gap value
double	base			#I base value
double	x			#I x

double	slope
double	diff			
double	y			

begin

	diff = nx - ox
	if(!(diff > 0)) return(INDEFD)

	if(diff > gap) return(base)

	if(IS_INDEFD(ny)) return(INDEFD)
	if(IS_INDEFD(oy)) return(INDEFD)

	slope = (ny - oy)/diff
	y = slope*(x - nx) + ny

	return(y)
end


#
# bo_erinterp()
#

double	procedure	bo_erinterp(nx, ny, ox, oy, gap, base, x) #I

double	nx			#I new x
double	ny			#I new y
double	ox			#I old x
double	oy			#I old y
double	gap			#I gap value
double	base			#I base value
double	x			#I x

double	diff			
double	alpha			
double	y			

begin

	diff = nx - ox
	if(!(diff > 0)) return(INDEFD)

	if(diff > gap) return(base)

	if(IS_INDEFD(ny)) return(INDEFD)
	if(IS_INDEFD(oy)) return(INDEFD)

	alpha = (x - ox)/diff
	y = ny*(1.0 + alpha)*(1.0 + alpha) + oy*alpha*alpha

	return(y)
end
