# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfabs.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfabs.x -r1.2 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	03/30/94   akeith	date and time created 94/03/30 12:36:54 by akeith
# H-
# 
#


#	Version: @(#)dfabs.x	1.2 4/24/95 UCB CEA EGO

include	"df.h"
include	<dfset.h>

#
# df_abs() takes the absolute value of the range of a
#	and places the resulting df in b. a can equal b
#	and if a is a piecewise function and b is
#	pixel data, the finial result is translated 
#	using df_pfpd(). The resulting df must exist.
#

procedure	df_abs(a, b) #E

pointer a			#I input df
pointer b			#I existing output df

pointer op, op_open()

begin
	call df_zabs(a, op_open(op, a, b))
	call op_close(op, a, b)
end


#
# df_zabs() performs the calculation for two distinct
#	df's of the same type.
#

procedure	df_zabs(a, b) #I

pointer a			#I input df
pointer b			#I existing output df

int	npix			# number of pixels
int	ngot			# number got

double	x0, ledge, redge
double	gap, delta, base

pointer sp, ax, ay

int	df_stati()
int	df_dgetd()

bool	df_gdelta()

begin

	call df_gx0(a, x0)
	if(IS_INDEFD(x0)) call df_mkx0(a)

	call df_gx0(a, x0); call df_px0(b, x0)
	call df_gedge(a, ledge, redge)			# Copy x0 and set
	if(!IS_INDEFD(ledge)) ledge = abs(ledge)	# the left and
	if(!IS_INDEFD(redge)) redge = abs(redge)	# right edge.
	call df_pedge(b, ledge, redge)

	if(df_gdelta(a, gap, delta, base))
            if(!IS_INDEFD(base))
		call df_pdelta(b, gap, delta, abs(base))
        else call df_undelta(b)

	npix = df_stati(a, DF_PAGESZ_PARM)

	call smark(sp)
	call salloc(ax, npix, TY_DOUBLE)
	call salloc(ay, npix, TY_DOUBLE)

	repeat {
		ngot = df_dgetd(a, Memd[ax], Memd[ay], npix) 
		call aabsd(Memd[ay], Memd[ay], ngot)
		call df_dputd(b, Memd[ax], Memd[ay], ngot)
	} until(ngot < npix)

	call sfree(sp)

end

