
#       Version: @(#)dfget.ggx	1.3 4/24/95 UCB CEA EGO

include	"df.h"



#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_sgets(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#O domain buffer
short	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufs()

begin

	state = dto_gbufs(DF_DMN(df), xbuf, nelms)
	state = dto_gbufs(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_sgeti(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#O domain buffer
int	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufs()
int	dto_gbufi()

begin

	state = dto_gbufs(DF_DMN(df), xbuf, nelms)
	state = dto_gbufi(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_sgetl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#O domain buffer
long	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufs()
int	dto_gbufl()

begin

	state = dto_gbufs(DF_DMN(df), xbuf, nelms)
	state = dto_gbufl(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_sgetr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#O domain buffer
real	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufs()
int	dto_gbufr()

begin

	state = dto_gbufs(DF_DMN(df), xbuf, nelms)
	state = dto_gbufr(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_sgetd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#O domain buffer
double	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufs()
int	dto_gbufd()

begin

	state = dto_gbufs(DF_DMN(df), xbuf, nelms)
	state = dto_gbufd(DF_RNG(df), ybuf, nelms)

	return(state)
end




#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_igets(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#O domain buffer
short	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufi()
int	dto_gbufs()

begin

	state = dto_gbufi(DF_DMN(df), xbuf, nelms)
	state = dto_gbufs(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_igeti(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#O domain buffer
int	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufi()

begin

	state = dto_gbufi(DF_DMN(df), xbuf, nelms)
	state = dto_gbufi(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_igetl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#O domain buffer
long	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufi()
int	dto_gbufl()

begin

	state = dto_gbufi(DF_DMN(df), xbuf, nelms)
	state = dto_gbufl(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_igetr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#O domain buffer
real	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufi()
int	dto_gbufr()

begin

	state = dto_gbufi(DF_DMN(df), xbuf, nelms)
	state = dto_gbufr(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_igetd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#O domain buffer
double	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufi()
int	dto_gbufd()

begin

	state = dto_gbufi(DF_DMN(df), xbuf, nelms)
	state = dto_gbufd(DF_RNG(df), ybuf, nelms)

	return(state)
end




#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_lgets(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#O domain buffer
short	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufl()
int	dto_gbufs()

begin

	state = dto_gbufl(DF_DMN(df), xbuf, nelms)
	state = dto_gbufs(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_lgeti(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#O domain buffer
int	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufl()
int	dto_gbufi()

begin

	state = dto_gbufl(DF_DMN(df), xbuf, nelms)
	state = dto_gbufi(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_lgetl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#O domain buffer
long	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufl()

begin

	state = dto_gbufl(DF_DMN(df), xbuf, nelms)
	state = dto_gbufl(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_lgetr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#O domain buffer
real	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufl()
int	dto_gbufr()

begin

	state = dto_gbufl(DF_DMN(df), xbuf, nelms)
	state = dto_gbufr(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_lgetd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#O domain buffer
double	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufl()
int	dto_gbufd()

begin

	state = dto_gbufl(DF_DMN(df), xbuf, nelms)
	state = dto_gbufd(DF_RNG(df), ybuf, nelms)

	return(state)
end




#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_rgets(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#O domain buffer
short	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufr()
int	dto_gbufs()

begin

	state = dto_gbufr(DF_DMN(df), xbuf, nelms)
	state = dto_gbufs(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_rgeti(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#O domain buffer
int	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufr()
int	dto_gbufi()

begin

	state = dto_gbufr(DF_DMN(df), xbuf, nelms)
	state = dto_gbufi(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_rgetl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#O domain buffer
long	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufr()
int	dto_gbufl()

begin

	state = dto_gbufr(DF_DMN(df), xbuf, nelms)
	state = dto_gbufl(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_rgetr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#O domain buffer
real	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufr()

begin

	state = dto_gbufr(DF_DMN(df), xbuf, nelms)
	state = dto_gbufr(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_rgetd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#O domain buffer
double	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufr()
int	dto_gbufd()

begin

	state = dto_gbufr(DF_DMN(df), xbuf, nelms)
	state = dto_gbufd(DF_RNG(df), ybuf, nelms)

	return(state)
end




#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_dgets(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#O domain buffer
short	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufd()
int	dto_gbufs()

begin

	state = dto_gbufd(DF_DMN(df), xbuf, nelms)
	state = dto_gbufs(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_dgeti(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#O domain buffer
int	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufd()
int	dto_gbufi()

begin

	state = dto_gbufd(DF_DMN(df), xbuf, nelms)
	state = dto_gbufi(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_dgetl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#O domain buffer
long	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufd()
int	dto_gbufl()

begin

	state = dto_gbufd(DF_DMN(df), xbuf, nelms)
	state = dto_gbufl(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_dgetr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#O domain buffer
real	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufd()
int	dto_gbufr()

begin

	state = dto_gbufd(DF_DMN(df), xbuf, nelms)
	state = dto_gbufr(DF_RNG(df), ybuf, nelms)

	return(state)
end


#
# df_[silrd]get[silrd]() gets an array of elements from the df.
#	The number of elements are taken from the current df
#	position. The actual number of elements stored in the
#	buffers is returned. If the number of elements returned
#	is 0, the buffers are not disturbed.  The buffers to
#	receive the values should be of the data type specified
#	by the routine name prefix and suffix. Type conversion
#	will be performed if the data type of the df does not
#	match. 
#

int	procedure	df_dgetd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#O domain buffer
double	ybuf[nelms]		#O range buffer
int	nelms			#I number of elms

int	state
int	dto_gbufd()

begin

	state = dto_gbufd(DF_DMN(df), xbuf, nelms)
	state = dto_gbufd(DF_RNG(df), ybuf, nelms)

	return(state)
end




