# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfinteg.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfinteg.x -r1.3 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	01/04/95   akeith	documentation
# 	03/30/94   akeith	date and time created 94/03/30 12:37:04 by akeith
# H-
# 
#


#       Version: @(#)dfinteg.x	1.3 4/24/95 UCB CEA EGO

include	"df.h"
include	<dfset.h>

#
# df_integ() integrates over the discrete function.
#

double	procedure	df_integ(df) #E

pointer	df			#I discrete function

double	diff
double	sum
double	xo, yo
double	x,  y
double	gap, delta, base

int	stat, df_dgetd()
int	df_type()
int	bo_dgetd()
pointer	bo, bo_open()
bool	df_gdelta()

begin

	call df_gx0(df, xo)
	if(IS_INDEFD(xo)) {
		call df_mkx0(df)
		call df_gx0(df, xo)
	}

	sum = 0.0d0
	if(df_type(df) == DF_PD) {
		bo = bo_open(df)
		while(bo_dgetd(bo, x, y) != 0) {
			if(!IS_INDEFD(y)) sum = sum + y*(x - xo)
			xo = x
		}
		call bo_close(bo)
	} else {
	    stat = df_dgetd(df, xo, yo, 1)
	    if(df_gdelta(df, gap, delta, base))
		while(df_dgetd(df, x, y, 1) != 0) {
			diff = x - xo
			if(diff > delta) 
				if(!IS_INDEF(base)) sum = sum + base*diff
			else if(!IS_INDEFD(y) || !IS_INDEFD(yo))
			        sum = sum + 0.5*(y + yo)*diff
			xo = x; yo = y
		}
	    else
		while(df_dgetd(df, x, y, 1) != 0) {
			if(!IS_INDEFD(y) || !IS_INDEFD(yo))
			      sum = sum + 0.5*(y + yo)*(x - xo)
			xo = x; yo = y
		}
	}

	return(sum)
end

