# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfinterp.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfinterp.x -r1.3 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated documentation
# 	08/22/94   akeith	included dfset.h
# 	03/30/94   akeith	date and time created 94/03/30 12:37:05 by akeith
# H-
# 
#


#	Version: @(#)dfinterp.x	1.3 4/24/95 UCB CEA EGO

include "df.h"
include <dfset.h>

#
# df_interp() computes the linear interpulated df
#	between a and b. k, a value between 0.0 and
#	1.0, represents the distance between a and b
#	at which c is to be computed. If a or b is a
#	pd type df, c MUST be a pd type df. The resulting
#	df must exist.
#

procedure	df_interp(a, k, b, c) #E

pointer a			#I input df
double	k			#I interp value
pointer b			#I input df
pointer c			#I existing output df

begin

	if(a == b)		     call df_mov(a, c)
	else if(DOUBLE_EQ(k, 0.0d0)) call df_mov(a, c)
	else if(DOUBLE_EQ(k, 1.0d0)) call df_mov(b, c)
	else call df_binop(a, b, c, DF_INTERP, k)

end

