# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  imgdf.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) imgdf.x -r1.5 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/28/94   akeith	disabled all external functions
# 	10/25/94   akeith	documentation
# 	09/14/94   akeith	now reads images straight
# 	06/29/94   akeith	changed mwcs system name
# 	03/30/94   akeith	date and time created 94/03/30 12:44:42 by akeith
# H-
# 
#


#       Version: @(#)imgdf.x	1.5 11/28/94 UCB CEA EGO

include	<dfset.h>
include <imio.h>
include <imhdr.h>
include <imset.h>
include <mwset.h>
include	"ioim.h"

#
# pd_im1[silrd]() creates a df directly from a one
#	dimensional image, im. imdf_close() must be
#	used to close the df.
#

pointer	procedure	pd_im1(im, mode) #E

pointer	im			#I image pointer
int	mode			#I io mode

pointer img_df()
errchk	img_df()

begin
	call error(1, "imgdf.x: This function is currently disabled.")
        return(img_df(DF_PD, im, mode, NULL, NULL))
end


#
# pd_im2[silrd]() creates a df directly from a line
#	in a two dimensional image, im. imdf_close() must be
#	used to close the df.
#

pointer	procedure	pd_im2(im, mode, line) #E

pointer	im			#I image pointer
int	mode			#I io mode
int	line			#I image line

pointer img_df()
errchk	img_df()
int	len

begin
	call error(1, "imgdf.x: This function is currently disabled.")
	len = 1
	return(img_df(DF_PD, im, mode, long(line), len))
end


#
# pd_im3[silrd]() creates a df directly from a line
#	and band in a three dimensional image, im. imdf_close() must be
#	used to close the df.
#

pointer	procedure	pd_im3(im, mode, line, band) #E

pointer	im			#I image pointer
int	mode			#I io mode
int	line			#I image line
int	band			#I image band

int	len
pointer sp			# stack pointer
pointer lp			# line position
pointer df			# discrete function
pointer img_df()
errchk	img_df()

begin
	call error(1, "imgdf.x: This function is currently disabled.")
        len = 2
	call smark(sp)
	call salloc(lp, len, TY_LONG)
	Meml[lp] = line
	Meml[lp+1] = band
	df = img_df(DF_PD, im, mode, Meml[lp], len)
	call sfree(sp)
	return(df)
end


#
# img_pd[silrd]() creates a df directly from a n-dimensional
#	image, im. The line position is specified by the line
#	position buffer, lp. imdf_close() must be
#	used to close the df.
#

pointer	procedure	img_pd(im, mode, lp, len) #E

pointer	im			#I image pointer
int	mode			#I io mode
long	lp[IM_MAXDIM]		#I line position
int	len			#I length

pointer img_df()
errchk	img_df()

begin
	call error(1, "imgdf.x: This function is currently disabled.")
	return(img_df(DF_PD, im, mode, lp, len))
end


#
# pf_im1[silrd]() creates a df directly from a one
#	dimensional image, im. imdf_close() must be
#	used to close the df.
#

pointer	procedure	pf_im1(im, mode) #E

pointer	im			#I image pointer
int	mode			#I io mode

pointer img_df()
errchk	img_df()

begin
	call error(1, "imgdf.x: This function is currently disabled.")
	return(img_df(DF_PF, im, mode, NULL, NULL))
end


#
# pf_im2[silrd]() creates a df directly from a line
#	in a two dimensional image, im. imdf_close() must be
#	used to close the df.
#

pointer	procedure	pf_im2(im, mode, line) #E

pointer	im			#I image pointer
int	mode			#I io mode
int	line			#I image line

int	len
pointer img_df()
errchk	img_df()

begin
	call error(1, "imgdf.x: This function is currently disabled.")
	len = 1
	return(img_df(DF_PF, im, mode, long(line), len))
end


#
# pf_im3[silrd]() creates a df directly from a line
#	and band in a three dimensional image, im. imdf_close() must be
#	used to close the df.
#

pointer	procedure	pf_im3(im, mode, line, band) #E

pointer	im			#I image pointer
int	mode			#I io mode
int	line			#I image line
int	band			#I image band

int	len
pointer sp			# stack pointer
pointer lp			# line position
pointer df			# discrete function
pointer img_df()
errchk	img_df()

begin
	call error(1, "imgdf.x: This function is currently disabled.")
	len = 2
	call smark(sp)
	call salloc(lp, len, TY_LONG)
	Meml[lp] = line
	Meml[lp+1] = band
	df = img_df(DF_PF, im, mode, Meml[lp], len)
	call sfree(sp)
	return(df)
end


#
# img_pf[silrd]() creates a df directly from a n-dimensional
#	image, im. The line position is specified by the line
#	position buffer, lp. imdf_close() must be
#	used to close the df.
#

pointer	procedure	img_pf(im, mode, lp, len) #E

pointer	im			#I image pointer
int	mode			#I io mode
long	lp[IM_MAXDIM]		#I line position
int	len			#I length

pointer img_df()
errchk	img_df()

begin
	call error(1, "imgdf.x: This function is currently disabled.")
	return(img_df(DF_PF, im, mode, lp, len))
end


#
# imdf_close() closes a df which has been opened with one
#	of the img_ dfio routions.
#

procedure	imdf_close(df) #E

pointer df			#I df pointer

int	ndim			#
int	stat			#

pointer io			#
pointer im			#
errchk	ioim_clos()
errchk	ioim_mkim()
errchk	ioim_toim()

begin

	call error(1, "imgdf.x: This function is currently disabled.")
	call df_ghdrp(df, "io_struct", io, stat)
	if(stat == NO) call error(1, "imdf_close(): The io pointer was lost!")

	im = IOIM_IM(io)
	ndim = IM_NDIM(im)

	if(IOIM_MODE(io) == READ_ONLY) {
		call ioim_clos(io)
		return
	}

	if(IOIM_MODE(io) == NEW_IMAGE)
		call ioim_mkim(df, io, im)
	else	call ioim_toim(df, io, im)

	call ioim_clos(io)

end


#
# img_df[silrd]() creates a df directly from a n-dimensional
#	image, im. The type of df is specified by type. The
#	line position is specified by the line position buffer,
#	lp.
#

pointer	procedure	img_df(type, im, mode, lp, len) #I

int	type			#I df type
pointer im			#I image pointer (range)
int	mode			#I i/o mode
long	lp[IM_MAXDIM]		#I line position
int	len			#I length

pointer df, df_open()		# data table
pointer io, ioim_open()		# image io
errchk	df_open()
errchk	ioim_open()

begin

	call error(1, "imgdf.x: This function is currently disabled.")
	df = df_open(type, TY_DOUBLE, TY_DOUBLE)

		# Create the domain

	io = ioim_open(df, im, mode, lp, len)
	call df_phdrp(df, "io_struct", io)

	return(df)
end


#
# ioim_open()
#

pointer	procedure	ioim_open(df, im, mode, lp, len) #I

pointer df			#I df
pointer im			#I image pointer (range)
int	mode			#I i/o mode
long	lp[IM_MAXDIM]		#I line position
int	len			#I length

int	i
int	ndim, last

pointer	io			# input/output pointer
pointer mw, mw_openim()
errchk	mw_openim()
errchk	ioim_fromim()

begin

	call ioim_malloc(io)

	IOIM_IM(io) = im
	IOIM_MODE(io) = mode
	IOIM_VS(io) = NULL
	IOIM_VE(io) = NULL

# Translate the line position in vector section start/end.

	if(IM_NDIM(im) == 0) IM_NDIM(im) = 1
	ndim = IM_NDIM(im)

	call malloc(IOIM_VS(io), ndim, TY_LONG)
	call malloc(IOIM_VE(io), ndim, TY_LONG)
 
	call amovkl(long(1), Meml[IOIM_VS(io)], ndim)
	call amovkl(long(1), Meml[IOIM_VE(io)], ndim)
 
	Meml[IOIM_VS(io)] = 1
	Meml[IOIM_VE(io)] = IM_LEN(im, 1)
 
	last = min(len, ndim-1)
	do i = 1, last {
		Meml[IOIM_VS(io)+i] = lp[i]
		Meml[IOIM_VE(io)+i] = lp[i]
	}


	if(mode == READ_ONLY || mode == READ_WRITE) {

		mw = mw_openim(im)
		call ioim_fromim(df, io, mw, im)
		call mw_close(mw)
	}

	return(io)

end


#
# ioim_fromim()
#

procedure	ioim_fromim(df, io, mw, im) #I

pointer df			#I df pointer
pointer	io			#I io pointer
pointer	mw			#I mwcs pointer
pointer im			#I image

int	i			#
int	p, l			#
int	ndim			#
int	npix			#
int	pdim			#
int	axis			#

double	xo			#

pointer	ct			#
pointer imbuf, imggsd()		#
pointer vs, ve			#
pointer	sp			#
pointer axno, axval		#
pointer lx, wx			#
pointer	x			#

int	df_type()		#

begin

	ndim = IM_NDIM(im)
	npix = IM_LEN(im, 1)
	  vs = IOIM_VS(io)
	  ve = IOIM_VE(io)

	imbuf = imggsd(im, Meml[vs], Meml[ve], ndim)

	call smark(sp)

	call wcs_gct(mw, "world", FALSE, ct, axno, axval, pdim)

	call salloc(lx, pdim, TY_DOUBLE)
	call salloc(wx, pdim, TY_DOUBLE)

	do p = 1, pdim {
		l = Memi[axno+p-1]
		if(l == 0) Memd[lx+p-1] = Memi[axval+p-1] + 1
		else if(l == 1) axis = p
		else Memd[lx+p-1] = Meml[vs+l-1]
	}

	call salloc(x, npix, TY_DOUBLE)

	if(df_type(df) == DF_PD) {

		Memd[lx+axis-1] = 0.5
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		xo = Memd[wx+axis-1]

		call df_px0(df, xo)

		do i = 1, npix {

			Memd[lx+axis-1] = i + 0.5
			call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
			ARRAY_D(x, i) = Memd[wx+axis-1]

		}

		call df_dputd(df, Memd[x], Memd[imbuf], npix)

	} else {

		Memd[lx+axis-1] = 1.0
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)

		call df_px0(df, Memd[wx+axis-1])

		do i = 1, npix {

			Memd[lx+axis-1] = i
			call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
			ARRAY_D(x, i) = Memd[wx+axis-1]
		}

		call df_dputd(df, Memd[x], Memd[imbuf], npix)
	}

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# ioim_mkim()
#

procedure	ioim_mkim(df, io, im) #I

pointer	df			#I df pointer
pointer	io			#I io pointer
pointer im			#I image

int	npts			#
double	delx			#
double	xo, x, y		#
double	mean, sdom		#
pointer mw, mw_openim()		#

int	df_dgetd()		#

begin

	mean = 0.0
	sdom = 0.0
	npts = 0

	call df_gx0(df, xo)
	if(IS_INDEFD(xo)) call df_mkx0(df)
	call df_gx0(df, xo)

	call df_rewind(df)
	while(df_dgetd(df, x, y, 1) != 0) {
		mean = mean + (x - xo)
		npts = npts + 1
		xo = x
	}
	if(npts == 0) return
	mean = mean/npts

	call df_rewind(df)
	call df_gx0(df, xo)
	while(df_dgetd(df, x, y, 1) != 0) {
		delx = x - xo
		sdom = sdom + (delx - mean)*(delx - mean)
		xo = x
	}
	sdom = sqrt(sdom/(npts*(npts - 1)))

	call df_gx0(df, xo)
	delx = mean - sdom
	npts = (x - xo)/delx

	call df_rewind(df)
	call df_rsdomain(df, xo, delx, npts, df)

	IM_LEN(im, 1) = npts
	Meml[IOIM_VE(io)] = npts
	call ioim_wrng(df, im, IOIM_VS(io), IOIM_VE(io), npts)

	mw = mw_openim(im)
	call mw_newsystem(mw, "world", 1)
	call mw_swtermd(mw, double(1), xo, delx, 1)
	call mw_saveim(mw, im)
	call mw_close(mw)
end


#
# ioim_toim()
#

procedure	ioim_toim(df, io, im) #I

pointer df			#I df pointer
pointer	io			#I io pointer
pointer im			#I image

int	npix			# number of pixels
int	ndim			# number of dimensions
pointer mw, mw_openim()		# mwcs

begin

	npix = IM_LEN(im, 1)
	ndim = IM_NDIM(im)

	mw = mw_openim(im)
	call df_ctdomain(df, mw, "world", 1, Meml[IOIM_VS(io)], ndim, npix, df)
	call mw_close(mw)

	call ioim_wrng(df, im, IOIM_VS(io), IOIM_VE(io), npix)

end


#
# ioim_wrng()
#

procedure	ioim_wrng(df, im, vs, ve, npix) #I

pointer df			#I df pointer
pointer im			#I image
pointer vs			#I vector section start
pointer ve			#I vector section end
int	npix			#I number of pixels

int	ndim, npts		#
pointer sp, x			#
pointer imbuf, impgsd()		#
int	df_dgetd()		#

begin

	call smark(sp)
	call salloc(x, npix, TY_DOUBLE)

	call df_rewind(df)

	ndim = IM_NDIM(im)
	imbuf = impgsd(im, Meml[vs], Meml[ve], ndim)

	npts = df_dgetd(df, Memd[x], Memd[imbuf], npix)
	if(npts != npix) {
		call eprintf("Warning: Number of points in df is not")
		call eprintf("the same as the number of pixels in the")
		call eprintf("image.")
	}

	call sfree(sp)

end


#
# ioim_clos()
#

procedure	ioim_clos(io, df) #I

pointer	io			#I io pointer
pointer	df			#I df pointer

begin

	if(IOIM_VS(io) != NULL)
		call mfree(IOIM_VS(io), TY_LONG)
	if(IOIM_VE(io) != NULL)
		call mfree(IOIM_VE(io), TY_LONG)

	call ioim_free(io)

	call df_close(df)

end


