# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  rimgdf.gx
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) rimgdf.gx -r1.3 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/25/94   akeith	documentation
# 	09/14/94   akeith	reads images straight
# 	03/30/94   akeith	date and time created 94/03/30 12:45:36 by akeith
# H-
# 
#


#	Version: @(#)rimgdf.gx	1.3 10/25/94 UCB CEA EGO

include	<dfset.h>
include	<imhdr.h>

define	ARR_S		Mems[($1)+($2)-1]
define	ARR_I		Memi[($1)+($2)-1]
define	ARR_L		Meml[($1)+($2)-1]
define	ARR_R		Memr[($1)+($2)-1]
define	ARR_D		Memd[($1)+($2)-1]

#
# pd_rimg() reads from an image a specific line and
#	band and returns a pd type df.
#

pointer	procedure	pd_rimg(im, line, band) #E

pointer	im			#I image
int	line			#I line
int	band			#I band

long	lp[3]			#
pointer	df			#
pointer	buf			#
pointer	mw, mw_openim()		#


pointer	imgl1s()		#
pointer	imgl2s()		#
pointer	imgl3s()		#

pointer	imgl1i()		#
pointer	imgl2i()		#
pointer	imgl3i()		#

pointer	imgl1l()		#
pointer	imgl2l()		#
pointer	imgl3l()		#

pointer	imgl1r()		#
pointer	imgl2r()		#
pointer	imgl3r()		#

pointer	imgl1d()		#
pointer	imgl2d()		#
pointer	imgl3d()		#


begin

	lp[2] = line
	lp[3] = band
	mw = mw_openim(im)
	switch(IM_PIXTYPE(im)) {

	  case TY_SHORT:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1s(im)
		  case 2: buf = imgl2s(im, line)
		  case 3: buf = imgl3s(im, line, band)
		}
		call mk_pdims(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	  case TY_INT:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1i(im)
		  case 2: buf = imgl2i(im, line)
		  case 3: buf = imgl3i(im, line, band)
		}
		call mk_pdimi(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	  case TY_LONG:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1l(im)
		  case 2: buf = imgl2l(im, line)
		  case 3: buf = imgl3l(im, line, band)
		}
		call mk_pdiml(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	  case TY_REAL:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1r(im)
		  case 2: buf = imgl2r(im, line)
		  case 3: buf = imgl3r(im, line, band)
		}
		call mk_pdimr(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	  case TY_DOUBLE:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1d(im)
		  case 2: buf = imgl2d(im, line)
		  case 3: buf = imgl3d(im, line, band)
		}
		call mk_pdimd(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	}
	call mw_close(mw)

	return(df)
end


#
# pf_rimg() reads from an image a specific line and
#	band and returns a pf type df.
#

pointer	procedure	pf_rimg(im, line, band) #E

pointer	im			#I image
int	line			#I line
int	band			#I band

long	lp[3]
pointer	df			#
pointer	buf			#
pointer	mw, mw_openim()		#

pointer	imgl1s()		#
pointer	imgl2s()		#
pointer	imgl3s()		#

pointer	imgl1i()		#
pointer	imgl2i()		#
pointer	imgl3i()		#

pointer	imgl1l()		#
pointer	imgl2l()		#
pointer	imgl3l()		#

pointer	imgl1r()		#
pointer	imgl2r()		#
pointer	imgl3r()		#

pointer	imgl1d()		#
pointer	imgl2d()		#
pointer	imgl3d()		#


begin

	lp[2] = line
	lp[3] = band
	mw = mw_openim(im)
	switch(IM_PIXTYPE(im)) {

	  case TY_SHORT:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1s(im)
		  case 2: buf = imgl2s(im, line)
		  case 3: buf = imgl3s(im, line, band)
		}
		call mk_pfims(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	  case TY_INT:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1i(im)
		  case 2: buf = imgl2i(im, line)
		  case 3: buf = imgl3i(im, line, band)
		}
		call mk_pfimi(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	  case TY_LONG:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1l(im)
		  case 2: buf = imgl2l(im, line)
		  case 3: buf = imgl3l(im, line, band)
		}
		call mk_pfiml(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	  case TY_REAL:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1r(im)
		  case 2: buf = imgl2r(im, line)
		  case 3: buf = imgl3r(im, line, band)
		}
		call mk_pfimr(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	  case TY_DOUBLE:
		switch(IM_NDIM(im)) {
		  case 1: buf = imgl1d(im)
		  case 2: buf = imgl2d(im, line)
		  case 3: buf = imgl3d(im, line, band)
		}
		call mk_pfimd(buf, mw, lp, IM_NDIM(im), IM_LEN(im, 1), df)

	}
	call mw_close(mw)

	return(df)
end



#
# mk_pdim$t
#

procedure	mk_pdims(buf, mw, lp, ndim, npix, pd) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pd			#O

int	i			#
int	axis			#
int	pdim			#
double	xo			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PD'S

	call smark(sp)

	pd = df_open(DF_PD, TY_DOUBLE, TY_SHORT)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	Memd[lx+axis-1] = 0.5
	call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
	xo = Memd[wx+axis-1]
 
	call df_px0(pd, xo)
 
	do i = 1, npix {
 
		Memd[lx+axis-1] = i + 0.5
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
 
	}
 
	call df_dputs(pd, Memd[x], Mems[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# mk_pdim$t
#

procedure	mk_pdimi(buf, mw, lp, ndim, npix, pd) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pd			#O

int	i			#
int	axis			#
int	pdim			#
double	xo			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PD'S

	call smark(sp)

	pd = df_open(DF_PD, TY_DOUBLE, TY_INT)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	Memd[lx+axis-1] = 0.5
	call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
	xo = Memd[wx+axis-1]
 
	call df_px0(pd, xo)
 
	do i = 1, npix {
 
		Memd[lx+axis-1] = i + 0.5
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
 
	}
 
	call df_dputi(pd, Memd[x], Memi[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# mk_pdim$t
#

procedure	mk_pdiml(buf, mw, lp, ndim, npix, pd) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pd			#O

int	i			#
int	axis			#
int	pdim			#
double	xo			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PD'S

	call smark(sp)

	pd = df_open(DF_PD, TY_DOUBLE, TY_LONG)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	Memd[lx+axis-1] = 0.5
	call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
	xo = Memd[wx+axis-1]
 
	call df_px0(pd, xo)
 
	do i = 1, npix {
 
		Memd[lx+axis-1] = i + 0.5
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
 
	}
 
	call df_dputl(pd, Memd[x], Meml[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# mk_pdim$t
#

procedure	mk_pdimr(buf, mw, lp, ndim, npix, pd) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pd			#O

int	i			#
int	axis			#
int	pdim			#
double	xo			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PD'S

	call smark(sp)

	pd = df_open(DF_PD, TY_DOUBLE, TY_REAL)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	Memd[lx+axis-1] = 0.5
	call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
	xo = Memd[wx+axis-1]
 
	call df_px0(pd, xo)
 
	do i = 1, npix {
 
		Memd[lx+axis-1] = i + 0.5
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
 
	}
 
	call df_dputr(pd, Memd[x], Memr[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# mk_pdim$t
#

procedure	mk_pdimd(buf, mw, lp, ndim, npix, pd) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pd			#O

int	i			#
int	axis			#
int	pdim			#
double	xo			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PD'S

	call smark(sp)

	pd = df_open(DF_PD, TY_DOUBLE, TY_DOUBLE)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	Memd[lx+axis-1] = 0.5
	call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
	xo = Memd[wx+axis-1]
 
	call df_px0(pd, xo)
 
	do i = 1, npix {
 
		Memd[lx+axis-1] = i + 0.5
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
 
	}
 
	call df_dputd(pd, Memd[x], Memd[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end





#
# mk_pfim$t
#

procedure	mk_pfims(buf, mw, lp, ndim, npix, pf) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pf			#O

int	i			#
int	axis			#
int	pdim			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PF'S

	call smark(sp)

	pf = df_open(DF_PF, TY_DOUBLE, TY_SHORT)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	do i = 1, npix {
		Memd[lx+axis-1] = i
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
	}
 
	call df_dputs(pf, Memd[x], Mems[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# mk_pfim$t
#

procedure	mk_pfimi(buf, mw, lp, ndim, npix, pf) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pf			#O

int	i			#
int	axis			#
int	pdim			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PF'S

	call smark(sp)

	pf = df_open(DF_PF, TY_DOUBLE, TY_INT)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	do i = 1, npix {
		Memd[lx+axis-1] = i
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
	}
 
	call df_dputi(pf, Memd[x], Memi[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# mk_pfim$t
#

procedure	mk_pfiml(buf, mw, lp, ndim, npix, pf) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pf			#O

int	i			#
int	axis			#
int	pdim			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PF'S

	call smark(sp)

	pf = df_open(DF_PF, TY_DOUBLE, TY_LONG)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	do i = 1, npix {
		Memd[lx+axis-1] = i
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
	}
 
	call df_dputl(pf, Memd[x], Meml[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# mk_pfim$t
#

procedure	mk_pfimr(buf, mw, lp, ndim, npix, pf) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pf			#O

int	i			#
int	axis			#
int	pdim			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PF'S

	call smark(sp)

	pf = df_open(DF_PF, TY_DOUBLE, TY_REAL)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	do i = 1, npix {
		Memd[lx+axis-1] = i
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
	}
 
	call df_dputr(pf, Memd[x], Memr[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# mk_pfim$t
#

procedure	mk_pfimd(buf, mw, lp, ndim, npix, pf) #I

pointer	buf			#I
pointer	mw			#I
long	lp[ndim]		#I
int	ndim			#I
int	npix			#I
pointer	pf			#O

int	i			#
int	axis			#
int	pdim			#

pointer	sp			#
pointer	x			#
pointer	ct			#
pointer lx, wx			#
pointer	df_open()		#

begin

#	FOR DF_PF'S

	call smark(sp)

	pf = df_open(DF_PF, TY_DOUBLE, TY_DOUBLE)

	call rimg_wcs(mw, lp, ct, axis, lx, wx, pdim)
	call salloc(x, npix, TY_DOUBLE)

	do i = 1, npix {
		Memd[lx+axis-1] = i
		call mw_ctrand(ct, Memd[lx], Memd[wx], pdim)
		ARR_D(x, i) = Memd[wx+axis-1]
	}
 
	call df_dputd(pf, Memd[x], Memd[buf], npix)

	call mw_ctfree(ct)
	call sfree(sp)

end




#
# rimg_wcs
#

procedure	rimg_wcs(mw, lp, ct, axis, lx, wx, pdim) #I

pointer	mw			#I
int	lp[3]			#I
pointer	ct			#O
int	axis			#O
pointer	lx			#O
pointer	wx			#O
int	pdim			#O

int	p, l
pointer axno, axval		#

begin

	call wcs_gct(mw, "world", FALSE, ct, axno, axval, pdim)

        call salloc(lx, pdim, TY_DOUBLE)
        call salloc(wx, pdim, TY_DOUBLE)
 
	do p = 1, pdim {
		l = Memi[axno+p-1]
		if(l == 0) Memd[lx+p-1] = Memi[axval+p-1] + 1
		else if(l == 1) axis = p
		else Memd[lx+p-1] = lp[l]
	}

end


