# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfminmax.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfminmax.x -r1.2 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	03/30/94   akeith	date and time created 94/03/30 12:37:06 by akeith
# H-
# 
#


#       Version: @(#)dfminmax.x	1.2 4/24/95 UCB CEA EGO

include "df.h"

#
# df_minmax() finds the minimum and maximum for both
#	domain and range of a discrete function.
#

procedure	df_minmax(a, x_min, x_max, y_min, y_max) #E

pointer	a			#I input DF
double	x_min			#O min domain value
double	x_max			#O max domain value
double	y_min			#O min range value
double	y_max			#O max range value

double	x, y 
double	gap, delta, base
int	nread, df_dgetd()
bool	df_gdelta()

begin

	call df_rewind(a)

	call df_gx0(a, x)
	if(IS_INDEFD(x)) {
		call df_mkx0(a)
		call df_gx0(a, x)
	}
	x_min = x

	repeat {
		nread = df_dgetd(a, x, y, 1)
	} until(!IS_INDEFD(y) || nread == 0)
	y_min = y
	y_max = y

# Get each element, check if x value is in range.

	while ( df_dgetd(a, x, y, 1) != 0 ) {

		if(IS_INDEFD(y)) next

		if (y < y_min) y_min = y
		else if (y > y_max) y_max = y
	}
	xmax = x
	if(df_gdelta(a, gap, delta, base) && !IS_INDEFD(base))
		if (base < y_min) y_min = base
		else if (base > y_max) y_max = base

	call df_rewind(a)

end


