# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfmov.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfmov.x -r1.2 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	03/30/94   akeith	date and time created 94/03/30 12:37:07 by akeith
# H-
# 
#


#	Version: @(#)dfmov.x	1.2 4/24/95 UCB CEA EGO

include	<dfset.h>

#
# df_mov() copies the df, a to df, b. If the a is a
#	piecewise function and b is pixel data, the
#	finial result is translated using df_pfpd().
#	The resulting df must exist.
#

procedure	df_mov(a, b) #E

pointer a			#I input df
pointer b			#I output df

int	df_type()

begin

	if(a == b) return

	if(df_type(a) == DF_PD)
		if(df_type(b) == DF_PD)
			call df_zmov(a, b)
		else
			call error(1, "df_mov(): Unable to translate a pd to a pf")
	else
		if(df_type(b) == DF_PD)
			call df_pfpd(a, b)
		else
			call df_zmov(a, b)
end


#
# df_zmov() copies a df to another df of the same type.
#

procedure	df_zmov(a, b) #I

pointer a			#I input df
pointer b			#I output df

double	x0, ledge, redge
double	gap, delta, base
pointer sp, x, y

int	ngot, df_dgetd()
int	npix, df_stati()

bool	df_gdelta()

begin

	call df_reset(b)
	if(df_gdelta(a, gap, delta, base)) call df_pdelta(b, gap, delta, base)
	else call df_undelta(b)

	call df_gx0(a, x0)
	if(IS_INDEFD(x0)) call df_mkx0(a)

	call df_gx0(a, x0); call df_px0(b, x0)
	call df_gedge(a, ledge, redge)
	call df_pedge(b, ledge, redge)

	npix = df_stati(a, DF_PAGESZ_PARM)

	call smark(sp)
	call salloc(x, npix, TY_DOUBLE)
	call salloc(y, npix, TY_DOUBLE)

	repeat {
		ngot = df_dgetd(a, Memd[x], Memd[y], npix)
		call df_dputd(b, Memd[x], Memd[y], ngot)
	} until(ngot < npix)

	call sfree(sp)

	call df_rewind(a)

end

