# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfopen.gx
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfopen.gx -r1.3 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	01/04/95   akeith	documentation
# 	03/30/94   akeith	date and time created 94/03/30 12:38:56 by akeith
# H-
# 
#


#       Version: @(#)dfopen.gx	1.3 4/24/95 UCB CEA EGO

include	"df.h"
include	<dfset.h>

#
# df_open() creates a discrete function of type, DF_PD or
#	DF_PF, whose domain data type is dmn_type and
#	range data type is rng_type. The df type defines
#	how the discrete function is interpreted.
#

pointer	procedure	df_open(type, dmn_type, rng_type) #E

int	type			#I discrete function type
int	dmn_type		#I domain data type
int	rng_type		#I range data type

pointer	df			# discrete function pointer


pointer dmn, dmn_open()
pointer rng, rng_open()

pointer dt_dto()
pointer dt_open()
extern	dmn_free()
extern	rng_free()

begin

	call df_malloc(df)
	DF_TYPE(df) = type
	DF_STORAGE(df) = DF_MEM
	DF_DT(df) = dt_open()
	DF_DMN(df) = NULL
	DF_RNG(df) = NULL
	DF_UCLOSE(df) = NULL
	DF_DELTA(df) = FALSE


#   Create the domain.

	switch(dmn_type) {

	  case TY_SHORT: call dto_creates(DF_DT(df), "domain")

	  case TY_INT: call dto_createi(DF_DT(df), "domain")

	  case TY_LONG: call dto_createl(DF_DT(df), "domain")

	  case TY_REAL: call dto_creater(DF_DT(df), "domain")

	  case TY_DOUBLE: call dto_created(DF_DT(df), "domain")

	  default: call error(1, "df_open(): Bad domain data type")
	}
	DF_DMN(df) = dt_dto(DF_DT(df), "domain")

	dmn = dmn_open()
	call dto_mkusr(DF_DMN(df), dmn, dmn_free)


#   Create the range.

	switch(rng_type) {

	  case TY_SHORT: call dto_creates(DF_DT(df), "range")

	  case TY_INT: call dto_createi(DF_DT(df), "range")

	  case TY_LONG: call dto_createl(DF_DT(df), "range")

	  case TY_REAL: call dto_creater(DF_DT(df), "range")

	  case TY_DOUBLE: call dto_created(DF_DT(df), "range")

	  default: call error(1, "df_open(): Bad range data type")
	}
	DF_RNG(df) = dt_dto(DF_DT(df), "range")

	rng = rng_open()
	call dto_mkusr(DF_RNG(df), rng, rng_free)

	return(df)

end


#
# df_close() closes a discrete function.
#

procedure	df_close(df) #E

pointer	df			#U discrete function pointer

begin

	if(df == NULL) return

	call dt_close(DF_DT(df))
	call df_clos(df)
end


#
# df_clos() removes the df_ structure.
#

procedure	df_clos(df) #I

pointer	df			#U discrete function pointer

begin
	call df_free(df)
	df = NULL
end


#
# dmn_open() creates the domain structure.
#

pointer	procedure	dmn_open() #I

pointer	dmn			# domain pointer

begin
	call dmn_malloc(dmn)
	DMN_WHO(dmn) = DF_DOMAIN
	DMN_X0(dmn) = INDEFD
	DMN_MIN(dmn) = INDEFD
	DMN_MAX(dmn) = INDEFD
	DMN_GAP(dmn) = INDEFD
	DMN_DELTA(dmn) = INDEFD
	DMN_BASE(dmn) = INDEFD

	return(dmn)
end


#
# rng_open() creates the range, rng_, structure.
#

pointer	procedure	rng_open() #I

pointer	rng			# range pointer

begin
	call rng_malloc(rng)
	RNG_WHO(rng) = DF_RANGE
	RNG_LEDGE(rng) = INDEFD
	RNG_REDGE(rng) = INDEFD
	RNG_MIN(rng) = INDEFD
	RNG_MAX(rng) = INDEFD

	return(rng)
end
