# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfpfpd.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfpfpd.x -r1.2 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	03/30/94   akeith	date and time created 94/03/30 12:37:13 by akeith
# H-
# 
#


#	Version: @(#)dfpfpd.x	1.2 4/24/95 UCB CEA EGO

include	"df.h"

#
# df_pfpd() converts a pf type df to a pd type df.
#	If a is not a pf type df or b is not a pd
#	type df, an error occurs. The resulting df
#	must exist.
#

procedure df_pfpd(a, b) #E

pointer	a			#I pf type discrete function
pointer	b			#I pd type discrete function

double	ledge, redge
double	gap, delta, base
bool	df_gdelta()
int	df_type()

begin

	if(df_type(a) != DF_PF || df_type(b) != DF_PD)
		call error(1, "df_pfpd(): Bad df type for conversion")

	call df_reset(b)

	call df_gedge(a, ledge, redge)
	call df_pedge(b, ledge, redge)

	if(df_gdelta(a, gap, delta, base))
	     call df_pdelta(b, gap, delta, base)
	else call df_undelta(b)

	call df_zpfpd(a, b)

	call df_rewind(a)

end


#
# pf_zpfpd() does the dirty work.
#

procedure df_zpfpd(a, b) #I

pointer	a			#I input df
pointer	b			#I output df

double	area			#
double	x_old, y_old		#
double	x_new, y_new		#
double	gap, delta, base	#
int	n_read			#

int	df_dgetd()
bool	a_is_delta, df_gdelta()

begin

	# Get first point, use it for pd x0.

	a_is_delta = df_gdelta(a, gap, delta, base)

	repeat {
		nread = df_dgetd(a, x_old, y_old, 1)
	} until(nread == 0 || !IS_INDEFD(y_old))
	call df_px0(b, x_old)

	# Now find the area of each segment of the pf.

	if(a_is_delta)
		while ( df_dgetd(a, x_new, y_new, 1) != 0 ) {

			if(x_new - x_old > delta) area = base
			else if(IS_INDEFD(y_old)
			     || IS_INDEFD(y_new)) area = INDEFD
			else			  area = 0.5 * (y_new + y_old)

			call df_dputd(b, x_new, area, 1) 
			x_old = x_new; y_old = y_new
		}
	else
		while ( df_dgetd(a, x_new, y_new, 1) != 0 ) {

			if(IS_INDEFD(y_old)
			|| IS_INDEFD(y_new)) area = INDEFD
			else		     area = 0.5 * (y_new + y_old)

			call df_dputd(b, x_new, area, 1) 
			x_old = x_new; y_old = y_new
		}

end

