
#       Version: @(#)dfput.ggx	1.1 3/30/94 UCB CEA EGO

include	"df.h"




#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_sputs(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#I domain buffer
short	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufs(DF_DMN(df), xbuf, nelms)
	call dto_pbufs(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_sputi(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#I domain buffer
int	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufs(DF_DMN(df), xbuf, nelms)
	call dto_pbufi(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_sputl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#I domain buffer
long	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufs(DF_DMN(df), xbuf, nelms)
	call dto_pbufl(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_sputr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#I domain buffer
real	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufs(DF_DMN(df), xbuf, nelms)
	call dto_pbufr(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_sputd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
short	xbuf[nelms]		#I domain buffer
double	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufs(DF_DMN(df), xbuf, nelms)
	call dto_pbufd(DF_RNG(df), ybuf, nelms)
end





#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_iputs(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#I domain buffer
short	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufi(DF_DMN(df), xbuf, nelms)
	call dto_pbufs(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_iputi(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#I domain buffer
int	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufi(DF_DMN(df), xbuf, nelms)
	call dto_pbufi(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_iputl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#I domain buffer
long	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufi(DF_DMN(df), xbuf, nelms)
	call dto_pbufl(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_iputr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#I domain buffer
real	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufi(DF_DMN(df), xbuf, nelms)
	call dto_pbufr(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_iputd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
int	xbuf[nelms]		#I domain buffer
double	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufi(DF_DMN(df), xbuf, nelms)
	call dto_pbufd(DF_RNG(df), ybuf, nelms)
end





#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_lputs(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#I domain buffer
short	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufl(DF_DMN(df), xbuf, nelms)
	call dto_pbufs(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_lputi(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#I domain buffer
int	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufl(DF_DMN(df), xbuf, nelms)
	call dto_pbufi(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_lputl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#I domain buffer
long	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufl(DF_DMN(df), xbuf, nelms)
	call dto_pbufl(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_lputr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#I domain buffer
real	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufl(DF_DMN(df), xbuf, nelms)
	call dto_pbufr(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_lputd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
long	xbuf[nelms]		#I domain buffer
double	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufl(DF_DMN(df), xbuf, nelms)
	call dto_pbufd(DF_RNG(df), ybuf, nelms)
end





#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_rputs(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#I domain buffer
short	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufr(DF_DMN(df), xbuf, nelms)
	call dto_pbufs(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_rputi(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#I domain buffer
int	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufr(DF_DMN(df), xbuf, nelms)
	call dto_pbufi(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_rputl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#I domain buffer
long	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufr(DF_DMN(df), xbuf, nelms)
	call dto_pbufl(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_rputr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#I domain buffer
real	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufr(DF_DMN(df), xbuf, nelms)
	call dto_pbufr(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_rputd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
real	xbuf[nelms]		#I domain buffer
double	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufr(DF_DMN(df), xbuf, nelms)
	call dto_pbufd(DF_RNG(df), ybuf, nelms)
end





#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_dputs(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#I domain buffer
short	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufd(DF_DMN(df), xbuf, nelms)
	call dto_pbufs(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_dputi(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#I domain buffer
int	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufd(DF_DMN(df), xbuf, nelms)
	call dto_pbufi(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_dputl(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#I domain buffer
long	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufd(DF_DMN(df), xbuf, nelms)
	call dto_pbufl(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_dputr(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#I domain buffer
real	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufd(DF_DMN(df), xbuf, nelms)
	call dto_pbufr(DF_RNG(df), ybuf, nelms)
end



#
# df_[silrd]put[silrd]() puts an array of elements into a df.
#       The number of elements are placed at the current put
#	position of the df. The buffers to holding the values
#	should be of the data type specified by the routine
#	name prefix and suffix. Type conversion will be
#	performed if the data type of the df does not match. 
#

procedure	df_dputd(df, xbuf, ybuf, nelms) #E

pointer	df			#I discrete function
double	xbuf[nelms]		#I domain buffer
double	ybuf[nelms]		#I range buffer
int	nelms			#I number of elms

begin

	call dto_pbufd(DF_DMN(df), xbuf, nelms)
	call dto_pbufd(DF_RNG(df), ybuf, nelms)
end




