# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfshift.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfshift.x -r1.2 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	03/30/94   akeith	date and time created 94/03/30 12:37:20 by akeith
# H-
# 
#


#	Version: @(#)dfshift.x	1.2 4/24/95 UCB CEA EGO

include	"df.h"
include	<dfset.h>

#
# df_shift() adds the constant, x, to the domain of a,
#	placing the resulting df in b. a can equal b
#       and if the a is a piecewise function and b is
#       pixel data, the finial result is translated
#       using df_pfpd(). The resulting df must exist.
#

procedure	df_shift(a, x, b) #E

pointer a			#I input df
double	x			#I constant
pointer b			#I existing output df

pointer	op, op_open()

begin
	call df_zshift(a, x, op_open(op, a, b))
	call op_close(op, a, b)
end


#
# df_zshift() performs the calculation for two distinct
#       df's of the same type.
#

procedure	df_zshift(a, x, b) #I

pointer a			#I input df
double	x			#I constant
pointer b			#I existing output df

int	npix			# number of pixels
int	ngot			# number got

double	x0, ledge, redge
double	gap, delta, base
pointer sp, ax, ay

int	df_stati()
int	df_dgetd()
bool	df_gdelta()

begin

	call df_gx0(a, x0)
	if(IS_INDEFD(x0)) call df_mkx0(a)

	call df_gx0(a, x0);
	if(!IS_INDEFD(x0)) call df_px0(b, x0+x)
	else	call df_px0(b, x0)
	call df_gedge(a, ledge, redge)
	call df_pedge(b, ledge, redge)

	if(df_gdelta(a, gap, delta, base))
		call df_pdelta(b, gap, delta, base)
        else call df_undelta(b)

	npix = df_stati(a, DF_PAGESZ_PARM)

	call smark(sp)
	call salloc(ax, npix, TY_DOUBLE)
	call salloc(ay, npix, TY_DOUBLE)

	repeat {
		ngot = df_dgetd(a, Memd[ax], Memd[ay], npix) 
		call aaddkd(Memd[ax], x, Memd[ax], ngot)
		call df_dputd(b, Memd[ax], Memd[ay], ngot)
	} until(ngot < npix)

	call sfree(sp)

end

