# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfsqrt.x
# 	Author	:  akeith
# 	Date	:  06/26/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfsqrt.x -r1.3 06/26/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	01/04/95   akeith	documentation
# 	06/26/94   akeith	date and time created 94/06/26 21:34:26 by akeith
# H-
# 
#


#	Version: @(#)dfsqrt.x	1.3 4/24/95 UCB CEA EGO

include	"df.h"
include	<dfset.h>

#
# df_sqrt() takes the sqrare root of a
#	and places the resulting df in b. a can equal b
#	and if a is a piecewise function and b is
#	pixel data, the finial result is translated
#	using df_pfpd(). The resulting df must exist.
#

procedure	df_sqrt(a, b, errfcn) #E

pointer a			#I input df
pointer b			#I existing output df
extern	errfcn()		#I error function

pointer op, op_open()

begin
	call df_zsqrt(a, op_open(op, a, b), errfcn)
	call op_close(op, a, b)
end


#
# df_zsqrt() performs the calculation for two distinct
#       df's of the same type.
#

procedure	df_zsqrt(a, b, errfcn) #I

pointer a			#I input df
pointer b			#I existing output df
extern	errfcn()		#I error function

int	npix			# number of pixels
int	ngot			# number got

double	x0, ledge, redge
double	gap, delta, base
pointer sp, ax, ay

int	df_stati()
int	df_dgetd()
bool	df_gdelta()

begin

	call df_gx0(a, x0)
	if(IS_INDEFD(x0)) call df_mkx0(a)

	call df_gx0(a, x0); call df_px0(b, x0)
	call df_gedge(a, ledge, redge)

	if(!IS_INDEFD(ledge)) call asqrd(ledge, ledge, 1, errfcn)
	if(!IS_INDEFD(redge)) call asqrd(redge, redge, 1, errfcn)

	call df_pedge(b, ledge, redge)

	if(df_gdelta(a, gap, delta, base)) {
	     if(!IS_INDEFD(base)) call asqrd(base, base, 1, errfcn)
	     call df_pdelta(b, gap, delta, base)
        } else call df_undelta(b)

	npix = df_stati(a, DF_PAGESZ_PARM)

	call smark(sp)
	call salloc(ax, npix, TY_DOUBLE)
	call salloc(ay, npix, TY_DOUBLE)

	repeat {
		ngot = df_dgetd(a, Memd[ax], Memd[ay], npix) 
		call asqrd(Memd[ay], Memd[ay], ngot, errfcn)
		call df_dputd(b, Memd[ax], Memd[ay], ngot)
	} until(ngot < npix)

	call sfree(sp)

end

