# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfstat.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfstat.x -r1.1 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/30/94   akeith	date and time created 94/03/30 12:37:20 by akeith
# H-
# 
#


#	Version: @(#)dfstat.x	1.1 3/30/94 UCB CEA EGO

include "df.h"
include	<dfset.h>
include	<dtset.h>

#
# df_stati() returns a value characteristic
#	of a discrete function as a interger value.
#	If the the parameter is not found an error
#	is called and the value is return as INDEFI.
#	The parameters are defined in <dfset.h>.
#

int	procedure	df_stati(df, param) #E

pointer	df			#I descrete function
int	param			#I parameter

int	ival, dto_stati()

begin

	i_val = INDEFI

	switch(param) {

	  case DF_STORAGE_PARM:
		i_val = DF_STORAGE(df)

	  case DF_DOMAIN_DTYPE_PARM:
		i_val = dto_stati(DF_DMN(df), DTO_DTYPE_PARM)

	  case DF_RANGE_DTYPE_PARM:
		i_val = dto_stati(DF_RNG(df), DTO_DTYPE_PARM)

	  case DF_TYPE_PARM:
		i_val = DF_TYPE(df)

	  case DF_PAGESZ_PARM:
		i_val = dto_stati(DF_DMN(df), DTO_PAGESZ_PARM)

	  default:

		call error(1, "df_stati(): No such parameter.")

	}

	return(i_val)

end

