# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfsym.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfsym.x -r1.1 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/30/94   akeith	date and time created 94/03/30 12:37:24 by akeith
# H-
# 
#


#       Version: @(#)dfsym.x	1.1 3/30/94 UCB CEA EGO

include	"df.h"

#
# df_symdmn() sets the domain of the df as a symbolic link to a
#	user defined io. The io parameter is a user define io
#	pointer which is passed as a parameter to the three
#	externally defined functions, io_rel, io_read and io_write.
#	When the df is closed, io_rel will be called with the io
#	pointer as its only parameter. io_read() and io_write()
#	should expect four arguments, the io pointer, a buffer of
#	the same data type as the domain, a start position and
#	the number of elements to read/write. Both functions must
#	be able to handle the EOF marker for the start position
#	and read must change the value of the number of elements
#	to the number of elements read.
#

procedure	df_symdmn(df, io, io_rel, io_read, io_write) #E

pointer df			#I discrete function
pointer	io			#I user io pointer
extern	io_rel			#I user io release function
extern	io_read			#I user io read function
extern	io_write		#I user io write function

begin
	DF_STORAGE(df) = DF_SYM
	call dto_mksym(DF_DMN(df), io, io_rel, io_read, io_write)
end


#
# df_symrng() sets the range of the df as a symbolic link to a
#	user defined io. The io parameter is a user define io
#	pointer which is passed as a parameter to the three
#	externally defined functions, io_rel, io_read and io_write.
#	When the df is closed, io_rel will be called with the io
#	pointer as its only parameter. io_read() and io_write()
#	should expect four arguments, the io pointer, a buffer of
#	the same data type as the domain, a start position and
#	the number of elements to read/write. Both functions must
#	be able to handle the EOF marker for the start position
#	and read must change the value of the number of elements
#	to the number of elements read.
#

procedure	df_symrng(df, io, io_rel, io_read, io_write) #E

pointer df			#I discrete function
pointer	io			#I user io pointer
extern	io_rel			#I user io release function
extern	io_read			#I user io read function
extern	io_write		#I user io write function

begin
	DF_STORAGE(df) = DF_SYM
	call dto_mksym(DF_RNG(df), io, io_rel, io_read, io_write)
end

