# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dfx0.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dfx0.x -r1.1 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/30/94   akeith	date and time created 94/03/30 12:37:29 by akeith
# H-
# 
#


#       Version: @(#)dfx0.x	1.1 3/30/94 UCB CEA EGO

include "df.h"
include <dfset.h>

#
# df_gx0() returns the left edge domain value of the df.
#

procedure	df_gx0(df, x0) #E

pointer	df			#I discrete function
double	x0			#O starting of domain

pointer dmn
pointer dto_usr()

begin
	dmn = dto_usr(DF_DMN(df)) 
	x0 = DMN_X0(dmn)
end


#
# df_px0() sets the left edge domain value of the df.
#

procedure	df_px0(df, x0) #E

pointer	df			#I discrete function
double	x0			#I starting of domain

pointer dmn
pointer dto_usr()

begin
	dmn = dto_usr(DF_DMN(df)) 
	DMN_X0(dmn) = x0
end


#
# df_mkx0() infers the left edge domain value of the df.
#

procedure	df_mkx0(df) #E

pointer	df			#I discrete function

int	df_type()
int	state, df_dgetd()
double	xo, xn, y, x0

begin
	call df_rewind(df)
	if(df_type(df) == DF_PD) {
		state = df_dgetd(df, xo, y, 1)
		state = df_dgetd(df, xn, y, 1)
		if(state == 0) return
		x0 = 2.0*xo - xn
		call df_px0(df, x0)
	} else {
		state = df_dgetd(df, xo, y, 1)
		if(state == 0) return
		call df_px0(df, xo)
	}
	call df_rewind(df)
end

