# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  pfinterp.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) pfinterp.x -r1.3 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	04/27/94   tnk	added x=ox and x=nx checks
# 	03/30/94   akeith	date and time created 94/03/30 12:37:31 by akeith
# H-
# 
#


#       Version: @(#)pfinterp.x	1.3 4/24/95 UCB CEA EGO

#
# pf_interp() interpulates between two function values
#	of a piecewise linear function.
#

double	procedure	pf_interp(nx, ny, ox, oy, x) #I

double	nx			#I new x
double	ny			#I new y
double	ox			#I old x
double	oy			#I old y
double	x			#I x

double	slope
double	y			

begin

	if(nx == ox) return(INDEFD)

	if(IS_INDEFD(ny)) return(INDEFD)
	if(IS_INDEFD(oy)) return(INDEFD)

	slope = (ny - oy)/(nx - ox)
	y = slope*(x - nx) + ny

	return(y)
end


#
# pf_erinterp() interpulates between two function values
#	of a piecewise linear function.
#

double	procedure	pf_erinterp(nx, ny, ox, oy, x) #I

double	nx			#I new x
double	ny			#I new y
double	ox			#I old x
double	oy			#I old y
double	x			#I x

double	alpha
double	y			

begin

	if(nx == ox) return(INDEFD)

	if(IS_INDEFD(ny)) return(INDEFD)
	if(IS_INDEFD(oy)) return(INDEFD)

	alpha = (x - ox)/(nx - ox)
	y = ny*(1.0 + alpha)*(1.0 + alpha) + oy*alpha*alpha

	return(y)
end

