# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  rngstat.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) rngstat.x -r1.1 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/30/94   akeith	date and time created 94/03/30 12:37:32 by akeith
# H-
# 
#


#	Version: @(#)rngstat.x	1.1 3/30/94 UCB CEA EGO

include "df.h"
include	<dfset.h>

#
# rng_statd() returns the status and charactoristics
#	particular to the range of the discrete function
#	The parameters are defined in <dfset.h>.
#

double	procedure	rng_statd(rng, param) #I

pointer	rng			#I domain pointer
int	param			#I parameter

double	d_val
bool	rng_statb()

begin

	d_val = INDEFD
	if(!rng_statb(rng))
		call error(1, "rng_statd(): Wrong pointer.")

	switch(param) {

	  case RNG_LEDGE_PARM:
		d_val = RNG_LEDGE(rng)

	  case RNG_REDGE_PARM:
		d_val = RNG_REDGE(rng)

	  case RNG_MIN_PARM:
		d_val = RNG_MIN(rng)

	  case RNG_MAX_PARM:
		d_val = RNG_MAX(rng)

	  default:
		call error(1, "rng_statd(): No such parameter.")
		d_val = INDEFD

	}

	return(d_val)

end


#
# rng_statb()
#

bool	procedure	rng_statb(rng) #I

pointer	rng			#I domain pointer

begin
	if(RNG_WHO(rng) == DF_RANGE) return(TRUE)
	return(FALSE)
end


