# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  zzdebug.x
# 	Author	:  akeith
# 	Date	:  04/20/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) zzdebug.x -r1.3 04/20/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/24/95   akeith	updated to better handle INDEF's, better io docs, and now df's can be defined as delta df's
# 	04/20/94   akeith	added version keywords
# 	04/20/94   akeith	date and time created 94/04/20 11:44:16 by akeith
# H-
# 
#


#	Version: @(#)zzdebug.x	1.3 4/24/95 UCB CEA EGO

include	<dfset.h>

task	dftest	= t_dftest

#
# df_test() is a code test procedure, not used in general.
#

procedure	t_dftest()

pointer sp				# stack pointer
pointer tb1, tb2			# table pointer
pointer df1, df2			# df pointer
pointer o_tb				# table pointer
pointer o_df				# df pointer
pointer tb1_name, tb2_name		# table name
pointer domain				# domain name
pointer range				# range name
pointer colptr				# column pointer

pointer table_open()
pointer tbtopn()
#pointer pd_tbl()
pointer pf_tbl()
bool	streq()

begin

	call smark(sp)

# Open table 1 and create the first df

	call eu_clstr(tb1_name, "table1")
	tb1 = table_open(Memc[tb1_name])    
	
	call eu_clstr(domain, "domain")
	call eu_clstr(range, "range")
	
	df1 = pf_tbl(tb1, Memc[domain], Memc[range])
#	df1 = pd_tbl(tb1, Memc[domain], Memc[range])
	call df_pedge(df1, 0.0, 0.0)	
	
# Open table 2 and create the second df

	call eu_clstr(tb2_name, "table2")
	if(streq(Memc[tb1_name], Memc[tb2_name])) tb2 = tb1
	else tb2 = table_open(Memc[tb2_name])    
	
	call eu_clstr(domain, "domain")
	call eu_clstr(range, "range")

	df2 = pf_tbl(tb2, Memc[domain], Memc[range])
#	df2 = pd_tbl(tb2, Memc[domain], Memc[range])
	call df_pedge(df2, 0.0, 0.0)

	
# Create the output table

	call eu_clstr(tb1_name, "result")
	o_tb = tbtopn(Memc[tb1_name], NEW_FILE, 0)    
	call tbcdef(o_tb, colptr, "domain", "sec", "%g", TY_DOUBLE, 0, 1)
	call tbcdef(o_tb, colptr, "range", "counts", "%g", TY_REAL, 0, 1)
	call tbtcre(o_tb)
	o_df = pf_tbl(o_tb, "domain", "range")
#	o_df = pd_tbl(o_tb, "domain", "range")


	call sfree(sp)


	call df_add(df1, df2, o_df)		# Add 2 df's

#	call df_mov(df1, o_df)			# Copy df

#	call df_div(df1, df2, o_df)		# Divide 2 df's

#	call df_addk(df1, double(10.0), o_df)	# Add by a constant

#	call df_stretch(df1, double(2.0), o_df)

#	call df_divk(o_df, double(2.0), o_df)

#	call df_trim(df1, double(10.0), double(34.2), o_df)

#	call df_pfpd(df1, o_df)

#	call df_movk(double(2.0), df1, o_df)

#	call df_rsdomain(df1, double(2.0), double(3.0), 15,  o_df)

#	call df_dfdomain(df1, df2, o_df)

#	call df_shift(df1, double(10.0), o_df)


# Clean up DF`s

	call df_close(df1)
	call df_close(df2)
	call df_close(o_df)

# Clean up tables

	call tbtclo(tb1)
	if(tb1 != tb2) call tbtclo(tb2)
	call tbtclo(o_tb)

end


#
# table_open() opens the named table, first checking if the table exists.
#

pointer	procedure	table_open(tb_name)

char	tb_name[ARB]				#I table name

pointer	tb_ptr					# table pointer

pointer tbtopn()				# tb opens table

begin

	iferr {
		tb_ptr = tbtopn(tb_name, READ_ONLY, NULL)
	} then {
		call fprintf(STDERR, "\n\n The ST table, %s")
		call pargstr(tb_name)
		call fprintf(STDERR, ", does not exist! \n\n")
		return(NULL)
	}

	return(tb_ptr)

end


