# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  addpoisson.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) addpoisson.x -r1.2 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/28/94   tnk	renamed poidev to nr_poidev
# 	04/28/94   tnk	date and time created 94/04/28 12:01:31 by tnk
# H-
# 
#

# @(#)addpoisson.x	1.2 4/28/94 UCB CEA EGO

include <dfset.h>

# add poisson noise to counts bins

procedure add_poisson (bins_df,seed)
pointer bins_df   #I/O counts bins 
long seed         #I random number seed

pointer save_df
real    yreal
double  x,y
double  ledge, redge

# FUNCTIONS
real    nr_poidev()
pointer df_open()
int     df_dgetd()

begin

   # save off DF
   save_df = df_open(DF_PD,TY_DOUBLE,TY_DOUBLE)
   call df_gedge(bins_df,ledge,redge)
   call df_mov(bins_df,save_df)
   call df_reset(bins_df)
   call df_pedge(bins_df,ledge,redge)

   # step thru each element, replace with poisson value
   while ( df_dgetd(save_df, x, y, 1) != 0) {

      yreal = y
      y = double(nr_poidev(yreal,seed))
      call df_dputd(bins_df, x, y, 1)

   }
   call df_close(save_df)

   call df_rewind(bins_df)

end
