# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eadf.x
# 	Author	:  akeith
# 	Date	:  03/24/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eadf.x -r1.2 03/24/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/24/94   akeith	fixed errors
# 	03/24/94   akeith	date and time created 94/03/24 14:15:25 by akeith
# H-
# 
#


include <dfset.h>

#  @(#)eadf.x	1.2 3/24/94 UCB CEA EGO

# get effective areas for a single detector and return as DF`s
# (one DF per order)
#
# do all the edd stuff here to slurp up the effective areas
#
# for each order
#   make a new df
#   copy over the wavelengths & effective areas

#  should malloc an array of DF pointers of size norders

procedure ea_df(dd, ea, max_orders, norders)
pointer dd             #I detector structure
pointer ea[ARB]     #O array of DF pointers, for each EA order
int     max_orders     #I allocated size of ea array
int     norders        #O no. of elements returned in ea array

int     order
int     len
pointer wavelength
pointer area

# FUNCTIONS
pointer df_open()   # create DF in memory

begin

   # find out number of orders
   call edd_ea_orders(dd,norders)

   if (max_orders < norders)
      call error(111,"ea_df: ea array is too small")

   for (order=1; order<=norders; order=order+1) {

      ea[order] = df_open(DF_PF,TY_DOUBLE,TY_DOUBLE)  #create DF in memory
      call df_pedge(ea[order],0.0d0,0.0d0)

      # read ea for this order
      call edd_ea_order(dd, order, len, wavelength, area)

      # stuff in df
      call df_rputr(ea[order],Memr[wavelength],Memr[area],len)

   }

end

