# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  getcrdf.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) getcrdf.x -r1.3 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/23/94   tnk	fixed collresp column names
# 	08/23/94   tnk	fixed args to get_file_df
# 	04/28/94   tnk	date and time created 94/04/28 12:02:31 by tnk
# H-
# 
#


# @(#)getcrdf.x	1.3 8/23/94 UCB CEA EGO

# get collimator response from reference dataset,
# formatted as a DF

procedure get_cr_df(detector,refdata,collresp_df)
char    detector[ARB]   #I name of detector
char    refdata[ARB]    #I path to detector ref table
pointer collresp_df     #I/O df containing collimator response (must exist)

pointer sp
pointer refpath
pointer resp_file
pointer ref_tp
char    ftype

pointer tbtopn()
bool    streq() 
bool    get_file_df()

begin

   call smark(sp)

   ref_tp = tbtopn(refdata, READ_ONLY, NULL)

   # find name of collresp file in detector file
   call salloc(resp_file, SZ_LINE, TY_CHAR)
   call collresp_fname(ref_tp, detector, Memc[resp_file], SZ_LINE)

   if (streq(Memc[resp_file],"INDEF"))
   {
      call eprintf("Collimator response not available for detector %s\n")
      call pargstr(detector)      
   }
   else {

      # pull out path to reference directory
      call salloc(refpath, SZ_LINE, TY_CHAR)
      call fnpath(refdata,Memc[refpath], SZ_LINE)

      # cat path & filename together, fetch the data
      call strcat(Memc[resp_file],Memc[refpath], SZ_LINE)

      # read in collimator response
      if (!get_file_df(collresp_df,Memc[refpath],"","",ftype))
         call error(120,"Cannot read collimator file")
   }

   call tbtclo(ref_tp)

   call sfree(sp)

end



