# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  geteadf.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) geteadf.x -r1.2 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/02/94   akeith	updated
# 	04/28/94   tnk	date and time created 94/04/28 11:41:14 by tnk
# H-
# 
#


include <dfset.h>

#  @(#)geteadf.x	1.2 9/2/94 UCB CEA EGO

# get effective areas for a single detector and return as DF`s
# (one DF per order)
#
# do all the edd stuff here to slurp up the effective areas
#
# for each order
#   make a new df
#   copy over the wavelengths & effective areas

#  should malloc an array of DF pointers of size norders

procedure get_ea_df(dd, ea_df, max_orders, norders)
pointer dd             #I detector structure
pointer ea_df[ARB]     #O array of DF pointers, for each EA order
int     max_orders     #I allocated size of ea_df array
int     norders        #O no. of elements returned in ea_df array

int     order
int     len
pointer wavelength
pointer area

# FUNCTIONS
pointer df_open()   # create DF in memory

begin

   # find out number of orders
   call edd_ea_orders(dd,norders)

   if (norders > max_orders) norders = max_orders

   for (order=1; order<=norders; order=order+1) {

      ea_df[order] = df_open(DF_PF,TY_DOUBLE,TY_DOUBLE)  #create DF in memory
      call df_pedge(ea_df[order],0.0d0,0.0d0)

      # read ea for this order
      call edd_ea_order(dd, order, len, wavelength, area)

      # edd multiplies the wavelength by the order, so divide it 
      # back out (actually, multiply by reciprocal)
      call amulkr(Memr[wavelength],1.0e0/order,Memr[wavelength],len)

      # stuff in df
      call df_rputr(ea_df[order],Memr[wavelength],Memr[area],len)

   }

end

