# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  getpsfdf.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) getpsfdf.x -r1.1 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/28/94   tnk	date and time created 94/04/28 12:02:33 by tnk
# H-
# 
#



#  @(#)getpsfdf.x	1.1 4/28/94 UCB CEA EGO

# Get point spread functions (psf`s) for a single detector 
# using the edd library, and return as a DF.
# Returns only 1 psf, containing wavelength & fwhm1.

procedure get_psf_df(dd, psf_df)
pointer dd              #I detector structure
pointer psf_df          #I/O  psf in DF format

int     psf_len       # length of data arrays
pointer psf_wave      # psf wavelengths
pointer psf_fwhm1     # fwhm values
pointer psf_fwhm2     # fwhm values
pointer psf_ratio     # fwhm ratio values

begin

   # get psf's
   call edd_psfs(dd, psf_len, psf_wave, psf_fwhm1, psf_fwhm2, psf_ratio)

   # stuff in df
   call df_rputr(psf_df,Memr[psf_wave],Memr[psf_fwhm1],psf_len)

   # set edges to be upper & lower limits
   call df_pedge(psf_df,double(Memr[psf_fwhm1+0]),
                        double(Memr[psf_fwhm1+psf_len-1]))


end
