# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  mkgaussdf.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) mkgaussdf.x -r1.1 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/28/94   tnk	date and time created 94/04/28 12:02:35 by tnk
# H-
# 
#

# @(#)mkgaussdf.x	1.1 4/28/94 UCB CEA EGO

include <math.h>

# make a sampled gaussian
#
# need to enhance by only generating half, since it's symmetrical
#
procedure mkgauss_df(xmid,sigma,nsigma,npts,out_df)
double xmid     #I midpoint (x value) of gaussian
double sigma    #I one sigma value of gaussian
double nsigma   #I how many sigma's out to generate
int    npts     #I no. of points to generate
pointer out_df  #I/O output df (must already exist)

# make a gaussian distribution
#
# from "experimental measurements" by barford  (p.118)
#
#               1                |  (x-xmid)^2  |
#  f(x) = ---------------- * exp |- ----------- |
#         SQRT(2*PI)*sigma       |   2*sigma^2  |
# where:
#    xmid  = mid x point of the gaussian
#    sigma = one sigma value

double scale         # scale (normalization) factor
double xstart,xend
double x,y
double sigma_sqr_2
double step
double width

begin

   width  = sigma*nsigma

   if (width > 0.0d0) {
      step   = width/npts
      xend   = xmid + width/2.0d0 + step
      xstart = xmid - width/2.0d0

      scale=1.0d0/(sqrt(TWOPI)*sigma)
      sigma_sqr_2 = 2 * sigma * sigma

      for (x=xstart; x<=xend; x=x+step) {
         y= scale * exp( -(x-xmid)**2 / sigma_sqr_2)
         call df_dputd(out_df,x,y,1)
      }
   }
end

