# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dtflush.gx
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dtflush.gx -r1.1 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/30/94   akeith	date and time created 94/03/30 14:11:29 by akeith
# H-
# 
#


#       Version: @(#)dtflush.gx	1.1 3/30/94 UCB CEA EGO

include "dt.h"
include "dto.h"

#
# dt_flush() flushes the named dto's buffer. If the dto's type is
#	DTO_MEMORY or its state is not DTO_PUT dto_flush does nothing.
#	Otherwise, it calls the usr defined write function and updates
#	the user file position, the buf position and the nelms held by
#	the buf.
#

procedure	dt_flush(dt, name) #E

pointer	dt				#I pointer to data table
char	name[ARB]			#I name of dto

pointer	dto				# pointer to data table obj

begin

	call ls_get(DT_LS(dt), name, dto)
	call dto_flush(dto)

end


#
# dto_flush() flushes the dto's buffer. If the dto's type is
#	DTO_MEMORY or its state is not DTO_PUT dto_flush does nothing.
#	Otherwise, it calls the usr defined write function and updates
#	the user file position, the buf position and the nelms held by
#	the buf.
#

procedure	dto_flush(dto) #E

pointer	dto				#I pointer to data table obj

int	nelms				# nelms to write
int	ufpos				# user file position

begin

	if(DTO_TYPE(dto) == DTO_MEMORY) return
	if(DTO_STATE(dto) != DTO_PUT) return

	ufpos = DTO_BMARK(dto)
	nelms = DTO_NELMS(dto)
	if(nelms == 0) return		# buffer is empty

	switch(DTO_DTYPE(dto)) {

	  case TY_SHORT:
		call zcall5(DTO_WRITE(dto), DTO_IO(dto), DTO_BUFS(dto),
					    ufpos, nelms)

	  case TY_INT:
		call zcall5(DTO_WRITE(dto), DTO_IO(dto), DTO_BUFI(dto),
					    ufpos, nelms)

	  case TY_LONG:
		call zcall5(DTO_WRITE(dto), DTO_IO(dto), DTO_BUFL(dto),
					    ufpos, nelms)

	  case TY_REAL:
		call zcall5(DTO_WRITE(dto), DTO_IO(dto), DTO_BUFR(dto),
					    ufpos, nelms)

	  case TY_DOUBLE:
		call zcall5(DTO_WRITE(dto), DTO_IO(dto), DTO_BUFD(dto),
					    ufpos, nelms)

	  default:
		call error(1, "dto_put$t: No such type.")
	}

	DTO_PBP(dto) = 1
	DTO_NELMS(dto) = 0
	DTO_BMARK(dto) = DTO_PFP(dto)

end

