# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dtmksym.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dtmksym.x -r1.1 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/30/94   akeith	date and time created 94/03/30 14:11:36 by akeith
# H-
# 
#


#       Version: @(#)dtmksym.x	1.1 3/30/94 UCB CEA EGO

include "dt.h"
include "dto.h"

#
# dt_mksym() makes the named dto a symbolic link to a user defined io.
#	The io parameter is a user define io pointer which is passed
#	as a parameter to the three externally defined functions,
#	io_rel, uread and uwrite. When the dto is released, io_rel will
#	release the io pointer. io_rel should expect two arguments,
#	the io pointer, io and the user defined pointer which may be NULL.
#	uread() and uwrite() should expect four
#	arguments, the io pointer, a buffer of the same type as the dto, a
#	start position and the number of elements to read/write. Both
#	functions must be able to handle the EOF marker for the start
#	position and read must change the value of the number of elements
#	to the number of elements read.
#

procedure	dt_mksym(dt, name, io, io_rel, uread, uwrite) #E

pointer	dt			#O pointer to data table
char	name[ARB]		#I name of dto
pointer io			#I usr io pointer
extern	io_rel			#I usr io release function
extern	uread			#I usr read function
extern	uwrite			#I usr write function

pointer	dto			# pointer to data table obj

begin

	call ls_get(DT_LS(dt), name, dto)
	call dto_mksym(dto, io, io_rel, uread, uwrite)

end


#
# dto_mksym() makes the given dto a symbolic link to a user defined io.
#	The io parameter is a user define io pointer which is passed
#	as a parameter to the three externally defined functions,
#	io_rel, uread and uwrite. When the dto is released, io_rel will
#	release the io pointer. io_rel should expect two arguments,
#	the io pointer, io and the user defined pointer which may be NULL.
#	uread() and uwrite() should expect four
#	arguments, the io pointer, a buffer of the same type as the dto, a
#	start position and the number of elements to read/write. Both
#	functions must be able to handle the EOF marker for the start
#	position and read must change the value of the number of elements
#	to the number of elements read.
#

procedure	dto_mksym(dto, io, io_rel, uread, uwrite) #E

pointer	dto			#O pointer to data table obj
pointer io			#I usr io pointer
extern	io_rel			#I usr io release function
extern	uread			#I usr read function
extern	uwrite			#I usr write function

pointer locpr()

begin

	if(DTO_STATE(dto) != INDEFI) {
		call error(1, "dto_mksym(): already in memory.")
	}

	DTO_TYPE(dto) = DTO_SYMBOL
	DTO_IO(dto) = io
	DTO_IOREL(dto) = locpr(io_rel)
	DTO_READ(dto) = locpr(uread)
	DTO_WRITE(dto) = locpr(uwrite)

end

