# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dtofillbuf.gx
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dtofillbuf.gx -r1.1 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/30/94   akeith	date and time created 94/03/30 14:11:42 by akeith
# H-
# 
#


#       Version: @(#)dtofillbuf.gx	1.1 3/30/94 UCB CEA EGO

include	"dto.h"

#
# dto_fillbuf[silrd]() reads in from the user defined function when
#	the buffer is considered empty, i.e. when
#	DTO_BPOS(dto) > DTO_NELMS(dto). dto_fillbuf[silrd]() attempts
#	to read the full length of the DTO_BUF(dto) and sets DTO_NELMS
#	to the number elements read as return by the user defined
#	function.
#

int	procedure	dto_fillbuf(dto) #I

pointer	dto				#I pointer to data table object

int	nelms				# number of elements
int	get_pos				# get position
int	zero

begin

	zero = DTO_GFP(dto) - DTO_BMARK(dto)
	if(zero >= 0) {
		nelms = DTO_NELMS(dto) - zero
		if(nelms > 0) {
			DTO_GBP(dto) = zero + 1
			return(nelms)
		}
	}

	DTO_BMARK(dto) = DTO_GFP(dto)
	nelms = DTO_BUF_LEN(dto)
	get_pos = DTO_GFP(dto)
	
	switch(DTO_DTYPE(dto)) {

	  case TY_SHORT:
		call zcall4(DTO_READ(dto), DTO_IO(dto), DTO_BUFS(dto),
					   get_pos, nelms)

	  case TY_INT:
		call zcall4(DTO_READ(dto), DTO_IO(dto), DTO_BUFI(dto),
					   get_pos, nelms)

	  case TY_LONG:
		call zcall4(DTO_READ(dto), DTO_IO(dto), DTO_BUFL(dto),
					   get_pos, nelms)

	  case TY_REAL:
		call zcall4(DTO_READ(dto), DTO_IO(dto), DTO_BUFR(dto),
					   get_pos, nelms)

	  case TY_DOUBLE:
		call zcall4(DTO_READ(dto), DTO_IO(dto), DTO_BUFD(dto),
					   get_pos, nelms)

	  default:
		nelms = 0
	}

	DTO_GBP(dto) = 1
	DTO_NELMS(dto) = nelms

	return(nelms)

end

