
#       Version: @(#)dtogbuf.ggx	1.1 3/30/94 UCB CEA EGO

include "dto.h"


#
# dto_gbuf[silrd]() gets an array of elements from the dto.
#	The user number of elements are taken from the current
#	file position. The actual number of elements stored in
#	the user buffer is returned. If the number of elements
#	returned is 0, the user buffer is not disturbed. The
#	current file position is updated upon each get. The
#	current file position is initialized to 1 for the first
#	call to dto_gbuf[silrd]() unless the position has been
#	set by a call to dto_seek(). The buffer to receive the
#	values should be of the data type specified by the routine
#	name suffix. Type conversion will be performed if the data
#	type of the dto does not match.
#

int	procedure	dto_gbufs(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
short	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	nelms_got			# nelms got


int	mem_sgets()
int	sym_sgets()

int	mem_igets()
int	sym_igets()

int	mem_lgets()
int	sym_lgets()

int	mem_rgets()
int	sym_rgets()

int	mem_dgets()
int	sym_dgets()


begin

	if(dto == NULL) return(-1)

	if(DTO_TYPE(dto) == DTO_MEMORY) {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = mem_sgets(dto, ubuf, unelms)

		  case TY_INT: nelms_got = mem_igets(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = mem_lgets(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = mem_rgets(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = mem_dgets(dto, ubuf, unelms)

		}
	} else {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = sym_sgets(dto, ubuf, unelms)

		  case TY_INT: nelms_got = sym_igets(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = sym_lgets(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = sym_rgets(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = sym_dgets(dto, ubuf, unelms)

		}
	}

	return(nelms_got)

end


#
# dto_gbuf[silrd]() gets an array of elements from the dto.
#	The user number of elements are taken from the current
#	file position. The actual number of elements stored in
#	the user buffer is returned. If the number of elements
#	returned is 0, the user buffer is not disturbed. The
#	current file position is updated upon each get. The
#	current file position is initialized to 1 for the first
#	call to dto_gbuf[silrd]() unless the position has been
#	set by a call to dto_seek(). The buffer to receive the
#	values should be of the data type specified by the routine
#	name suffix. Type conversion will be performed if the data
#	type of the dto does not match.
#

int	procedure	dto_gbufi(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
int	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	nelms_got			# nelms got


int	mem_sgeti()
int	sym_sgeti()

int	mem_igeti()
int	sym_igeti()

int	mem_lgeti()
int	sym_lgeti()

int	mem_rgeti()
int	sym_rgeti()

int	mem_dgeti()
int	sym_dgeti()


begin

	if(dto == NULL) return(-1)

	if(DTO_TYPE(dto) == DTO_MEMORY) {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = mem_sgeti(dto, ubuf, unelms)

		  case TY_INT: nelms_got = mem_igeti(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = mem_lgeti(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = mem_rgeti(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = mem_dgeti(dto, ubuf, unelms)

		}
	} else {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = sym_sgeti(dto, ubuf, unelms)

		  case TY_INT: nelms_got = sym_igeti(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = sym_lgeti(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = sym_rgeti(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = sym_dgeti(dto, ubuf, unelms)

		}
	}

	return(nelms_got)

end


#
# dto_gbuf[silrd]() gets an array of elements from the dto.
#	The user number of elements are taken from the current
#	file position. The actual number of elements stored in
#	the user buffer is returned. If the number of elements
#	returned is 0, the user buffer is not disturbed. The
#	current file position is updated upon each get. The
#	current file position is initialized to 1 for the first
#	call to dto_gbuf[silrd]() unless the position has been
#	set by a call to dto_seek(). The buffer to receive the
#	values should be of the data type specified by the routine
#	name suffix. Type conversion will be performed if the data
#	type of the dto does not match.
#

int	procedure	dto_gbufl(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
long	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	nelms_got			# nelms got


int	mem_sgetl()
int	sym_sgetl()

int	mem_igetl()
int	sym_igetl()

int	mem_lgetl()
int	sym_lgetl()

int	mem_rgetl()
int	sym_rgetl()

int	mem_dgetl()
int	sym_dgetl()


begin

	if(dto == NULL) return(-1)

	if(DTO_TYPE(dto) == DTO_MEMORY) {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = mem_sgetl(dto, ubuf, unelms)

		  case TY_INT: nelms_got = mem_igetl(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = mem_lgetl(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = mem_rgetl(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = mem_dgetl(dto, ubuf, unelms)

		}
	} else {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = sym_sgetl(dto, ubuf, unelms)

		  case TY_INT: nelms_got = sym_igetl(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = sym_lgetl(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = sym_rgetl(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = sym_dgetl(dto, ubuf, unelms)

		}
	}

	return(nelms_got)

end


#
# dto_gbuf[silrd]() gets an array of elements from the dto.
#	The user number of elements are taken from the current
#	file position. The actual number of elements stored in
#	the user buffer is returned. If the number of elements
#	returned is 0, the user buffer is not disturbed. The
#	current file position is updated upon each get. The
#	current file position is initialized to 1 for the first
#	call to dto_gbuf[silrd]() unless the position has been
#	set by a call to dto_seek(). The buffer to receive the
#	values should be of the data type specified by the routine
#	name suffix. Type conversion will be performed if the data
#	type of the dto does not match.
#

int	procedure	dto_gbufr(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
real	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	nelms_got			# nelms got


int	mem_sgetr()
int	sym_sgetr()

int	mem_igetr()
int	sym_igetr()

int	mem_lgetr()
int	sym_lgetr()

int	mem_rgetr()
int	sym_rgetr()

int	mem_dgetr()
int	sym_dgetr()


begin

	if(dto == NULL) return(-1)

	if(DTO_TYPE(dto) == DTO_MEMORY) {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = mem_sgetr(dto, ubuf, unelms)

		  case TY_INT: nelms_got = mem_igetr(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = mem_lgetr(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = mem_rgetr(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = mem_dgetr(dto, ubuf, unelms)

		}
	} else {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = sym_sgetr(dto, ubuf, unelms)

		  case TY_INT: nelms_got = sym_igetr(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = sym_lgetr(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = sym_rgetr(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = sym_dgetr(dto, ubuf, unelms)

		}
	}

	return(nelms_got)

end


#
# dto_gbuf[silrd]() gets an array of elements from the dto.
#	The user number of elements are taken from the current
#	file position. The actual number of elements stored in
#	the user buffer is returned. If the number of elements
#	returned is 0, the user buffer is not disturbed. The
#	current file position is updated upon each get. The
#	current file position is initialized to 1 for the first
#	call to dto_gbuf[silrd]() unless the position has been
#	set by a call to dto_seek(). The buffer to receive the
#	values should be of the data type specified by the routine
#	name suffix. Type conversion will be performed if the data
#	type of the dto does not match.
#

int	procedure	dto_gbufd(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
double	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	nelms_got			# nelms got


int	mem_sgetd()
int	sym_sgetd()

int	mem_igetd()
int	sym_igetd()

int	mem_lgetd()
int	sym_lgetd()

int	mem_rgetd()
int	sym_rgetd()

int	mem_dgetd()
int	sym_dgetd()


begin

	if(dto == NULL) return(-1)

	if(DTO_TYPE(dto) == DTO_MEMORY) {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = mem_sgetd(dto, ubuf, unelms)

		  case TY_INT: nelms_got = mem_igetd(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = mem_lgetd(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = mem_rgetd(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = mem_dgetd(dto, ubuf, unelms)

		}
	} else {
		switch(DTO_DTYPE(dto)) {

		  case TY_SHORT: nelms_got = sym_sgetd(dto, ubuf, unelms)

		  case TY_INT: nelms_got = sym_igetd(dto, ubuf, unelms)

		  case TY_LONG: nelms_got = sym_lgetd(dto, ubuf, unelms)

		  case TY_REAL: nelms_got = sym_rgetd(dto, ubuf, unelms)

		  case TY_DOUBLE: nelms_got = sym_dgetd(dto, ubuf, unelms)

		}
	}

	return(nelms_got)

end



