
#       Version: @(#)dtopbuf.ggx	1.1 3/30/94 UCB CEA EGO

include	"dto.h"


#
# dto_pbuf[silrd]() puts an array of elements into the dto. The user
#	number of elements are written from the current file position.
#	The current file position is updated upon each put. The put
#	file position is initialized to 1. 
#	If a seek has been performed, the current
#	file position is left alone. The buffer used to write the values
#	should be of the data type specified by the routine name suffix.
#	Type conversion will be performed if the data type of the dto
#	does not match.
#

procedure	dto_pbufs(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
short	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

begin

	if(dto == NULL)
		call error(1, "dto_pbuf(): Invalid dto.")


	switch(DTO_DTYPE(dto)) {

	  case TY_SHORT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_sputs(dto, ubuf, unelms)
		else	call sym_sputs(dto, ubuf, unelms)

	  case TY_INT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_iputs(dto, ubuf, unelms)
		else	call sym_iputs(dto, ubuf, unelms)

	  case TY_LONG:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_lputs(dto, ubuf, unelms)
		else	call sym_lputs(dto, ubuf, unelms)

	  case TY_REAL:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_rputs(dto, ubuf, unelms)
		else	call sym_rputs(dto, ubuf, unelms)

	  case TY_DOUBLE:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_dputs(dto, ubuf, unelms)
		else	call sym_dputs(dto, ubuf, unelms)


	  default:
		call error(1, "dto_pbuf$t: No such type.")
	}

end


#
# dto_pbuf[silrd]() puts an array of elements into the dto. The user
#	number of elements are written from the current file position.
#	The current file position is updated upon each put. The put
#	file position is initialized to 1. 
#	If a seek has been performed, the current
#	file position is left alone. The buffer used to write the values
#	should be of the data type specified by the routine name suffix.
#	Type conversion will be performed if the data type of the dto
#	does not match.
#

procedure	dto_pbufi(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
int	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

begin

	if(dto == NULL)
		call error(1, "dto_pbuf(): Invalid dto.")


	switch(DTO_DTYPE(dto)) {

	  case TY_SHORT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_sputi(dto, ubuf, unelms)
		else	call sym_sputi(dto, ubuf, unelms)

	  case TY_INT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_iputi(dto, ubuf, unelms)
		else	call sym_iputi(dto, ubuf, unelms)

	  case TY_LONG:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_lputi(dto, ubuf, unelms)
		else	call sym_lputi(dto, ubuf, unelms)

	  case TY_REAL:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_rputi(dto, ubuf, unelms)
		else	call sym_rputi(dto, ubuf, unelms)

	  case TY_DOUBLE:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_dputi(dto, ubuf, unelms)
		else	call sym_dputi(dto, ubuf, unelms)


	  default:
		call error(1, "dto_pbuf$t: No such type.")
	}

end


#
# dto_pbuf[silrd]() puts an array of elements into the dto. The user
#	number of elements are written from the current file position.
#	The current file position is updated upon each put. The put
#	file position is initialized to 1. 
#	If a seek has been performed, the current
#	file position is left alone. The buffer used to write the values
#	should be of the data type specified by the routine name suffix.
#	Type conversion will be performed if the data type of the dto
#	does not match.
#

procedure	dto_pbufl(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
long	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

begin

	if(dto == NULL)
		call error(1, "dto_pbuf(): Invalid dto.")


	switch(DTO_DTYPE(dto)) {

	  case TY_SHORT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_sputl(dto, ubuf, unelms)
		else	call sym_sputl(dto, ubuf, unelms)

	  case TY_INT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_iputl(dto, ubuf, unelms)
		else	call sym_iputl(dto, ubuf, unelms)

	  case TY_LONG:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_lputl(dto, ubuf, unelms)
		else	call sym_lputl(dto, ubuf, unelms)

	  case TY_REAL:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_rputl(dto, ubuf, unelms)
		else	call sym_rputl(dto, ubuf, unelms)

	  case TY_DOUBLE:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_dputl(dto, ubuf, unelms)
		else	call sym_dputl(dto, ubuf, unelms)


	  default:
		call error(1, "dto_pbuf$t: No such type.")
	}

end


#
# dto_pbuf[silrd]() puts an array of elements into the dto. The user
#	number of elements are written from the current file position.
#	The current file position is updated upon each put. The put
#	file position is initialized to 1. 
#	If a seek has been performed, the current
#	file position is left alone. The buffer used to write the values
#	should be of the data type specified by the routine name suffix.
#	Type conversion will be performed if the data type of the dto
#	does not match.
#

procedure	dto_pbufr(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
real	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

begin

	if(dto == NULL)
		call error(1, "dto_pbuf(): Invalid dto.")


	switch(DTO_DTYPE(dto)) {

	  case TY_SHORT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_sputr(dto, ubuf, unelms)
		else	call sym_sputr(dto, ubuf, unelms)

	  case TY_INT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_iputr(dto, ubuf, unelms)
		else	call sym_iputr(dto, ubuf, unelms)

	  case TY_LONG:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_lputr(dto, ubuf, unelms)
		else	call sym_lputr(dto, ubuf, unelms)

	  case TY_REAL:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_rputr(dto, ubuf, unelms)
		else	call sym_rputr(dto, ubuf, unelms)

	  case TY_DOUBLE:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_dputr(dto, ubuf, unelms)
		else	call sym_dputr(dto, ubuf, unelms)


	  default:
		call error(1, "dto_pbuf$t: No such type.")
	}

end


#
# dto_pbuf[silrd]() puts an array of elements into the dto. The user
#	number of elements are written from the current file position.
#	The current file position is updated upon each put. The put
#	file position is initialized to 1. 
#	If a seek has been performed, the current
#	file position is left alone. The buffer used to write the values
#	should be of the data type specified by the routine name suffix.
#	Type conversion will be performed if the data type of the dto
#	does not match.
#

procedure	dto_pbufd(dto, ubuf, unelms) #E

pointer	dto				#I pointer to data table obj
double	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

begin

	if(dto == NULL)
		call error(1, "dto_pbuf(): Invalid dto.")


	switch(DTO_DTYPE(dto)) {

	  case TY_SHORT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_sputd(dto, ubuf, unelms)
		else	call sym_sputd(dto, ubuf, unelms)

	  case TY_INT:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_iputd(dto, ubuf, unelms)
		else	call sym_iputd(dto, ubuf, unelms)

	  case TY_LONG:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_lputd(dto, ubuf, unelms)
		else	call sym_lputd(dto, ubuf, unelms)

	  case TY_REAL:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_rputd(dto, ubuf, unelms)
		else	call sym_rputd(dto, ubuf, unelms)

	  case TY_DOUBLE:
		if(DTO_TYPE(dto) == DTO_MEMORY)
			call mem_dputd(dto, ubuf, unelms)
		else	call sym_dputd(dto, ubuf, unelms)


	  default:
		call error(1, "dto_pbuf$t: No such type.")
	}

end




