# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dtostat.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dtostat.x -r1.1 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/30/94   akeith	date and time created 94/03/30 14:11:52 by akeith
# H-
# 
#


#       Version: @(#)dtostat.x	1.1 3/30/94 UCB CEA EGO

include <dtset.h>
include "dto.h"

define	DTO_DEFAULT	-128

#
# dto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the data table object.
#

bool	procedure	dto_statb (dto, dto_param) #E

pointer dto				#I pointer to data table
int	dto_param			#I parameter to inquire

bool	value				# output value for parameter

begin

	switch	(dto_param) {

	case DTO_DEFAULT:

	default:

		call error(1, "dto_stat(): No such parameter.")
		value = FALSE

	}

	return(value)

end


#
# dto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the data table object.
#

double	procedure	dto_statd (dto, dto_param) #E

pointer dto				#I pointer to data table
int	dto_param			#I parameter to inquire

double	value				# output value for parameter

begin

	switch	(dto_param) {

	case DTO_DEFAULT:

	default:

		call error(1, "dto_stat(): No such parameter.")
		value = INDEFD

	}

	return(value)

end


#
# dto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the data table object.
#

int	procedure	dto_stati (dto, dto_param) #E

pointer dto				#I pointer to data table
int	dto_param			#I parameter to inquire

int	value				# output value for parameter

begin

	switch	(dto_param) {

	case DTO_NELMS_PARM:

		value = DTO_NELMS(dto)

	case DTO_TYPE_PARM:

		value = DTO_TYPE(dto)

	case DTO_DTYPE_PARM:

		value = DTO_DTYPE(dto)

	case DTO_STATE_PARM:

		value = DTO_STATE(dto)

	case DTO_GBP_PARM:

		value = DTO_GBP(dto)

	case DTO_PBP_PARM:

		value = DTO_PBP(dto)

	case DTO_PAGESZ_PARM:

		value = DTO_PAGESZ(dto)

	case DTO_GFP_PARM:

		value = DTO_GFP(dto)

	case DTO_PFP_PARM:

		value = DTO_PFP(dto)

	case DTO_DEFAULT:

	default:

		call error(1, "dto_stat(): No such parameter.")
		value = INDEFI

	}

	return(value)

end


#
# dto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the data table object.
#

long	procedure	dto_statl (dto, dto_param) #E

pointer dto				#I pointer to data table
int	dto_param			#I parameter to inquire

long	value				# output value for parameter

begin

	switch	(dto_param) {

	case DTO_DEFAULT:

	default:

		call error(1, "dto_stat(): No such parameter.")
		value = INDEFL

	}

	return(value)

end


#
# dto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the data table object.
#

pointer	procedure	dto_statp (dto, dto_param) #E

pointer dto				#I pointer to data table
int	dto_param			#I parameter to inquire

pointer	value				# output value for parameter

begin

	switch	(dto_param) {

	case DTO_USR_PARM:

		value = DTO_USR(dto)

	case DTO_IO_PARM:

		value = DTO_IO(dto)

	case DTO_DEFAULT:

	default:

		call error(1, "dto_stat(): No such parameter.")
		value = NULL

	}

	return(value)

end


#
# dto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the data table object.
#

real	procedure	dto_statr (dto, dto_param) #E

pointer dto				#I pointer to data table
int	dto_param			#I parameter to inquire

real	value				# output value for parameter

begin

	switch	(dto_param) {

	case DTO_DEFAULT:

	default:

		call error(1, "dto_stat(): No such parameter.")
		value = INDEFR

	}

	return(value)

end


#
# dto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the data table object.
#

short	procedure	dto_stats (dto, dto_param) #E

pointer dto				#I pointer to data table
int	dto_param			#I parameter to inquire

short	value				# output value for parameter

begin

	switch	(dto_param) {

	case DTO_DEFAULT:

	default:

		call error(1, "dto_stat(): No such parameter.")
		value = INDEFS

	}

	return(value)

end

