# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dtreset.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dtreset.x -r1.2 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/03/94   akeith	changed error message
# 	03/30/94   akeith	date and time created 94/03/30 14:11:56 by akeith
# H-
# 
#


#       Version: @(#)dtreset.x	1.2 11/3/94 UCB CEA EGO

include	"dt.h"
include	"dto.h"

#
# dt_reset() resets the get and put positions back to 1
#	and sets the number of elements back to 0. If the
#	dto is storing data in memory that information is
#	lost. If the dto is storing data through a symbolic
#	link what was stored previously still exits and the
#	end of file indicator must be reset by the user.
#

procedure	dt_reset(dt, name) #E

pointer	dt				#O pointer to data table
char	name[ARB]			#I dto name

pointer	dto				#O pointer to data table obj

begin

	call ls_get(DT_LS(dt), name, dto)
	if(dto == NULL) call error(1, "dt_reset(): Invalid dto name.")
	call dto_reset(dto)

end


#
# dto_reset() resets the get and put positions back to 1
#	and sets the number of elements back to 0. If the
#	dto is storing data in memory that information is
#	lost. If the dto is storing data through a symbolic
#	link what was stored previously still exits and the
#	end of file indicator must be reset by the user.
#

procedure	dto_reset(dto) #E

pointer	dto				#O pointer to data table obj

begin

	if(dto == NULL) call error(1, "dto_reset(): Invalid dto.")
	call dto_seekg(dto, long(1))
	call dto_seekp(dto, long(1))
	DTO_NELMS(dto) = 0
	if(DTO_TYPE(dto) == DTO_MEMORY) {
		DTO_STATE(dto) = INDEFI
		if(DTO_BUF_PTR(dto) != NULL) {
			call mfree(DTO_BUF_PTR(dto), DTO_DTYPE(dto))
			DTO_BUF_PTR(dto) = NULL
			DTO_BUF_LEN(dto) = 0
		}
	}

end

