# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dtseek.x
# 	Author	:  akeith
# 	Date	:  03/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dtseek.x -r1.2 03/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/11/94   akeith	fixed error with nelms field in seek put
# 	03/30/94   akeith	date and time created 94/03/30 14:11:57 by akeith
# H-
# 
#


#       Version: @(#)dtseek.x	1.2 7/11/94 UCB CEA EGO

include	"dt.h"
include	"dto.h"

#
# dt_seek() sets both the get position and the put position of the
#	named dto. If the dto is memory based it is not possible
#	to seek passed the number of elements currently in the
#	buffer. If the dto is symbolic, the internal buffer is
#	flushed.
#

procedure	dt_seek(dt, name, fpos) #E

pointer	dt				#O pointer to data table
char	name[ARB]			#I dto name
int	fpos				#I file position

pointer	dto				#O pointer to data table obj

begin

	call ls_get(DT_LS(dt), name, dto)
	if(dto == NULL) call error(1, "dt_seek(): Invalid dto name.")
	call dto_seek(dto, fpos)

end


#
# dto_seek() sets both the get position and the put position of
#	the dto. If the dto is memory based it is not possible
#	to seek passed the number of elements currently in the
#	buffer. If the dto is symbolic, the internal buffer is
#	flushed.
#

procedure	dto_seek(dto, fpos) #E

pointer	dto				#O pointer to data table obj
int	fpos				#I file position

begin

	if(dto == NULL) call error(1, "dt_seek(): Invalid dto.")
	call dto_seekg(dto, fpos)
	call dto_seekp(dto, fpos)

end


#
# dto_seekg() sets the get position. If the dto is memory based it is
#	not possible to seek passed the number of elements currently
#	in the buffer.
#

procedure	dto_seekg(dto, fpos) #E

pointer	dto				#O pointer to data table obj
int	fpos				#I file position

begin

	if(dto == NULL) call error(1, "dt_seek(): Invalid dto.")

	if(fpos == BOF) fpos = 1
	if(DTO_TYPE(dto) == DTO_MEMORY) {
		if(fpos == EOF) fpos = DTO_NELMS(dto)+1
		DTO_GBP(dto) = min(DTO_NELMS(dto)+1, fpos)
	} else
		DTO_GFP(dto) = fpos

end


#
# dto_seekp() sets the put position. If the dto is memory based it is
#	not possible to seek passed the number of elements currently
#	in the buffer.
#

procedure	dto_seekp(dto, fpos) #E

pointer	dto				#O pointer to data table obj
int	fpos				#I file position

begin

	if(dto == NULL) call error(1, "dt_seek(): Invalid dto.")

	if(fpos == BOF) fpos = 1
	if(DTO_TYPE(dto) == DTO_MEMORY) {
		if(fpos == EOF) fpos = DTO_NELMS(dto)+1
		DTO_PBP(dto) = min(DTO_NELMS(dto)+1, fpos)
		DTO_NELMS(dto) = DTO_PBP(dto) - 1
	} else {
		call dto_flush(dto)
		DTO_NELMS(dto) = 0
		DTO_PFP(dto) = fpos
		DTO_BMARK(dto) = DTO_PFP(dto)
	}

end

