
#       Version: @(#)symput.ggx	1.1 3/30/94 UCB CEA EGO

include "dto.h"



#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_sputs(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
short	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_scpys()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_scpys(ubuf, up, nelms_2put,
				DTO_BUFS(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_iputs(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
short	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_scpyi()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_scpyi(ubuf, up, nelms_2put,
				DTO_BUFI(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_lputs(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
short	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_scpyl()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_scpyl(ubuf, up, nelms_2put,
				DTO_BUFL(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_rputs(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
short	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_scpyr()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_scpyr(ubuf, up, nelms_2put,
				DTO_BUFR(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_dputs(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
short	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_scpyd()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_scpyd(ubuf, up, nelms_2put,
				DTO_BUFD(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end



#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_sputi(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
int	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_icpys()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_icpys(ubuf, up, nelms_2put,
				DTO_BUFS(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_iputi(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
int	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_icpyi()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_icpyi(ubuf, up, nelms_2put,
				DTO_BUFI(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_lputi(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
int	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_icpyl()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_icpyl(ubuf, up, nelms_2put,
				DTO_BUFL(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_rputi(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
int	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_icpyr()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_icpyr(ubuf, up, nelms_2put,
				DTO_BUFR(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_dputi(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
int	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_icpyd()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_icpyd(ubuf, up, nelms_2put,
				DTO_BUFD(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end



#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_sputl(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
long	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_lcpys()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_lcpys(ubuf, up, nelms_2put,
				DTO_BUFS(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_iputl(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
long	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_lcpyi()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_lcpyi(ubuf, up, nelms_2put,
				DTO_BUFI(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_lputl(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
long	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_lcpyl()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_lcpyl(ubuf, up, nelms_2put,
				DTO_BUFL(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_rputl(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
long	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_lcpyr()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_lcpyr(ubuf, up, nelms_2put,
				DTO_BUFR(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_dputl(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
long	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_lcpyd()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_lcpyd(ubuf, up, nelms_2put,
				DTO_BUFD(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end



#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_sputr(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
real	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_rcpys()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_rcpys(ubuf, up, nelms_2put,
				DTO_BUFS(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_iputr(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
real	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_rcpyi()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_rcpyi(ubuf, up, nelms_2put,
				DTO_BUFI(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_lputr(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
real	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_rcpyl()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_rcpyl(ubuf, up, nelms_2put,
				DTO_BUFL(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_rputr(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
real	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_rcpyr()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_rcpyr(ubuf, up, nelms_2put,
				DTO_BUFR(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_dputr(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
real	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_rcpyd()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_rcpyd(ubuf, up, nelms_2put,
				DTO_BUFD(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end



#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_sputd(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
double	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_dcpys()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_dcpys(ubuf, up, nelms_2put,
				DTO_BUFS(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_iputd(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
double	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_dcpyi()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_dcpyi(ubuf, up, nelms_2put,
				DTO_BUFI(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_lputd(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
double	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_dcpyl()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_dcpyl(ubuf, up, nelms_2put,
				DTO_BUFL(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_rputd(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
double	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_dcpyr()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_dcpyr(ubuf, up, nelms_2put,
				DTO_BUFR(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end

#
# sym_[silrd]put[silrd]() puts an array of elements into a symbolic
#	dto buffer.
#

procedure	sym_dputd(dto, ubuf, unelms) #I

pointer	dto				#I pointer to data table obj
double	ubuf[ARB]			#O usr buffer
int	unelms				#I usr number of elements

int	up				# user buffer position
int	nelms_cpyd			# number of elms copied
int	nelms_2put			# number of elms to put
int	space_avail			# space availible in buffer

int	buf_dcpyd()

begin

	if(DTO_STATE(dto) == INDEFI) {

		DTO_BUF_LEN(dto) = DTO_PAGESZ(dto)
		call calloc(DTO_BUF_PTR(dto), DTO_BUF_LEN(dto), DTO_DTYPE(dto))
		DTO_BMARK(dto) = DTO_PFP(dto)

	} else if(DTO_STATE(dto) == DTO_GET) {

		DTO_BMARK(dto) = DTO_PFP(dto)
		DTO_PBP(dto) = 1
		DTO_NELMS(dto) = 0
	}
		
	DTO_STATE(dto) = DTO_PUT

	up = 1
	nelms_2put = unelms
	space_avail = DTO_BUF_LEN(dto) - DTO_PBP(dto) + 1

	repeat {

		nelms_cpyd = buf_dcpyd(ubuf, up, nelms_2put,
				DTO_BUFD(dto), DTO_PBP(dto), space_avail)

		DTO_NELMS(dto) = DTO_NELMS(dto) + nelms_cpyd

		DTO_PFP(dto) = DTO_PFP(dto) + nelms_cpyd

		nelms_2put = nelms_2put - nelms_cpyd
		space_avail = space_avail - nelms_cpyd

		if(space_avail == 0) {
			call dto_flush(dto)
			space_avail = DTO_BUF_LEN(dto)
		} 

	} until(nelms_2put == 0)

end



