# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  earead.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) earead.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/19/93   ericco	added information for random number generater
# 	09/28/92   akeith	setup debug statements
# 	10/28/91   ericco	updated eu_malloc calls
# 	05/07/91   ericco	date and time created 91/05/07 14:03:53 by ericco
# H-
# 
#

#	Revised: 3/19/93

include <eerror.h>
include	<edata.h>
include	<dbg.h>

#	Arithematic operations have up to two operands (FLD1, FLD2) as
#	well as a operator.  The result is put in FLDO.  All
#	calculations are doubles and no error checking is done.
#	The DEF double values are not really default values but
#	rather constant values to use instead of field names in
#	the event buffer.

define		EA_OPER	VEC_ELEMENT($1,1)
define		EA_FLD1	VEC_ELEMENT($1,2)
define		EA_FLD2	VEC_ELEMENT($1,3)
define		EA_FLDO	VEC_ELEMENT($1,4)
define		EA_BUF	VEC_ELEMENT($1,5)
define		EA_TYP1	VEC_ELEMENT($1,6)
define		EA_TYP2	VEC_ELEMENT($1,7)
define		EA_DEFS	VEC_ELEMENT($1,8)
define		EA_SEED	VEC_ELEMENT($1,9)

define		EA_LENGTH	long(10)

#	These definitions are used where two element arrays are
#       required.

define		EA_FLDS	EA_FLD1($1)
define		EA_TYPS	EA_TYP1($1)


#	Release arithmatic resources

procedure	ea_close (ear)		# release resources
pointer		ear			#I/O data pointer

begin
  call eu_mfree (EA_DEFS(ear), TY_DOUBLE)
  call ev_free(ear)
  ear = 0
end


#	Initialize a computational buffer from a tdb record.

procedure	ea_read(dt, rec, elem, buf) # initialize

pointer		dt		#I text database
int		rec		#I record id
pointer		elem		#O computation buffer
pointer		buf		#I input buffer-like

int	i
char	junk[1]
pointer	tmp, sp, new, defs
long	length
int	ip
int	dtgeti()

int	strdic()
errchk	eb_fieldid

begin
  call smark(sp)
  
  call ev_new(elem, EA_LENGTH)
  call eu_malloc(defs, 2, TY_DOUBLE)
  Memd[defs+0] = 0
  Memd[defs+1] = 0
  
  EA_DEFS(elem) = defs
  EA_TYP1(elem) = EA_COL
  EA_TYP2(elem) = EA_COL
  
  iferr(i = dtgeti(dt, rec, "Seed")) {
    i = 31415
  }
  EA_SEED(elem) = i
  
  call dtgptr(dt, rec, "Operation", tmp)
  i = strdic(Memc[tmp], junk, 0, EA_DICT)
  CHK_VALFIELD(i != 0)
  EA_OPER(elem) = i
  
  call dtgptr(dt, rec, "InField1", tmp)
  iferr(call eb_fieldid(Memc[tmp], i)) {
    ip = 1
    call ctod(Memc[tmp], ip, Memd[defs])
    EA_TYP1(elem) = EA_NUM
  } else {
    call eb_gcolumn(buf, i, EA_FLD1(elem))
  }
  
  call dtgptr(dt, rec, "InField2", tmp)
  iferr (call eb_fieldid(Memc[tmp], i)) {
    ip = 1
    call ctod(Memc[tmp], ip, Memd[defs+1])
    EA_TYP2(elem) = EA_NUM
  } else {
    call eb_gcolumn(buf, i, EA_FLD2(elem))
  }
  
  call dtgptr(dt, rec, "OutField", tmp)
  call eb_fieldid(Memc[tmp], i)
  CHK_VALFIELD(i != 0)
  call eb_gcolumn(buf, i, EA_FLDO(elem))
  
  call eb_headernew(new, buf)
  EA_BUF(elem) = new
  
  call eb_addfield(new, Memc[tmp])
  call eb_glength(buf, length)
  call eb_addbuffer(new, length)
  
  call sfree(sp)
end

#	Process data in a computation buffer.  This unpacks
#	the EAR data structure.

procedure	ear_proc (ear, buf) # process a computation
pointer		ear		#I computation buffer
pointer		buf		#I/O data buffer

begin
  if (buf != 0) {
    call ebar_proc (EA_BUF(ear),  EA_OPER(ear),
		    EA_FLDS(ear), EA_TYPS(ear),
		    Memd[EA_DEFS(ear)], EA_FLDO(ear),
		    EA_SEED(ear), buf)
  }
end
