# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ebarproc.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) ebarproc.x -r1.7 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/19/93   ericco	added uniform random number generator
# 	09/28/92   akeith	put in debug statements
# 	07/11/92   ericco	added checks for INDEF inputs
# 	06/24/92   ericco	added div and mod operations
# 	10/28/91   ericco	assume that there is enough room in the output buffer
# 	05/07/91   ericco	date and time created 91/05/07 14:05:19 by ericco
# H-
# 
#

#	Revised: 3/19/93

include	<edata.h>
include	<dbg.h>
include	"ebuffer.h"

#	Process a buffer of computations.  Currently, this
#	doesn't actually use the computation buffer.  Instead
#	it modifies the input buffer.
procedure	ebar_proc (buf, oper, flds, typs, defs, out, seed, inp)
pointer		buf		#I/O computation buffer
int		oper		#I operation to perform
int		flds[2]		#I input field ids
int		typs[2]		#I input field types
double		defs[2]		#I input field constant values
int		out		#I output field id
long		seed		#I/O random number seed
pointer		inp		#I input buffer

pointer		ptr
long		index
double		one, two, res
real		urand()

begin
    EB_FROMFIRST(index, inp) {
      ptr = EB_POINTER(inp,index)
      if (typs[1] == EA_COL) one = EB_VALUE(ptr, flds[1]); else one = defs[1]
      if (typs[2] == EA_COL) two = EB_VALUE(ptr, flds[2]); else two = defs[2]
      if (one == INDEFD || two == INDEFD)
        res = INDEFD
      else switch (oper){
      case EA_ADD :	res = one + two
      case EA_SUB :	res = one - two
      case EA_MULT:	res = one * two
      case EA_SET :	res = one
      case EA_MOD :	res = mod(one,two)
      case EA_DIV :	res = one / two
      case EA_RND :	res = one + (urand(seed) - 0.5) * two
      default :		res = 0
      }
      EB_VALUE(ptr, out) = res
    }
end
