# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ebcheck.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) ebcheck.x -r1.8 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/29/94   akeith	Now does ds and scanner remap
# 	05/04/94   akeith	Got rid of DEBUG statements
# 	12/06/92   ericco	added lookup
# 	09/28/92   akeith	put in debug statements
# 	07/07/92   ericco	set writing output buffer to null value
# 	10/28/91   ericco	pass output buffer status 
# 	05/07/91   ericco	date and time created 91/05/07 14:05:29 by ericco
# H-
# 
#

#	Revised: 6/29/94

#	EUV buffer check operations

include <edata.h>
include	<dbg.h>
include	"ebuffer.h"

#	Process time buffer if necessary
procedure	ebt_check (ob, in, index, ptr, ib) # buffer check
pointer		ob			#O output event buffer
long		in			#I get in mask events
long		index			#I time index
pointer		ptr			#I state pointer
pointer		ib			#I/O input buffer

pointer		ret

begin
  if (ib == 0) return
  ret = 1
  if (in == 0) {
    call eb_time(ptr, ib, index, NULL, ret)
  } else {
    call eb_time(ptr, ib, index, ret, NULL)
  }
  ob = ret
end

#	Process mask buffer if necessary
procedure	ebm_check (ob, in, index1, index2, ptr, ib) # buffer check
pointer		ob			#O output event buffer
long		in			#I get in mask events
long		index1			#I x index
long		index2			#I y index
pointer		ptr			#I state pointer
pointer		ib			#I/O input buffer

pointer		ret

begin
  if (ib == 0) return
  ret = 1
  if (in == 0) {
    call eb_mask(ptr, ib, index1, index2, NULL, ret)
  } else {
    call eb_mask(ptr, ib, index1, index2, ret, NULL)
  }
  ob = ret
end

#	Process correction buffer if necessary
procedure	ebc_check (ob, index1, index2, ptr, force, ib) # buffer check
pointer		ob			#O output event buffer
long		index1			#I x index
long		index2			#I y index
pointer		ptr			#I state pointer
int		force			#I flush
pointer		ib			#I/O input buffer

begin
  call eb_correct(ptr, ib, index1, index2, 0, ob, force)
end

#	Process aspect buffer if necessary
procedure	eba_check (ob, index1, index2, ti, qt, ptr, aspect, ib)
pointer		ob			#O output event buffer
long		index1			#I x index
long		index2			#I y index
long		ti			#I time index
pointer		qt			#I source quaternion
pointer		ptr			#I state pointer
pointer		aspect			#I aspect data
pointer		ib			#I/O input buffer

begin
  if (ib == 0) return
  call eb_aspect(ptr, ib, index1, index2, ti, Memd[qt], aspect, ob)
end

#	Process aspect buffer for the ds if necessary
procedure	ebima_check (ob, index1, index2, ti, ptr, aspect, ib)
pointer		ob			#O output event buffer
long		index1			#I x index
long		index2			#I y index
long		ti			#I time index
pointer		ptr			#I state pointer
pointer		aspect			#I aspect data
pointer		ib			#I/O input buffer

begin
  if (ib == 0) return
  call eb_imaspect(ptr, ib, index1, index2, ti, Memd[aspect], ob)
end

#	Process write buffer if necessary
procedure	ebw_check (ob, ptr, force, ib) # buffer check
pointer		ob			#O output event buffer
pointer		ptr			#I state pointer
int		force			#I force processing
pointer		ib			#I/O input buffer

int		f

begin
  if (ib != 0) f = 0; else f = force
  call ew_proc(ptr, ib, f)
  ob = 0
end

#	Process convert buffer if necessary
procedure	ebcn_check (ob, ptr, ib) # buffer check
pointer		ob			#O output event buffer
pointer		ptr			#I state pointer
pointer		ib			#I/O input buffer

begin
  if (ib == 0) return
  call eb_convert(ptr, ib)
  ob = ib
end

#	Process arithmatic buffer if necessary
procedure	ebar_check (ob, ptr, ib, force) # buffer check
pointer		ob			#O output event buffer
pointer		ptr			#I state pointer
pointer		ib			#I/O input buffer
int		force

begin
  if (ib == 0) return
  call ear_proc(ptr, ib)
  ob = ib
end

#	Process lookup buffer
procedure	eblu_check (ob, ptr, ib, force) # buffer check
pointer		ob			#O output event buffer
pointer		ptr			#I state pointer
pointer		ib			#I/O input buffer
int		force

begin
  if (ib == 0) return
  call clu_proc(ptr, ib)
  ob = ib
end

#	Process print buffer if necessary
procedure	ebcp_check (ob, ptr, ib, force) #E
pointer		ob			#O output event buffer
pointer		ptr			#I state pointer
pointer		ib			#I/O input buffer
int		force

begin
  if (ib == 0) return
  call cp_proc(ptr, ib)
  ob = ib
end
