# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ebconvert.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) ebconvert.x -r1.10 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/27/96   mabbott	undid debugging changes
# 	12/27/96   mabbott	did  some debugging
# 	05/04/94   akeith	Got rid of DEBUG statements
# 	02/02/94   ericco	changed dangerous er_gptr() to safe er_getd() call
# 	12/06/92   ericco	added eof flag
# 	09/28/92   akeith	put in debug statements
# 	06/17/92   ericco	added INDEF check as double as well as integer value
# 	06/15/92   carolc	removed w flag indicating xy photon wsz
# 	05/07/91   ericco	date and time created 91/05/07 14:05:37 by ericco
# H-
# 
#

#	Revised: 12/27/96

#	EUV buffer convert operations

include <edata.h>
include "../er/ercol.h"
include	"ebuffer.h"
include	<dbg.h>

define	XC_INDEX	1
define	XO_INDEX	2
define	YC_INDEX	3
define	YO_INDEX	4
define	TIME_INDEX	5

#	Get conversion column information.
#	In particular, get the table pointer and time
#	column.
procedure	ed_convc (ed, name, tp, time) # get conversion data
pointer		ed		#I/O data
char		name[ARB]	#I column name
pointer		tp		#O table pointer
pointer		time		#O time column

long		cn, tn
pointer		tptr, tc, cols

begin
  call edgtc(ed, name, tn, cn)
  tptr = ED_TABLE_PTR(ed)
  tp = VEC_ELEMENT(tptr, tn)

  tc = VEC_ELEMENT(ED_TIMES(ed), tn)
  cols = ED_COLUMN(ed)
  time = VEC_ELEMENT(cols, tc)
end

#	Initialize a conversion buffer from a tdb record.
procedure	ex_read(dt, rec, ptr, lp, ed)	# initialize
pointer		dt		#I text database
int		rec		#I conversion record
pointer		ptr		#O conversion data buffer
pointer		lp		#I input buffer-like
pointer		ed		#I EUV data pointer

pointer	xcptr, xoptr, ycptr, yoptr
pointer	tp, time

begin
  call dtgptr(dt, rec, "XConstant", xcptr)
  call dtgptr(dt, rec, "XOffset", xoptr)
  call dtgptr(dt, rec, "YConstant", ycptr)
  call dtgptr(dt, rec, "YOffset", yoptr)
  call ed_convc(ed, Memc[xcptr], tp, time)
  call ex_open(ptr,
	       Memc[xcptr], Memc[xoptr],
	       Memc[ycptr], Memc[yoptr],
	       Memc[time], tp)
end

#	Initialize conversion buffer from ST Tables
procedure	ex_open (conv, xcn, xon, ycn, yon, tn, tp) # open
pointer		conv			#I convert data
char		xcn[ARB]		#I X constant name
char		xon[ARB]		#I X offset name
char		ycn[ARB]		#I Y constant name
char		yon[ARB]		#I Y offset name
char		tn[ARB]			#I time name
pointer		tp			#I table pointers

pointer		names
int		hi, lo
bool		flag

begin
  call ev_new(names, long(5))
  call eu_newstr (xcn, VEC_ELEMENT(names,XC_INDEX))
  call eu_newstr (xon, VEC_ELEMENT(names,XO_INDEX))
  call eu_newstr (ycn, VEC_ELEMENT(names,YC_INDEX))
  call eu_newstr (yon, VEC_ELEMENT(names,YO_INDEX))
  call eu_newstr (tn, VEC_ELEMENT(names,TIME_INDEX))

  call er_gopen(tp,
		VEC_ELEMENT(names,1), int(VEC_SIZE(names)),
		long(TIME_INDEX),
		conv)
  call ev_free_string(names)

  call er_gfirst(conv)
  # fix bug?
  hi = EC_HI_OFFSET
  lo = EC_LO_OFFSET
  call er_gcopy(conv, hi, lo)
  call er_gnext(conv, flag)
end

#	Release conversion resources
procedure	ex_close (conv)	# close
pointer		conv				#I convert data

begin
  call er_gclose(conv)
  conv = 0
end

#	Evaluate conversion parameters at a particular time
#	Since conversion parameters are a group, this simply
#	means evaluate a group at a particular time.  Data
#	is stored in the group's tmp fields.
procedure	ex_cnveval (cnv, time)	# eval convert at time
pointer		cnv			#I convert columns
double		time			#I evaluation time

begin
  call er_gdelim(cnv, time)
  call er_gcopy(cnv, EC_LO_OFFSET, EC_TMP_OFFSET)
end

#	Get the span of time that a conversion is valid for.
procedure	ex_cnvlim (cnv, tlo, thi, xc, xo, yc, yo) # report time limits
pointer		cnv			#I convert columns
double		tlo, thi		#O time limits
long		xc, xo, yc, yo		#O conversion factors

long		rlo, rhi
double		v
pointer		ec, tc

begin
  ec = VEC_ELEMENT(cnv, 1)
  tc = EC_TIME_CP(ec)

  call er_ghilo(cnv, tlo, thi, rlo, rhi)
  if (rlo == rhi) {
    tlo = -INDEFD
    thi = INDEFD
  } else {
    tlo =  Memd[EC_LO_DATA(tc)]
    thi =  Memd[EC_HI_DATA(tc)]
  }
  call er_getd(cnv, XC_INDEX, EC_TMP_OFFSET, v); xc = v
  call er_getd(cnv, XO_INDEX, EC_TMP_OFFSET, v); xo = v
  call er_getd(cnv, YC_INDEX, EC_TMP_OFFSET, v); yc = v
  call er_getd(cnv, YO_INDEX, EC_TMP_OFFSET, v); yo = v
end

#	Process a event buffer by converting all wsz events
#	into xy events.
procedure	eb_convert (conv, eb)
pointer		conv				#I convert data
pointer		eb				#I/O events

long	xi, yi, wi, si, zi
long	xc, xo, yc, yo
double	thi
long	iw, is, iz
long	sum
double	dw
long	ti
double	tlo
long	index
pointer	ptr
double	time
short	x, y
int	firsttime

begin
  xi = EBE_X(eb)
  yi = EBE_Y(eb)
  wi = EBE_W(eb)
  si = EBE_S(eb)
  zi = EBE_Z(eb)
  ti = EBE_TIME(eb)
  firsttime = 1
  if (wi == 0 || si == 0 || zi == 0) return

  EB_FROMFIRST(index, eb) {
    ptr = EB_POINTER(eb, index)
    dw = EB_VALUE(ptr, wi)
    if (dw == INDEFD) next	# must be xy event
    iw = dw
    if (iw == INDEFI) next	# must be xy event
    time = EB_VALUE(ptr, ti)
    if (firsttime == 1 || tlo < time || time > thi) {
      firsttime = 0
      call ex_cnveval(conv, time)
      call ex_cnvlim(conv, tlo, thi, xc, xo, yc, yo)
    }

    iw = dw
    is = EB_VALUE(ptr, si)
    iz = EB_VALUE(ptr, zi)

    # Instrument wsz to xy, from PD-632-590
    sum = long(iw) + long(is) + 2 * long(iz)
    if (sum == 0) {
      x = 0
      y = 0
    } else {
      x = short(xc * iw / sum + xo + 1) / 2
      y = short(yc * is / sum + yo + 1) / 2
    }
#   EB_VALUE(ptr, wi) = INDEFD
    EB_VALUE(ptr, xi) = x
    EB_VALUE(ptr, yi) = y
  }
end
