# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ebcorr.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) ebcorr.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/01/96   ericco	bullet proofed array bounds checking
# 	05/04/94   akeith	Got rid of DEBUG statements
# 	09/28/92   akeith	put in debug statements
# 	10/28/91   ericco	pixel weighting was reversed
# 	05/07/91   ericco	date and time created 91/05/07 14:05:42 by ericco
# H-
# 
#

#	Revised: 2/1/96

#	EUV correction operations

include	<dbg.h>

define	A2	Memd[($1)+($2)-1+(($3)-1)*3]
define	FS	A2(fp,$1,$2, len)

#	These routines only really need two lines of image data.
#	I wasn't sure how rounding works in Fortran, so I just
#	got the line above and the line below, to be sure.

#	This routine takes a correction image position as input
#	but returns the correction as the result.  It is a simple
#	bi-linear fit to the point.

procedure	eb_corr (xs, ys, fp, iy, dx, dy, df, len) # correct position
double		xs[len,3]			#I x lines
double		ys[len,3]			#I y lines
pointer		fp				#I f lines
long		iy				#I y line index
double		dx, dy, df			#I/O position
int		len				#I array width

long		lx
long		ly
double		wx, wy

begin
  lx = dx
  if (lx > dx) lx = lx - 1
  if (lx < 1) {lx = 1; wx = 0}
  else if (lx >= len) {lx = len - 1; wx = 1}
  else wx = dx - lx

  if (iy > dy) {
    wy = dy - (iy - 1)
    ly = 1
  } else {
    wy = dy - iy
    ly = 2
  }
  if (wy > 1) wy = 1
  else if (wy < 0) wy = 0

  dy = ((ys[lx+1,ly  ] - ys[lx,ly  ]) * wx + ys[lx,ly  ]) * (1 - wy) +
       ((ys[lx+1,ly+1] - ys[lx,ly+1]) * wx + ys[lx,ly+1]) * wy

  dx = ((xs[lx+1,ly  ] - xs[lx,ly  ]) * wx + xs[lx,ly  ]) * (1 - wy) +
       ((xs[lx+1,ly+1] - xs[lx,ly+1]) * wx + xs[lx,ly+1]) * wy

  if (fp != NULL) {
    df = ((FS(lx+1,ly  ) - FS(lx,ly  )) * wx + FS(lx,ly  )) * wy +
         ((FS(lx+1,ly+1) - FS(lx,ly+1)) * wx + FS(lx,ly+1)) * (1 - wy)
  }
end
