# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ebctrans.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) ebctrans.x -r1.4 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/04/94   akeith	Got rid of DEBUG statements
# 	09/28/92   akeith	put in debug statements
# 	05/07/91   ericco	date and time created 91/05/07 14:05:48 by ericco
# H-
# 
#

#	Revised: 5/4/94

#	EUV buffer scale operations

include	<dbg.h>
include	<edata.h>
include	"ebuffer.h"

#	Apply a 1d MWCS transformation to an event buffer
procedure	eb_ctran1 (ctrans, eb, in, out) # transform buffer
pointer		ctrans				#I transformation
pointer		eb				#I input events
int		in				#I field index
int		out				#O field index

int		index

begin
  if (EB_DIRECT(eb)) {
    do index = 1, EBG_USED(eb) {
      call mw_ctrand(ctrans,
		     EB_DOUBLE(eb, index, in),
		     EB_DOUBLE(eb, index, out), 1)
    }
  } else {
    do index = 1, EBG_USED(eb) {
      call mw_ctrand(ctrans,
		     EBI_DOUBLE(eb, index, in),
		     EBI_DOUBLE(eb, index, out), 1)
    }
  }
end

#	Apply a 2d MWCS transformation to a buffer
procedure	eb_ctran2 (ctrans, eb, in1, in2, out1, out2)
pointer		ctrans				#I transformation
pointer		eb				#I input events
int		in1,in2				#I field index
int		out1, out2			#O field index

int		index
double		in[2], out[2]

begin
  if (EB_DIRECT(eb)) {
    do index = 1, EBG_USED(eb) {
      in[1] = EB_DOUBLE(eb, index, in1)
      in[2] = EB_DOUBLE(eb, index, in2)
      call mw_ctrand(ctrans, in, out, 2)
      EB_DOUBLE(eb, index, out1) = out[1]
      EB_DOUBLE(eb, index, out2) = out[2]
    }
  } else {
    do index = 1, EBG_USED(eb) {
      in[1] = EBI_DOUBLE(eb, index, in1)
      in[2] = EBI_DOUBLE(eb, index, in2)
      call mw_ctrand(ctrans, in, out, 2)
      EBI_DOUBLE(eb, index, out1) = out[1]
      EBI_DOUBLE(eb, index, out2) = out[2]
    }
  }
end
