# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ebmask.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) ebmask.x -r1.8 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/04/94   akeith	Got rid of DEBUG statements
# 	12/10/92   ericco	fixed empty input buffer condition
# 	09/28/92   akeith	put in debug statements
# 	07/11/92   ericco	added check for INDEF inputs
# 	10/28/91   ericco	fixed "out" mask buffer assignment
# 	05/07/91   ericco	date and time created 91/05/07 14:05:53 by ericco
# H-
# 
#

#	Revised: 5/4/94

#	EUV buffer mask operations

include	<dbg.h>
include <edata.h>
include "ebuffer.h"

#	Apply a 2D filter mask to a buffer.  The mask is a
#	simple limit mask.  Events are copied from the input
#	buffer to the appropriate output buffer.
procedure	eb_mask (mask, eb, xi, yi, ebin, ebout)
pointer		mask				#I mask data
pointer		eb				#I input events
int		xi, yi				#I x and y offsets
pointer		ebin				#O events in mask
pointer		ebout				#O events not in mask

long		index
int		lenin, lenout
bool		dirp
pointer		ptr
long		lx, ly, truth
int		usedin, usedout

pointer		bout, bin
double		dx, dy

begin
  dirp = EB_DIRECT(eb)
  if (ebin != 0) {
    bout = 0
    call em_gbuf(mask, ebin)
    bin = ebin
  } else if (ebout != 0) {
    bin = 0
    call em_gbuf(mask, ebout)
    bout = ebout
  } else return	# nothing to do!

  if (bin != 0) {
    lenin = EBG_LENGTH(bin)
    usedin = EBG_USED(bin)
  } else {
    lenin = 0
    usedin = 0
  }
  if (bout != 0) {
    lenout = EBG_LENGTH(bout)
    usedout = EBG_USED(bout)
  } else {
    lenout = 0
    usedout = 0
  }
  EB_FROMLAST(index, eb) {
    if (dirp) {ptr = EB_POINTER(eb,index)} else {ptr = EBI_POINTER(eb,index)}
    dx = EB_VALUE(ptr, xi)
    dy = EB_VALUE(ptr, yi)
    if (dx == INDEFD || dy == INDEFD) {
      truth = 0
    } else {
      lx = EB_VALUE(ptr, xi)
      ly = EB_VALUE(ptr, yi)
      call em_check(mask, lx, ly, truth, 1)
    }
    if (truth != 0) {				# out buffer
      if (usedin < lenin) {
	usedin = usedin + 1
#	EBI_POINTER(ebin,usedin) = ptr
	call eb_copye (eb, index, bin, usedin)
      } else if (bin != 0) {
	break
      }
    } else {					# in buffer
      if (usedout < lenout) {
	usedout = usedout + 1
#	EBI_POINTER(ebout,usedout) = ptr
	call eb_copye (eb, index, bout, usedout)
      } else if (bout != 0) {
	break
      }
    }
  }
  EBG_USED(eb) = index
  if (ebin != 0) {
    if (EBG_LENGTH(ebin) == 0) ebin = 0
    EBG_USED(bin) = usedin
    if (usedin == 0) ebin = 0
  }
  if (ebout != 0) {
    if (EBG_LENGTH(ebout) == 0) ebout = 0
    EBG_USED(bout) = usedout
    if (usedout == 0) ebout = 0
  }
end
