# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ebtime.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) ebtime.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/04/94   akeith	Got rid of DEBUG statements
# 	09/28/92   akeith	put in debug statements
# 	10/28/91   ericco	clear unused time filter buffers
# 	05/07/91   ericco	date and time created 91/05/07 14:06:05 by ericco
# H-
# 
#

#	Revised: 5/4/94

#	EUV buffer time operations

include	<dbg.h>
include	<edata.h>
include	"ebuffer.h"

#	Apply a time filter to an event buffer.
#	Events are copied to the appropriate output
#	event buffer.
procedure	eb_time (time, eb, ti, ebin, ebout)
pointer		time				#I time data
pointer		eb				#I input events
int		ti				#I time offset
pointer		ebin				#O events in time
pointer		ebout				#O events not in time

long		index
int		lenin, lenout
bool		dirp
pointer		ptr
long		truth
int		usedin, usedout

pointer		bout, bin

begin
  dirp = EB_DIRECT(eb)
  if (ebin != 0) {
    bout = 0
    call et_gbuf(time, ebin)
    bin = ebin
  } else if (ebout != 0) {
    bin = 0
    call et_gbuf(time, ebout)
    bout = ebout
  } else return	# nothing to do!

  if (bin != 0) {
    lenin = EBG_LENGTH(bin)
    usedin = EBG_USED(bin)
  } else {
    lenin = 0
    usedin = 0
  }
  if (bout != 0) {
    lenout = EBG_LENGTH(bout)
    usedout = EBG_USED(bout)
  } else {
    lenout = 0
    usedout = 0
  }
  EB_FROMLAST(index, eb) {
    if (dirp) {ptr = EB_POINTER(eb,index)} else {ptr = EBI_POINTER(eb,index)}
    call et_check(time, EB_VALUE(ptr, ti), truth)
    if (truth != 0) {				# out buffer
      if (usedin < lenin) {
	usedin = usedin + 1
#	EBI_POINTER(bin,usedin) = ptr
	call eb_copye (eb, index, bin, usedin)
      } else if (bin != 0) {
	break
      }
    } else {					# in buffer
      if (usedout < lenout) {
	usedout = usedout + 1
#	EBI_POINTER(bout,usedout) = ptr
	call eb_copye (eb, index, bout, usedout)
      } else if (bout != 0) {
	break
      }
    }
  }
  EBG_USED(eb) = index
  if (ebin != 0) {
    if (EBG_LENGTH(ebin) == 0) ebin = 0
    if (usedin == 0) ebin = 0
    EBG_USED(bin) = usedin
  }
  if (ebout != 0) {
    if (EBG_LENGTH(ebout) == 0) ebout = 0
    if (usedout == 0) ebout = 0
    EBG_USED(bin) = usedout
  }
end
