# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  edcorr.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) edcorr.x -r1.4 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/28/92   akeith	put in debug statements
# 	07/17/91   ericco	modified malloc/mfree calls.
# 	05/07/91   ericco	date and time created 91/05/07 14:07:08 by ericco
# H-
# 
#

#	Revised: 9/28/92

include	<edata.h>
include	<dbg.h>

#	Release correction information held in the
#	EUV data structure.  This is the geotrans
#	type map information.

procedure	ed_fr_corr(correction)		# release correction

pointer		correction	#I correction data

int		index, len

begin

DEBUG(
	call dbg_printf("ed_fr_corr,func", "ed_fr_corr()\n")
)
	len = VEC_SIZE(correction)

	do index = 1, len {
		if (VEC_ELEMENT(correction, index) != 0) {
			call gsfree (VEC_ELEMENT(correction, index))
		}
	}

call ev_free(correction)

end

#	Read correction information.
#	This reads output from geotrans.

procedure	ed_rd_corr(dt, record, correction) # load correction

pointer		dt				#I text database
char		record[ARB]			#I record name
pointer		correction			#O correction data

int	rec, dtlocate()
int	ncoeff, dtgeti()
pointer	sx1, sy1, sx2, sy2
pointer	xptr, yptr
int	i
pointer	sp

begin

DEBUG(
	call dbg_printf("ed_rd_corr,func", "ed_rd_corr() record = %s\n")
	call pargstr(record)
)
	call smark (sp)
	rec = dtlocate (dt, record)

#    get the transformation parameters

	ncoeff = dtgeti (dt, rec, "surface1")
	call eu_malloc (xptr, ncoeff, TY_REAL)
	call eu_malloc (yptr, ncoeff, TY_REAL)

	do i = 1, ncoeff {
		call dtscan (dt)
		call gargr (Memr[xptr+i-1])
		call gargr (Memr[yptr+i-1])
	}

	call gsrestore (sx1, Memr[xptr])
	call gsrestore (sy1, Memr[yptr])

	ncoeff = dtgeti (dt, rec, "surface2")
	if (ncoeff == 0) {
		sx2 = NULL
		sy2 = NULL
	} else {

		call realloc (xptr, ncoeff, TY_REAL)
		call realloc (yptr, ncoeff, TY_REAL)

		do i = 1, ncoeff {
			call dtscan (dt)
			call gargr (Memr[xptr+i-1])
			call gargr (Memr[yptr+i-1])
		}

		call gsrestore (sx2, Memr[xptr])
		call gsrestore (sy2, Memr[yptr])
	}
  
	call eu_mfree(xptr, TY_REAL)
	call eu_mfree(yptr, TY_REAL)

	call ev_new(correction, long(4))
	VEC_ELEMENT(correction,1) = sx1
	VEC_ELEMENT(correction,2) = sy1
	VEC_ELEMENT(correction,3) = sx2
	VEC_ELEMENT(correction,4) = sy2
	call sfree (sp)

end

