# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  edoasp.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) edoasp.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/28/92   akeith	put in debug statements
# 	10/29/91   ericco	added function documentation
# 	07/17/91   ericco	fixed memory management.
# 	05/07/91   ericco	date and time created 91/05/07 14:07:23 by ericco
# H-
# 
#

#	Revised: 9/28/92

include	<eerror.h>
include <edata.h>
include <dbg.h>

#	Get Aspect column information.

procedure	edaspc (ed, field, ptr, tp, time) # get aspect columns

pointer		ed		#I/O data
int		field		#I field index
pointer		ptr		#O column pointer
pointer		tp		#O table pointer
pointer		time		#O associated time column pointer

pointer		spc_col
pointer		col
long		realcol, tn
pointer		tbl, tptr

begin

DEBUG(
	call dbg_printf("edaspc,func", "edaspc()\n")
)

	spc_col = ED_SPC_COL(ed)
	col = ED_COLUMN(ed)
	realcol = VEC_ELEMENT(spc_col, field)
	tbl = ED_TBL_REF(ed)
	tptr = ED_TABLE_PTR(ed)
	ptr = VEC_ELEMENT(col, realcol)
	tn = VEC_ELEMENT(tbl, realcol)
	tp = VEC_ELEMENT(tptr, tn)
	time = VEC_ELEMENT(ED_TIMES(ed), tn)

end


#	Release aspect resources

procedure	ed_casp (ed)	# close all aspect columns
pointer		ed		#I/O EUV data

begin

DEBUG(
	call dbg_printf("ed_casp,func", "ed_casp()\n")
)
  if (ED_ASPECT(ed) != 0) {
    call er_aspclose(ED_ASPECT(ed))
    ED_ASPECT(ed) = 0
  }

end


#	Open aspect ST Table information

procedure	edoasp (ed)	# open photon information

pointer		ed		#I/O data

pointer		time, time1
pointer		tp, tp1
pointer		asp

begin

DEBUG(
	call dbg_printf("edoasp,func", "edoasp()\n")
)

  call ev_new(asp, long(5))
  call edaspc (ed, ED_ASP_W_ID, VEC_ELEMENT(asp, 1), tp, time)
  call edaspc (ed, ED_ASP_X_ID, VEC_ELEMENT(asp, 2), tp1, time1)
  if (tp1 != tp || time1 != time) call eerror(EES_GROUP)
  call edaspc (ed, ED_ASP_Y_ID, VEC_ELEMENT(asp, 3), tp1, time1)
  if (tp1 != tp || time1 != time) call eerror(EES_GROUP)
  call edaspc (ed, ED_ASP_Z_ID, VEC_ELEMENT(asp, 4), tp1, time1)
  if (tp1 != tp || time1 != time) call eerror(EES_GROUP)
  call edaspc (ed, ED_ASP_T_ID, VEC_ELEMENT(asp, 5), tp1, time1)
  if (tp1 != tp || time1 != time) call eerror(EES_GROUP)

  call er_aspopen(tp, VEC_ELEMENT(asp,1), VEC_SIZE(asp), 5,
		  ED_ASPECT(ed))
  call er_aspsetw (ED_ASPECT(ed), 1)
  call er_aspsetx (ED_ASPECT(ed), 2)
  call er_aspsety (ED_ASPECT(ed), 3)
  call er_aspsetz (ED_ASPECT(ed), 4)
  call er_aspsett (ED_ASPECT(ed), 5)
  call ev_free(asp)
  call er_aspfirst(ED_ASPECT(ed))

end

#	Get the currect aspect quaternion
procedure	edacur(ed, q)	# get aspect quaternion
pointer		ed		#I euv data
double		q[4]		#O current quaternion

begin
DEBUG(
	call dbg_printf("edacur,fun", "edacur()\n")
)
  call er_aspcur(ED_ASPECT(ed), q)
end

#	Get the next aspect position
procedure	edanxt(ed, flag) # next aspect
pointer		ed		#I euv data
bool		flag		#O end of column flag

begin
DEBUG(
	call dbg_printf("edanxt,fun", "edanxt()\n")
)
  call er_aspnext(ED_ASPECT(ed), flag)
end
