# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  edopht.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) edopht.x -r1.6 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/29/94   akeith	Now supports no wsz columns in special list
# 	05/12/94   akeith	took out debug statements
# 	09/28/92   akeith	put in debug statements
# 	07/17/91   ericco	fixed memory management
# 	05/07/91   ericco	date and time created 91/05/07 14:07:29 by ericco
# H-
# 
#

#	Revised: 7/29/94

include	<eerror.h>
include <edata.h>
include <dbg.h>

#	Get photon column information.

procedure	edphtc (ed, field, col_name_ptr, tp, time)

pointer		ed		#I/O data
int		field		#I field index
pointer		col_name_ptr	#O pointer to column name
pointer		tp		#O ptr to GT_ of particular table
pointer		time		#O associated time column pointer

pointer		spc_col		# ptr to array of special column indx's
pointer		col		# ptr to column names
pointer		tbl		# ptr to list of tbl numbers (indx by spcl clmn indx)
pointer		tptr		# ptr to list of gen. tbl. strct's
long		realcol		# spcl clmn index
long		tn		# indx to tble containing the spcl clmn

begin

	tp = NULL
	time = NULL
	col_name_ptr = NULL

	spc_col = ED_SPC_COL(ed)
	realcol = VEC_ELEMENT(spc_col, field)
	if(realcol == 0) return

	col = ED_COLUMN(ed)
	tbl = ED_TBL_REF(ed)
	tptr = ED_TABLE_PTR(ed)

	col_name_ptr = VEC_ELEMENT(col, realcol)
	tn = VEC_ELEMENT(tbl, realcol)
	tp = VEC_ELEMENT(tptr, tn)

end

#	Release ST Table photon column resources

procedure	ed_cpht (ed)	# close all photon columns

pointer		ed		#I/O EUV data

begin
  call ebp_close(ED_PHTBUF(ed))
end

#	Open photon column information

procedure	edopht (ed)	# open photon information
pointer		ed		#I/O data

pointer		time
pointer		tp, tp1
pointer		pht

begin

#  Within the pht array, he stores a pointer to column names
#    and if the initial pointer to the general table structure
#    is not the same, we have a problem. So basically, each of
#    these special columns better be in the same table.
#  So he gets a list of seven special column names, all residing
#    within the same table.

	call ev_new(pht, long(7))

	call edphtc (ed, ED_PHT_X_ID, VEC_ELEMENT(pht, 1), tp, time)

	call edphtc (ed, ED_PHT_Y_ID, VEC_ELEMENT(pht, 2), tp1, time)
	if (tp1 != tp && tp1 != NULL) call eerror(EES_GROUP)

	call edphtc (ed, ED_PHT_W_ID, VEC_ELEMENT(pht, 3), tp1, time)
	if (tp1 != tp && tp1 != NULL) call eerror(EES_GROUP)

	call edphtc (ed, ED_PHT_S_ID, VEC_ELEMENT(pht, 4), tp1, time)
	if (tp1 != tp && tp1 != NULL) call eerror(EES_GROUP)

	call edphtc (ed, ED_PHT_Z_ID, VEC_ELEMENT(pht, 5), tp1, time)
	if (tp1 != tp && tp1 != NULL) call eerror(EES_GROUP)

	call edphtc (ed, ED_PHT_T_ID, VEC_ELEMENT(pht, 6), tp1, time)
	if (tp1 != tp && tp1 != NULL) call eerror(EES_GROUP)

	call edphtc (ed, ED_PHT_DET_ID, VEC_ELEMENT(pht, 7), tp1, time)
	if (tp1 != tp && tp1 != NULL) call eerror(EES_GROUP)

  # the order of elements in the name list is very important

	call ebp_open(ED_PHTBUF(ed), tp, pht, long(256))
	call ev_free(pht)

end
