# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  edotab.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) edotab.x -r1.8 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/27/96   mabbott	removed unused variables
# 	12/27/96   mabbott	changes to support parameter overrides
# 	05/12/94   akeith	took out debug statements
# 	09/28/92   akeith	put in debug statements
# 	10/29/91   ericco	save number of rows in table
# 	07/17/91   ericco	added QPOE tables as well as ST Tables
# 	05/07/91   ericco	date and time created 91/05/07 14:07:35 by ericco
# H-
# 
#

#	Revised: 12/27/96

include <qpioset.h>
include	<edata.h>
include	<dbg.h>

#	Instead of insisting on ST Tables, use either ST Tables
#	or a QPOE file.

#	Release ST Tables used

procedure	ed_ctab (ed)	# close all tables

pointer		ed		#I/O EUV data

long		i, len
pointer		tptr

long		type
pointer		tp

begin
  
	tptr = ED_TABLE_PTR(ed)
	len = VEC_SIZE(tptr)

	do i = 1, len {

		tp = VEC_ELEMENT(tptr, i)
		if (tp == 0) next

		type = GT_TYPE(tp)
		switch (GT_TYPE(tp)) {

		  case GT_BAD :
		  case GT_STBT :
			call tbtclo (GT_PTR(tp))
		  case GT_QPOE :
			if (GT_QPBUF(tp) != 0) call eu_mfree(GT_QPBUF(tp), TY_SHORT)
			if (GT_QPIO(tp) != 0) call qpio_close(GT_QPIO(tp))
			call qp_close(GT_PTR(tp))

		}

		call ev_free(tp)
		VEC_ELEMENT(tptr, i) = 0

	}

end

#
#	Open all required ST Tables and for each table allocate the
#	The pointer to the structure is stored in ED_TABLE_PTR.
#

procedure	ed_otab (ed, path)	# open all tables
pointer		ed		#I/O EUV data
char		path[ARB]

pointer		tbtopn()
long		i, len
pointer		tnames
pointer		tptr
pointer		tref
long		tblnum
pointer		sp, tmp
int		tbtacc()
int		qp_access()
pointer		qp_open()
pointer		qpio_open()

pointer		tp
int		qpio_stati()
int		rows
int		qp_lenf()

begin

	call smark(sp)

	tnames = ED_TABLES(ed)		# pointer to list of table names.
	tptr = ED_TABLE_PTR(ed)		# allocated and cleared.
	tref = ED_TBL_REF(ed)		# pointer to list of table numbers.
	len = VEC_SIZE(tref)

	do i = 1, len {

		tblnum = VEC_ELEMENT(tref, i)
		if (VEC_ELEMENT(tptr, tblnum) != 0) next

		# Store the GT_ structure for each table in the list held by 
		# ED_TABLE_PTR.

		call ev_new_clear(tp, GT_SIZE)
		VEC_ELEMENT(tptr, tblnum) = tp

		# Prepend the ObsPath unless the file path is absolute or in the
		# current directory.
		if (VEC_STRING(tnames, tblnum) != '/' &&
		    VEC_STRING(tnames, tblnum) != '.')
		  call eu_file(path, VEC_STRING(tnames, tblnum), tmp)
		else call eu_snewstr(VEC_STRING(tnames, tblnum), tmp)

		# if the file is a directory, tbtacc can sometimes fail in
		# strange way, but the result is the same - CEP dies.

		if (tbtacc(Memc[tmp], READ_ONLY) == YES) {

			GT_PTR(tp) = tbtopn (Memc[tmp], READ_ONLY, 0)
			GT_TYPE(tp) = GT_STBT
			call tbtrows(GT_PTR(tp), rows)
			GT_NROWS(tp) = rows

		} else if (qp_access(Memc[tmp], READ_ONLY) == YES) {

			GT_PTR(tp) = qp_open (Memc[tmp], READ_ONLY, 0)
			GT_TYPE(tp) = GT_QPOE

	# it would be nice to be able to change "events"

			GT_QPIO(tp) = qpio_open(GT_PTR(tp), "events", READ_ONLY)
			GT_INDEX(tp) = 0
			GT_QPLEN(tp) = qpio_stati(GT_QPIO(tp), QPIO_EVENTLEN)
			call eu_malloc(GT_QPBUF(tp), GT_QPLEN(tp), TY_SHORT)
			GT_EOF(tp) = 0
			GT_NROWS(tp) = qp_lenf(GT_PTR(tp), "events")

		} else {
			GT_TYPE(tp) = GT_BAD
		}
	}

	call sfree(sp)

end
