#	This file generated by dsd2spp
#	Last revised: 4/4/95

#	Version: %W% %G% UCB CEA EGO

include "dd.h"
include <tbset.h>


#	 Structure DD operations

#	Help allocate a new dd

procedure dd_malloc (dd) #I
pointer	dd                                  #O new structure

begin
	call malloc(dd, DD_LEN, DD_TYP)
end

#	Stack allocate a new dd

procedure dd_salloc (dd) #I
pointer	dd                                  #O new structure

begin
	call salloc(dd, DD_LEN, DD_TYP)
end

#	Heap deallocate dd

procedure dd_free (dd) #I
pointer	dd		#I old structure

begin
	call mfree(dd, DD_TYP)
end

#	Read a dd from a euv table
#	Assumes that field names are the column names
#	rows is ARB or max rows on input
#	rows is number of rows on output
procedure et_dd_read(et, array, rows) #E
pointer		et		#I euv table
pointer		array		#B results
int		rows		#B number results

pointer		tb
pointer		sp
pointer		buf
int		cnt
bool		nullp

int		row
pointer		ptr

begin
  call et_table(et, tb)
  if (tb == 0) {
    rows = 0
    return
  }

  call smark(sp)
  call salloc(buf, DD_LEN, TY_LONG)
  call tbcfnd(tb, "detector", Meml[buf+0], 1)
  if (Meml[buf+0] == NULL) call error(100,"Cannot open column detector")
  call tbcfnd(tb, "psf", Meml[buf+2], 1)
  if (Meml[buf+2] == NULL) call error(100,"Cannot open column psf")
  call tbcfnd(tb, "boresight_w", Meml[buf+4], 1)
  if (Meml[buf+4] == NULL) call error(100,"Cannot open column boresight_w")
  call tbcfnd(tb, "boresight_x", Meml[buf+5], 1)
  if (Meml[buf+5] == NULL) call error(100,"Cannot open column boresight_x")
  call tbcfnd(tb, "boresight_y", Meml[buf+6], 1)
  if (Meml[buf+6] == NULL) call error(100,"Cannot open column boresight_y")
  call tbcfnd(tb, "boresight_z", Meml[buf+7], 1)
  if (Meml[buf+7] == NULL) call error(100,"Cannot open column boresight_z")

  row = 0
  cnt = 0
  repeat {
    call et_next(et, row)
    if (row == EOF) break
    if (rows == ARB) {
      if (cnt == 0) {
	call malloc(array, cnt+1, TY_LONG)
      } else {
	call realloc(array, cnt+1, TY_LONG)
      }
    } else if (cnt >= rows) break
    cnt = cnt + 1

    call dd_malloc(ptr)
    call tbrgti (tb, Meml[buf+0], DD_DETECTOR(ptr), nullp, 1, row)
    if (nullp)	DD_DETECTOR(ptr) = INDEFI
    call tbrgti (tb, Meml[buf+2], DD_PSF(ptr), nullp, 1, row)
    if (nullp)	DD_PSF(ptr) = INDEFI
    call tbrgtd (tb, Meml[buf+4], DD_BORESIGHT_W(ptr), nullp, 1, row)
    if (nullp)	DD_BORESIGHT_W(ptr) = INDEFD
    call tbrgtd (tb, Meml[buf+5], DD_BORESIGHT_X(ptr), nullp, 1, row)
    if (nullp)	DD_BORESIGHT_X(ptr) = INDEFD
    call tbrgtd (tb, Meml[buf+6], DD_BORESIGHT_Y(ptr), nullp, 1, row)
    if (nullp)	DD_BORESIGHT_Y(ptr) = INDEFD
    call tbrgtd (tb, Meml[buf+7], DD_BORESIGHT_Z(ptr), nullp, 1, row)
    if (nullp)	DD_BORESIGHT_Z(ptr) = INDEFD
    Meml[array+cnt-1] = ptr
  }

  rows = cnt
  call sfree(sp)
end

