# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eaoops.x
# 	Author	:  ericco
# 	Date	:  04/29/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) eaoops.x -r1.2 04/29/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/29/92   ericco	date and time created 92/04/29 17:39:05 by ericco
# H-
# 
#

include	"ea.h"
include	"eao.h"

#	Release effective area structure resources
procedure	eao_close(eao)
pointer		eao			#I structure pointer

begin
  if (eao == 0) return

  if (EAO_LENGTH(eao) != 0) {
    call mfree(EAO_WAVELENGTH(eao), TY_REAL)
    call mfree(EAO_EFFECTIVE_AREA(eao), TY_REAL)
  }

  call eao_free(eao)
  eao = 0
end

#	Read an eao structure from an ST effective area
#	table.
procedure	et_eao_read(et, array, rows)
pointer		et			#I table pointer
pointer		array			#O resulting orders
int		rows			#O number of orders

int		cnt

int		row
pointer		ptr
pointer		ea, eas
int		len
int		i
int		offset
int		k
int		curorder

begin

  # read in all orders
  len = ARB
  call et_ea_read(et, eas, len)
  cnt = 0
  do i = 1, len {
    curorder = - EA_ORDER(Memi[eas+i-1])
    if (curorder > cnt) cnt = curorder
  }

  # Allocate space for resulting orders
  if (rows != ARB) {
    if (cnt > rows) cnt = rows
  } else if (cnt > 0) {
    call malloc(array, cnt, TY_LONG)
  }
  rows = cnt
  if (cnt == 0) return

  offset = 0
  do i = 1, cnt {
    call eao_malloc(ptr)
    Meml[array+i-1] = ptr

    for (row = 0; offset+row < len ; row = row + 1) {
      if (i < - EA_ORDER(Memi[eas+offset+row])) break
    }

    EAO_LENGTH(ptr) = row
    call malloc(EAO_WAVELENGTH(ptr), row, TY_REAL)
    call malloc(EAO_EFFECTIVE_AREA(ptr), row, TY_REAL)
    do k = 1, row {
      ea = Meml[eas+offset+k-1]
      Memr[EAO_WAVELENGTH(ptr)+k-1] = EA_WAVELENGTH(ea) * i
      Memr[EAO_EFFECTIVE_AREA(ptr)+k-1] = EA_EFFAREA(ea)
      call ea_free(ea)
    }
    Meml[array+i-1] = ptr
    offset = offset + row
  }

  call mfree(eas, TY_LONG)
end
