# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eddpsf.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) eddpsf.x -r1.1 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/30/92   ericco	date and time created 92/04/30 00:26:51 by ericco
# H-
# 
#

include	"dd.h"
include "pd.h"

#	Returns a pair of fwhms and their ratio for a set
#	set of wavelengths.
procedure	edd_psf(edd, wl, fwhm1, fwhm2, ratio, length)
pointer		edd			#I detector description
pointer		wl			#O wavelength values
pointer		fwhm1			#O first fwhm value at wl
pointer		fwhm2			#O second fwhm value at wl
pointer		ratio			#O ratio of first/second at wl
int		length			#O length of arrays

pointer		psf

begin
  wl = 0
  fwhm1 = 0
  fwhm2 = 0
  ratio = 0
  length = 0
  if (edd == 0) return
  psf = DD_PSF(edd)
  if (psf == 0) return
  wl = PD_WAVELENGTHS(psf)
  fwhm1 = PD_FWHM1(psf)
  fwhm2 = PD_FWHM2(psf)
  ratio = PD_RATIO(psf)
  length = PD_LENGTH(psf)
end
