# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  pdops.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) pdops.x -r1.1 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/30/92   ericco	date and time created 92/04/30 00:26:56 by ericco
# H-
# 
#

include "pd.h"
include	"psf.h"

#	Release detector psf resources
procedure	pd_close(pd)
pointer		pd		#I detector psf

begin
	if (pd == 0) return

	if (PD_LENGTH(pd) != 0) {
		call mfree(PD_WAVELENGTHS(pd), TY_REAL)
		call mfree(PD_FWHM1(pd), TY_REAL)
		call mfree(PD_FWHM2(pd), TY_REAL)
		call mfree(PD_RATIO(pd), TY_REAL)
	}

	call pd_free(pd)
	pd = 0
end

#	Read detector psf from a table
procedure	et_pd_get(et, pd)
pointer		et			#I table
pointer		pd			#O detector psf

pointer		psfs
int		len

int		i
pointer		psf

begin
	pd = 0
	if (et == 0) return

	len = ARB
	call et_psf_read(et, psfs, len)
	if (psfs == 0 || len == 0) return

	call pd_malloc(pd)
	PD_LENGTH(pd) = len
	call malloc(PD_WAVELENGTHS(pd), len, TY_REAL)
	call malloc(PD_FWHM1(pd), len, TY_REAL)
	call malloc(PD_FWHM2(pd), len, TY_REAL)
	call malloc(PD_RATIO(pd), len, TY_REAL)

	do i = 1, len {
		psf = Meml[psfs+i-1]
		Memr[PD_WAVELENGTHS(pd)+i-1] = PSF_WAVELENGTH(psf)
		Memr[PD_FWHM1(pd)+i-1] = PSF_FWHM1(psf)
		Memr[PD_FWHM2(pd)+i-1] = PSF_FWHM2(psf)
		Memr[PD_RATIO(pd)+i-1] = PSF_RATIO(psf)
		call psf_free(psf)
	}
	call mfree(psfs, TY_LONG)
end
