#	This file generated by dsd2spp
#	Last revised: 4/4/95

#	Version: %W% %G% UCB CEA EGO

include "psf.h"
include <tbset.h>


#	 Structure PSF operations

#	Help allocate a new psf

procedure psf_malloc (psf) #I
pointer	psf                                 #O new structure

begin
	call malloc(psf, PSF_LEN, PSF_TYP)
end

#	Stack allocate a new psf

procedure psf_salloc (psf) #I
pointer	psf                                 #O new structure

begin
	call salloc(psf, PSF_LEN, PSF_TYP)
end

#	Heap deallocate psf

procedure psf_free (psf) #I
pointer	psf		#I old structure

begin
	call mfree(psf, PSF_TYP)
end

#	Read a psf from a euv table
#	Assumes that field names are the column names
#	rows is ARB or max rows on input
#	rows is number of rows on output
procedure et_psf_read(et, array, rows) #E
pointer		et		#I euv table
pointer		array		#B results
int		rows		#B number results

pointer		tb
pointer		sp
pointer		buf
int		cnt
bool		nullp

int		row
pointer		ptr

begin
  call et_table(et, tb)
  if (tb == 0) {
    rows = 0
    return
  }

  call smark(sp)
  call salloc(buf, PSF_LEN, TY_LONG)
  call tbcfnd(tb, "wavelength", Meml[buf+0], 1)
  if (Meml[buf+0] == NULL) call error(100,"Cannot open column wavelength")
  call tbcfnd(tb, "fwhm1", Meml[buf+1], 1)
  if (Meml[buf+1] == NULL) call error(100,"Cannot open column fwhm1")
  call tbcfnd(tb, "fwhm2", Meml[buf+2], 1)
  if (Meml[buf+2] == NULL) call error(100,"Cannot open column fwhm2")
  call tbcfnd(tb, "ratio", Meml[buf+3], 1)
  if (Meml[buf+3] == NULL) call error(100,"Cannot open column ratio")

  row = 0
  cnt = 0
  repeat {
    call et_next(et, row)
    if (row == EOF) break
    if (rows == ARB) {
      if (cnt == 0) {
	call malloc(array, cnt+1, TY_LONG)
      } else {
	call realloc(array, cnt+1, TY_LONG)
      }
    } else if (cnt >= rows) break
    cnt = cnt + 1

    call psf_malloc(ptr)
    call tbrgtr (tb, Meml[buf+0], PSF_WAVELENGTH(ptr), nullp, 1, row)
    if (nullp)	PSF_WAVELENGTH(ptr) = INDEFR
    call tbrgtr (tb, Meml[buf+1], PSF_FWHM1(ptr), nullp, 1, row)
    if (nullp)	PSF_FWHM1(ptr) = INDEFR
    call tbrgtr (tb, Meml[buf+2], PSF_FWHM2(ptr), nullp, 1, row)
    if (nullp)	PSF_FWHM2(ptr) = INDEFR
    call tbrgtr (tb, Meml[buf+3], PSF_RATIO(ptr), nullp, 1, row)
    if (nullp)	PSF_RATIO(ptr) = INDEFR
    Meml[array+cnt-1] = ptr
  }

  rows = cnt
  call sfree(sp)
end

