# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ekopen.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) ekopen.x -r1.3 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/29/94   akeith	fixed malloc problem
# 	04/30/92   ericco	date and time created 92/04/30 00:35:59 by ericco
# H-
# 
#

include	<ctype.h>

include	<eerror.h>
include	"ek.h"

define	IS_OCTAL	(($1)>='0' && ($1) <= '7')

#	Initialize a key map from a macro file (which is
#	optional.

procedure	ek_key_file(ek, file, order)
pointer		ek			#O key map
char		file[ARB]		#I macro file
int		order			#I definition order

begin
  call ek_malloc(ek)
  call ds_strcpy(file, EK_FILE_PTR(ek))
  EK_HASH(ek) = 0
  EK_BINDINGS_LEN(ek) = 256
  call calloc(EK_BINDINGS_PTR(ek), EK_BINDINGS_LEN(ek), TY_LONG)

  EK_ORDER(ek) = order
  if (file[1] != EOS) call ek_load_file(ek)
end

#	Read in a macro file
procedure	ek_macro_file(ek, file, order)
pointer		ek			#I/O key map
char		file[ARB]		#I macro file
int		order			#I definition order

pointer		locpr()
extern		ek_release()

begin
  call ek_malloc(ek)
  call ds_strcpy(file, EK_FILE_PTR(ek))
  EK_BINDINGS_LEN(ek) = 0
  EK_BINDINGS_PTR(ek) = 0
  call hash_open(EK_HASH(ek), locpr(ek_release))
  EK_ORDER(ek) = order
  EK_DIRTY(ek) = 0
  if (file[1] != EOS) call ek_load_file(ek)
end

#	Dummy routine
procedure	ek_release(ptr, type)
pointer		ptr			#I key map
int		type			#I data type

begin
  call eerror(EES_DS_NOT_EXPECTED)
end

#	Load an initial macro file
procedure	ek_load_file(ek)
pointer		ek			#I/O key map

int		order

int	ip
int	fd
int	open()
int	getline()
pointer	sp
pointer	buf
pointer	one
pointer	two
int	access()

begin
  order = EK_ORDER(ek)

  call smark(sp)
  call salloc(buf, SZ_LINE, TY_CHAR)
  call salloc(one, SZ_LINE, TY_CHAR)
  call salloc(two, SZ_LINE, TY_CHAR)

  # look for a good file name
  call sprintf(Memc[buf], SZ_LINE, "%s")
  call pargstr(EK_FILE(ek))
  if (access(Memc[buf], READ_ONLY, TEXT_FILE) == NO) {
    call sprintf(Memc[buf], SZ_LINE, "home$%s")
    call pargstr(EK_FILE(ek))
    if (access(Memc[buf], READ_ONLY, TEXT_FILE) == NO) {
      call sprintf(Memc[buf], SZ_LINE, "uparm$%s")
      call pargstr(EK_FILE(ek))
      if (access(Memc[buf], READ_ONLY, TEXT_FILE) == NO) {
	return
      }
    }
  }

  fd = open(Memc[buf], READ_ONLY, TEXT_FILE)
  while (getline(fd, Memc[buf]) != EOF) {
    ip = 1
    call ek_parse_string(Memc[buf], ip, Memc[one])
    call ek_parse_string(Memc[buf], ip, Memc[two])
    if (order == 0) {
      call ek_put(ek, Memc[one], Memc[two])
    } else {
      call ek_put(ek, Memc[two], Memc[one])
    }
  }

  call close(fd)
  call sfree(sp)
end

#	Lookup macro name
procedure	ek_get (ek, name, value)
pointer		ek		#I
char		name[ARB]	#I macro name
pointer		value		#O macro value

pointer		item
int		i

begin
  if (EK_HASH(ek) != 0)  {
    call hash_exists(EK_HASH(ek), name, item)
    if (item == 0)	value = 0
    else		call item_data_pointer(item, value)
  } else {
    i = name[1] - (name[1]/ 256) * 256
    value = EK_BINDINGS(ek, i + 1)
  }
end

#	Add macro name
procedure	ek_put (ek, name, value)
pointer		ek		#I 
char		name[ARB]	#I macro name
char		value[ARB]	#I macro value

pointer		ptr
int		i

begin
  if (EK_HASH(ek) != 0)  {
    call item_new_string(ptr, value)
    call hash_put(EK_HASH(ek), name, ptr)
  } else {
    i = name[1] - (name[1]/ 256) * 256
    call ds_strcpy(value, EK_BINDINGS(ek,i+1))
  }
end

#	Convert macro string into internal format
procedure	ek_parse_string(str, ip, val)
char		str[ARB]		#I input string
int		ip			#I/O parse position
char		val[ARB]		#I output string

int		delim
int		op
char		chr

begin
  op = 1
  delim = EOS
  if (str[ip] == '"' || str[ip] == '\'') {
    delim = str[ip]
    ip = ip + 1
  }

  for (; str[ip] != EOS && IS_WHITE(str[ip]); ip = ip + 1) ;

  while (str[ip] != EOS) {
    if (delim == EOS) {
      if (IS_WHITE(str[ip])) break
    } else if (str[ip] == delim) break

    switch (str[ip]) {
    case '\\':
      ip = ip + 1
      switch(str[ip]) {
      case 'b':	chr = '\010'
      case 'e':	chr = '\033'
      case 'f':	chr = '\f'
      case 'n':	chr = '\n'
      case 'r':	chr = '\r'
      case 't':	chr = '\t'
      case EOS:	break
      default:
	if (IS_OCTAL(str[ip])) {
	  chr = str[ip] - '0'; ip = ip + 1
	  if (IS_OCTAL(str[ip])) {chr = chr + str[ip] - '0'; ip = ip + 1}
	  if (IS_OCTAL(str[ip])) {chr = chr + str[ip] - '0'; ip = ip + 1}
	} else	chr = str[ip]
      }
      val[op] = chr
      op = op + 1

    case '^':
      ip = ip + 1
      if (str[ip] == EOS) break
      val[op] = mod(str[ip], 32)
      op = op + 1
      
    default:
      val[op] = str[ip]
      op = op + 1
    }

    ip = ip + 1
  }

  if (delim != EOS && str[ip] == delim) ip = ip + 1
  val[op] = EOS
end
