# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  etime.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) etime.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/15/92   ericco	added additional element for vecelt structure
# 	09/28/92   akeith	put in debug statements
# 	04/30/92   ericco	change because of name conflict
# 	10/29/91   ericco	added eu_malloc calls
# 	05/07/91   ericco	date and time created 91/05/07 14:08:46 by ericco
# H-
# 
#

#	Revised: 12/15/92

include	<imhdr.h>
include	<edata.h>
include	<dbg.h>

define	ET_START_PTR	VEC_ELEMENT($1,1)
define	ET_END_PTR	VEC_ELEMENT($1,2)
define	ET_LEN		VEC_ELEMENT($1,3)
define	ET_INDEX	VEC_ELEMENT($1,4)
define	ET_BUF		VEC_ELEMENT($1,5)

define	ET_LENGTH	long(5)

define	ET_START	Memd[ET_START_PTR($1)+($2)]
define	ET_END		Memd[ET_END_PTR($1)+($2)]
define	ET_LAST_START	ET_START($1,0)
define	ET_LAST_END	ET_END($1,0)

#	Get a time buffer
procedure	et_gbuf(et, buf)
pointer		et
pointer		buf

begin
DEBUG(
	call dbg_printf("et_gbuf,fun", "et_gbuf()\n")
)
  buf = ET_BUF(et)
end

#	Get time filter from a text database

procedure	et_read (dt, rec, ptr, ob)	# read a time
pointer		dt				#I text database
int		rec				#I record id
pointer		ptr				#O time data
pointer		ob				#I/O an output buffer

int		dtgeti()
int		len
pointer		sp, ep
int		index

begin
  call ev_new(ptr, ET_LENGTH)
  len = dtgeti(dt, rec, "Length")
  ET_LEN(ptr) = len

  call eu_malloc(ET_START_PTR(ptr), len+1, TY_DOUBLE)
  sp = ET_START_PTR(ptr)
  call eu_malloc(ET_END_PTR(ptr), len+1, TY_DOUBLE)
  ep = ET_END_PTR(ptr)

  do index = 1, len {
    call dtscan(dt)
    call gargd (ET_START(ptr,index))
    call gargd (ET_END(ptr,index))
  }

  ET_INDEX(ptr) = 1
  ET_LAST_START(ptr) = ET_START(ptr,1)
  ET_LAST_END(ptr) = ET_END(ptr,1)
  call eb_copybuffer(ET_BUF(ptr), ob, 0)
  ob = ET_BUF(ptr)
end

#	Write a time filter to a text database
procedure	et_write (dt, record, ptr)	# write a time
pointer		dt				#I text database
char		record[ARB]			#I record name
pointer		ptr				#I time data

long		index

begin
DEBUG(
	call dbg_printf("et_write,func", "et_write() record = %s\n")
	call pargstr(record)
)
  call dtptime(dt)
  call dtput(dt, "begin\t%s\n")
  call pargstr(record)
  call dtput(dt, "\tLength\t%d\n"); call pargl(ET_LEN(ptr))
  do index = 1, ET_LEN(ptr) {
    call dtput(dt,"\t\t%g\t%g\n")
    call pargd (ET_START(ptr,index))
    call pargd (ET_END(ptr,index))
  }
end

#	Release time filter resources
procedure	et_old (ptr)		# free a time
pointer		ptr			#I time data

begin
DEBUG(
	call dbg_printf("et_old,fun", "et_old()\n")
)
  call eu_mfree(ET_START_PTR(ptr), TY_DOUBLE)
  call eu_mfree(ET_END_PTR(ptr), TY_DOUBLE)
  call ev_free(ptr)
  ptr = 0
end

#	Compare a set of times with a time filter
procedure	et_check (ptr, time, t)
pointer		ptr
double		time
long		t

long		index

begin
DEBUG(
	call dbg_printf("et_check,fun", "et_check()\n")
)
  for (index = ET_INDEX(ptr);
       index > 1;
       index = index - 1) {
    if (ET_START(ptr,index) <= time) break
  }
  for (;
       index < ET_LEN(ptr);
       index = index + 1) {
    if (ET_END(ptr,index) >= time) break
  }
  ET_INDEX(ptr) = index
  if (ET_START(ptr,index) <= time && ET_END(ptr,index) >= time) t = 1;
  else t = 0;
end
