# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eoxbkg.x
# 	Author	:  akeith
# 	Date	:  07/15/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eoxbkg.x -r1.1 07/15/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/15/94   akeith	date and time created 94/07/15 11:40:00 by akeith
# H-
# 
#


#	Version: @(#)eoxbkg.x	1.1 7/15/94 UCB CEA EGO

define	ARY_R		Memr[($1)+($2)-1]

#
# eox_smooth_bkg() smooths the background with first a median filter
#	then with two boxcar filters.
#

procedure	eox_smooth_bkg(bkg, bvar, len, filtersize)

real	bkg[len]			#B background
real	bvar[len]			#O background variance
int	len				#I length of arrays
int	filtersize			#I length of filter in pixels

int	p				# pixel position
int	half				# half the filtersize

pointer	sp				# stack
pointer	border				# background with extra length for border
pointer smooth				# background median smoothed

real	amedr()				#
real	asumr()				#

begin

   # smooth the average background before using

	half = filtersize / 2
	if (filtersize-2*half == 0) filtersize = filtersize + 1

	call smark(sp)
	call salloc(border, len+2*half, TY_REAL)
	call salloc(smooth, len, TY_REAL)

	call amovr(bkg[1], Memr[border+half], len)
	call amovkr(bkg[1], Memr[border], half)
	call amovkr(bkg[len], Memr[border+half+len], half)

   # median filter

	call aclrr(Memr[smooth], len)
	do p = 1, len
		ARY_R(smooth, p) = amedr(ARY_R(border, p), filtersize)

	call amovr(Memr[smooth], Memr[border+half], len)
	call amovkr(Memr[smooth], Memr[border], half)
	call amovkr(Memr[smooth+len-1], Memr[border+half+len], half)

   # boxcar filter

	call aclrr(Memr[smooth], len)
	do p = 0, len-1 {
		Memr[smooth+p] = asumr(Memr[border+p],filtersize) / real(filtersize)
	}

	call amovr(ARY_R(smooth, 1), Memr[border+half], len)
	call amovkr(ARY_R(smooth, 1), Memr[border], half)
	call amovkr(ARY_R(smooth, len), Memr[border+half+len], half)

   # boxcar again

	call aclrr(Memr[smooth], len)
	do p = 1, len
		bkg[p] = asumr(ARY_R(border, p), filtersize) / real(filtersize)

   # At this point background variance is effectively zero compared
   # to the variance in the spectral pixels. To avoid the problem of
   # trying to compute the variance after median filtering, just set
   # it to zero.

	call aclrr(bvar, len)

	call sfree(sp)

end

