# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eoxcenter.x
# 	Author	:  akeith
# 	Date	:  07/27/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eoxcenter.x -r1.4 07/27/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/08/94   akeith	no divide by zero
# 	07/27/94   akeith	date and time created 94/07/27 14:07:26 by akeith
# H-
# 
#


#	Version: @(#)eoxcenter.x	1.4 9/8/94 UCB CEA EGO

include	<imhdr.h>

#
# eox_center()
#

int	procedure	eox_center(im, ap_cntr, ap, iguess, radius, thres, axis, band)

pointer	im			#I image
int	ap_cntr			#I aperture center
char	ap[ARB]			#I aperture
int	iguess			#I initial guess
int	radius			#I radius about which to look
real	thres			#I threshold
int	axis			#I dispersion axis
int	band			#I data band

real	hi_val			#
real	mean			#
real	sigma			#
real	ksig			#
real	ahivr()			#

int	i			#
int	ax			#
int	len			#
int	nlines			#
int	lo, hi			#
int	spec_cntr		#
int	rejected		#
int	aravr()			#

pointer	sp, buf			#

begin

	if(axis == 1) ax = 2
	else ax = 1

	len = IM_LEN(im, ax)

	call smark(sp)
	call salloc(buf, len, TY_REAL)

	call eox_ladd(im, ap_cntr, ap, band, ax, Memr[buf], len, nlines)

	spec_cntr = INDEFI

	lo = iguess - radius; if(lo < 1) lo = 1
	hi = iguess + radius; if(hi > len) hi = len

	hi_val = ahivr(Memr[buf+lo-1], hi-lo+1)

	ksig = 0.0
	rejected = aravr(Memr[buf+lo-1], hi-lo+1, mean, sigma, ksig)

	if((hi_val-mean) > (thres*sigma) && rejected != hi-lo+1) {
		hi_val = 0.9999*hi_val
		i = lo - 1
		repeat {
			i = i + 1
		} until(Memr[buf+i-1] >= hi_val || i == hi)
		spec_cntr = i
		if(i == hi) spec_cntr = INDEFI
	}

	call sfree(sp)

	return(spec_cntr)
end

