# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eoxmkheaders.x
# 	Author	:  akeith
# 	Date	:  07/15/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eoxmkheaders.x -r1.8 07/15/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/14/94   akeith	fixed src string
# 	09/08/94   akeith	fixed header
# 	09/08/94   akeith	fix header card
# 	09/08/94   akeith	check for bkg_type for bands
# 	08/29/94   akeith	fixed header cards
# 	07/26/94   akeith	generalized adding header strings
# 	07/15/94   akeith	date and time created 94/07/15 11:40:00 by akeith
# H-
# 
#


#	Version: @(#)eoxmkheaders.x	1.8 9/14/94 UCB CEA EGO

include	<eoxset.h>
include	<imhdr.h>

#
# eox_mkheaders()
#

define	SRC_STR		"spectrum - extracted spectrum"
define	BKG_STR		"background - subtracted background"
define	SIG_STR		"sigma - one stdev error in extracted spectrum"
define	HIST_STR	"Extracted by euvextract - bkg method: "

procedure	eox_mkheaders(in, out, src, bkg, center, etype, btype f_sz)

pointer	in				#I
pointer	out				#I
char	src[ARB]			#I
char	bkg[ARB]			#I
int	center				#I
int	etype				#I
int	btype				#I
int	f_sz				#I

int	ip
int	lo, hi
pointer	sp, apid, hist

int	eu_grange()

begin

  # write out the headers
 
	call smark(sp)
	call salloc(apid, SZ_LINE, TY_CHAR)
	call salloc(hist, SZ_LINE, TY_CHAR)
	Memc[apid] = EOS

	ip = 1
	while(eu_grange(src, ip, lo, hi) != 0) {
		if(center > 0) {
			lo = lo + center
			hi = hi + center
		}
		call sprintf(Memc[apid], SZ_LINE, "%d %d %d %d")
		call pargi(1)
		call pargi(1)
		call pargi(lo)
		call pargi(hi)
	}

	
	call imastr(out, "APNUM1", Memc[apid])
	call imaddi(out, "APCENTER", center)
	call imastr(out, "APSRC", src)
	call imastr(out, "APBKG", bkg)

	call strcpy(IM_HISTORY(in), IM_HISTORY(out), SZ_IMHIST)
	call strcat(HIST_STR, IM_HISTORY(out), SZ_IMHIST)

	call eu_idxstr(BKG_DICT, btype, Memc[hist], SZ_LINE)
	call strcat(Memc[hist], IM_HISTORY(out), SZ_IMHIST)

	if(btype == BSMOOTH) {
		Memc[hist] = EOS
		call sprintf(Memc[hist], SZ_LINE, ", filtersize: %d")
		call pargi(f_sz)
		call strcat(Memc[hist], IM_HISTORY(out), SZ_IMHIST)
	}
	call strcat("\n", IM_HISTORY(out), SZ_IMHIST)

	call imastr(out, "BANDID1", SRC_STR)
	call imastr(out, "BANDID2", SIG_STR)
	if(btype != BNONE)
		call imastr(out, "BANDID3", BKG_STR)

	call sfree(sp)

end

