# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eoxmkout.x
# 	Author	:  akeith
# 	Date	:  07/15/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eoxmkout.x -r1.6 07/15/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/08/94   akeith	fixed mwcs and added nbands
# 	09/06/94   akeith	changed back to equispec system
# 	08/29/94   akeith	fixed header cards
# 	07/26/94   akeith	added hcpkill
# 	07/15/94   akeith	date and time created 94/07/15 11:40:02 by akeith
# H-
# 
#


#	Version: @(#)eoxmkout.x	1.6 9/8/94 UCB CEA EGO

include	<imhdr.h>

#
# eox_mkout() makes the output image and mwcs and return the 
#	output image pointer.
#

pointer	procedure	eox_mkout(out_name, in, nbands)

char	out_name[ARB]			#I output image name
pointer	in				#I input image pointer
int	nbands				#I number of bands

int	i				#
int	ndim_in, ndim_out		#

pointer sp				# stack pointer
pointer str				# string
pointer r_out				# reference pixels
pointer w_out				# world positions
pointer cd_out				# coordinate matrix
double	pix_one				#
double	pix_two				#

int	axis, imgeti()			#
pointer	out, immap()			#
pointer mw_in, mw_openim()		#
pointer mw_out, mw_open()		#

begin

  # open output image, copy header from input

	call smark(sp)

	out = immap(out_name, NEW_IMAGE, NULL)
	call hcpkill(in, "IMAGE", out, "IMAGE", NULL)

  # set up output image as 3-d real Nx1xnbands

	axis = imgeti(in, "DISPAXIS")

	ndim_in = IM_NDIM(in)
	ndim_out = 3
	IM_PIXTYPE(out) = TY_REAL
	IM_NDIM(out) = ndim_out
	IM_LEN(out, 1) = IM_LEN(in, axis)
	IM_LEN(out, 2) = 1
	IM_LEN(out, 3) = nbands

	call imputi(out, "DISPAXIS", 1)

  # construct WCS for output image - take axis 1 WCS from input

	mw_in = mw_openim(in)
	mw_out = mw_open(NULL, ndim_out)

	call mw_newsystem(mw_out, "equispec", ndim_out)

	call salloc(cd_out, ndim_out*ndim_out, TY_DOUBLE)
	call salloc(r_out, ndim_out, TY_DOUBLE)
	call salloc(w_out, ndim_out, TY_DOUBLE)

	call aclrd(Memd[cd_out], ndim_out*ndim_out)
	call amovkd(1.0d0, Memd[r_out], ndim_out)
	call amovkd(1.0d0, Memd[w_out], ndim_out)

	do i = 1, ndim_out
		Memd[cd_out+ndim_out*(i-1)+i-1] = 1.0d0

	call lw_c1trand(mw_in, "world", Memd[r_out], pix_one)
	call lw_c1trand(mw_in, "world", Memd[r_out]+1.0, pix_two)
	Memd[w_out] = pix_one
	Memd[cd_out] = pix_two - pix_one

	call mw_swtermd(mw_out, Memd[r_out], Memd[w_out], Memd[cd_out], ndim_out)

	call mw_swtype(mw_out, 1, 1, "linear", "")
	call mw_swtype(mw_out, 2, 1, "linear", "")

	call salloc(str, SZ_LINE, TY_CHAR)
	ifnoerr(call mw_gwattrs(mw_in, 1, "units", Memc[str], SZ_LINE))
		call mw_swattrs(mw_out, 1, "units", Memc[str])

	Memc[str] = EOS
	ifnoerr(call mw_gwattrs(mw_in, 1, "label", Memc[str], SZ_LINE))
		call mw_swattrs(mw_out, 1, "label", Memc[str])

	call mw_saveim(mw_out, out)

	call mw_close(mw_out)
	call mw_close(mw_in)

	call sfree(sp)

	return(out)

end

