# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eoxops.gx
# 	Author	:  akeith
# 	Date	:  07/26/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eoxops.gx -r1.5 07/26/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/08/94   akeith	fixed type mismatch
# 	07/26/94   akeith	made compile
# 	07/26/94   akeith	date and time created 94/07/26 16:44:50 by akeith
# H-
# 
#


#	Version: @(#)eoxops.gx	1.5 9/8/94 UCB CEA EGO

include	<imhdr.h>

define	IMG_ARY		Memr[($1)+($2)*(($4)-1)+($3)-1]

#
# eox_ladd() 
#

procedure	eox_ladd(im, center, str, band, axis, buf, len, nlines)

pointer	im				#
int	center				#I
char	str[ARB]			#
int	band				#
int	axis				#
real	buf[len]			#
int	len				#
int	nlines				#

begin

	if(axis == 1)
		call eox_hladd(im, center, str, band, buf, len, nlines, FALSE)
	else
		call eox_vladd(im, center, str, band, buf, len, nlines, FALSE)

end


#
# eox_lsqradd() 
#

procedure	eox_lsqradd(im, center, str, band, axis, buf, len, nlines)

pointer	im				#
int	center				#
char	str[ARB]			#
int	band				#
int	axis				#
real	buf[len]			#
int	len				#
int	nlines				#

begin

	if(axis == 1)
		call eox_hladd(im, center, str, band, buf, len, nlines, TRUE)
	else
		call eox_vladd(im, center, str, band, buf, len, nlines, TRUE)

end


procedure	eox_hladd(im, center, str, band, buf, len, nlines, sum_sqr)

pointer	im				#I
int	center				#I
char	str[ARB]			#I
int	band				#I
int	len				#I
real	buf[len]			#I
int	nlines				#O
bool	sum_sqr				#I

int	ip				#
int	i, line				#
int	lo, hi				#

pointer imbuf				#
int	eu_grange()			#


pointer	imgl3s()

pointer	imgl3i()

pointer	imgl3l()

pointer	imgl3r()

pointer	imgl3d()


begin

	ip = 1
	nlines = 0

	call aclrr(buf, len)

	while(eu_grange(str, ip, lo, hi) != 0) {

		if(center > 0) {
			lo = lo + center
			hi = hi + center
		}

		do line = lo, hi {
			switch(IM_PIXTYPE(im)) {

			  case TY_SHORT:
				imbuf = imgl3s(im, line, band)
				if(sum_sqr) {
					do i = 1, len
						buf[i] = buf[i] +
						Mems[imbuf+i-1] * Mems[imbuf+i-1]
				} else {
					do i = 1, len
						buf[i] = buf[i] + Mems[imbuf+i-1]
				}

			  case TY_INT:
				imbuf = imgl3i(im, line, band)
				if(sum_sqr) {
					do i = 1, len
						buf[i] = buf[i] +
						Memi[imbuf+i-1] * Memi[imbuf+i-1]
				} else {
					do i = 1, len
						buf[i] = buf[i] + Memi[imbuf+i-1]
				}

			  case TY_LONG:
				imbuf = imgl3l(im, line, band)
				if(sum_sqr) {
					do i = 1, len
						buf[i] = buf[i] +
						Meml[imbuf+i-1] * Meml[imbuf+i-1]
				} else {
					do i = 1, len
						buf[i] = buf[i] + Meml[imbuf+i-1]
				}

			  case TY_REAL:
				imbuf = imgl3r(im, line, band)
				if(sum_sqr) {
					do i = 1, len
						buf[i] = buf[i] +
						Memr[imbuf+i-1] * Memr[imbuf+i-1]
				} else {
					do i = 1, len
						buf[i] = buf[i] + Memr[imbuf+i-1]
				}

			  case TY_DOUBLE:
				imbuf = imgl3d(im, line, band)
				if(sum_sqr) {
					do i = 1, len
						buf[i] = buf[i] +
						Memd[imbuf+i-1] * Memd[imbuf+i-1]
				} else {
					do i = 1, len
						buf[i] = buf[i] + Memd[imbuf+i-1]
				}

			}
		}

		nlines = nlines + hi - lo + 1
	}

end


procedure	eox_vladd(im, center, str, band, buf, len, nlines, sum_sqr)

pointer	im				#I
int	center				#I
char	str[ARB]			#I
int	band				#I
int	len				#I
real	buf[len]			#I
int	nlines				#O
bool	sum_sqr				#I

int	ip				#
int	line, j, k			#
int	n_sect				#
int	lo[100], hi[100]

pointer imbuf				#
int	eu_grange()			#


pointer	imgl3s()


real	asums()
real	assqs()


pointer	imgl3i()


real	asumi()
real	assqi()


pointer	imgl3l()


double	asuml()
double	assql()


pointer	imgl3r()


real	asumr()
real	assqr()


pointer	imgl3d()


double	asumd()
double	assqd()



begin

	ip = 1
	nlines = 0

	call aclrr(buf, len)

	k = 1
	while(eu_grange(str, ip, lo[k], hi[k]) != 0) {

		if(center > 0) {
			lo[k] = lo[k] + center
			hi[k] = hi[k] + center
		}

		nlines = nlines + hi[k] - lo[k] + 1
		k = k + 1

	}
	n_sect = k - 1


	switch(IM_PIXTYPE(im)) {

	  case TY_SHORT:
		do line = 1, len {
			imbuf = imgl3s(im, line, band)
			if(sum_sqr) {
				do j = 1, n_sect
					buf[line] =
					assqs(Mems[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			} else {
				do j = 1, n_sect
					buf[line] =
					asums(Mems[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			}
		}

	  case TY_INT:
		do line = 1, len {
			imbuf = imgl3i(im, line, band)
			if(sum_sqr) {
				do j = 1, n_sect
					buf[line] =
					assqi(Memi[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			} else {
				do j = 1, n_sect
					buf[line] =
					asumi(Memi[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			}
		}

	  case TY_LONG:
		do line = 1, len {
			imbuf = imgl3l(im, line, band)
			if(sum_sqr) {
				do j = 1, n_sect
					buf[line] =
					assql(Meml[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			} else {
				do j = 1, n_sect
					buf[line] =
					asuml(Meml[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			}
		}

	  case TY_REAL:
		do line = 1, len {
			imbuf = imgl3r(im, line, band)
			if(sum_sqr) {
				do j = 1, n_sect
					buf[line] =
					assqr(Memr[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			} else {
				do j = 1, n_sect
					buf[line] =
					asumr(Memr[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			}
		}

	  case TY_DOUBLE:
		do line = 1, len {
			imbuf = imgl3d(im, line, band)
			if(sum_sqr) {
				do j = 1, n_sect
					buf[line] =
					assqd(Memd[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			} else {
				do j = 1, n_sect
					buf[line] =
					asumd(Memd[imbuf+lo[j]-1], hi[j]-lo[j]+1)
			}
		}

	}

end

