# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eoxoptimal.x
# 	Author	:  akeith
# 	Date	:  07/15/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eoxoptimal.x -r1.1 07/15/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/15/94   akeith	date and time created 94/07/15 11:40:04 by akeith
# H-
# 
#


#	Version: @(#)eoxoptimal.x	1.1 7/15/94 UCB CEA EGO

include	<dfset.h>
include	<imhdr.h>

procedure	eox_optimal(im, ili, match, bkg, spec, svar, ishift, ncol, maxiter, tol)

pointer	im			#I
pointer ili			#I
pointer match			#I
real	bkg[ncol]		#O
real	spec[ncol]		#O
real	svar[ncol]		#O
int	ishift			#I
int	ncol			#I
int	maxiter			#I
real	tol			#I

pointer	sp			#
pointer	profs			#
pointer	prof			#
pointer	src			#
pointer	pvar			#
pointer	sum1			#
pointer	sum2			#
pointer	sum3			#
pointer	tmp1			#
pointer	tmp2			#
pointer	ospec			#

pointer mw, mw_openim()		#
pointer	ibuf, imgl2r()		#

real	diff, assqr()		#

int	i			#
int	nline			#
int	iter			#
int	start_ln		#
int	end_ln			#

real	simp_dvzero()		#

begin

	nline = IM_LEN(im, 2)

	call smark(sp)
	call salloc(profs, nline, TY_LONG)
	call salloc(src, ncol, TY_REAL)
	call salloc(pvar, ncol, TY_REAL)
	call salloc(sum1, ncol, TY_REAL)
	call salloc(sum2, ncol, TY_REAL)
	call salloc(sum3, ncol, TY_REAL)
	call salloc(tmp1, ncol, TY_REAL)
	call salloc(tmp2, ncol, TY_REAL)
	call salloc(ospec, ncol, TY_REAL)

	mw = mw_openim(im)

	call eox_gprofs(ili, mw, match, ncol, nline, ishift, profs, start_ln, end_ln)

#   Iterate the optimal extraction to convergence.

	iter = 1
	repeat {

#	   Save prior spectrum for convergence check.

		call amovr(spec, Memr[ospec], ncol)

#	   Clear buffers.

		call aclrr(Memr[sum1], ncol)
		call aclrr(Memr[sum2], ncol)
		call aclrr(Memr[sum3], ncol)
  
		do i = start_ln, end_ln {
#
			prof = Meml[profs+i-1]

#		   Use the current best spectrum and the spatial profile
#		      to predict the variance in each pixel.  Otherwise the
#		      extraction will be biased toward low values
#		      (low value -> low variance -> high weight!).  

			call amulr(Memr[prof], spec, Memr[pvar], ncol)
			call aaddr(Memr[pvar], bkg, Memr[pvar], ncol)
			call aabsr(Memr[pvar], Memr[pvar], ncol)

#
#		   Optimal extraction equations.
#
#		   see Horne, K. 1985, PASP, 98, 609
#
#		   flux = sum(p*(s-b)/var) / sum(p**2/var)
#
#		   fvar = sum(p) / sum(p**2/var)
#

#		   Read the data for this line of spectral image.

			ibuf = imgl2r(im, i)

			call asubr(Memr[ibuf], bkg, Memr[src], ncol)
			call advzr(Memr[prof], Memr[pvar], Memr[tmp1], ncol, simp_dvzero)
			call amulr(Memr[tmp1], Memr[src], Memr[tmp2], ncol)
			call amulr(Memr[tmp1], Memr[prof], Memr[tmp1], ncol)

			call aaddr(Memr[tmp1], Memr[sum1], Memr[sum1], ncol)
			call aaddr(Memr[tmp2], Memr[sum2], Memr[sum2], ncol)
			call aaddr(Memr[prof], Memr[sum3], Memr[sum3], ncol)

		}
#
#	   Compute bkg subtracted spectrum and variance.
#
		call adivr(Memr[sum2], Memr[sum1], spec, ncol)
		call adivr(Memr[sum3], Memr[sum1], svar, ncol)
#
#	   Check for convergence
#
		call asubr(spec, Memr[ospec], Memr[tmp1], ncol)
		diff = sqrt(assqr(Memr[tmp1], ncol))

		iter = iter + 1

	} until (iter > maxiter || diff < tol)

	call mw_close(mw)

	call sfree(sp)

end


#
# simp_dvzero()
#

real	procedure	simp_dvzero(x)
 
real	x
 
begin
	return(x)
end

