# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eoxout.x
# 	Author	:  akeith
# 	Date	:  07/15/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eoxout.x -r1.3 07/15/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/08/94   akeith	check for bkg_type for bands
# 	07/26/94   akeith	added real macro
# 	07/15/94   akeith	date and time created 94/07/15 11:40:05 by akeith
# H-
# 
#


#	Version: @(#)eoxout.x	1.3 9/8/94 UCB CEA EGO

include	<eoxset.h>

define	R	Memr[($1)]

#
# eox_out() writes output the spectrum
#
#  band 1 = bkg subtracted spectrum
#  band 2 = std dev of spectrum
#  band 3 = bkg which was subtracted (scaled for non-optimal)
#

procedure	eox_out(im, bkg_type, ext_type, bkg, spec, svar, ncol, nline)

pointer	im				#I
int	ext_type			#I
int	bkg_type			#I
real	bkg[ncol]			#I
real	spec[ncol]			#I
real	svar[ncol]			#I
int	ncol				#I
int	nline				#I

pointer	obuf, impl3r()			#
real	simp_rterr()

begin

	obuf = impl3r(im, 1, 1)
	call amovr(spec, R(obuf), ncol)

	obuf = impl3r(im, 1, 2)
	call asqrr(svar, R(obuf), ncol, simp_rterr)

	if(bkg_type != BNONE) {
		obuf = impl3r(im, 1, 3)
		if (ext_type == EPROFILE)
			call amovr(bkg, R(obuf), ncol)
		else	call amulkr(bkg, real(nline), R(obuf), ncol)
	}

end


#
# simp_rterr()
#

real	procedure	simp_rterr(x)

real	x

begin
	call error(231,"negative variance, impossible")
	return(0.0)
end

