# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dtgvstr.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) dtgvstr.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/29/94   akeith	Now remaps deepserv and scanners
# 	12/18/92   akeith	put in error checking
# 	09/28/92   akeith	put in debug statements
# 	05/07/91   ericco	date and time created 91/05/07 14:09:35 by ericco
# H-
# 
#

#	Revised: 6/29/94

include	<ctype.h>
include	<edata.h>
include <error.h>

#	Read an array of strings into a EUV vector.
#	A string may be no more than 1024 chars long,
#	and no more than 128 strings can be read in.

procedure	dtgvstr (dt, record, label, vec) # read in a list

pointer		dt			#I data base
int		record			#I record id
char		label[ARB]		#I field name
pointer		vec			#O output vector

pointer		sp
pointer		buf, ptr, ip, lp
int		pcnt
bool		streq()
int		strlen()

begin

	call smark(sp)
	call salloc(buf, 1024, TY_CHAR)
	call salloc(ptr, 128, TY_LONG)
	pcnt = 0

	iferr( call dtgstr (dt, record, label, Memc[buf], 1024) ) {
		vec = NULL
		call sfree(sp)
		call eprintf("\n Unable to get field label, %s\n")
		call pargstr(label)
		call erract(EA_ERROR)
		return
	}

	Memc[buf] = EOS

	repeat {

		call dtscan(dt)
		call gargstr(Memc[buf], 1024)

		for (ip = buf; IS_WHITE(Memc[ip]) && Memc[ip] != EOS; ip = ip + 1);

		for (lp = ip + strlen(Memc[ip]) - 1;
			lp > ip && IS_WHITE(Memc[lp]);
			lp = lp - 1);

		if (Memc[ip] != EOS) { # skip blank lines
			if (streq(Memc[ip], "EOL")) break
			Memc[lp+1] = EOS
			call eu_newstr(Memc[ip], Meml[ptr+pcnt])
			pcnt = pcnt + 1
		}
	}

	call ev_new (vec, long(pcnt))

	while (pcnt > 0) {
		VEC_ELEMENT(vec, pcnt) = Meml[ptr+pcnt-1]
		pcnt = pcnt - 1
	}

	call sfree(sp)

end

