# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ep.h
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) ep.h -r1.4 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/29/94   akeith	Now remaps deepserv and scanners
# 	12/06/92   ericco	added print and lookup
# 	06/19/91   ericco	added STARCAT datatype for catalog positions
# 	05/07/91   ericco	date and time created 91/05/07 14:09:40 by ericco
# H-
# 
#

#	Revised: 6/29/94

#	Known EUV processing record type names

define	PROC_DICT	",Pipeline,Read,TimeList,MaskList,CorrectionList,AspectList,WriteList,Indirect,MaskFilter,Quaternion,Write,AspectThing,CorrectionImage,TimeFilter,ConversionList,WSZConversion,CalcList,Calculation,StarCatalog,PrintList,PrintBuffer,LookList,Lookup,ImageAspectList,ImageAspect"

#	This ids must correspond to name position in the above
#	dictionary.

define	EP_PIPE		1
define	EP_READ		2
define	EP_TIMELIST	3
define	EP_MASKLIST	4
define	EP_CORRLIST	5
define	EP_ASPLIST	6
define	EP_WRITELIST	7
define	EP_INDIRECT	8
define	EP_MASK		9
define	EP_QUATERNION	10
define	EP_WRITE	11
define	EP_ASPECT	12
define	EP_CORR		13
define	EP_TIME		14
define	EP_CONVLIST	15
define	EP_CONV		16
define	EP_CALCLIST	17
define	EP_CALC		18
define	EP_STARCAT	19
define	EP_PRINTLIST	20
define	EP_PRINTBUFFER	21
define	EP_LOOKLIST	22
define	EP_LOOKUP	23
define	EP_IMASPLIST	24
define	EP_IMASP	25

#	EP data structure.
define	EP_REF_DT	VEC_ELEMENT($1,1)	# reference text db
define	EP_OBS_DT	VEC_ELEMENT($1,2)	# observation text db
define	EP_PRC_PTR	VEC_ELEMENT($1,3)	# list processing elements
define	EP_PRC_LST	VEC_ELEMENT($1,4)	# list processing names
define	EP_OBS_PTR	VEC_ELEMENT($1,5)	# EUV Observation data
define	EP_REF_PATH_PTR	VEC_ELEMENT($1,6)	# reference data path
define	EP_OBS_PATH_PTR	VEC_ELEMENT($1,7)	# observation data path
define	EP_PRC_DT	VEC_ELEMENT($1,8)	# processing text db
define	EP_PRC_PATH_PTR	VEC_ELEMENT($1,9)	# processing data path

define	EP_LENGTH	long(20)

#	String access macros
define	EP_REF_PATH	Memc[EP_REF_PATH_PTR($1)]
define	EP_OBS_PATH	Memc[EP_OBS_PATH_PTR($1)]

#	Number of processing elements
define	NUM_PROC	VEC_SIZE(EP_PRC_LST($1))

#	Element processing fields
define	EPP_TYPE	VEC_ELEMENT($1,1)	# type
define	EPP_BUF		VEC_ELEMENT($1,2)	# event buffer
define	EPP_MASKIN	VEC_ELEMENT($1,3)	# mask in/ mask out pred
define	EPP_FIELD	VEC_ELEMENT($1,4)	# generic field 1
define	EPP_PERDET	VEC_ELEMENT($1,5)	# per detector information
define	EPP_FIELD2	VEC_ELEMENT($1,6)	# generic field 2
define	EPP_DATA	VEC_ELEMENT($1,7)	# other information
define	EPP_FIELD3	VEC_ELEMENT($1,8)	# generic field 3
define	EPP_ASP		VEC_ELEMENT($1,9)	# aspect information

define	EPP_LENGTH	long(10)
