# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  epdtfind.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) epdtfind.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/29/94   akeith	Now remaps deepserv and scanners
# 	05/12/94   akeith	took out debug statements
# 	09/28/92   akeith	put in debug statements
# 	05/07/91   ericco	date and time created 91/05/07 14:09:48 by ericco
# H-
# 
#

#	Revised: 6/29/94

include	<eerror.h>
include <edata.h>
include <dbg.h>
include "ep.h"

#	Locate a record in one of the text database.
#	Search order is: processing, observation, reference.

procedure	ep_dtfind(ep, record, dt, rec, path) # find record
pointer		ep				#I euv data
char		record[ARB]			#I record name
pointer		dt				#O text db
pointer		rec				#O record id
pointer		path				#O path pointer

int		dtlocate()
pointer		obs, ref, prc
errchk		dtlocate

begin

  path = 0
  obs = EP_OBS_DT(ep)
  ref = EP_REF_DT(ep)
  prc = EP_PRC_DT(ep)
  rec = 0
  ifnoerr (rec = dtlocate(prc, record)) {
    dt = prc
    path = EP_PRC_PATH_PTR(ep)
  } else ifnoerr (rec = dtlocate(obs, record)) {
    dt = obs
    path = EP_OBS_PATH_PTR(ep)
  } else ifnoerr (rec = dtlocate(ref, record)) {
    dt = ref
    path = EP_REF_PATH_PTR(ep)
  } else {
    call eprintf("\n Unable to find record, %s\n")
    call pargstr(record)
    call eerror(EES_DTRNFND)
  }

end
