# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eprdrec.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) eprdrec.x -r1.9 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/29/94   akeith	Now remaps deepserv and scanners
# 	05/12/94   akeith	took out debug statements
# 	03/10/94   tnk	added ed parameter to ew_read call
# 	12/06/92   ericco	added lookup
# 	12/04/92   ericco	added print module
# 	09/28/92   akeith	put in debug statements
# 	06/19/91   ericco	layered star catalog positons over quaternions
# 	05/07/91   ericco	date and time created 91/05/07 14:10:01 by ericco
# H-
# 
#

#	Revised: 6/29/94

include	<eerror.h>
include <edata.h>
include <dbg.h>
include "ep.h"

#	Read a element record from a text database.

procedure	ep_rdrec(ep,dt,record,label,type,dets,lp) # read record

pointer		ep			#I euv data
pointer		dt			#I database
int		record			#I record name
char		label[ARB]		#I field
int		type			#I expected type
pointer		dets			#O detector slots
pointer		lp			#I last buffer

pointer		ed  
int		rec
pointer		sp, buf
int		typ
pointer		eb
int		i
int		id
pointer		elem
pointer		tmp
pointer		path
pointer		ndt

begin

	ed = EP_OBS_PTR(ep)
	eb = ED_PHTBUF(ed)
	call smark(sp)
	call salloc (buf, 1024, TY_CHAR)

	call dtgvstr(dt, record, label, tmp)

	do i = 1, VEC_SIZE(tmp) {

		call sscan(VEC_STRING(tmp,i))
		call gargwrd(Memc[buf], 1024)
		call eu_detect_id (Memc[buf], id)
		call gargwrd(Memc[buf], 1024)
		call ep_dtfind(ep, Memc[buf], ndt, rec, path)
		call dtgtype(ndt, rec, typ)

		if (typ != type) {	# overlay starcat onto quaternions
					# since we know how to convert them.
			if (typ == EP_STARCAT && type == EP_QUATERNION) {
			} else call eerror(EES_WRGTYPE)
		}

		switch (type) {
		  case EP_CALC:		call ea_read(ndt, rec, elem, lp)
		  case EP_CONV:		call ex_read(ndt, rec, elem, lp, ed)
		  case EP_TIME:		call et_read(ndt, rec, elem, lp)
		  case EP_MASK:		call em_read(ndt, rec, elem, lp)
		  case EP_CORR:		call ec_read(ndt, rec, Memc[path], elem, lp, id)
		  case EP_QUATERNION:	call eq_read(ndt, rec, elem)
		  case EP_WRITE:	call ew_read(ndt, Memc[buf], elem, lp, ed, ep)
		  case EP_PRINTBUFFER:	call cp_read(ndt, rec, elem, lp)
		  case EP_LOOKUP:	call clu_read(ndt, rec, elem, lp, ed)
		}

		VEC_ELEMENT(dets, id) = elem
	}

	call ev_free_string(tmp)

	call sfree(sp)

end
