# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eprun.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) eprun.x -r1.8 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/29/94   akeith	Now remaps deepserv and scanners
# 	05/12/94   akeith	took out debug statements
# 	12/06/92   ericco	added print and lookup
# 	09/28/92   akeith	put in debug statements
# 	07/07/92   ericco	replaced output buffer setting
# 	10/29/91   ericco	let output buffer filter through
# 	05/07/91   ericco	date and time created 91/05/07 14:10:06 by ericco
# H-
# 
#

#	Revised: 6/29/94

include	<eerror.h>
include	<edata.h>
include	<dbg.h>
include	"ep.h"

#	Execute a processing list
#
#	It is no long clear to me why the output buffer
#	is set to the EPP_BUF when the output buffer
#	succeeds.  This is bad for flushing on correction
#	and writing modules.  These modules may have no
#	input buffer, but produce output buffers when the
#	force flag is on.
procedure	ep_run(prc, index, buf, force)
pointer		prc		#I processing list
int		index		#I index into detector list
pointer		buf		#I input buffer
int		force		#I force output

int		type
pointer		detstate

begin

	if (buf == 0 && force == 0) return

	type = EPP_TYPE(prc)
	if (type == EP_READ) call eerror(EES_NOREAD)

	detstate = VEC_ELEMENT(EPP_PERDET(prc), index)

	switch (type) {

	  case EP_CALCLIST:
		call ebar_check (EPP_BUF(prc), detstate, buf, force)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_LOOKLIST:
		call eblu_check (EPP_BUF(prc), detstate, buf, force)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_PRINTLIST:
		call ebcp_check (EPP_BUF(prc), detstate, buf)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_CONVLIST:
		call ebcn_check (EPP_BUF(prc), detstate, buf)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_TIMELIST:
		call ebt_check (EPP_BUF(prc),
				EPP_MASKIN(prc),
				EPP_FIELD(prc),
				detstate, buf)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_MASKLIST:
		call ebm_check (EPP_BUF(prc),
				EPP_MASKIN(prc),
				EPP_FIELD(prc),
				EPP_FIELD2(prc),
				detstate, buf)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_CORRLIST:
		call ebc_check (EPP_BUF(prc),
				EPP_FIELD(prc),
				EPP_FIELD2(prc),
				detstate, force, buf)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_ASPLIST:
		call eba_check (EPP_BUF(prc),
				EPP_FIELD(prc),
				EPP_FIELD2(prc),
				EPP_FIELD3(prc),
				EPP_DATA(prc),
				EPP_ASP(prc),
				detstate, buf)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_IMASPLIST:
		call ebima_check (EPP_BUF(prc),
				  EPP_FIELD(prc),
				  EPP_FIELD2(prc),
				  EPP_FIELD3(prc),
				  EPP_ASP(prc),
				  detstate, buf)
		if (buf != 0) buf = EPP_BUF(prc)

	  case EP_WRITELIST:
		call ebw_check (EPP_BUF(prc), detstate, force, buf)
		if (buf != 0) buf = EPP_BUF(prc)

	  default: call eerror(EES_REQLIST)

	}

end
