# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  erphoton.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) erphoton.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	01/13/97   mabbott	added check for GT_BAD table causing null column ptrs
# 	05/12/94   akeith	took out debug statements
# 	09/28/92   akeith	put in debug statements
# 	05/07/91   ericco	date and time created 91/05/07 14:10:58 by ericco
# H-
# 
#

#	Revised: 1/13/97

#	EUV run time photon operations

include	<edata.h>
include	<eerror.h>
include	<dbg.h>
include	"ercol.h"

#	Release photon columns
procedure	er_phtclose (pht)	# close photon columns
pointer		pht			#I photon column list

begin
  call er_gclose(pht)
end

#	Open photon columns
procedure	er_phtopen (tp, names, len, pht) # open photon columns
pointer		tp			#I table pointer
pointer		names[len]		#I column name pointers
long		len			#I number of names
pointer		pht			#O column descriptors

bool	eu_nullinvec()

begin
  call er_gopen(tp, names, len, long(0), pht)

  # Die if we couldn't find all of the columns we need
  if (eu_nullinvec(pht)) {
	call eprintf("cannot find all event list columns\n")
	call eerror(EES_NOTAB)
  }
end

#	Get first valid photon
procedure	er_phtfirst (pht)	# get first photon
pointer		pht			#I photon data

begin
  call er_cinit0(VEC_ELEMENT(pht, 1), int(VEC_SIZE(pht)))
end

#	Get next valid photon
procedure	er_phtnext (pht, flag)	# get next photon
pointer		pht			# photon data
bool		flag			# EOD flag

begin
  call er_cnext0(VEC_ELEMENT(pht, 1), int(VEC_SIZE(pht)), flag)
end
