# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  erun.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) erun.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/27/96   mabbott	added override structure to er_open()
# 	05/12/94   akeith	took out debug statements
# 	09/28/92   akeith	put in debug statements
# 	05/07/91   ericco	date and time created 91/05/07 14:11:21 by ericco
# H-
# 
#

#	Revised: 12/27/96

#	EUV run time system

include	<edata.h>
include	<dbg.h>

#	Initialize run time environment from text db.
procedure	er_open (rundb, runrecord, override, er) # initalize
char		rundb[ARB]		#I runtime filename
char		runrecord[ARB]		#I pipeline record
pointer	    override    #I parameter override structure
pointer		er			#O runtime data structure

pointer		dtmap(), dt

begin

	dt = dtmap(rundb, READ_ONLY)
	call ep_proc(dt, runrecord, override, er)
	call dtunmap(dt)

end


#	Process all data
procedure	er_process (state) # process
pointer		state		#I processing state

bool		flag

begin

	repeat {
		call ep_loop (state, flag)
	} until (flag == TRUE)

end

#	Release processing state
procedure	er_close (state) # release
pointer		state		#I processing state

begin
  call ep_free(state)
end
