# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  alsops.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) alsops.x -r1.1 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/30/92   ericco	date and time created 92/04/30 00:50:56 by ericco
# H-
# 
#

#	4/30/92

#	Operations on als structure.  The al structure is
#	only a component of the als structure, and should
#	not be accessed directly.

#	An als is a list of aliases.  Aliases are regular
#	expression.  Values are literal strings.  The first
#	alias to match the input is used.

include "al.h"
include "als.h"

#	Create a new als structure from an ST Table.
procedure	als_open (als, table, et_old) # create als
pointer		als			#O new als structure pointer
char		table[ARB]		#I new of ST Table
pointer		et_old			#I old et table or NULL

pointer		et

int		nrows
pointer		al
int		i
pointer		pat
int		sz_pat
int		new_pat
pointer		sp
int		patmake()

begin
  als = 0
  call et_open_new(et, table, et_old)
  if (et == 0) return

  nrows = ARB
  call et_al_read(et, al, nrows)
  call et_close(et)

  if (nrows == 0) return

  call smark(sp)
  sz_pat = SZ_LINE
  call salloc(pat, sz_pat, TY_CHAR)

  call als_malloc(als)
  ALS_ALIASES_LEN(als) = nrows
  ALS_ALIASES_PTR(als) = al

  do i = 1, nrows {
    al = ALS_ALIASES(als,i)
    repeat {
      new_pat = patmake(AL_NAME(al), Memc[pat], sz_pat)
      if (new_pat != ERR) break
      sz_pat = sz_pat * 2
      call salloc(pat, sz_pat, TY_CHAR)
    }
    call realloc(AL_NAME_PTR(al), new_pat, TY_CHAR)
    call amovc(Memc[pat], AL_NAME(al), new_pat)
  }
  call sfree(sp)
end

#	Release als structure
procedure	als_close(als) # release als
pointer		als			#I/O structure pointer

int		i, nrows
pointer		al

begin
  if (als == 0) return

  nrows = ALS_ALIASES_LEN(als)
  do i = 1, nrows {
    al = ALS_ALIASES(als,i)
    call mfree(AL_NAME_PTR(al), TY_CHAR)
    call mfree(AL_VALUE_PTR(al), TY_CHAR)
    call al_free(al)
  }
  call mfree(ALS_ALIASES_PTR(als), TY_LONG)
  call als_free(als)
end

#	returns a read-only pointer to the alias's value
#	if it exists.  otherwise, it returns a NULL pointer
procedure	als_alias (als, alias, value)
pointer		als			#I structure
char		alias[ARB]		#I alias
pointer		value			#O value of alias or NULL

pointer		al
int		i
int		len
int		strlen()
int		patmatch()
int		match

begin
  value = NULL
  if (alias[1] == EOS) return
  len = strlen(alias)+1

  do i = 1, ALS_ALIASES_LEN(als) {
    al = ALS_ALIASES(als, i)
    if (al != 0) {
      match = patmatch(alias, AL_NAME(al))
      if (match == len) {
        value = AL_VALUE_PTR(al)
        return
      }
    }
  }
end
