# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  chierr.x
# 	Author	:  tnk
# 	Date	:  09/02/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) chierr.x -r1.3 09/02/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/12/94   tnk	adjusted error checking
# 	09/02/94   tnk	rm factor of 1;  adjusted error check
# 	09/02/94   tnk	date and time created 94/09/02 13:16:25 by tnk
# H-
# 
#

# @(#)chierr.x	1.3 9/12/94

include <mach.h>

#	chi square with errors
#
int procedure	chi_err (bins1, bins2, err1, err2, nbins, cnstrn, df, 
   chsq, prob)
real	bins1[nbins]		#I data
real	bins2[nbins]		#I data
real	err1[nbins]		#I error in bins1 (variance)
real	err2[nbins]		#I error in bins2 (variance)
int	nbins			#I length of data
int	cnstrn			#I constraints
int	df			#O degrees of freedom
real	chsq			#O chi square statistic
real	prob			#O probability

int	j
real    num, denom
int	nr_gammq()

begin

  df = nbins - cnstrn
  chsq = 0.
  do j = 1, nbins {
    num = (bins1[j] - bins2[j])**2
    denom = err1[j] + err2[j]
    if (err1[j] < 0.0 || err2[j] < 0.0) {
        call error(1,"Cannot compute chi square using negative variances")
        return NO
    }
    else if (denom < EPSILONR) { 
      if (num < EPSILONR)
         df = df - 1.
      else
         return NO
    } else {
      chsq = chsq + num / denom
    }
  }
  if (nr_gammq(0.5 * df, 0.5 * chsq, prob) == NO) return NO
  return YES
end
