# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dbg.x
# 	Author	:  ericco
# 	Date	:  08/19/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dbg.x -r1.3 08/19/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/28/92   akeith	This was reworked to do what it was meant to do and that was
#  check that each word in the key was matched by a word in the dict. Thus
#  my own kind of strdict had to be created.
# 	08/19/92   ericco	date and time created 92/08/19 16:27:19 by ericco
# H-
# 
#

#	@(#)dbg.x	1.3

#	Print out debugging information when the given keyword
#	has been set with dbg_open.

include	<dbg.h>

procedure	dbg_printf(key, format)
char		key[ARB]		#I key word
char		format[ARB]		#I output format

pointer		dict
data		dict / NULL /

char	ch_idx
char	junk
bool	good_key
int	len, nlen

pointer	sp
pointer nkey

bool	dbg_andkey()
int	strdic()
int	strlen()

begin

	if (dict == NULL) return

  	if (strdic("KEYS", junk, 1, Memc[dict]) != 0) {
DEBUG(
		call eprintf("KEY = %s \n")
		call pargstr(key)
		call flush(STDERR)
)
	}

#   Format key into a new key.

	call smark(sp)
	call salloc(nkey, 10000, TY_CHAR)

	len = strlen(key)
	call fmt_dict(ch_idx, key, len, Memc[nkey], nlen)

#   Check if it's a good key.

	good_key = dbg_andkey(Memc[dict], Memc[nkey])

	call sfree(sp)

	if(strdic("NOTKEYS", junk, 1, Memc[dict]) != 0){
		if(!good_key) {
DEBUG(
			call eprintf("KEY = %s \n")
			call pargstr(key)
			call flush(STDERR)
)
		}
		return
	}

	if(!good_key) return

DEBUG(
	call eprintf(format)
	call flush(STDERR)
)

	return


#procedure	dbg_start
entry		dbg_start(key, format)

	if (dict != NULL) call mfree(dict, TY_CHAR)
	dict = NULL
	if (format[1] == EOS) return
	len = strlen(format)
	ch_idx = ','

DEBUG(
	call malloc(dict, len+2, TY_CHAR)
	call fmt_dict(ch_idx, format, len, Memc[dict], len)
)
	return

end


bool	procedure	dbg_andkey(dict, key)

char	dict[ARB]		#I dictionary
char	key[ARB]		#I key word

int	d_indx
int	k_indx
int	d_strt
int	k_strt
int	d_len
int	k_len

char	ch_idx

int	ip
int	stridx()
int	strlen()

bool	d_done
bool	k_done

bool	match

begin

	ch_idx = ','

	k_done = FALSE
	k_strt = 2

#	call eprintf("\nstarting dict word = %s ")
#	call pargstr(dict)
#	call eprintf("   key word = %s \n")
#	call pargstr(key)

	repeat {

		k_indx = stridx(ch_idx, key[k_strt])

		if(k_indx == 0) k_done = TRUE
		else key[k_strt+k_indx-1] = EOS

		k_len = strlen(key[k_strt])

		d_done = FALSE
		d_strt = 2

		match = FALSE
		repeat {

			d_indx = stridx(ch_idx, dict[d_strt])

			if(d_indx == 0) d_done = TRUE
			else dict[d_strt+d_indx-1] = EOS

			d_len = strlen(dict[d_strt])

#			call eprintf(" dict word = %s ")
#			call pargstr(dict[d_strt])
#			call eprintf("   key word = %s ")
#			call pargstr(key[k_strt])

			if(d_len > k_len) d_done = TRUE

			do ip = 0, d_len-1 {
				if(dict[d_strt+ip] != key[k_strt+ip]) {
					match = FALSE
					break
				} else match = TRUE
			}

#			call eprintf("   match = %b\n")
#			call pargb(match)

			dict[d_strt+d_indx-1] = ch_idx
			d_strt = d_strt + d_indx

		} until(d_done || match)

		key[k_strt+k_indx-1] = ch_idx
		k_strt = k_strt + k_indx

		if(!match) return(FALSE)

	} until(k_done)

#	call eprintf("\nleaving dict word = %s ")
#	call pargstr(dict)
#	call eprintf("   key word = %s \n")
#	call pargstr(key)

	return(TRUE)

end

procedure	fmt_dict(ch, in, in_len, out, out_len)

char	ch				#I
char	in[in_len]			#I
int	in_len				#I
char	out[ARB]			#O
int	out_len				#O

int	i, j
int	strt, iend

begin

	out[1] = ch

	if(in[1] == ch) strt = 2
	else strt = 1

	if(in[in_len] == ch) iend = in_len-1
	else iend = in_len

	j = 2
	do i = strt, iend {
		out[j] = in[i]
		j = j + 1
	}
	out[j] = EOS
	out_len = j - 1

end


#	Set the key word list of debug output

procedure	dbg_set(dict)
char		dict[ARB]		#I keyword dictionary

char		junk

begin
  call dbg_start(junk, dict)
end


#	Initialize the key word list of debug output

procedure	dbg_open()

char		junk

pointer		sp, dict
int		envgets()

int		dict_len

begin
  dict_len = 20*SZ_LINE
  call smark(sp)
  call salloc(dict, dict_len, TY_CHAR)
  if (envgets("DBGKEYS", Memc[dict], dict_len) == 0) {
    Memc[dict] = EOS
  }
  call dbg_start(junk, Memc[dict])
  call sfree(sp)
end


#	Clear the debug key word list

procedure	dbg_close()

char		junk
begin
  call dbg_start(junk, "")
end


