# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dnam2row.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) dnam2row.x -r1.1 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/28/94   tnk	date and time created 94/04/28 12:20:27 by tnk
# H-
# 
#

# @(#)dnam2row.x	1.1 4/28/94

include <tbset.h>

define DETNAME_COL  "name"

#------------------------------------------------------
# lookup detector name in detector table, return row number
# if not found row is -1
# name search is case insensitive
#
procedure dnam2row(tp,det_name,det_row)
pointer tp               #I   table pointer
char    det_name[ARB]    #I   detector name
int     det_row

# LOCAL VARS
int     nrows            # number of rows
int     row              # current row no.
pointer text
pointer sp
pointer uc_detname
pointer detname_cp       # detector name column pointer

# FUNCTIONS
int     tbpsta()
bool    streq()

begin

  call smark(sp)
  det_row = -1

  # convert incoming detector name to uppercase
  call salloc(uc_detname, SZ_LINE, TY_CHAR)
  call strcpy(det_name, Memc[uc_detname], SZ_LINE)
  call strupr(Memc[uc_detname])

  # get column pointers
  call tbcfnd (tp, DETNAME_COL,  detname_cp, 1)  
  if (detname_cp == NULL) {
    call error(650,"Could not find detname column in detector file")
  }


  # go down each row in table, look for detector name
  call salloc(text, SZ_LINE, TY_CHAR)
  n_rows = tbpsta (tp, TBL_NROWS)
  for (row=1; row <=n_rows; row=row+1) {

     # get detector name
     call tbegttn(tp, detname_cp, row, Memc[text], SZ_LINE)
     call strupr(Memc[text])

     # if match, get collresp & get out
     if (streq(Memc[uc_detname],Memc[text])) {
        det_row = row
        break
     }
  }

  call sfree(sp)

end


