# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eudet.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) eudet.x -r1.5 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	01/21/94   akeith	now convert detector string to upper case so as to match SDICT and put in an error check.
# 	07/13/93   tnk	changed ScA,ScB,ScC to uppercase
# 	09/28/92   akeith	put in debug statements
# 	05/07/91   ericco	date and time created 91/05/07 14:13:34 by ericco
# H-
# 
#

#	Revised: 1/24/94

include <dbg.h>

#	Long detector names

define		LDICT	",SCANNERA,SCANNERB,SCANNERC,SWSPECTROMETER,MWSPECTROMETER,LWSPECTROMETER,DEEPSURVER"

#	Detector number names
define		NDICT	",1,2,3,4,5,6,7"

#	Detector short names
define		SDICT	",SCA,SCB,SCC,SWS,MWS,LWS,DS"

#	Return a detector id from a name.
procedure	eu_detect_id (str, id)		# Get detector id
char		str[ARB]			#I detector name
int		id				#O detector id

int		pos, strdic()
char		junk[1]

pointer	sp, up_str

begin

  call smark(sp)
  call salloc(up_str, SZ_LINE, TY_CHAR)
  call strcpy(str, Memc[up_str], SZ_LINE)
  call strupr(Memc[up_str])

  pos = strdic(Memc[up_str], junk, 0, LDICT)
  if (pos == 0) pos = strdic(Memc[up_str], junk, 0, SDICT)
  if (pos == 0) pos = strdic(Memc[up_str], junk, 0, NDICT)
  if (pos == 0) call eu_error(1, "eu_detect_id(): Not a recognized detector name, ", str)
  id = pos

  call sfree(sp)

end

#	return a detector name based on an id.
procedure	eu_detect_name (id, str, len)	# Get detector name
int		id				#I detector id
char		str[len]			#O string buffer
int		len				#O buffer size

string		ldict LDICT
char		delim
int		cnt
int		op, ep
int		pos

begin
  cnt = 0
  delim = ldict[1]
  op = 0
  ep = 0
  for (pos = 1; ldict[pos] != EOS; pos = pos + 1) {
    if (ldict[pos] == delim) {
      cnt = cnt + 1
      if (op != 0) {
	ep = pos
	break
      } else if (cnt == id) {
	op = pos
      }
    }
  }
  if (ep == 0) ep = pos
  if (op != 0) {
    ep = ep - op
    call strcpy(ldict[op], str, ep)
  } else {
    ep = 0
  }
  if (ep < len) str[ep+1] = EOS
end
