# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eugrange.x
# 	Author	:  akeith
# 	Date	:  06/10/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eugrange.x -r1.1 06/10/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/10/94   akeith	date and time created 94/06/10 15:15:10 by akeith
# H-
# 
#


#	Version: @(#)eugrange.x	1.1 6/10/94 UCB CEA EGO

#
# eu_grange() parses range strings of the form 123:456,321:876
#	Multiple ranges are allowed. Each call to eu_grange() returns
#	the next range in the string. The index pointer, ip, tracks
#	eu_grange()'s position in the range string and should be
#	initialized to 1. The start of each range is returned in
#	lstart and the end of each range is returned in lend. The
#	return value of eu_grange() is the number of charactors
#	converted to an integer value. 0 is returned when the
#	end of string is reached.
#

int	procedure	eu_grange(str, ip, lstart, lend)
 
char	str[ARB]			#I range string
int	ip				#O index of string
int	lstart				#O range start
int	lend				#O range end
 
int	nconv
int	ctoi()
 
begin

	if(ip < 1) ip = 1
	if (str[ip] == EOS) return(0)

	nconv = ctoi(str, ip, lstart)
	if (nconv == 0) call error(42,"invalid number in range")

	if (str[ip] == ':') {
		ip = ip + 1
		nconv = ctoi(str, ip, lend)

		if (nconv == 0)
			call error(42,"invalid number in range")

		if (str[ip] == ',') {
			ip = ip + 1
			return(nconv)

		} else if (str[ip] != EOS)
			call error(456,"invalid character in range")

		return(nconv)

	} else if (str[ip] == ',') {
		lend = lstart
		ip = ip + 1
		return(nconv)

	} else if (str[ip] == EOS) {
		lend = lstart
		return(nconv)

	} else
		call error(546,"invalid character in range")

end

