# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  eugwcs.gx
# 	Author	:  akeith
# 	Date	:  02/14/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) eugwcs.gx -r1.6 02/14/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/14/94   akeith	got rid of unused vars
# 	09/07/94   akeith	commented
# 	03/07/94   akeith	fixed axis mapping for collapsed axis
# 	02/14/94   akeith	date and time created 94/02/14 14:17:52 by akeith
# H-
# 
#


#       Version: @(#)eugwcs.gx	1.6 9/14/94 UCB CEA EGO

include	<imhdr.h>
include	<mwset.h>


#
# lw_c1tran$t()
#

procedure	lw_c1tranr(mw, sys, lx, wx)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	lx				#I logical coord
real	wx				#O world coord

real	t_lx[1], t_wx[1]

begin
	t_lx[1] = lx
	call lw_ctranr(mw, sys, t_lx, t_wx, 1)
	wx = t_wx[1]
end


#
# lw_c1tran$t()
#

procedure	lw_c1trand(mw, sys, lx, wx)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	lx				#I logical coord
double	wx				#O world coord

double	t_lx[1], t_wx[1]

begin
	t_lx[1] = lx
	call lw_ctrand(mw, sys, t_lx, t_wx, 1)
	wx = t_wx[1]
end




#
# wl_c1tran$t()
#

procedure	wl_c1tranr(mw, sys, wx, lx)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	wx				#I world coord
real	lx				#O logical coord

real	t_lx[1], t_wx[1]

begin
	t_wx[1] = wx
	call wl_ctranr(mw, sys, t_lx, t_wx, 1)
	lx = t_lx[1]
end


#
# wl_c1tran$t()
#

procedure	wl_c1trand(mw, sys, wx, lx)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	wx				#I world coord
double	lx				#O logical coord

double	t_lx[1], t_wx[1]

begin
	t_wx[1] = wx
	call wl_ctrand(mw, sys, t_lx, t_wx, 1)
	lx = t_lx[1]
end




#
# lw_v1tran$t()
#

procedure	lw_v1tranr(mw, sys, lx, wx, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	lx[npts]			#I logical coord
real	wx[npts]			#O world coord
int	npts				#I number of points

int	i

begin
	do i = 1, npts
		call lw_ctranr(mw, sys, lx[i], wx[i], 1)
end


#
# lw_v1tran$t()
#

procedure	lw_v1trand(mw, sys, lx, wx, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	lx[npts]			#I logical coord
double	wx[npts]			#O world coord
int	npts				#I number of points

int	i

begin
	do i = 1, npts
		call lw_ctrand(mw, sys, lx[i], wx[i], 1)
end




#
# wl_v1tran$t()
#

procedure	wl_v1tranr(mw, sys, wx, lx, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	wx[npts]			#I world coord
real	lx[npts]			#O logical coord
int	npts				#I number of points

int	i

begin
	do i = 1, npts
		call wl_ctranr(mw, sys, wx[i], lx[i], 1)
end


#
# wl_v1tran$t()
#

procedure	wl_v1trand(mw, sys, wx, lx, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	wx[npts]			#I world coord
double	lx[npts]			#O logical coord
int	npts				#I number of points

int	i

begin
	do i = 1, npts
		call wl_ctrand(mw, sys, wx[i], lx[i], 1)
end




#
# lw_c2tran$t()
#

procedure	lw_c2tranr(mw, sys, lx, ly, wx, wy)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	lx				#I logical coord
real	ly				#I logical coord
real	wx				#O world coord
real	wy				#O world coord

pointer	sp
pointer	a, b

begin
	call smark(sp)
	call salloc(a, 2, TY_REAL)
	call salloc(b, 2, TY_REAL)

	Memr[a] = lx; Memr[a+1] = ly

	call lw_ctranr(mw, sys, Memr[a], Memr[b], 2)

	wx = Memr[b]; wy = Memr[b+1]

	call sfree(sp)
end


#
# lw_c2tran$t()
#

procedure	lw_c2trand(mw, sys, lx, ly, wx, wy)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	lx				#I logical coord
double	ly				#I logical coord
double	wx				#O world coord
double	wy				#O world coord

pointer	sp
pointer	a, b

begin
	call smark(sp)
	call salloc(a, 2, TY_DOUBLE)
	call salloc(b, 2, TY_DOUBLE)

	Memd[a] = lx; Memd[a+1] = ly

	call lw_ctrand(mw, sys, Memd[a], Memd[b], 2)

	wx = Memd[b]; wy = Memd[b+1]

	call sfree(sp)
end




#
# wl_c2tran$t()
#

procedure	wl_c2tranr(mw, sys, wx, wy, lx, ly)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	wx				#I world coord
real	wy				#I world coord
real	lx				#O logical coord
real	ly				#O logical coord

pointer	sp
pointer	a, b

begin
	call smark(sp)
	call salloc(a, 2, TY_REAL)
	call salloc(b, 2, TY_REAL)

	Memr[a] = wx; Memr[a+1] = wy

	call lw_ctranr(mw, sys, Memr[a], Memr[b], 2)

	lx = Memr[b]; ly = Memr[b+1]

	call sfree(sp)
end


#
# wl_c2tran$t()
#

procedure	wl_c2trand(mw, sys, wx, wy, lx, ly)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	wx				#I world coord
double	wy				#I world coord
double	lx				#O logical coord
double	ly				#O logical coord

pointer	sp
pointer	a, b

begin
	call smark(sp)
	call salloc(a, 2, TY_DOUBLE)
	call salloc(b, 2, TY_DOUBLE)

	Memd[a] = wx; Memd[a+1] = wy

	call lw_ctrand(mw, sys, Memd[a], Memd[b], 2)

	lx = Memd[b]; ly = Memd[b+1]

	call sfree(sp)
end




#
# lw_v2tran$t()
#

procedure	lw_v2tranr(mw, sys, lx, ly, wx, wy, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	lx[npts]			#I logical coord
real	ly[npts]			#I logical coord
real	wx[npts]			#O world coord
real	wy[npts]			#O world coord
int	npts				#I number of points

int	i
pointer	sp
pointer	a, b

begin
	call smark(sp)
	call salloc(a, 2, TY_REAL)
	call salloc(b, 2, TY_REAL)

	do i = 1, npts {
		Memr[a] = lx[i]; Memr[a+1] = ly[i]
		call lw_ctranr(mw, sys, Memr[a], Memr[b], 2)
		wx[i] = Memr[b]; wy[i] = Memr[b+1]
	}

	call sfree(sp)
end


#
# lw_v2tran$t()
#

procedure	lw_v2trand(mw, sys, lx, ly, wx, wy, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	lx[npts]			#I logical coord
double	ly[npts]			#I logical coord
double	wx[npts]			#O world coord
double	wy[npts]			#O world coord
int	npts				#I number of points

int	i
pointer	sp
pointer	a, b

begin
	call smark(sp)
	call salloc(a, 2, TY_DOUBLE)
	call salloc(b, 2, TY_DOUBLE)

	do i = 1, npts {
		Memd[a] = lx[i]; Memd[a+1] = ly[i]
		call lw_ctrand(mw, sys, Memd[a], Memd[b], 2)
		wx[i] = Memd[b]; wy[i] = Memd[b+1]
	}

	call sfree(sp)
end




#
# wl_v2tran$t()
#

procedure	wl_v2tranr(mw, sys, wx, wy, lx, ly, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	wx[npts]			#I world coord
real	wy[npts]			#I world coord
real	lx[npts]			#O logical coord
real	ly[npts]			#O logical coord
int	npts				#I number of points

int	i
pointer	sp
pointer	a, b

begin
	call smark(sp)
	call salloc(a, 2, TY_REAL)
	call salloc(b, 2, TY_REAL)

	do i = 1, npts {
		Memr[a] = wx[i]; Memr[a+1] = wy[i]
		call lw_ctranr(mw, sys, Memr[a], Memr[b], 2)
		lx[i] = Memr[b]; ly[i] = Memr[b+1]
	}

	call sfree(sp)
end


#
# wl_v2tran$t()
#

procedure	wl_v2trand(mw, sys, wx, wy, lx, ly, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	wx[npts]			#I world coord
double	wy[npts]			#I world coord
double	lx[npts]			#O logical coord
double	ly[npts]			#O logical coord
int	npts				#I number of points

int	i
pointer	sp
pointer	a, b

begin
	call smark(sp)
	call salloc(a, 2, TY_DOUBLE)
	call salloc(b, 2, TY_DOUBLE)

	do i = 1, npts {
		Memd[a] = wx[i]; Memd[a+1] = wy[i]
		call lw_ctrand(mw, sys, Memd[a], Memd[b], 2)
		lx[i] = Memd[b]; ly[i] = Memd[b+1]
	}

	call sfree(sp)
end




#
# lw_ctran$t()
#

procedure	lw_ctranr(mw, sys, lx, wx, ndim)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	lx[ndim]			#I logical coord
real	wx[ndim]			#O world coord
int	ndim				#I number of dimensions

int	pdim				#
int	physical			#
int	logical				#

pointer	ct				#
pointer	sp				#
pointer x, xp				#
pointer axno, axval			#

begin

	call smark(sp)

	call wcs_gct(mw, sys, FALSE, ct, axno, axval, pdim)

	call salloc(x,  pdim, TY_REAL)
	call salloc(xp, pdim, TY_REAL)

	do physical = 1, pdim {
		logical = Memi[axno+physical-1]
		if(logical != 0) {
			Memr[x+physical-1] = lx[logical]
		} else	Memr[x+physical-1] = Memi[axval+physical-1] + 1
	}

	call mw_ctranr(ct, Memr[x], Memr[xp], pdim)

	do physical = 1, pdim {
		logical = Memi[axno+physical-1]
		if(logical != 0)
			wx[logical] = Memr[xp+physical-1]
	}

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# lw_ctran$t()
#

procedure	lw_ctrand(mw, sys, lx, wx, ndim)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	lx[ndim]			#I logical coord
double	wx[ndim]			#O world coord
int	ndim				#I number of dimensions

int	pdim				#
int	physical			#
int	logical				#

pointer	ct				#
pointer	sp				#
pointer x, xp				#
pointer axno, axval			#

begin

	call smark(sp)

	call wcs_gct(mw, sys, FALSE, ct, axno, axval, pdim)

	call salloc(x,  pdim, TY_DOUBLE)
	call salloc(xp, pdim, TY_DOUBLE)

	do physical = 1, pdim {
		logical = Memi[axno+physical-1]
		if(logical != 0) {
			Memd[x+physical-1] = lx[logical]
		} else	Memd[x+physical-1] = Memi[axval+physical-1] + 1
	}

	call mw_ctrand(ct, Memd[x], Memd[xp], pdim)

	do physical = 1, pdim {
		logical = Memi[axno+physical-1]
		if(logical != 0)
			wx[logical] = Memd[xp+physical-1]
	}

	call mw_ctfree(ct)
	call sfree(sp)

end




#
# wl_ctran$t()
#

procedure	wl_ctranr(mw, sys, wx, lx, ndim)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	wx[ndim]			#I world coord
real	lx[ndim]			#O logical coord
int	ndim				#I number of dimensions

int	pdim				#
int	physical			#
int	logical				#

pointer	ct				#
pointer	sp				#
pointer x, xp				#
pointer axno, axval			#

begin

	call smark(sp)

	call wcs_gct(mw, sys, TRUE, ct, axno, axval, pdim)

	call salloc(x,  pdim, TY_REAL)
	call salloc(xp, pdim, TY_REAL)

	do physical = 1, pdim {
		logical = Memi[axno+physical-1]
		if(logical != 0) {
			Memr[x+physical-1] = wx[logical]
		} else	Memr[x+physical-1] = Memi[axval+physical-1] + 1
	}

	call mw_ctranr(ct, Memr[x], Memr[xp], pdim)

	do physical = 1, pdim {
		logical = Memi[axno+physical-1]
		if(logical != 0)
			lx[logical] = Memr[xp+physical-1]
	}

	call mw_ctfree(ct)
	call sfree(sp)

end


#
# wl_ctran$t()
#

procedure	wl_ctrand(mw, sys, wx, lx, ndim)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	wx[ndim]			#I world coord
double	lx[ndim]			#O logical coord
int	ndim				#I number of dimensions

int	pdim				#
int	physical			#
int	logical				#

pointer	ct				#
pointer	sp				#
pointer x, xp				#
pointer axno, axval			#

begin

	call smark(sp)

	call wcs_gct(mw, sys, TRUE, ct, axno, axval, pdim)

	call salloc(x,  pdim, TY_DOUBLE)
	call salloc(xp, pdim, TY_DOUBLE)

	do physical = 1, pdim {
		logical = Memi[axno+physical-1]
		if(logical != 0) {
			Memd[x+physical-1] = wx[logical]
		} else	Memd[x+physical-1] = Memi[axval+physical-1] + 1
	}

	call mw_ctrand(ct, Memd[x], Memd[xp], pdim)

	do physical = 1, pdim {
		logical = Memi[axno+physical-1]
		if(logical != 0)
			lx[logical] = Memd[xp+physical-1]
	}

	call mw_ctfree(ct)
	call sfree(sp)

end




#
# lw_vtran$t()
#

procedure	lw_vtranr(mw, sys, lx, wx, ndim, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	lx[ndim,npts]			#I logical coord
real	wx[ndim,npts]			#O world coord
int	ndim				#I number of dimensions
int	npts				#I number of points

int	i

begin
	do i = 1, npts
		call lw_ctranr(mw, sys, lx[1, i], wx[1,i], ndim)
end


#
# lw_vtran$t()
#

procedure	lw_vtrand(mw, sys, lx, wx, ndim, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	lx[ndim,npts]			#I logical coord
double	wx[ndim,npts]			#O world coord
int	ndim				#I number of dimensions
int	npts				#I number of points

int	i

begin
	do i = 1, npts
		call lw_ctrand(mw, sys, lx[1, i], wx[1,i], ndim)
end




#
# wl_vtran$t()
#

procedure	wl_vtranr(mw, sys, wx, lx, ndim, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
real	wx[ndim,npts]			#I world coord
real	lx[ndim,npts]			#O logical coord
int	ndim				#I number of dimensions
int	npts				#I number of points

int	i

begin
	do i = 1, npts
		call wl_ctranr(mw, sys, wx[1, i], lx[1,i], ndim)
end


#
# wl_vtran$t()
#

procedure	wl_vtrand(mw, sys, wx, lx, ndim, npts)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
double	wx[ndim,npts]			#I world coord
double	lx[ndim,npts]			#O logical coord
int	ndim				#I number of dimensions
int	npts				#I number of points

int	i

begin
	do i = 1, npts
		call wl_ctrand(mw, sys, wx[1, i], lx[1,i], ndim)
end






procedure	wcs_gct(mw, sys, world_logical, ct, axno, axval, ndim)

pointer	mw				#I mwcs
char	sys[ARB]			#I system
bool	world_logical			#I direction
pointer	ct				#O coord. trans.
pointer axno				#O axis numbers
pointer axval				#O axis numbers
int	ndim				#O number of dim

pointer	mw_sctran()
int	mw_stati()

begin

	call mw_seti(mw, MW_USEAXMAP, NO)
	if(world_logical)
		ct = mw_sctran(mw, sys, "logical", 0)
	else	ct = mw_sctran(mw, "logical", sys, 0)

	ndim = mw_stati(mw, MW_NDIM)

	call salloc(axno, ndim, TY_INT)
	call salloc(axval, ndim, TY_INT)
	call mw_gaxmap(mw, Memi[axno], Memi[axval], ndim)

end

