# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  euqpoe.x
# 	Author	:  ericco
# 	Date	:  10/29/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) euqpoe.x -r1.15 10/29/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/12/95   tnk	added QPF_INHERIT to set inherit flag
# 	08/22/94   tnk	another qp_accessf type mismatch 
# 	08/22/94   tnk	changed qp_accessf type (TRUE->YES)
# 	07/27/94   tnk	added qp_deletef call to fix header card overwrite problem
# 	11/17/93   ericco	logical/int error fix
# 	02/12/93   ericco	removed lowercase
# 	02/05/93   ericco	force macro names to lower case
# 	12/10/92   ericco	removed macro bug hack
# 	10/20/92   ericco	added qp_add_macro
# 	08/11/92   ericco	added qp_add_string function
# 	10/29/91   ericco	added keyword
# 	10/29/91   ericco	date and time created 91/10/29 16:21:19 by ericco
# H-
# 
#

#	Revised: 9/12/95

include <qpset.h>

#	Start a new QPIO event list
procedure	euqpst (qp, axlen, eventdef, qpio)
pointer		qp			#I qpoe descriptor
int		axlen[2]		#I image size	
char		eventdef		#I event definition
pointer		qpio			#O qpio event pointer

long		now, clktime()
int	datamin[8], datamax[8]
data	datamin/0,0,0,0,0,0,0,0/
data	datamax/0,0,0,0,0,0,0,0/
pointer		qpio_open()

begin
  call qp_addf (qp, "naxes", "i", 1, "number of image axis", 0)
  call qp_puti(qp, "naxes", 2)
  call qp_addf(qp, "axlen", "i", 2, "length of each axis", 0)
  call qp_write(qp, "axlen", axlen, 2, 1, "i")

  call qp_addf(qp, "event", eventdef, 1, "event type", 0)
  call qp_addf(qp, "events", "event", 0, "event list", 0)

  now = clktime(0)
  call qp_addf(qp, "cretime", "i", 1, "image creation time", 0)
  call qp_puti(qp, "cretime", now)
  call qp_addf(qp, "modtime", "i", 1, "image modify time", 0)
  call qp_puti(qp, "modtime", now)
  call qp_addf(qp, "limtime", "i", 1, "data min/max update time", 0)
  call qp_puti(qp, "limtime", now)
  call qp_addf(qp, "datamin", "i", 8, "minimum pixel value", 0)
  call qp_write(qp, "datamin", datamin, 8, 1, "i")
  call qp_addf(qp, "datamax", "i", 8, "maximum pixel value", 0)
  call qp_write(qp, "datamax", datamax, 8, 1, "i")
  qpio = qpio_open(qp, "events", NEW_FILE)
end

#
#
#       Add a QPOE file string
#

procedure	qp_add_string (qp, symbol, value) # add string

pointer	qp                      #I QPOE file
char	symbol[ARB]             #I macro name
char	value[ARB]              #I macro value

int	len
int	strlen()
int	qp_accessf()

begin

	len = strlen(value)
	if (qp_accessf(qp, symbol) == YES)
		call qp_deletef(qp, symbol)

	call qp_addf(qp, symbol, "char", 0, "string", QPF_INHERIT)
	call qp_write(qp, symbol, value, len, 1, "char")

end


#	Add a QPOE file macro

	procedure qp_add_macro (qp, symbol, value) # add macro
pointer	qp			#I QPOE file
char	symbol[ARB]		#I macro name
char	value[ARB]		#I macro value

int	len
int	strlen()
int	qp_accessf()

begin
  len = strlen(value)
  if (qp_accessf(qp, symbol) == NO) {
    call qp_addf(qp, symbol, "macro", len, "macro definition", QPF_INHERIT)
  }
  call qp_write(qp, symbol, value, len, 1, "macro")

end

#	Add a table name macro to a QPOE file
procedure	eutabst (qp, table, def) # add table name
pointer		qp			#I QPOE file
int		table			#I table number
char		def[ARB]		#I definition

char	tablename[20]

begin
  call sprintf(tablename, 20, "table%d")
  call pargi(table)
  call qp_add_macro(qp, tablename, def)
end
