# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  hdrcpy.gx
# 	Author	:  tnk
# 	Date	:  04/08/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) hdrcpy.gx -r1.2 04/08/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/23/94   tnk	added cast for tbhadi calls
# 	04/08/94   tnk	date and time created 94/04/08 15:41:24 by tnk
# H-
# 
#

#@(#)hdrcpy.gx	1.2 8/23/94 UCB CEA EGO

# copy a header card from an input file to an output file
# handles file types of QPOE, IMAGE, and TABLE

procedure hdrcpy(in_file,in_ftype,out_file,out_ftype,parmname,parmtype)
pointer in_file           # input file ptr
char    in_ftype[ARB]     # input file type (QPIO, IMAGE, TABLE)
pointer out_file          # output file ptr
char    out_ftype[ARB]    # output file type (QPIO, IMAGE, TABLE)
char    parmname[ARB]     # name of header card to copy over
int     parmtype          # spp variable type of output card

define VALID_FTYPES "|QPOE|IMAGE|TABLE|"

#local vars
pointer sp
pointer textbuff

# for tables, map long & shorts to ints


bool   bool_val

int   int_val

real   real_val

double   double_val

short   short_val

long   long_val


#FUNCTIONS

bool   qp_getb(), imgetb()
bool tbhgtb()

int   qp_geti(), imgeti()
int tbhgti()

real   qp_getr(), imgetr()
real tbhgtr()

double   qp_getd(), imgetd()
double tbhgtd()

short   qp_gets(), imgets()

long   qp_getl(), imgetl()


# FUNCTIONS
int   strdic()

begin

   call smark(sp)
   call salloc(textbuff, SZ_LINE,  TY_CHAR)

   # verify input & output file types
   if (strdic (in_ftype, Memc[textbuff], SZ_LINE, VALID_FTYPES) == 0) 
      call error(150,"cpy_parm: invalid input file type")

   if (strdic (out_ftype, Memc[textbuff], SZ_LINE, VALID_FTYPES) == 0) 
      call error(151,"cpy_parm: invalid output file type")

   # read the value
   switch (parmtype)
   {

      case TY_BOOL:
         switch (in_ftype[1])
         {
            case 'Q': bool_val = qp_getb(in_file, parmname)
            case 'I': bool_val =  imgetb(in_file, parmname)
            case 'T': 
                      bool_val =  tbhgtb(in_file, parmname)    
         }

      case TY_INT:
         switch (in_ftype[1])
         {
            case 'Q': int_val = qp_geti(in_file, parmname)
            case 'I': int_val =  imgeti(in_file, parmname)
            case 'T': 
                      int_val =  tbhgti(in_file, parmname)    
         }

      case TY_REAL:
         switch (in_ftype[1])
         {
            case 'Q': real_val = qp_getr(in_file, parmname)
            case 'I': real_val =  imgetr(in_file, parmname)
            case 'T': 
                      real_val =  tbhgtr(in_file, parmname)    
         }

      case TY_DOUBLE:
         switch (in_ftype[1])
         {
            case 'Q': double_val = qp_getd(in_file, parmname)
            case 'I': double_val =  imgetd(in_file, parmname)
            case 'T': 
                      double_val =  tbhgtd(in_file, parmname)    
         }

      case TY_SHORT:
         switch (in_ftype[1])
         {
            case 'Q': short_val = qp_gets(in_file, parmname)
            case 'I': short_val =  imgets(in_file, parmname)
            case 'T': 
                      short_val =  tbhgti(in_file, parmname)
         }

      case TY_LONG:
         switch (in_ftype[1])
         {
            case 'Q': long_val = qp_getl(in_file, parmname)
            case 'I': long_val =  imgetl(in_file, parmname)
            case 'T': 
                      long_val =  tbhgti(in_file, parmname)
         }


      case TY_CHAR:   # string
         switch (in_ftype[1])
         {
            case 'Q': call qp_gstr(in_file, parmname, Memc[textbuff], SZ_LINE)
            case 'I': call  imgstr(in_file, parmname, Memc[textbuff], SZ_LINE)
            case 'T': call  tbhgtt(in_file, parmname, Memc[textbuff], SZ_LINE)
         }

      default:
         call eprintf("cpy_parm: Warning, can't handle data type %d for '%s'\n")
         call pargi(parmtype)
         call pargstr(parmname)
   }

   #write the value
   switch (parmtype)
   {

      case TY_BOOL:
         switch (out_ftype[1])
         {
            case 'Q': call qp_addb(out_file, parmname, bool_val, "")
            case 'I': call  imaddb(out_file, parmname, bool_val)
            case 'T': 
                      call  tbhadb(out_file, parmname, bool_val)
         }

      case TY_INT:
         switch (out_ftype[1])
         {
            case 'Q': call qp_addi(out_file, parmname, int_val, "")
            case 'I': call  imaddi(out_file, parmname, int_val)
            case 'T': 
                      call  tbhadi(out_file, parmname, int_val)
         }

      case TY_REAL:
         switch (out_ftype[1])
         {
            case 'Q': call qp_addr(out_file, parmname, real_val, "")
            case 'I': call  imaddr(out_file, parmname, real_val)
            case 'T': 
                      call  tbhadr(out_file, parmname, real_val)
         }

      case TY_DOUBLE:
         switch (out_ftype[1])
         {
            case 'Q': call qp_addd(out_file, parmname, double_val, "")
            case 'I': call  imaddd(out_file, parmname, double_val)
            case 'T': 
                      call  tbhadd(out_file, parmname, double_val)
         }

      case TY_SHORT:
         switch (out_ftype[1])
         {
            case 'Q': call qp_adds(out_file, parmname, short_val, "")
            case 'I': call  imadds(out_file, parmname, short_val)
            case 'T': 
                      call  tbhadi(out_file, parmname, int(short_val))
         }

      case TY_LONG:
         switch (out_ftype[1])
         {
            case 'Q': call qp_addl(out_file, parmname, long_val, "")
            case 'I': call  imaddl(out_file, parmname, long_val)
            case 'T': 
                      call  tbhadi(out_file, parmname, int(long_val))
         }


      case TY_CHAR:  # string
         switch (out_ftype[1])
         {
            case 'Q': call qp_astr(out_file, parmname, Memc[textbuff], "")
            case 'I': call  imastr(out_file, parmname, Memc[textbuff], "")
            case 'T': call  tbhadt(out_file, parmname, Memc[textbuff], "")
         }

   }

   call sfree(sp)

end
