# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  imcpcmnt.x
# 	Author	:  tnk
# 	Date	:  08/19/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) imcpcmnt.x -r1.5 08/19/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/30/94   tnk	use salloc for local strings
# 	08/30/94   tnk	extracted get_key_val
# 	08/22/94   tnk	took out debugs
# 	08/19/94   tnk	switched to db calls 
# 	08/19/94   tnk	date and time created 94/08/19 09:54:00 by tnk
# H-
# 
#

# @(#)imcpcmnt.x	1.5 8/30/94 UCB CEA EGO


define KEYLEN 8
define FITSLEN 80

# copy COMMENT and HISTORY cards from input image
# to output image

procedure imcpcmnt(in_fp,out_fp)
pointer in_fp   #I    input image
pointer out_fp  #I/O  output image

int     ualen                   #O size of storage area
pointer idb, rp
pointer idb_open()
int     idb_nextcard()
int     i
pointer sp
pointer key
pointer value
pointer line

# FUNCTIONS
bool    fits_key_val()
bool    streq()
int     strlen()

begin

   call smark(sp)

   call salloc(key,KEYLEN+1,TY_CHAR)
   call salloc(value,SZ_LINE,TY_CHAR)
   call salloc(line,SZ_LINE,TY_CHAR)

   # Get an image header in a text string as a sequence of
   # keyword = value assignments, one per line.

   idb = idb_open (in_fp, ualen)
   while ( idb_nextcard (idb, rp) != EOF)
   {
      for (i=1; i<=FITSLEN; i=i+1)
      {
         Memc[line+i-1]=Memc[rp+i-1]
         if (Memc[line+i-1] == '\n')
            break
         if (Memc[line+i-1] == EOS)
            break
      }
      Memc[line+i-1] = EOS

      if (fits_key_val(Memc[line],Memc[key],Memc[value],SZ_LINE))
      {
         if (streq("COMMENT",key) || streq("HISTORY",key))
         {
            # note that imputh has problems if value has tabs in it!
            for (i=1; i<=strlen(Memc[value]); i=i+1)
            {
               if (Memc[value+i-1] == '\t')
                  Memc[value+i-1]=' '
            }
            call imputh(out_fp,Memc[key],Memc[value])
         }

      }

   }
   call idb_close (idb)

   call sfree(sp)


end
