# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  imcpy.gx
# 	Author	:  tnk
# 	Date	:  05/02/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) imcpy.gx -r1.2 05/02/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/23/94   tnk	made data types generic for alim
# 	05/02/94   tnk	date and time created 94/05/02 13:29:29 by tnk
# H-
# 
#

# @(#)imcpy.gx	1.2 8/23/94 UCB CEA EGO

include	<imhdr.h>

# IM_CPY -- Copy an image.  Use sequential routines to permit copying
# images of any dimension.  Perform pixel i/o in the datatype of the image,
# to avoid unnecessary type conversion.  Also updates min & max values,
# and header timestamps

procedure im_cpy (im1, im2)

pointer im1		#I   open Input image ptr
pointer im2		#I/O open Output image ptr

int	npix, junk
pointer	buf1, buf2
long	v1[IM_MAXDIM], v2[IM_MAXDIM]


int	imgnls(), impnls() 
short   mins, maxs

int	imgnli(), impnli() 
int   mini, maxi

int	imgnll(), impnll() 
long   minl, maxl

int	imgnlr(), impnlr() 
real   minr, maxr

int	imgnld(), impnld() 
double   mind, maxd


double   minval, maxval
long     clktime()

begin

   # Setup start vector for sequential reads and writes.

   call amovkl (long(1), v1, IM_MAXDIM)
   call amovkl (long(1), v2, IM_MAXDIM)

   # Copy the image.
   minval = INDEFD
   maxval = -INDEFD

   npix = IM_LEN(im1, 1)

   switch (IM_PIXTYPE(im1)) {


      case TY_SHORT:
         while (imgnls (im1, buf1, v1) != EOF) {

            junk = impnls (im2, buf2, v2)
            call amovs (Mems[buf1], Mems[buf2], npix)

            # find line min & max
            call alims(Mems[buf1], npix, mins, maxs)
            if (mins < minval) minval = double(mins)
            if (maxs > maxval) maxval = double(maxs)
         }

      case TY_INT:
         while (imgnli (im1, buf1, v1) != EOF) {

            junk = impnli (im2, buf2, v2)
            call amovi (Memi[buf1], Memi[buf2], npix)

            # find line min & max
            call alimi(Memi[buf1], npix, mini, maxi)
            if (mini < minval) minval = double(mini)
            if (maxi > maxval) maxval = double(maxi)
         }

      case TY_LONG:
         while (imgnll (im1, buf1, v1) != EOF) {

            junk = impnll (im2, buf2, v2)
            call amovl (Meml[buf1], Meml[buf2], npix)

            # find line min & max
            call aliml(Meml[buf1], npix, minl, maxl)
            if (minl < minval) minval = double(minl)
            if (maxl > maxval) maxval = double(maxl)
         }

      case TY_REAL:
         while (imgnlr (im1, buf1, v1) != EOF) {

            junk = impnlr (im2, buf2, v2)
            call amovr (Memr[buf1], Memr[buf2], npix)

            # find line min & max
            call alimr(Memr[buf1], npix, minr, maxr)
            if (minr < minval) minval = double(minr)
            if (maxr > maxval) maxval = double(maxr)
         }

      case TY_DOUBLE:
         while (imgnld (im1, buf1, v1) != EOF) {

            junk = impnld (im2, buf2, v2)
            call amovd (Memd[buf1], Memd[buf2], npix)

            # find line min & max
            call alimd(Memd[buf1], npix, mind, maxd)
            if (mind < minval) minval = double(mind)
            if (maxd > maxval) maxval = double(maxd)
         }


      default:
         call error (1, "im_cpy: unknown pixel datatype")
  }

  # update min/max & timestamps in header
  IM_MIN(im2) = minval
  IM_MAX(im2) = maxval
  IM_MTIME(im2) = clktime(long(0))
  IM_LIMTIME(im2) = IM_MTIME(im2) + 1


end
