# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  imhdfnd.x
# 	Author	:  tnk
# 	Date	:  05/17/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) imhdfnd.x -r1.2 05/17/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/26/95   tnk	closed list
# 	05/17/94   tnk	date and time created 94/05/17 17:05:23 by tnk
# H-
# 
#

# @(#)imhdfnd.x	1.2 9/26/95 UCB CEA EGO

# Look up header cards that match a keyword (with wildcard),
# and have an additional string as the first word in their 'value'.
# Returns the "index" of the header card, ie, the number at the
# the end of the header card,
# or -1 on error.
#
# eg,
#
# GHOST03 = 'casper the friendly ghost'
# GHOST05 = 'father of hamlet'
#
# If cardpat="GHOST*" valkey="casper" returns '3'

# limitations
#    - valkey must be the first word in the header card's value
#    - the index scan begins with the first numeral found in the card

int procedure imhdfnd(im, cardpat, valkey)
pointer im              #I   opened input image
char    cardpat[ARB]    #I   header card pattern to search for
char    valkey[ARB]     #I   header value to search for

pointer sp
pointer parmname   # parameter name
pointer parmval    # parameter name
pointer list       # list of symbols in image
int     indx       
int     first,last
int     tmp
int     nchar

# FUNCTIONS
pointer im_ofnlu()
int     im_gnfn()
int     gstrmatch()
int     stridxs()
int     ctoi()

begin

   call smark(sp)
   call salloc(parmname,   SZ_FNAME, TY_CHAR)
   call salloc(parmval,   SZ_FNAME, TY_CHAR)

   indx = -1

   # go through the list of header cards that match the given pattern
   list = im_ofnlu (im, cardpat)
   while (im_gnfn (list, Memc[parmname], SZ_FNAME) != EOF) {

      # get the value associated with the card
      call imgstr(im, Memc[parmname], Memc[parmval], SZ_LINE)

      # is valkey in the value string?
      if (gstrmatch(Memc[parmval],valkey,first,last) != 0)
      {
         # does valkey start at the beginning?
         if (first == 1)
         { 
            # convert numerical "suffix" of header card to an integer
            first = stridxs ("0123456789",Memc[parmname])
            if (first != 0)
            {
               nchar = ctoi(Memc[parmname],first,tmp) 
               if (nchar != 0)
                  indx = tmp
            }
            break
         }
      }

   }
   call imcfnl(list)
   call sfree(sp)

   return(indx)


end
