# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  imhdtype.x
# 	Author	:  tnk
# 	Date	:  08/30/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) imhdtype.x -r1.4 08/30/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/06/94   tnk	fixed bool detect
# 	08/30/94   tnk	took out debugs
# 	08/30/94   tnk	use salloc for local strings
# 	08/30/94   tnk	date and time created 94/08/30 13:23:23 by tnk
# H-
# 
#

# @(#)imhdtype.x	1.4 9/6/94 UCB CEA EGO

include <lexnum.h>
include <ctype.h>

define KEYLEN 8
define FITSLEN 80

# return data type of image header

int procedure imhdtype(im,search_key)
pointer im                #I    input image
char    search_key[ARB]   #I    header key to find type of

int     ualen                   #O size of storage area
pointer idb, rp
pointer idb_open()
int     idb_nextcard()
int     i
int     ret_type
pointer sp
pointer key
pointer value
pointer line

# FUNCTIONS
bool    fits_key_val()
bool    streq()
int     hdrtype()

begin

   call smark(sp)

   call salloc(key,KEYLEN+1,TY_CHAR)
   call salloc(value,SZ_LINE,TY_CHAR)
   call salloc(line,SZ_LINE,TY_CHAR)

   # Get an image header in a text string as a sequence of
   # keyword = value assignments, one per line.

   idb = idb_open (im, ualen)
   while ( idb_nextcard (idb, rp) != EOF)
   {
      for (i=1; i<=FITSLEN; i=i+1)
      {
         Memc[line+i-1]=Memc[rp+i-1]
         if (Memc[line+i-1] == '\n')
            break
         if (Memc[line+i-1] == EOS)
            break
      }
      Memc[line+i-1] = EOS

      if (fits_key_val(Memc[line],Memc[key],Memc[value],SZ_LINE))
      {
         if (streq(search_key,Memc[key]))
         {
             ret_type = hdrtype(Memc[value])
         }

      }

   }
   call idb_close (idb)

   call sfree(sp)

   return(ret_type)

end
#-------------------------------------
# return the data type of a header card value

int procedure hdrtype(value)
char value[ARB]   #I header card value

int ret_type
int ret
int nchars
int ip
char ch
int i,j
int len_nowhite
int strlen()
int lexnum()

begin

   ip = 1
   ret = lexnum(value, ip, nchars)

   # find out how many non-white chars we have
   len_nowhite=0
   for (i=1; i<=strlen(value); i=i+1)
   {
      if (!IS_WHITE(value[i]))
         len_nowhite = len_nowhite + 1
   }

   # if the entire string was converted, we might have some kind of number
   if ( nchars == len_nowhite ) {
        ip = 1
        switch ( ret ) {
          case LEX_NONNUM :  
            ret_type = TY_CHAR
          case LEX_DECIMAL :
            ret_type = TY_INT
          case LEX_REAL :
            ret_type = TY_REAL
         default :
            ret_type = TY_CHAR
        }
   }
   else {
       ret_type = TY_CHAR
   }

   # Check for boolean field (single T or F in white space)
   if (ret_type == TY_CHAR)
   {
      j=0
      for (i=1; i<=strlen(value); i=i+1)
      {
         ch = value[i]
         if (! IS_WHITE(ch))
         {
            if (ch == 'T' || ch == 'F')
            {
               j = j + 1
               if (j>1) break
            }
            else
            {
               j=0
               break
            }
         }         
      }
      if (j == 1)
          ret_type = TY_BOOL
   }

   return(ret_type)
 
end
