# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  match_list.x
# 	Author	:  tnk
# 	Date	:  04/08/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) match_list.x -r1.4 04/08/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	01/13/97   tnk	more comment tweaks
# 	01/13/97   tnk	updated comments
# 	01/10/97   mabbott	new pattern matching for regex
# 	04/08/94   tnk	date and time created 94/04/08 15:43:06 by tnk
# H-
# 
#


# @(#)match_list.x	1.4 1/13/97 UCB CEA EGO

#-------------------------------------------------------------
# Returns true if target matches one of the patterns in list_str.
# Match is case-insensitive.
# The patterns in list_str 
# will be anchored at the beginning & end, i.e., "^<pattern>$"
#

define SZ_PATBUF (2*SZ_LINE)


bool procedure match_list(list_str, target)
char list_str[ARB]     #I space separated list of patterns 
char target[ARB]       #I target to match to list

bool    match
int     ip
int     n
pointer sp
pointer pattern
pointer patbuf
pointer text

#FUNCTIONS
int ctowrd()
int patmatch()
int patmake()

begin

    call smark(sp)
    call salloc(pattern, SZ_LINE,  TY_CHAR)
    call salloc(patbuf, SZ_PATBUF,  TY_CHAR)
    call salloc(text, SZ_LINE, TY_CHAR)

    match=false
    ip = 1

    # pull each pattern out of list
    while (ctowrd (list_str, ip, Memc[text], SZ_LINE) > 0)
    {
       # format pattern as "^{<pattern>}$"
       # so that matching is anchored at both ends 
       # and case is ignored

       call strcpy("^{",Memc[pattern],SZ_LINE)
       call strcat(Memc[text], Memc[pattern], SZ_LINE)
       call strcat("}$",Memc[pattern],SZ_LINE)

       n = patmake(Memc[pattern], Memc[patbuf], SZ_PATBUF)
       if (patmatch (target,Memc[patbuf]) != 0)
       {
          match=true
          break
       }
    }  

    call sfree(sp)

    return(match)

end

