# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  mkgauss.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) mkgauss.x -r1.1 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/28/94   tnk	date and time created 94/04/28 12:20:28 by tnk
# H-
# 
#

# @(#)mkgauss.x	1.1 4/28/94 UCB CEA EGO

include <math.h>

# make a sampled gaussian, results go into an array
#
# need to enhance by only generating half, since it's symmetrical
#
procedure mkgauss(xmid,sigma,npts,xlist,out)
double xmid       #I midpoint (x value) of gaussian
double sigma      #I one sigma value of gaussian
int    npts       #I no. of points to generate
double xlist[ARB] #I list of x values to evaluate (npts long)
double out[ARB]  #I/O output array (must already exist)

# make a gaussian distribution
#
# from "experimental measurements" by barford  (p.118)
#
#               1                |  (x-xmid)^2  |
#  f(x) = ---------------- * exp |- ----------- |
#         SQRT(2*PI)*sigma       |   2*sigma^2  |
# where:
#    xmid  = mid x point of the gaussian
#    sigma = one sigma value

double scale         # scale (normalization) factor
double sigma_sqr_2
int    i

begin

   scale=1.0d0/(sqrt(TWOPI)*sigma)
   sigma_sqr_2 = 2 * sigma * sigma

   for (i=1; i<=npts; i=i+1) {
      out[i] = scale * exp( - (xlist[i]-xmid)**2 / sigma_sqr_2) 
   }

end

