# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  mw2d3d.x
# 	Author	:  tnk
# 	Date	:  07/19/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) mw2d3d.x -r1.1 07/19/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/19/94   tnk	date and time created 94/07/19 10:10:02 by tnk
# H-
# 
#

# @(#)mw2d3d.x	1.1 7/19/94 UCB CEA EGO

#---------------------------------------------
# copy 2d mwcs info into a newly created 3d mwcs pointer
#   default wcs is set to 'world'
procedure mw2d3d(mw2d, mw3d)
pointer mw2d       #I 2d wcs info
pointer mw3d       #O 3d wcs info pointer

pointer sp
pointer cd_in,cd_out, r, w
pointer ltm_in, ltm_out, ltv
int     ndim_in, ndim_out
int     i
pointer attr_index_str
pointer valstr
int	attr_index
pointer mw_open()

begin

   call smark(sp)

   ndim_in = 2
   ndim_out = 3

   # create 3d mwcs
   mw3d = mw_open(NULL, ndim_out)

   # logical coords
   call salloc(ltm_in, ndim_in*ndim_in, TY_REAL)
   call salloc(ltm_out, ndim_out*ndim_out, TY_REAL)
   call salloc(ltv, ndim_out, TY_REAL)

   # world coords
   call salloc(r, ndim_out, TY_REAL)
   call salloc(w, ndim_out, TY_REAL)
   call salloc(cd_in, ndim_in*ndim_in, TY_REAL)
   call salloc(cd_out, ndim_out*ndim_out, TY_REAL)

   # fill in default WCS values
   call aclrr(Memr[ltm_in], ndim_in*ndim_in)
   call aclrr(Memr[ltm_out], ndim_out*ndim_out)
   call amovkr(0.0, Memr[ltv], ndim_out)
   call amovkr(1.0, Memr[r], ndim_out)
   call amovkr(1.0, Memr[w], ndim_out)
   call aclrr(Memr[cd_in], ndim_in*ndim_in)
   call aclrr(Memr[cd_out], ndim_out*ndim_out)
    
   # set diagonal to 1
   do i=1,ndim_out {
      Memr[ltm_out+ndim_out*(i-1)+i-1] = 1.0
      Memr[cd_out+ndim_out*(i-1)+i-1] = 1.0
   }

   call mw_newsystem(mw3d,"world",ndim_out)

   # copy over attributes
   call salloc(attr_index_str, SZ_LINE, TY_CHAR)
   call salloc(valstr, SZ_LINE, TY_CHAR)
   for (i=1; i<=ndim_in; i=i+1)
   {
      attr_index=1
      repeat {
         call sprintf(Memc[attr_index_str], SZ_LINE, "%d")
         call pargi(attr_index)

         ifnoerr(call mw_gwattrs(mw2d, i, Memc[attr_index_str],
                    Memc[valstr], SZ_LINE))
         {
             call mw_swattrs(mw3d, i, Memc[attr_index_str],
                    Memc[valstr], SZ_LINE)

             attr_index = attr_index + 1
         }
         else
            break
      }
   }

   # overwrite info for first 2 dims
   # Logical
   call mw_gltermr(mw2d, Memr[ltm_in], Memr[ltv], ndim_in)
   Memr[ltm_out+0] = Memr[ltm_in+0]
   Memr[ltm_out+1] = Memr[ltm_in+1]
   Memr[ltm_out+3] = Memr[ltm_in+2]
   Memr[ltm_out+4] = Memr[ltm_in+3]
   call mw_sltermr(mw3d, Memr[ltm_out], Memr[ltv], ndim_out)

   # world
   call mw_gwtermr(mw2d, Memr[r], Memr[w], Memr[cd_in], ndim_in)
   Memr[cd_out+0] = Memr[cd_in+0]
   Memr[cd_out+1] = Memr[cd_in+1]
   Memr[cd_out+3] = Memr[cd_in+2]
   Memr[cd_out+4] = Memr[cd_in+3]
   call mw_swtermr(mw3d, Memr[r], Memr[w], Memr[cd_out], ndim_out)
   
   call sfree(sp)

end
