# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  psarray.gx
# 	Author	:  ericco
# 	Date	:  11/23/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) psarray.gx -r1.2 11/23/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/17/93   ericco	fixed ...toc parameter datatypes
# 	11/23/92   ericco	date and time created 92/11/23 11:11:50 by ericco
# H-
# 
#



define	STR_LEN_D	15
define	STR_FMT_D	"%f"

define	STR_LEN_R	10
define	STR_FMT_R	"%f"

define	STR_LEN_L	10
define	STR_FMT_L	"%d"

define	STR_LEN_I	10
define	STR_FMT_I	"%d"

define	STR_LEN_S	10
define	STR_FMT_S	"%d"

include <ctype.h>

define	EL	(str[$1] == EOS || str[$1] == '\n')
define	NC	(str[$1] != EOS && str[$1] != $2)
define	SC	while (NC($1,',')) IN($1)
define	IN	$1 = $1 + 1
define	SW	while (IS_WHITE(str[$1])) IN($1)

int procedure	ctos(str, ip, val)
char		str[ARB]	#I string
int		ip		#I index
short		val		#O value

int		status
int		value
int		ctoi()

begin
  status = ctoi(str, ip, value)
  val = value
  return status
end


int procedure	ps_itoc(value, str, len)
int		value		#I value to convert
char		str[len]	#O string to write to
int		len		#O length of string

int		itoc()

begin
  return itoc(value, str, len)
end

int procedure	ps_stoc(value, str, len)
short		value		#I value to convert
char		str[len]	#O string to write to
int		len		#O length of string

int		itoc()

begin
  return itoc(int(value), str, len)
end

int procedure	ps_ltoc(value, str, len)
long		value		#I value to convert
char		str[len]	#O string to write to
int		len		#O length of string

int		ltoc()

begin
  return ltoc(value, str, len)
end

int procedure	ps_rtoc(value, str, len)
real		value		#I value to convert
char		str[len]	#O string to write to
int		len		#O length of string

int		ps_dtoc()

begin
  return ps_dtoc(double(value), str, len)
end

int procedure	ps_dtoc(value, str, len)
double		value		#I value to convert
char		str[len]	#O string to write to
int		len		#O length of string

int		dtoc()
char		fmt
data		fmt / 'f' /

begin
  return dtoc(value, str, len, 0, int(fmt), STR_LEN_D)
end



#	Convert an array of values into a delimited string
procedure	ps_array_i(ptr, array, length) #E
pointer		ptr		#O salloced string pointer
int		array[length]	#I values
int		length		#I number of values

int		i
int		len
pointer		op, ep
int		ps_itoc()

begin
  len = STR_LEN_I * length + length
  call salloc(ptr, len, TY_CHAR)
  ep = ptr + len
  op = ptr
  do i = 1, length {
    if (i != 1) {
      Memc[op] = ','
      op = op + 1
    }
    op = op + ps_itoc(array[i], Memc[op], ep - op)
  }
  Memc[op] = EOS
end

#	Convert a string into an array of values
procedure	ps_new_array_i(str, ptr, length) #E
char		str[ARB]	#I string buffer
pointer		ptr		#O output values
int		length		#O number of values

int		len
pointer		op
int		ctoi()
int		strlen()
int		nchr

begin
  op = 1
  len = strlen(str)/2 + 2
  call malloc(ptr, len, TY_INT)
  length = 0

  repeat {
    SW(op)
    if (EL(op)) break
    nchr = ctoi(str, op, Memi[ptr+length])
#    op = op + nchr
    IN(length)

    SC(op)
    if (EL(op)) break
    IN(op)
  }
  if (length == 0) {
    call mfree(ptr, TY_INT)
    ptr = 0
  } else {
    call realloc(ptr, length, TY_INT)
  }
end

#	Convert a string into an array of values
procedure	ps_get_array_i(str, array, length) #E
char		str[ARB]	#I string buffer
int		array[length]	#O output values
int		length		#O number of values

pointer		op
int		ctoi()
int		cnt
int		nchr

begin
  op = 1
  cnt = 1
  repeat {
    SW(op)
    if (EL(op)) break
    if (cnt > length) break
    nchr = ctoi(str, op, array[cnt])
#    op = op + nchr
    IN(cnt)

    SC(op)
    IN(op)
  }
end

#	Convert an array of values into a delimited string
procedure	ps_array_s(ptr, array, length) #E
pointer		ptr		#O salloced string pointer
short		array[length]	#I values
int		length		#I number of values

int		i
int		len
pointer		op, ep
int		ps_stoc()

begin
  len = STR_LEN_S * length + length
  call salloc(ptr, len, TY_CHAR)
  ep = ptr + len
  op = ptr
  do i = 1, length {
    if (i != 1) {
      Memc[op] = ','
      op = op + 1
    }
    op = op + ps_stoc(array[i], Memc[op], ep - op)
  }
  Memc[op] = EOS
end

#	Convert a string into an array of values
procedure	ps_new_array_s(str, ptr, length) #E
char		str[ARB]	#I string buffer
pointer		ptr		#O output values
int		length		#O number of values

int		len
pointer		op
int		ctos()
int		strlen()
int		nchr

begin
  op = 1
  len = strlen(str)/2 + 2
  call malloc(ptr, len, TY_SHORT)
  length = 0

  repeat {
    SW(op)
    if (EL(op)) break
    nchr = ctos(str, op, Mems[ptr+length])
#    op = op + nchr
    IN(length)

    SC(op)
    if (EL(op)) break
    IN(op)
  }
  if (length == 0) {
    call mfree(ptr, TY_SHORT)
    ptr = 0
  } else {
    call realloc(ptr, length, TY_SHORT)
  }
end

#	Convert a string into an array of values
procedure	ps_get_array_s(str, array, length) #E
char		str[ARB]	#I string buffer
short		array[length]	#O output values
int		length		#O number of values

pointer		op
int		ctos()
int		cnt
int		nchr

begin
  op = 1
  cnt = 1
  repeat {
    SW(op)
    if (EL(op)) break
    if (cnt > length) break
    nchr = ctos(str, op, array[cnt])
#    op = op + nchr
    IN(cnt)

    SC(op)
    IN(op)
  }
end

#	Convert an array of values into a delimited string
procedure	ps_array_l(ptr, array, length) #E
pointer		ptr		#O salloced string pointer
long		array[length]	#I values
int		length		#I number of values

int		i
int		len
pointer		op, ep
int		ps_ltoc()

begin
  len = STR_LEN_L * length + length
  call salloc(ptr, len, TY_CHAR)
  ep = ptr + len
  op = ptr
  do i = 1, length {
    if (i != 1) {
      Memc[op] = ','
      op = op + 1
    }
    op = op + ps_ltoc(array[i], Memc[op], ep - op)
  }
  Memc[op] = EOS
end

#	Convert a string into an array of values
procedure	ps_new_array_l(str, ptr, length) #E
char		str[ARB]	#I string buffer
pointer		ptr		#O output values
int		length		#O number of values

int		len
pointer		op
int		ctol()
int		strlen()
int		nchr

begin
  op = 1
  len = strlen(str)/2 + 2
  call malloc(ptr, len, TY_LONG)
  length = 0

  repeat {
    SW(op)
    if (EL(op)) break
    nchr = ctol(str, op, Meml[ptr+length])
#    op = op + nchr
    IN(length)

    SC(op)
    if (EL(op)) break
    IN(op)
  }
  if (length == 0) {
    call mfree(ptr, TY_LONG)
    ptr = 0
  } else {
    call realloc(ptr, length, TY_LONG)
  }
end

#	Convert a string into an array of values
procedure	ps_get_array_l(str, array, length) #E
char		str[ARB]	#I string buffer
long		array[length]	#O output values
int		length		#O number of values

pointer		op
int		ctol()
int		cnt
int		nchr

begin
  op = 1
  cnt = 1
  repeat {
    SW(op)
    if (EL(op)) break
    if (cnt > length) break
    nchr = ctol(str, op, array[cnt])
#    op = op + nchr
    IN(cnt)

    SC(op)
    IN(op)
  }
end

#	Convert an array of values into a delimited string
procedure	ps_array_r(ptr, array, length) #E
pointer		ptr		#O salloced string pointer
real		array[length]	#I values
int		length		#I number of values

int		i
int		len
pointer		op, ep
int		ps_rtoc()

begin
  len = STR_LEN_R * length + length
  call salloc(ptr, len, TY_CHAR)
  ep = ptr + len
  op = ptr
  do i = 1, length {
    if (i != 1) {
      Memc[op] = ','
      op = op + 1
    }
    op = op + ps_rtoc(array[i], Memc[op], ep - op)
  }
  Memc[op] = EOS
end

#	Convert a string into an array of values
procedure	ps_new_array_r(str, ptr, length) #E
char		str[ARB]	#I string buffer
pointer		ptr		#O output values
int		length		#O number of values

int		len
pointer		op
int		ctor()
int		strlen()
int		nchr

begin
  op = 1
  len = strlen(str)/2 + 2
  call malloc(ptr, len, TY_REAL)
  length = 0

  repeat {
    SW(op)
    if (EL(op)) break
    nchr = ctor(str, op, Memr[ptr+length])
#    op = op + nchr
    IN(length)

    SC(op)
    if (EL(op)) break
    IN(op)
  }
  if (length == 0) {
    call mfree(ptr, TY_REAL)
    ptr = 0
  } else {
    call realloc(ptr, length, TY_REAL)
  }
end

#	Convert a string into an array of values
procedure	ps_get_array_r(str, array, length) #E
char		str[ARB]	#I string buffer
real		array[length]	#O output values
int		length		#O number of values

pointer		op
int		ctor()
int		cnt
int		nchr

begin
  op = 1
  cnt = 1
  repeat {
    SW(op)
    if (EL(op)) break
    if (cnt > length) break
    nchr = ctor(str, op, array[cnt])
#    op = op + nchr
    IN(cnt)

    SC(op)
    IN(op)
  }
end

#	Convert an array of values into a delimited string
procedure	ps_array_d(ptr, array, length) #E
pointer		ptr		#O salloced string pointer
double		array[length]	#I values
int		length		#I number of values

int		i
int		len
pointer		op, ep
int		ps_dtoc()

begin
  len = STR_LEN_D * length + length
  call salloc(ptr, len, TY_CHAR)
  ep = ptr + len
  op = ptr
  do i = 1, length {
    if (i != 1) {
      Memc[op] = ','
      op = op + 1
    }
    op = op + ps_dtoc(array[i], Memc[op], ep - op)
  }
  Memc[op] = EOS
end

#	Convert a string into an array of values
procedure	ps_new_array_d(str, ptr, length) #E
char		str[ARB]	#I string buffer
pointer		ptr		#O output values
int		length		#O number of values

int		len
pointer		op
int		ctod()
int		strlen()
int		nchr

begin
  op = 1
  len = strlen(str)/2 + 2
  call malloc(ptr, len, TY_DOUBLE)
  length = 0

  repeat {
    SW(op)
    if (EL(op)) break
    nchr = ctod(str, op, Memd[ptr+length])
#    op = op + nchr
    IN(length)

    SC(op)
    if (EL(op)) break
    IN(op)
  }
  if (length == 0) {
    call mfree(ptr, TY_DOUBLE)
    ptr = 0
  } else {
    call realloc(ptr, length, TY_DOUBLE)
  }
end

#	Convert a string into an array of values
procedure	ps_get_array_d(str, array, length) #E
char		str[ARB]	#I string buffer
double		array[length]	#O output values
int		length		#O number of values

pointer		op
int		ctod()
int		cnt
int		nchr

begin
  op = 1
  cnt = 1
  repeat {
    SW(op)
    if (EL(op)) break
    if (cnt > length) break
    nchr = ctod(str, op, array[cnt])
#    op = op + nchr
    IN(cnt)

    SC(op)
    IN(op)
  }
end

