# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  pssplit.x
# 	Author	:  ericco
# 	Date	:  11/23/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) pssplit.x -r1.1 11/23/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/23/92   ericco	date and time created 92/11/23 11:16:27 by ericco
# H-
# 
#

#	11/23/92

include <ctype.h>

define	EL	(Memc[$1] == EOS || Memc[$1] == '\n' || Memc[$1] == '#')
define	NC	(Memc[$1] != EOS && Memc[$1] != $2)
define	ND	(NC($1,',') && (!IS_WHITE(Memc[$1])))
define	NQ	NC($1,'"')
define	IN	$1 = $1 + 1
define	SW	while (IS_WHITE(Memc[$1])) IN($1)
define	SD	while (ND($1)) IN($1)
define	SC	while (NC($1,',')) IN($1)
define	SQ	while (NQ($1)) IN($1)
define	SE	Memc[$1] = EOS

#	Split pset line into components
int procedure	ps_split(buf, name, type, mode, value, comment)
pointer		buf		#I line pointer
pointer		name		#O name field
pointer		type		#O type field
pointer		mode		#O mode field
pointer		value		#O value field
pointer		comment		#O comment field

pointer		ip

begin
  ip = buf

  # delimit parameter name
  SW(ip)			# skip white
  if (EL(ip)) return NO		# return on end
  name = ip
  SD(ip)			# skip non-commas
  if (EL(ip)) return NO		# return on end
  SE(ip)			# set EOS
  SW(ip)			# skip white
  IN(ip)			# increment pointer

  # delimit type
  SW(ip)			# skip white
  if (EL(ip)) return NO		# return on end
  type = ip
  SD(ip)			# skip non-commas
  if (EL(ip)) return NO		# return on end
  SE(ip)			# set EOS
  SW(ip)			# skip white
  IN(ip)			# increment pointer

  # delimit mode
  SW(ip)			# skip white
  if (EL(ip)) return NO		# return on end
  mode = ip
  SD(ip)			# skip non-commas
  if (EL(ip)) return NO		# return on end
  SE(ip)			# set EOS
  SW(ip)			# skip white
  IN(ip)			# increment pointer

  # delimit value
  SW(ip)			# skip white
  if (EL(ip)) return NO		# return on end
  value = ip
  if (NQ(ip)) {
    SD(ip)			# skip non-commas
    if (EL(ip)) return NO	# return on end
    if (NC(ip,',')) {
      SE(ip)			# set EOS
      IN(ip)			# increment pointer
      SC(ip)			# skip to comma
    }
    SE(ip)			# set EOS
    IN(ip)
  } else {
    IN(ip)
    IN(value)
    SQ(ip)			# skip non-quote
    if (EL(ip)) return NO	# return on end
    SE(ip)			# set EOS
    IN(ip)			# increment pointer
    SC(ip)			# skip to comma
    IN(ip)			# increment pointer
  }

  # skip min value
  SW(ip)			# skip white
  if (EL(ip)) return NO		# return on end
  SD(ip)			# skip non-commas
  if (EL(ip)) return NO		# return on end
  SW(ip)			# skip white
  if (EL(ip)) return NO		# return on end
  IN(ip)			# increment pointer

  # skip max value
  SW(ip)			# skip white
  if (EL(ip)) return NO		# return on end
  SD(ip)			# skip non-commas
  if (EL(ip)) return NO		# return on end
  SW(ip)			# skip white
  if (EL(ip)) return NO		# return on end
  IN(ip)			# increment pointer

  SW(ip)			# skip white
  comment = ip
  return YES
end
