# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpdtypeeuv.x
# 	Author	:  bboyd
# 	Date	:  09/26/97
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpdtypeeuv.x -r1.2 09/26/97 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/10/97   bboyd	removed third argument (dsym) and last case for datatype
# 	09/26/97   bboyd	date and time created 97/09/26 15:11:14 by bboyd
# H-
# 
#

include	<ctype.h>
include	<qpeuv.h>

# QP_DTYPEEUV -- Translate the given symbolic datatype name into an integer
# type code.  The possible type codes are most of the standard SPP TY_type
# codes, plus TY_MACRO, TY_OPAQUE, and TY_USER. The integer type code is
# returned as the function value.
#
# Based on the private QPOE routine QP_DTYPE and modified for use in the
# euv package.

int procedure qp_dtypeeuv (qp, datatype)

pointer	qp			#I QPOE descriptor
char	datatype[ARB]		#I symbolic datatype name

char	junk[1]
int	dtype, ip
string	types "|bool|char|short|int|long|real|double|complex|macro|opaque|"

int	stridx(), strdic()

begin
	dtype = NULL
	for (ip=1;  IS_WHITE(datatype[ip]);  ip=ip+1)
	    ;

	# Single character standard dtype code (bcsilrdx)?
	if (datatype[ip+1] == EOS)
	    dtype = stridx (datatype[ip], SPPTYPES)

	# Spelled out dtype name.  Check standard names first.
	if (dtype == NULL) {
	    dtype = strdic (datatype[ip], junk, 1, types)
	    if (dtype == 9)
		dtype = TY_MACRO
	    else if (dtype == 10)
		dtype = TY_OPAQUE
	}

	# Lastly, check the special types.
	if (dtype == 0) {
	    dtype = TY_USER
	}

	return (dtype)
end
