# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  tbhckl.x
# 	Author	:  tnk
# 	Date	:  12/11/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) tbhckl.x -r1.1 12/11/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/11/92   tnk	date and time created 92/12/11 16:40:55 by tnk
# H-
# 
#


# @(#)tbhckl.x	1.1 12/11/92 CEA
# Author: T. Kilsdonk

include <tbset.h>

# copy table header parameters, except for those that match
# the patterns in the kill list.

# kill list is a string of patterns w/ metacharacters, eg. "RATE00? RATE001"
#
# STRMATCH recognizes the metacharacters BOL, EOL, ANY, WHITESPACE, IGNORECASE,
# and MATCHCASE (BOL and EOL are special only as the first and last chars
# in the pattern).  The null pattern matches any string.  Metacharacters
# can be escaped.


procedure tbhckl(in_tab, kill_list, out_tab)

pointer in_tab       #I input table pointer
char kill_list[ARB]  #I list of wildcards to exclude (white space sep. tokens)
pointer out_tab      #O output table pointer

# LOCAL VARIABLES

pointer sp            # stack pointer
pointer parm_name     # parameter name
pointer parm_val      # parameter value
int     data_type     # data type
int     in_parm_num   # input table parameter number
int     n_in_parms    # total number of input table parameters
int     out_parm_num  # output parameter number
int     nextch        # index returned from strmatch
int     ip            # index into string
bool    match         # true if kill pattern matches parameter
pointer one_kill      # buffer to hold individual kill pattern

# FUNCTIONS
int     tbpsta()      # table status information
int     strmatch()    # string match
int     ctowrd()      # get word

begin

   call smark(sp)         # mark the stack
   call salloc (parm_name, SZ_KEYWORD, TY_CHAR)
   call salloc (parm_val, SZ_PARREC, TY_CHAR)
   call salloc (one_kill, SZ_LINE, TY_CHAR)
 
   out_parm_num = 0 
   n_in_parms =  tbpsta(in_tab,TBL_NPAR)

   # go through all the input table parameters
   do in_parm_num=1, n_in_parms {

      # read next parameter
      call tbhgnp (in_tab, in_parm_num, Memc[parm_name], data_type, 
         Memc[parm_val])

      # see if any of the kill wildcard patterns match

      ip = 1
      match=false

      # pull each pattern out of the kill list & compare against parm_name
      while (ctowrd (kill_list, ip, Memc[one_kill], SZ_LINE) > 0) {
         nextch = strmatch (Memc[parm_name],Memc[one_kill])
         if (nextch != 0) match=true
      }  
        
      # if doesn't match any kill patterns, then copy it to the output table
      if (!match) {
         # add parameter 
         out_parm_num = out_parm_num + 1
         call tbhanp (out_tab, Memc[parm_name], data_type, Memc[parm_val],
            out_parm_num)
     
      }
   }

   call sfree(sp)

end


