# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  tpops.x
# 	Author	:  akeith
# 	Date	:  02/12/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) tpops.x -r1.1 02/12/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/12/93   akeith	date and time created 93/02/12 10:20:04 by akeith
# H-
# 
#


include "tp.h"

pointer	procedure	tp_open(nitems)

int	nitems

int	i

pointer	tp
pointer it

begin

	call tp_malloc(tp)

	TP_ELM_LEN(tp) = nitems
	call malloc(TP_ELM_PTR(tp), TP_ELM_LEN(tp), TY_LONG)

	do i = 1, nitems {
		call it_malloc(it)
		TP_ELM(tp, i) = it
		IT_TCPU(it) = ZERO_TIME
		IT_START(it) = ZERO_TIME
		IT_NRUN(it) = 0
	}

	return(tp)
end



procedure	tp_print(tp)

pointer		tp

int	i
real	avg
pointer	it

begin

	call printf("\n Timing results: \n\n")
	call printf("\ttcpu\tnrun\tavg\n\n")

	do i = 1, TP_ELM_LEN(tp) {
		it = TP_ELM(tp, i)
		if(IT_NRUN(it) == 0) avg = 0.0
		else avg = real(IT_TCPU(it))/IT_NRUN(it)
		call printf("\t%d\t%d\t%f\n")
		call pargl(IT_TCPU(it))
		call pargi(IT_NRUN(it))
		call pargr(avg)
	}
	call printf("\n\n")

end



procedure	tp_start(tp, elm)

pointer		tp
int		elm

pointer		it
long		cputime()

begin

	it = TP_ELM(tp, elm)
	IT_START(it) = cputime(ZERO_TIME)

end


procedure	tp_stop(tp, elm)

pointer		tp
int		elm

pointer		it
long		cputime()

begin

	it = TP_ELM(tp, elm)
	IT_TCPU(it) = IT_TCPU(it) + cputime(IT_START(it))
	IT_NRUN(it) = IT_NRUN(it) + 1

end



procedure	tp_close(tp)

pointer		tp

int	i
pointer it

begin

	do i = 1, TP_ELM_LEN(tp) {
		it = TP_ELM(tp, i)
		call it_free(it)
	}

	call mfree(TP_ELM_PTR(tp), TY_LONG)

	call tp_free(tp)

end

