# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  xy2quad.x
# 	Author	:  tnk
# 	Date	:  05/02/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) xy2quad.x -r1.1 05/02/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/02/94   tnk	date and time created 94/05/02 13:29:27 by tnk
# H-
# 
#

# @(#)xy2quad.x	1.1 5/2/94 UCB CEA EGO

# quadrant types
define  QUAD_VERT_TYPE        2        # "quads" are really vertically stacked
define  QUAD_SQR_TYPE         1        # "quads" really are quadrants

#-----------------------------------------------
#
# Find detector quadrant, given x,y location
# Quads are numbered from 0-3
#
int procedure xy2quad (bound_type, bound_x_y1, bound_y_y2,
bound_y3, x, y)  #LOCAL
int bound_type     #I   boundary type
int bound_x_y1     #I   boundaries
int bound_y_y2     #I
int bound_y3       #I
short    x         #I detector x-value
short    y         #I detector y-value

# LOCAL VARS
int      q         # quad num

#   TYPE VERT           TYPE SQUARE
#             3
#         Y3 -----        1  |  3
#             2              |
#         Y2 -----       ---------- Y
#             1              |
#         Y1 -----        0  |  2
#             0
#                            X

begin

  if (bound_type == QUAD_VERT_TYPE) {

     # detector "quads" are really a vertical stack (Y1,Y2,Y3)
     if      ( y >= bound_y3)    q = 3
     else if ( y >= bound_y_y2)  q = 2
     else if ( y >= bound_x_y1)  q = 1
     else q = 0
  }
  else {
     # detector is really quadrants (X,Y)
     if ( x >= bound_x_y1) {
          if (y >= bound_y_y2) q = 3
            else  q = 2
     }
     else  {
          if (y >= bound_y_y2) q = 1
            else q = 0
     }
  }
  return(q)

end
