# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  evector.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) evector.x -r1.3 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/29/91   ericco	added eu_malloc
# 	05/07/91   ericco	date and time created 91/05/07 14:14:22 by ericco
# H-
# 
#

#	Revised: 4/30/92

include	<edata.h>

#	Allocate a new vector
procedure	ev_new (ptr, length) # get a vector
pointer		ptr		#O vector
long		length		#I length

begin
  call eu_malloc (ptr, VEC_LENGTH(length), TY_LONG)
  VEC_SIZE(ptr) = length
end

#	Allocate clear vector
procedure	ev_new_clear (ptr, length) # get clear vector
pointer		ptr		#O vector
long		length		#I length

long		index

begin
  call ev_new(ptr, length)
  VEC_SIZE(ptr) = length
  do index = 1, length {
    VEC_ELEMENT(ptr,index) = 0
  }
end

#	Release vector
procedure	ev_free(ptr) # release vector
pointer		ptr		#I vector

begin
  if (ptr != 0) call eu_free(ptr, TY_LONG)
  ptr = 0
end

#	release string vector
procedure	ev_free_string(ptr) # release string vector
pointer		ptr		#I string vector

long		index

begin
  if (ptr != 0) {
    do index = 1, VEC_SIZE(ptr) {
      call eu_free(VEC_ELEMENT(ptr,index), TY_CHAR)
    }
    call ev_free(ptr)
  }
end

