# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  grpops.x
# 	Author	:  akeith
# 	Date	:  07/16/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) grpops.x -r1.1 07/16/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	date and time created 93/07/16 11:05:40 by akeith
# H-
# 
#


#	Version: @(#)grpops.x	1.1 7/16/93 UCB CEA EGO
#

include "grp.h"

#
# grp_clstr() is a copy of eu_clstr(), but copies the string to value.
#

procedure	grp_clstr(keyword, value, maxchar) #I

char	keyword[ARB]			#I keyword
char	value[maxchar]			#O list of words
int	maxchar				#I maximum chars

pointer	sp
pointer tmp

begin

	call smark(sp)
	call eu_clstr(tmp, keyword)
	call strcpy(Memc[tmp], value, maxchar)
	call sfree(sp)

end


#
# grp_init() initializes the group structure.
#

procedure	grp_init(grp, fd, keyword) #I

pointer	grp				#I/O group library pointer
pointer	fd				#I file descriptor
char	keyword[ARB]			#I keyword

int	strlen()

begin

	GRP_FD(grp) = fd
	GRP_FDTYPE(grp) = NULL
	GRP_NWRDS(grp) = 0
	GRP_CWN(grp) = 0
	GRP_LIST_PTR(grp) = NULL
	GRP_LIST_LEN(grp) = 0

	GRP_KW_LEN(grp) = strlen(keyword)
	call malloc(GRP_KW_PTR(grp), GRP_KW_LEN(grp), TY_CHAR)
end


#
# grp_close() closes the group structure freeing allocated mem.
#

procedure	grp_close(grp) #E

pointer	grp				#I/O group library pointer

begin

	if(GRP_KW_PTR(grp) != NULL)
		call mfree(GRP_KW_PTR(grp), TY_CHAR)

	if(GRP_LIST_PTR(grp) != NULL)
		call mfree(GRP_LIST_PTR(grp), TY_CHAR)

	call grp_free(grp)
	grp = NULL

end


#
# grp_slist() saves the input list into the grp structure making sure the
#	format of the string is abc,ijkl,wxyz, not ,,abc,ijkl or anything
#	else.
#

procedure	grp_slist(grp, list) #I

pointer	grp				#I/O group library pointer
char	list[ARB]			#I List of words

int	ip, jp
int	len

int	strlen()
int	grp_gnwords()

begin

	ip = 1
	while(list[ip] == ',' && list[ip] != EOS) ip = ip + 1

	len = strlen(list[ip])

	if(len == 0) call eu_error(1, "grp_slist(): Bad list, ", list)

	if(list[len] != ',') len = len + 1

	GRP_LIST_LEN(grp) = len + 1
	call malloc(GRP_LIST_PTR(grp), GRP_LIST_LEN(grp), TY_CHAR)

	jp = 1
	while(list[ip] != EOS) {
		GRP_LIST_CHR(grp, jp) = list[ip]
		jp = jp + 1
		ip = ip + 1
	}
	if(list[ip-1] != ',') GRP_LIST_CHR(grp, jp) = ','
	GRP_LIST_CHR(grp, GRP_LIST_LEN(grp)) = EOS
	
	GRP_NWRDS(grp) = grp_gnwords(GRP_LIST(grp))

end

