# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dsops.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dsops.x -r1.3 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/30/92   ericco	date and time created 92/04/30 01:45:46 by ericco
# H-
# 
#

include "ds.h"

#	Get a new data structure holder
procedure	ds_new(ds, dtype, dptr)
pointer		ds		#O structure
int		dtype		#I type
pointer		dptr		#I type pointer

begin
  call ds_malloc(ds)
  DS_VALUE(ds) = dptr
  DS_TYPE(ds) = dtype
  DS_COUNT(ds) = 1
end

#	Copy a structure by increase its reference count
procedure	ds_indirect_copy(ds)
pointer		ds			#I structure

begin
  if (ds == 0) return
  DS_COUNT(ds) = DS_COUNT(ds) + 1
end

#	Release a structure
procedure	ds_release(ds, release)
pointer		ds			#I structure
pointer		release			#I release function

begin
  if (ds == 0) return
  if (DS_COUNT(ds) < 1) return			# should not happen
  DS_COUNT(ds) = DS_COUNT(ds) - 1
  if (DS_COUNT(ds) == 0) {
    call zcall2(release, DS_VALUE(ds), DS_TYPE(ds))
    call ds_free(ds)
    ds = 0
  }
end

#	Get a pointer to a structure value
procedure	ds_value(ds, ptr)
pointer		ds		#I structure
pointer		ptr		#O pointer to value

begin
  ptr = DS_VALUE(ds)
end

#	Get a data structure
procedure	ds_get(ds, dtype, dptr)
pointer		ds		#I structure
int		dtype		#O type
pointer		dptr		#O type pointer

begin
  dtype = INDEFI
  dptr = NULL
  if(ds == 0) return

  dptr = DS_VALUE(ds)
  dtype = DS_TYPE(ds)
end

