# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  helpops.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) helpops.x -r1.1 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/30/92   ericco	date and time created 92/04/30 01:45:52 by ericco
# H-
# 
#

include <ctype.h>

include "hr.h"
include "help.h"

define	PREFIX_STRING	".\\\" procedure"

#	Release help resources
procedure	help_release(help)
pointer		help			#I help info

int		i

begin
  if (help == 0) return

  do i = 1, HELP_LIST_LEN(help) {
    call hr_release(HELP_LIST(help, i))
  }
  call mfree(HELP_LIST_PTR(help), TY_LONG)
  call close(HELP_FD(help))
end

#	Initialize help info
procedure	help_open(help, name)
pointer		help			#O help info
char		name[ARB]		#I help file name

int		fd, open()
pointer		sp, buf
int		len, strlen()
int		num, tp, getline(), strncmp(), note()
int		leng
int		plen

string		prefix PREFIX_STRING

begin
  help = 0
  plen = strlen(prefix)
  fd = open(name, READ_ONLY, TEXT_FILE)
  if (fd == 0) return

  call smark(sp)
  num = 1
  call malloc(tp, num, TY_LONG)
  call salloc(buf, SZ_LINE, TY_CHAR)

  while (getline(fd, Memc[buf]) != EOF) {
    if (strncmp(prefix, Memc[buf], plen) == 0) {
      for (len = plen; IS_WHITE(Memc[buf+len]); len = len + 1) ;
      leng = strlen(Memc[buf + len])
      if (leng > 1) {
	leng = leng - 1
	Memc[buf + len + leng] = EOS
	call hr_new(Meml[tp+num-1], Memc[buf+len], note(fd))
	num = num + 1
	call realloc(tp, num, TY_LONG)
      }
    }
  }
  num = num - 1
  call realloc(tp, num, TY_LONG)
  call help_malloc(help)
  HELP_FD(help) = fd
  HELP_LIST_LEN(help) = num
  HELP_LIST_PTR(help) = tp
  call sfree(sp)
end

#	Generate help string on topic
procedure	help_info(help, topic, hp)
pointer		help			#I help info
char		topic[ARB]		#I help topic
pointer		hp			#O help message

int		nlen
int		len, strlen()
int		i, num
bool		streq()
int		op
int		getline()
pointer		buf, sp
int		plen
int		strncmp()
pointer		hr

string	defmsg	"Help not found on "
string	prefix	PREFIX_STRING

begin
  call smark(sp)
  plen = strlen(prefix)
  hp = 0

  if (HELP_FD(help) != 0) {
    num = HELP_LIST_LEN(help)
    do i = 1, num {
      hr = HELP_LIST(help, i)
      if (streq(HR_TOPIC(hr), topic)) break
    }
    if (i <= num) {
      call seek(HELP_FD(help), HR_NOTE(hr))
      call salloc(buf, SZ_LINE, TY_CHAR)
      call malloc(hp, 1, TY_CHAR)
      Memc[hp] = EOS
      op = 0
      while (getline(HELP_FD(help), Memc[buf]) != EOF) {
	if (strncmp(prefix, Memc[buf], plen) == 0) break
	if (strncmp(".ih", Memc[buf], 3) == 0) next
	if (strncmp(".le", Memc[buf], 3) == 0) next
	if (strncmp(".ls", Memc[buf], 3) == 0) {
	  Memc[buf+0] = '-'
	  Memc[buf+1] = '-'
	  Memc[buf+2] = '-'
	}
	len = strlen(Memc[buf])
	call realloc(hp, op + len, TY_CHAR)
	call strcpy(Memc[buf], Memc[hp+op], len)
	op = op + len
      }
    }
  }
  if (hp == 0) {
    len = strlen(topic) + strlen(defmsg) + 2
    call malloc(hp, len, TY_CHAR)
    call strcpy(defmsg, Memc[hp], len)
    nlen = strlen(Memc[hp])
    call strcpy(topic, Memc[hp+nlen], len)
    nlen = strlen(Memc[hp])
    call strcpy(".\n", Memc[hp+nlen], len)
  }
  call sfree(sp)
end
