# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  lsops.x
# 	Author	:  akeith
# 	Date	:  01/14/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) lsops.x -r1.3 01/14/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/28/94   akeith	updated documentation
# 	01/14/94   akeith	date and time created 94/01/14 11:20:14 by akeith
# H-
# 
#


#	Version: @(#)lsops.x	1.3 2/28/94 UCB CEA EGO

include	"ls.h"

#
# ls_open()
#

procedure	ls_open(ls) #E

pointer	ls			#O list pointer

begin
	call ls_malloc(ls)
	LS_SPOT_PTR(ls) = NULL
	LS_SPOT_LEN(ls) = 0
	LS_NEXT(ls) = 0
end


#
# ls_close()
#

procedure	ls_close(ls) #E

pointer	ls			#I list pointer

begin
	if(LS_SPOT_PTR(ls) != NULL)
		call mfree(LS_SPOT_PTR(ls), TY_LONG)
	call ls_free(ls)
end


#
# ls_add()
#

procedure	ls_add(ls, str, obj) #E

pointer	ls			#I list pointer
char	str[ARB]		#I object name
pointer obj			#I object

int	indx
int	len, strlen()		#
pointer spot			#

begin

#   Check that the string identifier is unique.

	len = strlen(str)
	call ls_gspot(ls, str, len, indx)
	if(indx != 0) call error(1, "ls_add(): Object was not stored in list.")

#   Store 

	call ls_gempty(ls, indx)
	call spot_open(spot, str, obj)
	LS_SPOT(ls, indx) = spot
end


#
# ls_get()
#

procedure	ls_get(ls, str, obj) #E

pointer	ls			#I list pointer
char	str[ARB]		#I object name
pointer obj			#O object

int	indx			#
int	len, strlen()		#

begin
	obj = NULL
	len = strlen(str)
	call ls_gspot(ls, str, len, indx)
	if(indx != 0)
		obj = SPOT_OBJ(LS_SPOT(ls, indx))
end


#
# ls_delete()
#

procedure	ls_delete(ls, str, obj) #E

pointer	ls			#I list pointer
char	str[ARB]		#I object name
pointer obj			#O object

int	indx			#
int	len, strlen()		#
pointer spot			#

begin

	obj = NULL
	len = strlen(str)
	call ls_gspot(ls, str, len, indx)
	if(indx != 0) {
		spot = LS_SPOT(ls, indx)
		obj = SPOT_OBJ(spot)
		call spot_clos(spot)
		LS_SPOT(ls, indx) = NULL
	}
end


#
# ls_start()
#

procedure	ls_start(ls) #E

pointer	ls			#I list pointer

begin
	LS_NEXT(ls) = 0
end


#
# ls_next()
#

bool	procedure	ls_next(ls, str, maxchar, obj) #E

pointer	ls			#I list pointer
char	str[ARB]		#O object name
int	maxchar			#I max chars
pointer obj			#O object

pointer spot

begin

	obj = NULL
	repeat {
		LS_NEXT(ls) = LS_NEXT(ls) + 1

		if(LS_NEXT(ls) > LS_SPOT_LEN(ls)) {
			LS_NEXT(ls) = 0
			return(FALSE)
		}
	} until(LS_SPOT(ls, LS_NEXT(ls)) != NULL)

	spot = LS_SPOT(ls, LS_NEXT(ls))
	call strcpy(SPOT_STR(spot), str, maxchar)
	obj = SPOT_OBJ(spot)

	return(TRUE)

end


#
# ls_gempty()
#

procedure	ls_gempty(ls, indx) #I

pointer	ls			#I list pointer
int	indx			#I spot index

int	i

begin

	indx = 1
	while(indx <= LS_SPOT_LEN(ls)) {
		if(LS_SPOT(ls, indx) == NULL) return
		indx = indx + 1
	}

	LS_SPOT_LEN(ls) = LS_SPOT_LEN(ls) + LS_PAGE
	call realloc(LS_SPOT_PTR(ls), LS_SPOT_LEN(ls), TY_LONG)

	do i = indx, LS_SPOT_LEN(ls)
		LS_SPOT(ls, i) = NULL
end


#
# ls_streq()
#

bool	procedure	ls_streq(a_str, a_len, b_str, b_len) #I

char	a_str[ARB]		#I
int	a_len			#I
char	b_str[ARB]		#I
int	b_len			#I

int	i

begin

	if(a_len != b_len) return(FALSE)
	do i = 1, a_len
		if(a_str[i] != b_str[i]) return(FALSE)

	return(TRUE)

end


#
# ls_gspot()
#

procedure	ls_gspot(ls, str, len, indx) #I

pointer	ls			#I list pointer
char	str[ARB]		#I object name
int	len			#I string length
int	indx			#O spot index

pointer spot			#
bool	ls_streq()

begin

	indx = 1
	while(indx <= LS_SPOT_LEN(ls)) {
		spot = LS_SPOT(ls, indx)
		if(spot != NULL)
			if(ls_streq(str, len, SPOT_STR(spot), SPOT_LNGTH(spot)))
				return
		indx = indx + 1
	}
	indx = 0
end


#
# spot_open()
#

procedure	spot_open(spot, str, obj) #I

pointer	spot			#O spot pointer
char	str[ARB]		#I object name
pointer obj			#I object

int	strlen()

begin

	call spot_malloc(spot)
	SPOT_LNGTH(spot) = strlen(str)
	SPOT_OBJ(spot) = obj
	call malloc(SPOT_STR_PTR(spot), SPOT_LNGTH(spot)+1, TY_CHAR)
	SPOT_STR(spot) = EOS
	call strcpy(str, SPOT_STR(spot), SPOT_LNGTH(spot)+1)
end


#
# spot_clos()
#

procedure	spot_clos(spot) #I

pointer	spot			#O spot pointer

begin

	if(SPOT_STR_PTR(spot) != NULL)
		call mfree(SPOT_STR_PTR(spot), TY_CHAR)
	call spot_free(spot)

end

