# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  lstops.x
# 	Author	:  ericco
# 	Date	:  11/17/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) lstops.x -r1.2 11/17/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/17/92   ericco	date and time created 92/11/17 17:20:11 by ericco
# H-
# 
#

#	List maintainence utilities
#	This is a simplified interface to the hash
#	table functions.

include	"hash.h"

#	Open a new list
#	The release function must release all resources of the
#	data object.  This function must accept a single argument
#	which is the data structure pointer.

procedure	lst_open(lst, release) #E
pointer		lst		#O list pointer
extern		release		#I release function

pointer		rel		# function pointer

pointer	locpr()
begin
  rel = locpr(release)
  call hash_open(lst, rel)
end

#	Release all resources used by the list

procedure	lst_close(lst) #E
pointer		lst		#B list pointer

begin
  call hash_close(lst)
end

#	Get the value of an element in the list

procedure	lst_get(lst, str, value) #E
pointer		lst		#B list pointer
char		str[ARB]	#I label name
pointer		value		#O label value

pointer	item                    # data holder
pointer	ds                     # value holder

begin
  call hash_exists(lst, str, item)
  call item_data_pointer(item, ds)
  call ds_value(ds, value)
end

#	Replace the value of an element in the list

procedure	lst_add(lst, str, value) #E
pointer		lst		#B list pointer
char		str[ARB]	#I label name
pointer		value		#I label value

pointer	item                    # data holder

begin
  call item_new_structure(item, 0, value)
  call hash_put(lst, str, item)
  call item_release(item, HASH_RELEASE(lst))
end

#	Remove an element from the list.
#	Replacing the existing element with an empty element.

procedure	lst_del(lst, str) #E
pointer		lst		#B list pointer
char		str[ARB]	#I label name

pointer	item                    # data holder
pointer	value

begin
  call lst_get(lst, str, value)
  if (value != 0) {
    call item_new_empty(item)
    call hash_put(lst, str, item)
    call item_release(item, HASH_RELEASE(lst))
  }
end

#  lst_next()

int	procedure	lst_next(lst, nxt, str, value) #E

pointer		lst		#B list pointer
int		nxt		#O next value
char		str[ARB]	#O label name
pointer		value		#O label value

pointer	item                    # data holder
pointer	ds                     # value holder

int	ret
int	hash_next()

begin
  ret = hash_next(lst, nxt, str, item)
  call item_data_pointer(item, ds)
  call ds_value(ds, value)
  return(ret)
end
