# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  nr_gammln.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) nr_gammln.x -r1.3 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/10/95   tnk	added copyright notice
# 	04/30/92   ericco	date and time created 92/04/30 01:54:38 by ericco
# H-
# 
#

#	Copyright (C) 1986 Numerical Recipes Software
#	nr_gammln

#      FUNCTION GAMMLN(XX)
#      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER
#      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
#     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
#      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
#      X=XX-ONE
#      TMP=X+FPF
#      TMP=(X+HALF)*LOG(TMP)-TMP
#      SER=ONE
#      DO 11 J=1,6
#        X=X+ONE
#        SER=SER+COF(J)/X
#11    CONTINUE
#      GAMMLN=TMP+LOG(STP*SER)
#      RETURN
#      END

#	Numerical Reciepes ln gamma function
int procedure	nr_gammln(xx, value)
real		xx		#I data
real		value		#O value

double		cof[6]
double		stp, half, one, fpf, x, tmp, ser

data		cof  / 76.18009173D0, -86.50532033D0, 24.01409822D0,
                      -1.231739516D0,   .120858003D-2, -.536382D-5 /
data		stp  / 2.50662827465D0 /
data		half / 0.5D0 /
data		one  / 1.0D0 /
data		fpf  / 5.5D0 /

int		j

begin
  x = xx - one
  tmp = x + fpf
  tmp = (x + half) * log(tmp) - tmp
  ser = one
  do j = 1, 6 {
    x = x + one
    ser = ser + cof[j] / x
  }
  value = tmp + log(stp * ser)
  return YES
end
