# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  nr_gcf.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) nr_gcf.x -r1.3 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/10/95   tnk	added copyright notice
# 	05/14/92   ericco	added documentation
# 	04/30/92   ericco	date and time created 92/04/30 01:54:39 by ericco
# H-
# 
#

#	Copyright (C) 1986 Numerical Recipes Software
#	nr_gcf

#      SUBROUTINE GCF(GAMMCF,A,X,GLN)
#      PARAMETER (ITMAX=100,EPS=3.E-7)
#      GLN=GAMMLN(A)
#      GOLD=0.
#      A0=1.
#      A1=X
#      B0=0.
#      B1=1.
#      FAC=1.
#      DO 11 N=1,ITMAX
#        AN=FLOAT(N)
#        ANA=AN-A
#        A0=(A1+A0*ANA)*FAC
#        B0=(B1+B0*ANA)*FAC
#        ANF=AN*FAC
#        A1=X*A0+ANF*A1
#        B1=X*B0+ANF*B1
#        IF(A1.NE.0.)THEN
#          FAC=1./A1
#          G=B1*FAC
#          IF(ABS((G-GOLD)/G).LT.EPS)GO TO 1
#          GOLD=G
#        ENDIF
#11    CONTINUE
#      PAUSE 'A too large, ITMAX too small'
#1     GAMMCF=EXP(-X+A*ALOG(X)-GLN)*G
#      RETURN
#      END

define	ITMAX	100
define	EPS	3.E-7

#	Numerical Reciepes gamma function
int procedure	nr_gcf(gammcf, a, x, gln)
real		gammcf		#I data
real		a		#I data
real		x		#I data
real		gln		#O value

int		nr_gammln()
real		gold
real		a0
real		a1
real		b0
real		b1
real		fac
int		n
real		an
real		ana
real		anf
real		g

begin
  if (nr_gammln(a, gln) == NO) return NO

  gold = 0.
  a0 = 1.
  a1 = x
  b0 = 0.
  b1 = 1.
  fac = 1.

  do n = 1, ITMAX {
    an = real(N)
    ana = an - a
    a0 = (a1 + a0 * ana) * fac
    b0 = (b1 + b0 * ana) * fac
    anf = an * fac
    a1 = x * a0 + anf * a1
    b1 = x * b0 + anf * b1
    if ( a1 != 0.) {
      fac = 1. / a1
      g = b1 * fac
      if ( abs((g-gold) / g) < EPS) break
      gold = g
    }
  }

  gammcf = exp(-x + a * alog(x) - gln) * g
  return YES
end
