# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  nr_gser.x
# 	Author	:  ericco
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) nr_gser.x -r1.3 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/10/95   tnk	added copyright notice
# 	05/14/92   ericco	added documentation
# 	04/30/92   ericco	date and time created 92/04/30 01:54:39 by ericco
# H-
# 
#

#	Copyright (C) 1986 Numerical Recipes Software
#	gser

#      SUBROUTINE GSER(GAMSER,A,X,GLN)
#      PARAMETER (ITMAX=100,EPS=3.E-7)
#      GLN=GAMMLN(A)
#      IF(X.LE.0.)THEN
#        IF(X.LT.0.)PAUSE
#        GAMSER=0.
#        RETURN
#      ENDIF
#      AP=A
#      SUM=1./A
#      DEL=SUM
#      DO 11 N=1,ITMAX
#        AP=AP+1.
#        DEL=DEL*X/AP
#        SUM=SUM+DEL
#        IF(ABS(DEL).LT.ABS(SUM)*EPS)GO TO 1
#11    CONTINUE
#      PAUSE 'A too large, ITMAX too small'
#1     GAMSER=SUM*EXP(-X+A*LOG(X)-GLN)
#      RETURN
#      END

define	ITMAX	100
define	EPS	3.E-7

#	Numerical Receipes gamma series function
int procedure	nr_gser (gamser, a, x, gln)
real		gamser		#I data
real		a		#I data
real		x		#I data
real		gln		#O value

real		ap
real		sum
real		del

int		n
int		nr_gammln()

begin
  if (nr_gammln(a, gln) == NO) return NO

  if (x <= 0) {
    if (x < 0) return NO
    gamser = 0.
    return YES
  }
  ap = a
  sum = 1. / a
  del = sum
  do n = 1, ITMAX {
    ap = ap + 1
    del = del * x / ap
    sum = sum + del
    if (abs(del) < abs(sum) * EPS) break
  }
  gamser = sum * exp ( -x + a * log(x) - gln)
  return YES
end
