# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  plf_integrate.x
# 	Author	:  ericco
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) plf_integrate.x -r1.5 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/02/93   gareth	added comments
# 	07/02/93   akeith	documented
# 	05/29/92   gareth	corrected for change to dependent routine
# 	04/13/92   ericco	date and time created 92/04/13 14:08:31 by ericco
# H-
# 
#


#       Version: @(#)plf_integrate.x	1.5 7/2/93 UCB CEA EGO

#
#	plf_integrate() integrates ( calculates the area under the function )
#	a plf between minx and maxx
#	and returns the result in value. If the boundaries are
#	INDEFR the full plf is integrated.
#

procedure	plf_integrate(xs, ys, len, minx, maxx, value) #E
real		xs[len], ys[len]		#I plf
int		len				#I plf length
real		minx, maxx			#I intergration range
real		value				#O value

real		mix, mx

begin
  value = 0
  if (len < 1) return
  if (minx == INDEFR) mix = xs[1]; else mix = minx
  if (maxx == INDEFR) mx = xs[len]; else mx = maxx
  call plf_to_array(xs, ys, len, mix, mx - mix, value, 1)
  value = value * ( mx-mix )
end

