# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  plfarray.x
# 	Author	:  gareth
# 	Date	:  05/12/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) plfarray.x -r1.6 05/12/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/02/93   gareth	added comments
# 	07/02/93   akeith	documented
# 	05/20/92   gareth	double precision added
# 	05/12/92   gareth	date and time created 92/05/12 13:50:30 by gareth
# H-
# 
#


#       Version: @(#)plfarray.x	1.6 7/2/93 UCB CEA EGO

#
# Reads in a plf and converts it into an array of a specified minimum
# x value, bin size (delx) and length. 
#

procedure plf_array( xs, ys, length, minx, delx, array, len ) #E

# AUTHOR : GARETH BEVAN

# IMPORT VARIABLES :
real xs[length], ys[length]               #I input plf
int length                                #I size of plf
real minx                                 #I centre of 1st bin
real delx                                 #I length of bin
int len                                   #I size of output array

# IMPORT/EXPORT VARIABLES :
# EXPORT VARIABLES :
real array[len]                           #O output array

# LOCAL VARIABLES :
int i,j                                   # loop counters

double yvaluen                              # calculated yvalue of plf
double cx                                   # current x value
double nextpt                               # next x value
double binedge                              # x value of bin edge
double yvaluec                              # current value
double area                                 # the area under the cuve

bool eqflag                               # set when then the next plf point
                                          # is equal to the bin RHS

double dminx
double ddelx
  
# FUNCTIONS :
#############################################################################

begin
  
  ddelx =  delx
  dminx =  minx

  call aclrr( array, len )

  cx = xs[1]
  yvaluec = ys[1]
  j = 1
  eqflag = false

  do i= 1, len
  {
    binedge = ( i-1 )*ddelx + dminx + ddelx/2.0

    while ( ( cx < binedge ) && ( j < length ))
    {
      nextpt = xs[j+1]

      if ( nextpt >= binedge )
      {
	if ( nextpt == binedge )
	{
	  eqflag = true
	  yvaluen = ys[j+1]
	}
	else
	{
	  yvaluen = yvaluec + (ys[j+1]-yvaluec )*( binedge-cx )/(nextpt-cx )
	  
	}

	area = 0.5*( yvaluen + yvaluec )*( binedge - cx )
	array[i] = array[i] + area
	cx = binedge
	yvaluec = yvaluen

	
	if ( eqflag )
	{
	  j = j + 1
	  eqflag = false
	}
	next
      }  # end if >=

      
      yvaluen = ys[j+1]
      area =  0.5*( yvaluec + yvaluen )*( nextpt - cx )
      array[i] = array[i] + area
      j = j + 1
      cx = nextpt
      yvaluec = yvaluen
    } # end while
  } # end do


  do i= 1, len
  {
    array[i] = array[i] / ddelx
  }


end  # OF PROCEDURE plf_array
