# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  plfflatten.x
# 	Author	:  ericco
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) plfflatten.x -r1.5 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/02/93   gareth	added comments
# 	07/02/93   akeith	documented
# 	04/13/92   ericco	date and time created 92/04/13 14:08:35 by ericco
# H-
# 
#


#       Version: @(#)plfflatten.x	1.5 7/15/93 UCB CEA EGO

#	Flatten out a plf. Removes points in a plf that have the same x
#	coordinates that do not have the maximum and minimum y coordinates

procedure	plf_flatten(xs, ys, len, nxs, nys, nlen) #E
real		xs[len], ys[len]		#I plf
int		len				#I plf length
pointer		nxs, nys			#O plf
int		nlen				#O plf length

int		i
int		di

begin
  nlen = 0
  for (i = 1; i <= len; i = i + di) {
    for (di = 1; i + di <= len; di = di + 1) if (ys[i] != ys[i+di]) break
    if (di < 2) {
      # there must be at least a sequence off three points
      # before any intermediate points can be skipped
      di = 1
    } else {
      di = di - 1
      # the following line trims 0 values off the front of the plf
      if (i == 1 && ys[i] == 0) next
      # the following line trims 0 values off the end of the plf
      if (i + di == len && ys[i] == 0) di = di + 1
    }
    nlen = nlen + 1
    if (nlen == 1) {
      call malloc(nxs, nlen, TY_REAL)
      call malloc(nys, nlen, TY_REAL)
    } else {
      call realloc(nxs, nlen, TY_REAL)
      call realloc(nys, nlen, TY_REAL)
    }
    Memr[nxs+nlen-1] = xs[i]
    Memr[nys+nlen-1] = ys[i]
  }
end
