# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  plfleftget.x
# 	Author	:  ericco
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) plfleftget.x -r1.5 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/13/97   mabbott	removed hlib$ from mach.h include
# 	07/02/93   gareth	added comments
# 	06/17/92   gareth	divide by zero corrected
# 	04/13/92   ericco	date and time created 92/04/13 14:15:33 by ericco
# H-
# 
#

# DATE 10/13/97
# PLF GET LEFT
#
# INCLUDE FILES
include <mach.h>           # iraf number accuracy file
#

# calculates the left most value of a plf at a given x value. ie 
# it returns the first y value that would be seen for a given x if
# the plf is followed from left to right.

real procedure plf_left_get( x1, y1, length, i, x_val ) #I

# AUTHOR : GARETH BEVAN
# HISTORY :
#
# IMPORT VARIABLES :
real x1[length], y1[length]                       #I INPUT PLF
int length                                        #I LENGTH OF PLF
int i                                             #I CURRENT POSITION
                                                  # THIS PLF
real x_val                                        #I X VALUE AT WHICH THE PLF
                                                  # IS TO BE EVALUATED

real left_get
       
# EXPORTED VALUE
# LOCAL VARIABLES :
#############################################################################

begin

  if ( abs( x1[i] - x1[i-1]) <= EPSILONR )
  {
    left_get = 0.0
  }
  else
  {
    left_get = y1[i-1] + ( y1[i] - y1[i-1] )*(( x_val-x1[i-1] )/
                           ( x1[i]-x1[i-1] ))
  }

  return(left_get)

end  # OF FUNCTION <>

