# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  plftoarray.x
# 	Author	:  gareth
# 	Date	:  05/12/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) plftoarray.x -r1.4 05/12/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/29/92   ericco	updated comments
# 	05/12/92   gareth	date and time created 92/05/12 13:50:50 by gareth
# H-
# 
#

# DATE 5/29/92
# plf_to_array
#
# INCLUDE FILES

# Reads in a plf and converts it into an array with W0 and wpc

procedure plf_to_array( xs, ys, length, minx, delx, array, len )

#IMPORT VARIABLES :
real xs[length], ys[length]               #I input plf
int length                                #I size of plf
real minx                                 #I centre of 1st bin
real delx                                 #I length of bin
int len                                   #I size of output array

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
real array[len]                           #O output array

#LOCAL VARIABLES :
pointer nxs,nys                          # plf pointers
int nlen                                 # length of plf
real minval,maxval                       # cliping lengths
#real tminx                               # New w0 


# FUNCTIONS :
#############################################################################

begin
  call aclrr( array, len )
  if ( length <= 1 ) return
  if ( delx <= 0 ) return

  minval = minx - delx/2.0
  maxval = minx + ( (len-0.5) * delx )

  call plf_clip( xs, ys, length, minval, maxval, nxs, nys, nlen )
  call plf_array( Memr[nxs], Memr[nys], nlen, minx, delx,
		  array, len )

end  # OF PROCEDURE plf_to_array
