# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  plfunary.x
# 	Author	:  ericco
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) plfunary.x -r1.3 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/17/93   ericco	fixed '!' operation
# 	04/13/92   ericco	date and time created 92/04/13 14:08:38 by ericco
# H-
# 
#

#	Perform unary functions on plf
procedure	plf_unary(xs1, ys1, len1, op, nxs, nys, nlen)
real		xs1[len1], ys1[len1]	#I plf
int		len1			#I length
short		op			#I operation
pointer		nxs, nys		#O plf
int		nlen			#O length

int		x1, x, lx
real		y1, y, ly

begin
  nlen = 0
  x1 = 1
  lx = xs1[1] - 1
  ly = ys1[1]
  while (x1 <= len1) {
    x  = xs1[x1]
    y1 = ys1[x1]
    x1 = x1 + 1

    y = 0
    switch (op) {
    case '>' :	y = y1; x = x * 2
    case '<' :	y = y1; x = x / 2
    case '!' :	if (y1 == 0) y = 1; else y = 0
    case '-' :	y = - y1
    case 'd' :	if (x == lx) next; y = (y - ly) / (x - lx)
    case 'i' :	y = int(y1)
    case 'a' :	y = abs(y1)
    case 's' :	y = sin(y1)
    case 'c' :	y = cos(y1)
    case 't' :	y = tan(y1)
    case 'l' :	if (y > 0) y = log(y1)
    case 'e' :	y = exp(y1)
    case '2' :	y = y1 * y1
    case 'r' :	if (y > 0) y = sqrt(y1)
    case 'S' :  y = asin(y1)
    case 'C' :  y = acos(y1)
    case 'T' :  y = atan(y1)
    }

    nlen = nlen + 1
    if (nlen == 1) {
      call malloc(nxs, nlen, TY_REAL)
      call malloc(nys, nlen, TY_REAL)
    } else {
      call realloc(nxs, nlen, TY_REAL)
      call realloc(nys, nlen, TY_REAL)
    }
    Memr[nxs+nlen-1] = x
    Memr[nys+nlen-1] = y
    lx = x
    ly = y
  }
end

