# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  plfvalue.x
# 	Author	:  ericco
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) plfvalue.x -r1.2 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/13/92   ericco	date and time created 92/04/13 14:08:39 by ericco
# H-
# 
#

#	Get the value of the plf
procedure	plf_value(xs, ys, len, x, y)
real		xs[len], ys[len]	#I plf
int		len			#I length
real		x			#I position
real		y			#O value

int		ix

begin
  call plf_value_directed(xs, ys, len, x, y, 1, ix)
end

#	Get the left most value
procedure	plf_left_value(xs, ys, len, x, y)
real		xs[len], ys[len]	#I plf
int		len			#I length
real		x			#I position
real		y			#O value

int		ix

begin
  call plf_value_directed(xs, ys, len, x, y, 0, ix)
end

#	Get both left and right values
procedure	plf_both_value(xs, ys, len, x, yl, yr)
real		xs[len], ys[len]	#I plf
int		len			#I length
real		x			#I position
real		yl, yr			#O values

int		ix

begin
  call plf_value_directed(xs, ys, len, x, yl, 0, ix)
  call plf_value_directed(xs, ys, len, x, yr, 1, ix)
end

#	Get right value
procedure	plf_right_value(xs, ys, len, x, y)
real		xs[len], ys[len]	#I plf
int		len			#I plf length
real		x			#I position
real		y			#O value

int		ix

begin
  call plf_value_directed(xs, ys, len, x, y, 1, ix)
end

#	Get a left of right value
procedure	plf_value_directed(xs, ys, len, x, y, right, lx)
real		xs[len], ys[len]	#I plf
int		len			#I plf length
real		x			#I position
real		y			#O value
int		right			#I right flag
int		lx			#O index of left side

int		ix
int		hx

begin
  lx = 1
  hx = len

  if (len <= 0) {
    y = 0
    return
  } else if (len == 1) {
    if (x == xs[1])		y = ys[1]
    else			y = 0
    return
  } else if (x < xs[1] || x > xs[len]) {
    y = 0
    return
  } else if (x == xs[1]) {
    if (right == 1)	y = xs[1]
    else		y = 0
  } else if (x == xs[len]) {
    if (right == 1)	y = 0
    else		y = xs[len]
  }

  while (lx + 1 < hx) {
    ix = (lx + hx) / 2
    if (xs[ix] < x) {
      lx = ix
    } else if (xs[ix] > x) {
      hx = ix
    } else {
      # exact match, but could be jumps
      # we know that xs[1] < x < xs[len]
      if (right == 1) {
	while (xs[ix+1] == x) ix = ix + 1
      } else {
	while (xs[ix-1] == x) ix = ix - 1
      }
      lx = ix
      y = ys[lx]
      return
    }
  }

  # xs[lx] < x < xs[lx+1] = xs[hx]
  if (xs[lx] == xs[hx]) {
    if (right == 1)	y = ys[lx]
    else		y = ys[hx]
  } else {
    y = ys[lx] + (x - xs[lx]) * (ys[hx] - ys[lx]) / (xs[hx] - xs[lx])
  }
end
