# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpsrt.x
# 	Author	:  akeith
# 	Date	:  12/15/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpsrt.x -r1.11 12/15/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/25/97   bboyd	Replaced private qpoe constants with euv constants, qpacquirefields
# 	09/28/94   akeith	documentation
# 	09/27/94   akeith	now utilizes the FMIO library
# 	06/29/94   akeith	fixed imdir for tmp files
# 	03/31/93   akeith	error handling fix
# 	03/25/93   akeith	quick fix
# 	03/24/93   akeith	everything has changed
# 	01/27/93   akeith	Now using vfio library instead of fmio
# 	01/27/93   akeith	replaced the fmio cache system with the straight binary read/write
# 	12/15/92   akeith	date and time created 92/12/15 11:07:27 by akeith
# H-
# 
#


#       Version: @(#)qpsrt.x	1.11 9/25/97 UCB CEA EGO

include <qpsrt.h>
include <qpset.h>
include <qpioset.h>
include	<fmset.h>
include <qs.h>
include <qpeuv.h>

#
# qs_init() initializes the qs structure.
#

procedure	qs_init(qs, qpio)  #L

pointer qs				#I/O 
pointer qpio				#I qpoe input/output

pointer dd

begin

	# Allocate space for the field descriptor struct
	call malloc (dd, LEN_EUVDDDES, TY_STRUCT)

	# Fill the struct
	call qp_acquirefields(qpio, dd)

	QS_TP(qs)     = NULL		# TP is only used for time profiling

	QS_QPIO(qs)   = qpio
	QS_DD(qs)     = dd

	QS_EVSZ(qs)   = EUVDD_STRUCTLEN(dd)*SZ_STRUCT/SZ_SHORT
	QS_EV(qs)     = NULL
	QS_NEVBUF(qs) = 0
	QS_NEV_AVAIL(qs) = 0

	QS_FM(qs)     = NULL
	QS_NLF(qs)    = 0
	QS_SETFLG(qs) = FALSE

	QS_PAGESZ(qs)  = -1		# use fmio defaults
	QS_MAXLF(qs)   = -1
	QS_CACHESZ(qs) = -1
	QS_FMBUFSZ(qs) = -1

	QS_BUF_LEN(qs)  = 0
	QS_BUF_PTR(qs)  = NULL
	QS_SBUF_LEN(qs) = 0
	QS_SBUF_PTR(qs) = NULL

	call malloc(QS_FNAME_PTR(qs), QS_DIR_SZ, TY_CHAR)
	call malloc(QS_DIR_PTR(qs), QS_DIR_SZ, TY_CHAR)
	call strcpy("./", QS_DIR(qs), QS_DIR_SZ)

	call qs_bufinit(qs, DEF_BUFSIZE)

#   These are the field offsets needed by qscmp.x
 
	QS_XOS(qs) = EUVDD_FOFFSET(dd, EUVDD_XFIELD(dd))
	QS_YOS(qs) = EUVDD_FOFFSET(dd, EUVDD_YFIELD(dd))

	call mfree (dd, TY_STRUCT)
end


#
# qs_bufinit() initializes the sbuf and buf.
#

procedure	qs_bufinit(qs, size)  #L

pointer qs				#I/O 
int	size				#I buf size in events

pointer	sp
pointer buf

int	errcode()

begin

	QS_NEVBUF(qs) = size
	QS_NEV_AVAIL(qs) = QS_NEVBUF(qs)

	QS_SBUF_LEN(qs) = QS_NEVBUF(qs)
	iferr( call realloc(QS_SBUF_PTR(qs), QS_SBUF_LEN(qs), TY_LONG) ) {
		call smark(sp)
		call salloc(buf, 1024, TY_CHAR)
		call sprintf(Memc[buf], ARB, "Unable to allocate the memory.")
		call error(errcode(),Memc[buf])
		call sfree(sp)
	}

	QS_BUF_LEN(qs) = QS_NEVBUF(qs)*QS_EVSZ(qs)
	iferr( call realloc(QS_BUF_PTR(qs), QS_BUF_LEN(qs), TY_SHORT) ) {
		call smark(sp)
		call salloc(buf, 1024, TY_CHAR)
		call sprintf(Memc[buf], ARB, "Unable to allocate the memory.")
		call error(errcode(),Memc[buf])
		call sfree(sp)
	}

end

#
# qs_seti() makes the calls to fm_seti() and is called once right after
#	the fmio file is opened.
#

procedure	qs_seti(qs)

pointer	qs			#I

begin

	if(QS_MAXLF(qs) != -1)
		call fm_seti(QS_FM(qs), FM_MAXLFILES, QS_MAXLF(qs))

	if(QS_PAGESZ(qs) != -1)
		call fm_seti(QS_FM(qs), FM_PAGESIZE, QS_PAGESZ(qs))

	if(QS_CACHESZ(qs) != -1)
		call fm_seti(QS_FM(qs), FM_FCACHESIZE, QS_CACHESZ(qs))

	if(QS_FMBUFSZ(qs) != -1)
		call fm_seti(QS_FM(qs), FM_OPTFBSIZE, QS_FMBUFSZ(qs))

end

