# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpsrtputev.x
# 	Author	:  akeith
# 	Date	:  01/27/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpsrtputev.x -r1.8 01/27/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/28/94   akeith	documentation
# 	09/27/94   akeith	now utilizes the FMIO library
# 	06/29/94   akeith	fixed imdir for tmp files
# 	05/03/93   akeith	put in imdir$ for tmp file.
# 	03/31/93   akeith	error handling fix
# 	03/25/93   akeith	quick fix
# 	03/24/93   akeith	everything has changed
# 	01/27/93   akeith	date and time created 93/01/27 17:26:04 by akeith
# H-
# 
#


#       Version: @(#)qpsrtputev.x	1.8 9/28/94 UCB CEA EGO

include <qpsrt.h>
include "qs.h"

#
# qpsrt_putevents() appends events to a new event list just like
#	qpio_putevents() except this routine stores the events
#	for sorting which takes place when qpsrt_close() is called.
#

procedure	qpsrt_putevents(qs, ev, nevents)  #E

pointer	qs				#I qpoe sort structure pointer
pointer ev[nevents]			#I event buffer
int	nevents				#I number of events in buffer

int	i 				# index
int	nev_avail			# num of avail spaces in buffer

pointer	fm_open()			# fmio open

begin

	if(!QS_SETFLG(qs)) {

		QS_SETFLG(qs) = TRUE

		call qs_gfilename(QS_DIR(qs), QS_FNAME(qs), QS_DIR_SZ)
		QS_FM(qs) = fm_open(QS_FNAME(qs), NEW_FILE)
		call qs_seti(qs)

	}

	if(nevents < QS_NEV_AVAIL(qs)) {

		do i = 1, nevents
			call qs_buffer(qs, ev[i]) 

	} else {

		nev_avail = QS_NEV_AVAIL(qs)
		do i = 1, nev_avail
			call qs_buffer(qs, ev[i]) 

		call qs_sortout(qs, QS_NEVBUF(qs))

		if(nevents > nev_avail)
			do i = nev_avail+1, nevents
				call qs_buffer(qs, ev[i]) 
		
	}

end


#
# qs_buffer() buffers the events
#

procedure	qs_buffer(qs, ev_ptr)

pointer	qs				#I qpoe sort structure pointer
pointer ev_ptr				#I pointer to a single event

int	i				# index
int	position			# buf position
pointer	buf				# event buffer pointer

begin

	buf = QS_BUF_PTR(qs)

	QS_NEV_AVAIL(qs) = QS_NEV_AVAIL(qs) - 1
	position = QS_NEVBUF(qs) - QS_NEV_AVAIL(qs)

	QS_SBUF(qs, position) = QS_BUF_PTR(qs) + QS_EVSZ(qs)*(position-1)

	do i = 1, QS_EVSZ(qs) {
		Mems[QS_SBUF(qs, position)+i-1] = Mems[ev_ptr+i-1]
	}

end


#
# qs_sortout() sorts the events and puts them out to a file for later
#	merge sorting.
#

procedure	qs_sortout(qs, nev)

pointer	qs				#I qpoe sort structure pointer
int	nev				#I number of events to sort

int	i				# index

pointer	lf, fm_fopen()
extern	qs_cmp

include	"qs.com"

begin

	if(nev == 0) return

	QS_NEV_AVAIL(qs) = QS_NEVBUF(qs)

#   These are the field offsets needed by qscmp.x and are passed in
#	using the common block in qs.com.
 
	xoffset = QS_XOS(qs)
	yoffset = QS_YOS(qs)

	call qsort(Meml[QS_SBUF_PTR(qs)], nev, qs_cmp)

	QS_NLF(qs) = QS_NLF(qs) + 1

	iferr(lf = fm_fopen(QS_FM(qs), QS_NLF(qs), NEW_FILE, BINARY_FILE))
		call error(1, "qs_sortout(): Unable to open file lfile.")
	
	do i = 1, nev {
		call write(lf, Mems[QS_SBUF(qs, i)], QS_EVSZ(qs))
	}

	call close(lf)

end


#
# qs_gfilename()
#

procedure	qs_gfilename(dir, fname, len)

char	dir[len]		#I directory name
char	fname[len]		#O file name
int	len			#I length

pointer	sp, root		#

begin

	call smark(sp)
	call salloc(root, len, TY_CHAR)
	call strcpy(dir, root, len)
	call strcat("qs_tmp", root, len)
	call mktemp(root, fname, len)
	call sfree(sp)

end

