# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpsrtseti.x
# 	Author	:  akeith
# 	Date	:  03/24/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpsrtseti.x -r1.6 03/24/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/28/94   akeith	documentation
# 	09/27/94   akeith	now utilizes the FMIO library
# 	06/29/94   akeith	fixed imdir for tmp files
# 	03/24/93   akeith	everything has changed
# 	03/24/93   akeith	changed name 
# 	03/24/93   akeith	date and time created 93/03/24 14:26:40 by akeith
# H-
# 
#


#       Version: @(#)qpsrtseti.x	1.6 9/28/94 UCB CEA EGO

include <qpsrt.h>
include	"qs.h"

#
# qpsrt_seti() allows the various qpoe sort parameters to be
#	set. These parametes are unsetable after the first
#	call to qpsrt_putevents().
#

procedure	qpsrt_seti(qs, param, value)

pointer	qs			#I QS descriptor
int	param			#I parameter code
int	value			#I new parameter value

begin

	switch (param) {

	case QS_EVBUFSZ:
		if(!QS_SETFLG(qs)) call qs_bufinit(qs, value)

	case QS_PAGESIZE:
		if(!QS_SETFLG(qs)) QS_PAGESZ(qs) = value

	case QS_MAXLFILES:
		if(!QS_SETFLG(qs)) QS_MAXLF(qs) = value

	case QS_FCACHESIZE:
		if(!QS_SETFLG(qs)) QS_CACHESZ(qs) = value

	case QS_OPTFBSIZE:
		if(!QS_SETFLG(qs)) QS_FMBUFSZ(qs) = value

	default:
		call qpio_seti(QS_QPIO(qs), param, value)
	}

end


#
# qpsrt_dir() allows the directory where the temporary files will be
#	stored to be set.
#

procedure	qpsrt_dir(qs, dir)

pointer	qs			#I QS descriptor
char	dir[ARB]		#I temp. dir name

begin
	if(!QS_SETFLG(qs))
		call strcpy(dir, QS_DIR(qs), QS_DIR_SZ)
end

