# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  spcflux.x
# 	Author	:  akeith
# 	Date	:  08/22/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) spcflux.x -r1.1 08/22/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/22/94   akeith	date and time created 94/08/22 12:46:28 by akeith
# H-
# 
#


#	Version: @(#)spcflux.x	1.1 8/22/94 UCB CEA EGO

#
# spc_gflux()
#

procedure	spc_gflux(fo_ea, exp_time, spectrum, flux)

pointer	fo_ea				#I first order eff. area
double	exp_time			#I exposure time
pointer	spectrum			#I spectrum
pointer	flux				#I output flux

begin
	call df_div(spectrum, fo_ea, flux)
	call df_divk(flux, exp_time, flux)
	call df_pedge(flux, 0.0d0, 0.0d0)
end


#
# spc_gfluxerr()
#

procedure	spc_gfluxerr(fo_ea, exp_time, spec_err, flux_err)

pointer	fo_ea				#I first order eff. area
double	exp_time			#I exposure time
pointer	spec_err			#I spectral error
pointer	flux_err			#I output error flux

begin

	call df_mulk(fo_ea, exp_time, flux_err)
	call df_powk(flux_err, 2, flux_err)

	call df_div(spec_err, flux_err, flux_err)
	call df_pedge(flux_err, 0.0d0, 0.0d0)

end

