# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  spcout.x
# 	Author	:  akeith
# 	Date	:  08/22/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) spcout.x -r1.3 08/22/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/02/94   akeith	took out redundent call
# 	09/14/94   akeith	deals with a null spectral error
# 	08/22/94   akeith	date and time created 94/08/22 12:46:31 by akeith
# H-
# 
#


#	Version: @(#)spcout.x	1.3 11/2/94 UCB CEA EGO

include	<dfset.h>
include	<imhdr.h>

#
# spc_out()
#

procedure	spc_out(out, xl, delx, npts, fo_ea, exp_t, spectrum, spec_err)

pointer	out			#I
double	xl			#I
double	delx			#I
int	npts			#I
pointer	fo_ea			#I
double	exp_t			#I
pointer	spectrum		#I
pointer	spec_err		#I

int	ndim			#
int	stat			#

pointer	sp, x			#
pointer	flux			#
pointer	imbuf			#

int	df_rgetr()		#
pointer	impl3r()		#
pointer	df_open()		#
extern	spc_asqrt()		#

begin

	call smark(sp)
	call salloc(x, npts, TY_REAL)

	ndim = 3
	IM_PIXTYPE(out) = TY_REAL
	IM_NDIM(out) = ndim
	IM_LEN(out, 1) = npts
	IM_LEN(out, 2) = 1
	if(spec_err == NULL) IM_LEN(out, 3) = 1
	else IM_LEN(out, 3) = 2

	call spc_mkmwcs(out, xl, delx, ndim)

#    Store the spectrum in the image.

	flux = df_open(DF_PD, TY_DOUBLE, TY_DOUBLE)

	call spc_gflux(fo_ea, exp_t, spectrum, flux)
	call df_rsdomain(flux, xl, delx, npts, flux)

	imbuf = impl3r(out, 1, 1)
	stat = df_rgetr(flux, Memr[x], Memr[imbuf], npts)

	call df_close(flux)


#    Store the error in the image.

	if(spec_err != NULL) {

		flux = df_open(DF_PD, TY_DOUBLE, TY_DOUBLE)

		call spc_gfluxerr(fo_ea, exp_t, spec_err, flux)
		call df_rsdomain(flux, xl, delx, npts, flux)

		call df_sqrt(flux, flux, spc_asqrt)

		imbuf = impl3r(out, 1, 2)
		stat = df_rgetr(flux, Memr[x], Memr[imbuf], npts)

		call df_close(flux)

	}

	call sfree(sp)

end

