# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  cfops.x
# 	Author	:  akeith
# 	Date	:  02/12/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) cfops.x -r1.1 02/12/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/12/93   akeith	date and time created 93/02/12 10:34:25 by akeith
# H-
# 
#

#	Revised: 2/12/93

include "cf.h"
include <vfio.h>


#
# cf_init()
#

procedure	cf_init(cf, filename, mode, type)  #L

pointer cf			#I/O composite file pointer
char	filename[ARB]		#I filename
int	mode			#I file mode
int	type			#I file type

int	len
int	strlen()

begin

	len = strlen(filename)
	call malloc(CF_FNAME_PTR(cf), len+1, TY_CHAR)
	call strcpy(filename, CF_FNAME(cf), len)

	CF_FD(cf) = 0
	CF_OMODE(cf) = mode
	CF_MODE(cf) = mode
	CF_TYPE(cf) = type
	CF_CREATE(cf) = FALSE
	CF_PAGESIZE(cf) = DEF_PAGESIZE
	CF_MAXVFILE(cf) = DEF_MAXVFILE
	CF_FO(cf) = FILE_OFFSET
	CF_NPAGES(cf) = 0
	CF_AEP(cf) = 0
	CF_CLRBUF(cf) = NULL
	CF_VF_LEN(cf) = 0
	CF_VF_PTR(cf) = NULL
	CF_PL_LEN(cf) = 0
	CF_PL_PTR(cf) = NULL

end


#
# cf_vfclose()
#

procedure	cf_vfclose(vf)  #L

pointer vf			#I/O virtual file pointer

begin

	if(vf == NULL) return
	if(VF_APP_PTR(vf) != NULL)
		call mfree(VF_APP_PTR(vf), TY_LONG)
	call vf_free(vf)
	vf = NULL

end


#
# cf_pageinit()
#

procedure	cf_pageinit(cf)  #L

pointer cf			#I/O composite file pointer

begin

	call seek(CF_FD(cf), EOF)
	call write(CF_FD(cf), Memc[CF_CLRBUF(cf)], CF_PAGESIZE(cf))

end


#
# pl_init()
#

procedure	pl_init(pl, vfile, afp)  #L

pointer	pl			#I/O page list pointer
int	vfile			#I virtual file number
int	afp			#I absolute file position

begin

	PL_VFILE(pl) = vfile
	PL_AFP(pl) = afp

end


#
# cf_addpage()
#

procedure	cf_addpage(cf, vfile)  #L

pointer cf			#I/O composite file pointer
int	vfile			#I virtual file number

int	afp			# absolute file position
pointer vf			# virtual file pointer
pointer	pl			# page list

begin

	vf = CF_VF(cf, vfile)
	CF_NPAGES(cf) = CF_NPAGES(cf) + 1
	CF_AEP(cf) = CF_AEP(cf) + CF_PAGESIZE(cf)

	call chk_space(CF_PL_PTR(cf), CF_PL_LEN(cf), CF_NPAGES(cf), TY_LONG)

	call pl_malloc(pl)
	CF_PL(cf, CF_NPAGES(cf)) = pl

	afp = CF_FO(cf) + CF_PAGESIZE(cf)*(CF_NPAGES(cf) - 1)
	call pl_init(pl, vfile, afp)

	call cf_pageinit(cf)

	call vf_addpage(vf, afp)

end

define	MEM_BLOCK_SIZE		20

#
# chk_space()
#

procedure	chk_space(ptr, len, new_len, type)  #L

pointer	ptr			#O pointer
int	len			#O length
int	new_len			#I what the length should be
int	type			#I mem. type

begin

	if(new_len <= len) return

	len = len + MEM_BLOCK_SIZE
	call realloc(ptr, len, type)

end


