# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vfops.x
# 	Author	:  akeith
# 	Date	:  02/12/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) vfops.x -r1.1 02/12/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/12/93   akeith	date and time created 93/02/12 10:34:36 by akeith
# H-
# 
#

#       Revised: 2/12/93

include "cf.h"
include <vfio.h>


#
# vf_init()
#

procedure	vf_init(cf, vf, mode, type)  #L

pointer cf			#I/O composite file pointer
pointer vf			#I   virtual file pointer
int	mode			#I   file mode
int	type			#I   file type

begin

	VF_CF(vf) = cf
	VF_MODE(vf) = mode
	VF_TYPE(vf) = type
	VF_OPEN(vf) = TRUE
	VF_CPI(vf) = 0
	VF_CAFP(vf) = 0
	VF_CVFP(vf) = 1
	VF_VEOF(vf) = 1
	VF_VEOP(vf) = 1
	VF_NPAGES(vf) = 0

	VF_APP_LEN(vf) = 0
	VF_APP_PTR(vf) = NULL

end


#
# vf_vfpafp()
#

int	procedure	vf_vfpafp(vf, vfp)  #L

pointer vf			#I virtual file pointer
int	vfp			#I virtual file position

pointer	cf			# composite file pointer

int	page			# page
int	page_offset		# page offset
int	afp			# absolute file position

begin

	cf = VF_CF(vf)

	page = vfp/CF_PAGESIZE(cf) + 1

	page_offset = vfp - CF_PAGESIZE(cf)*(page-1)
	afp = VF_APP(vf, page) + page_offset
	return(afp)

end


#
# vf_addpage()
#

procedure	vf_addpage(vf, afp)  #L

pointer vf			#I virtual file pointer
int	afp			#I absolute file position

begin

	VF_NPAGES(vf) = VF_NPAGES(vf) + 1
	VF_VEOP(vf) = VF_VEOP(vf) + CF_PAGESIZE(VF_CF(vf))

	call chk_space(VF_APP_PTR(vf), VF_APP_LEN(vf), VF_NPAGES(vf), TY_LONG)
	VF_APP(vf, VF_NPAGES(vf)) = afp

end


