# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  zzdebug.x
# 	Author	:  akeith
# 	Date	:  02/12/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) zzdebug.x -r1.1 02/12/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/12/93   akeith	date and time created 93/02/12 10:34:40 by akeith
# H-
# 
#


include	"cf.h"
include	<vfio.h>

task	open	= t_open,
	vfopen	= t_vfopen,
	write   = t_vfwrite,
	read    = t_vfinout


procedure	t_open()

pointer cf
char	datafile[SZ_FNAME]
int	pagesize, nvfiles

int	clgeti()
pointer cf_open()

begin

	call clgstr("datafile", datafile, SZ_FNAME)
	pagesize = clgeti("pagesize")
	nvfiles = clgeti("vlfiles")

	cf = cf_open(datafile, NEW_FILE, BINARY_FILE)
	call cf_seti(cf, VF_PAGESIZE, pagesize)
	call cf_seti(cf, VF_MAXVFILES, nvfiles)
	call cf_debug(cf)

	call cf_create(cf)
	call cf_debug(cf)

	call cf_close(cf)

end



procedure	t_vfopen()

pointer cf
char	datafile[SZ_FNAME]
int	pagesize, nvfiles

int	vfile
int	clgeti()
pointer cf_open()

begin

	call clgstr("datafile", datafile, SZ_FNAME)
	pagesize = clgeti("pagesize")
	nvfiles = clgeti("vlfiles")

	cf = cf_open(datafile, NEW_FILE, BINARY_FILE)
	call cf_seti(cf, VF_PAGESIZE, pagesize)
	call cf_seti(cf, VF_MAXVFILES, nvfiles)
	call cf_debug(cf)

	call cf_create(cf)
	call cf_debug(cf)

	do vfile = 1, nvfiles {
		call vf_open(cf, vfile, READ_WRITE, BINARY_FILE)
		call cf_addpage(cf, vfile)
		call cf_addpage(cf, vfile)
		call cf_addpage(cf, vfile)
		call vf_debug(cf, vfile)
	}

	call cf_debug(cf)
	call cf_close(cf)

end




procedure	t_vfwrite()

pointer cf
char	datafile[SZ_FNAME]
char	buf[SZ_FNAME]
int	pagesize, nvfiles

int	i, vfile
int	nelmspp
int	nelmspf
int	len
long	lval
pointer tp

int	strlen()
int	clgeti()
real	urand()
pointer cf_open()
pointer tp_open()

begin

	call clgstr("datafile", datafile, SZ_FNAME)
	nvfiles = clgeti("vlfiles")
	nelmspp = clgeti("nelms/page")
	nelmspf = clgeti("nelms/file")

	call strcpy("0123456789", buf, 10)
	len = strlen(buf)
	pagesize = nelmspp*len
	cf = cf_open(datafile, NEW_FILE, BINARY_FILE)
	call cf_seti(cf, VF_PAGESIZE, pagesize)
	call cf_seti(cf, VF_MAXVFILES, nvfiles)
	call cf_debug(cf)

	call cf_create(cf)
	call cf_debug(cf)

	do vfile = 1, nvfiles {
		call vf_open(cf, vfile, READ_WRITE, BINARY_FILE)
	}

	tp = tp_open(1)
	lval = 487462
	do i = 1, nelmspf*nvfiles {
		vfile = int(nvfiles*urand(lval) + 1.0)
		call tp_start(tp, 1)
		call vf_ibinwrite(cf, vfile, buf, len)
		call tp_stop(tp, 1)
	}

	call cf_debug(cf)
	call tp_print(tp)
	call tp_close(tp)
	call cf_close(cf)

end



procedure	t_vfinout()

pointer cf
char	datafile[SZ_FNAME]
char	buf[SZ_FNAME]
int	pagesize, nvfiles

int	i, vfile
int	stat
int	len
long	lval
pointer tp
pointer sp
pointer rbuf

int	strlen()
int	clgeti()
real	urand()
int	vf_ibinread()
pointer cf_open()
pointer tp_open()

begin

	call clgstr("datafile", datafile, SZ_FNAME)
	call clgstr("buf", buf, SZ_FNAME)
	nvfiles = clgeti("vlfiles")

	len = strlen(buf)
	pagesize = 50*len
	cf = cf_open(datafile, NEW_FILE, BINARY_FILE)
	call cf_seti(cf, VF_PAGESIZE, pagesize)
	call cf_seti(cf, VF_MAXVFILES, nvfiles)
	call cf_debug(cf)

	call smark(sp)
	call salloc(rbuf, pagesize, TY_CHAR)

	call cf_create(cf)
	call cf_debug(cf)

	do vfile = 1, nvfiles {
		call vf_open(cf, vfile, READ_WRITE, BINARY_FILE)
	}

	tp = tp_open(4)
	lval = 487462
	do i = 1, 50*nvfiles {
		vfile = int(nvfiles*urand(lval) + 1.0)
		if(vfile != 1) {
			call tp_start(tp, 1)
			call vf_ibinwrite(cf, vfile, buf, len)
			call tp_stop(tp, 1)
		}
	}

	call cf_debug(cf)

	do vfile = 1, nvfiles {
		call printf("\n\n VFILE = %d \n")
		call pargi(vfile)
		call vf_seek(cf, vfile, 1)
		repeat {
			call tp_start(tp, 2)
			stat = vf_ibinread(cf, vfile, Memc[rbuf], pagesize)
			call tp_stop(tp, 2)
			if(stat == EOF) break
		}
	}

	do vfile = 1, nvfiles
		call vf_reset(cf, vfile)

	do i = 1, 20*nvfiles {
		vfile = int(nvfiles*urand(lval) + 1.0)
		call tp_start(tp, 1)
		call vf_ibinwrite(cf, vfile, buf, len)
		call tp_stop(tp, 1)
	}

	call cf_debug(cf)

	do vfile = 1, nvfiles {
		call printf("\n\n VFILE = %d \n")
		call pargi(vfile)
		call tp_start(tp, 3)
		call vf_seek(cf, vfile, 1)
		call tp_stop(tp, 3)
		repeat {
			call tp_start(tp, 2)
			stat = vf_ibinread(cf, vfile, Memc[rbuf], pagesize)
			call tp_stop(tp, 2)
			if(stat == EOF) break
		}
	}

	call tp_print(tp)
	call tp_close(tp)
	call cf_close(cf)
	call sfree(sp)

end

