# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vtodestroy.x
# 	Author	:  akeith
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) vtodestroy.x -r1.1 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/13/92   akeith	date and time created 92/04/13 15:34:32 by akeith
# H-
# 
#

#       Last revised: 4/13/92
#
include <vtl.h>
include "vt.h"
include "vto.h"

#
# vto_destroy deletes a vector table object from a vector table.
#

procedure	vto_destroy (vto_ptr_init)

pointer vto_ptr_init			#O pointer to vector table object

pointer vto_ptr				# pointer to vector table object
int	dtype				# data type

pointer vt_ptr				# vector table pointer
int	vto_ind				# VTO index w/in vt pointer array

int	nvto				# number of VTO's
int	vt_cur_ind			# index of current VTO

#pointer usr_ptr			# pointer to user defined structure
#pointer vto_gusrptr()			# get user pointer function

bool	vt_statb()			# vt_stat function
int	vt_stati()			# vt_stat function

bool	vto_statb()			# vto_stat function
int	vto_stati()			# vto_stat function
pointer vto_statp()

begin

	vto_ptr = vto_ptr_init

	if(vto_ptr == NULL) return

   # Reset vector table structure

	vt_ptr = vto_statp(vto_ptr, VTO_VTPTR_PARM)

	vto_ind = vto_stati(vto_ptr, VTO_VTIND_PARM)

	nvto = vt_stati(vt_ptr, VT_NVTO_PARM)

	vt_cur_ind = vt_stati(vt_ptr, VT_VTOIND_PARM)


   # Deal with the IDS and DDS defined VTO's


	if(vt_statb(vt_ptr, VT_IDSFLG_PARM) && 
	   vt_stati(vt_ptr, VT_IDS_PARM) == vto_ind){
		call vt_setb(vt_ptr, VT_IDSFLG_PARM, FALSE)
		call vt_seti(vt_ptr, VT_IDS_PARM, INDEFI)
	}

	if(vt_statb(vt_ptr, VT_DDSFLG_PARM) && 
	   vt_stati(vt_ptr, VT_DDS_PARM) == vto_ind){
		call vt_setb(vt_ptr, VT_DDSFLG_PARM, FALSE)
		call vt_seti(vt_ptr, VT_DDS_PARM, INDEFI)
	}


   # Deal with the vector table current index and pointer.
   #	The vtci only changes if the vto_ind == vt_cur_ind.


	if(vto_ind == vt_cur_ind){
		call vt_seti(vt_ptr, VT_VTOIND_PARM, INDEFI)
	}

	VT_VTO(vt_ptr, vto_ind) = NULL

	call vt_seti(vt_ptr, VT_NVTO_PARM, nvto-1)


   # Free vector element data memory.


	if(vto_statb(vto_ptr, VTO_SET_PARM)) {
		dtype = vto_stati(vto_ptr, VTO_DTYPE_PARM)
		call mfree(VTO_VCT(vto_ptr), dtype)
		call vto_setp(vto_ptr, VTO_VCT_PARM, NULL)
		call vto_setb(vto_ptr, VTO_SET_PARM, FALSE)
	}

	if(vto_statp(vto_ptr, VTO_AUX_PARM) != NULL) {
		dtype = vto_stati(vto_ptr, VTO_DTYPE_PARM)
		call mfree(VTO_AUX(vto_ptr), dtype)
		call vto_setp(vto_ptr, VTO_AUX_PARM, NULL)
	}

   # Free user pointer.

#	usr_ptr = vto_gusrptr(vto_ptr)
#	if(usr_ptr != NULL) call vto_fusrptr(vto_ptr)

   # Free structure.

	call mfree(vto_ptr, TY_STRUCT)

	vto_ptr_init = NULL


end

