# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vtoinit.x
# 	Author	:  akeith
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) vtoinit.x -r1.2 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/26/92   akeith	Major changes where made to accomedate the deletion of a vto.
# 	04/13/92   akeith	date and time created 92/04/13 15:34:36 by akeith
# H-
# 
#

#       Last revised: 6/26/92
#
include <vtl.h>
include "vt.h"

#
# vto_init initializes a new vector table object, first setting the vt structure
#	and then initializing the vto structure. Each pointer to a vto structre
#	is stored within a vt list of pointers. This is a dynamic list. When a
#	vto structure is deleted, a null overwrites the vto pointer stored in the
#	list. Upon initializing a new vto, the following algorithm takes place.
#	If the list length is zero, the length is set to one, memory is allocated,
#	the current vto index is set and the vto_ptr is saved. Else, the first
#	NULL value is found and the vto_ptr is saved there, else if no NULL exists
#	the list is expanded.
#

procedure	vto_init (vt_ptr, vto_ptr)

pointer vt_ptr				#I pointer to vector table
pointer vto_ptr				#I pointer to vector table object

int	nvto				# current number of VTO's
int	vto_indx			# vt vto pointer array length
int	indx				# vt_vto list index

bool	done				# are we done yet?

int	vt_stati()			# vt_stat function

begin

	# First set the vector table structure.

	nvto = vt_stati(vt_ptr, VT_NVTO_PARM) + 1
	call vt_seti(vt_ptr, VT_NVTO_PARM, nvto)

	if(VT_VTO_LEN(vt_ptr) == 0) {

		VT_VTO_LEN(vt_ptr) = VT_VTO_LEN(vt_ptr) + 1
		call malloc(VT_VTO_PTR(vt_ptr), VT_VTO_LEN(vt_ptr), TY_LONG)
		call vt_seti(vt_ptr, VT_VTOIND_PARM, VT_VTO_LEN(vt_ptr))
		vto_indx = VT_VTO_LEN(vt_ptr)
		VT_VTO(vt_ptr, VT_VTO_LEN(vt_ptr)) = vto_ptr

	} else {

		indx = 1
		done = FALSE
		repeat {
			if(VT_VTO(vt_ptr, indx) == NULL) {
				call vt_seti(vt_ptr, VT_VTOIND_PARM, indx)
				VT_VTO(vt_ptr, indx) = vto_ptr
				vto_indx = indx
				done = TRUE
			}
			indx = indx + 1
		} until(indx > VT_VTO_LEN(vt_ptr) || done)

		if(indx > VT_VTO_LEN(vt_ptr) && !done) {
			VT_VTO_LEN(vt_ptr) = VT_VTO_LEN(vt_ptr) + 1
			call realloc(VT_VTO_PTR(vt_ptr), VT_VTO_LEN(vt_ptr), TY_LONG)
			call vt_seti(vt_ptr, VT_VTOIND_PARM, VT_VTO_LEN(vt_ptr))
			vto_indx = VT_VTO_LEN(vt_ptr)
			VT_VTO(vt_ptr, VT_VTO_LEN(vt_ptr)) = vto_ptr
		}

	}
		

	# Second set the vector table object structure.

	call vto_seti(vto_ptr, VTO_NELMS_PARM, 0)
	call vto_setp(vto_ptr, VTO_VTPTR_PARM, vt_ptr)
	call vto_seti(vto_ptr, VTO_VTIND_PARM, vto_indx)
	call vto_seti(vto_ptr, VTO_SPEC_PARM, INDEFI)
	call vto_setb(vto_ptr, VTO_ORDER_PARM, FALSE)
	call vto_seti(vto_ptr, VTO_DTYPE_PARM, INDEFI)
	call vto_seti(vto_ptr, VTO_MODE_PARM, VTO_NEW)
	call vto_setb(vto_ptr, VTO_SET_PARM, FALSE)
	call vto_setp(vto_ptr, VTO_VCT_PARM, NULL)
	call vto_seti(vto_ptr, VTO_CVI_PARM, 0)
	call vto_setp(vto_ptr, VTO_AUX_PARM, NULL)

#	call vto_iusrptr(vto_ptr)

end

