# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vtopvct.gx
# 	Author	:  akeith
# 	Date	:  07/16/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) vtopvct.gx -r1.1 07/16/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	date and time created 93/07/16 12:10:17 by akeith
# H-
# 
#

#       Last revised: 7/16/93
#
include <vtl.h>
include <eerror.h>
include "vto.h"
include "vtlid.h"


#
# vto_pvct[silrd] stores an array of data values in a vto within memory.
#

int	procedure	vto_pvctd (vto_ptr, vct_ary, lngth)

pointer vto_ptr				#I pointer to vector table object
double	vct_ary[lngth]			#I vector data array
int	lngth				#I length of data array

int	i
int	nelms				# number of vector elements
int	cvi				# current vector index

pointer	vct_ptr				# vector data pointer
pointer	aux_ptr				# auxiliary data pointer
pointer	tmp_ptr				# tmp vector data pointer

bool	vto_statb()			# vto_stat functions
int	vto_stati()
pointer	vto_statp()

begin


	switch( vto_stati(vto_ptr, VTO_MODE_PARM) ){

	case VTO_NEW:

	   # Check that memory has not been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) ) {
			call eerror(VT_MEMSET)
			return(NO)
		}

	   # allocate memory

		call malloc(vct_ptr, lngth, TY_DOUBLE)
		call malloc(aux_ptr, VTO_AUX_LEN, TY_DOUBLE)

	   # copy data into vector array

		call amovd(vct_ary, ARRYD(vct_ptr,1), lngth)

	   # set the vector table object parameters

		call vto_setp(vto_ptr, VTO_VCT_PARM, vct_ptr)
		call vto_setb(vto_ptr, VTO_SET_PARM, TRUE)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, lngth)
		call vto_seti(vto_ptr, VTO_MODE_PARM, VTO_APPEND)
		call vto_seti(vto_ptr, VTO_DTYPE_PARM, TY_DOUBLE)
		call vto_seti(vto_ptr, VTO_SPEC_PARM, VTO_ARRAY)
		call vto_setp(vto_ptr, VTO_AUX_PARM, aux_ptr)

		return(YES)


	case VTO_APPEND:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	    # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)

		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_DOUBLE ){
			call eerror(VT_BADDTYP)
			return(NO)
		}

	   # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_DOUBLE)

	   # copy data to new memory

		do i = 1, cvi
			ARRYD(tmp_ptr,i) = ARRYD(vct_ptr,i)

		do i = 1, lngth
			ARRYD(tmp_ptr,i+cvi) = vct_ary(i)

		do i = cvi+1, nelms
			ARRYD(tmp_ptr,i+lngth) = ARRYD(vct_ptr,i)

	   # free old vector memory

		call mfree(vct_ptr, TY_DOUBLE)

	   # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, nelms+lngth)

		return(YES)


	case VTO_INSERT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_DOUBLE ){
			call eerror(VT_BADDTYP)
			return(NO)

		}

	    # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_DOUBLE)

	    # copy data to new memory

		do i = 1, cvi-1
			ARRYD(tmp_ptr,i) = ARRYD(vct_ptr,i)

		do i = 1, lngth
			ARRYD(tmp_ptr,i+cvi-1) = vct_ary(i)

		do i = cvi, nelms
			ARRYD(tmp_ptr,i+lngth) = ARRYD(vct_ptr,i)

	    # free old vector memory

		call mfree(vct_ptr, TY_DOUBLE)

	    # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, cvi+lngth)

		return(YES)

	case VTO_OVRWRT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_DOUBLE ){
			call eerror(VT_BADDTYP)
			return(NO)
		}


	    # Two cases of overwrite.
	    # One, overwriting passed the nelms currently defined for the VTO.
	    # Two, overwriting within the nelms currently defined for the VTO.


		if(cvi-1+lngth > nelms) {

		    # allocate enough memory for all the data

			call malloc(tmp_ptr, cvi-1+lngth, TY_DOUBLE)

		    # copy data to new memory

			do i = 1, cvi-1
				ARRYD(tmp_ptr,i) = ARRYD(vct_ptr,i)

			do i = 1, lngth
				ARRYD(tmp_ptr,i+cvi-1) = vct_ary(i)

		    # free old vector memory

			call mfree(vct_ptr, TY_DOUBLE)

		    # reset the vto

			call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
			call vto_seti(vto_ptr, VTO_NELMS_PARM, cvi-1+lngth)
			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		} else {

			do i = 1, lngth
				VTO_ARYD(vto_ptr,cvi-1+i) = vct_ary(i)

			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		}

		return(YES)

	}

end


#
# vto_pvct[silrd] stores an array of data values in a vto within memory.
#

int	procedure	vto_pvcti (vto_ptr, vct_ary, lngth)

pointer vto_ptr				#I pointer to vector table object
int	vct_ary[lngth]			#I vector data array
int	lngth				#I length of data array

int	i
int	nelms				# number of vector elements
int	cvi				# current vector index

pointer	vct_ptr				# vector data pointer
pointer	aux_ptr				# auxiliary data pointer
pointer	tmp_ptr				# tmp vector data pointer

bool	vto_statb()			# vto_stat functions
int	vto_stati()
pointer	vto_statp()

begin


	switch( vto_stati(vto_ptr, VTO_MODE_PARM) ){

	case VTO_NEW:

	   # Check that memory has not been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) ) {
			call eerror(VT_MEMSET)
			return(NO)
		}

	   # allocate memory

		call malloc(vct_ptr, lngth, TY_INT)
		call malloc(aux_ptr, VTO_AUX_LEN, TY_INT)

	   # copy data into vector array

		call amovi(vct_ary, ARRYI(vct_ptr,1), lngth)

	   # set the vector table object parameters

		call vto_setp(vto_ptr, VTO_VCT_PARM, vct_ptr)
		call vto_setb(vto_ptr, VTO_SET_PARM, TRUE)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, lngth)
		call vto_seti(vto_ptr, VTO_MODE_PARM, VTO_APPEND)
		call vto_seti(vto_ptr, VTO_DTYPE_PARM, TY_INT)
		call vto_seti(vto_ptr, VTO_SPEC_PARM, VTO_ARRAY)
		call vto_setp(vto_ptr, VTO_AUX_PARM, aux_ptr)

		return(YES)


	case VTO_APPEND:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	    # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)

		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_INT ){
			call eerror(VT_BADDTYP)
			return(NO)
		}

	   # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_INT)

	   # copy data to new memory

		do i = 1, cvi
			ARRYI(tmp_ptr,i) = ARRYI(vct_ptr,i)

		do i = 1, lngth
			ARRYI(tmp_ptr,i+cvi) = vct_ary(i)

		do i = cvi+1, nelms
			ARRYI(tmp_ptr,i+lngth) = ARRYI(vct_ptr,i)

	   # free old vector memory

		call mfree(vct_ptr, TY_INT)

	   # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, nelms+lngth)

		return(YES)


	case VTO_INSERT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_INT ){
			call eerror(VT_BADDTYP)
			return(NO)

		}

	    # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_INT)

	    # copy data to new memory

		do i = 1, cvi-1
			ARRYI(tmp_ptr,i) = ARRYI(vct_ptr,i)

		do i = 1, lngth
			ARRYI(tmp_ptr,i+cvi-1) = vct_ary(i)

		do i = cvi, nelms
			ARRYI(tmp_ptr,i+lngth) = ARRYI(vct_ptr,i)

	    # free old vector memory

		call mfree(vct_ptr, TY_INT)

	    # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, cvi+lngth)

		return(YES)

	case VTO_OVRWRT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_INT ){
			call eerror(VT_BADDTYP)
			return(NO)
		}


	    # Two cases of overwrite.
	    # One, overwriting passed the nelms currently defined for the VTO.
	    # Two, overwriting within the nelms currently defined for the VTO.


		if(cvi-1+lngth > nelms) {

		    # allocate enough memory for all the data

			call malloc(tmp_ptr, cvi-1+lngth, TY_INT)

		    # copy data to new memory

			do i = 1, cvi-1
				ARRYI(tmp_ptr,i) = ARRYI(vct_ptr,i)

			do i = 1, lngth
				ARRYI(tmp_ptr,i+cvi-1) = vct_ary(i)

		    # free old vector memory

			call mfree(vct_ptr, TY_INT)

		    # reset the vto

			call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
			call vto_seti(vto_ptr, VTO_NELMS_PARM, cvi-1+lngth)
			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		} else {

			do i = 1, lngth
				VTO_ARYI(vto_ptr,cvi-1+i) = vct_ary(i)

			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		}

		return(YES)

	}

end


#
# vto_pvct[silrd] stores an array of data values in a vto within memory.
#

int	procedure	vto_pvctl (vto_ptr, vct_ary, lngth)

pointer vto_ptr				#I pointer to vector table object
long	vct_ary[lngth]			#I vector data array
int	lngth				#I length of data array

int	i
int	nelms				# number of vector elements
int	cvi				# current vector index

pointer	vct_ptr				# vector data pointer
pointer	aux_ptr				# auxiliary data pointer
pointer	tmp_ptr				# tmp vector data pointer

bool	vto_statb()			# vto_stat functions
int	vto_stati()
pointer	vto_statp()

begin


	switch( vto_stati(vto_ptr, VTO_MODE_PARM) ){

	case VTO_NEW:

	   # Check that memory has not been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) ) {
			call eerror(VT_MEMSET)
			return(NO)
		}

	   # allocate memory

		call malloc(vct_ptr, lngth, TY_LONG)
		call malloc(aux_ptr, VTO_AUX_LEN, TY_LONG)

	   # copy data into vector array

		call amovl(vct_ary, ARRYL(vct_ptr,1), lngth)

	   # set the vector table object parameters

		call vto_setp(vto_ptr, VTO_VCT_PARM, vct_ptr)
		call vto_setb(vto_ptr, VTO_SET_PARM, TRUE)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, lngth)
		call vto_seti(vto_ptr, VTO_MODE_PARM, VTO_APPEND)
		call vto_seti(vto_ptr, VTO_DTYPE_PARM, TY_LONG)
		call vto_seti(vto_ptr, VTO_SPEC_PARM, VTO_ARRAY)
		call vto_setp(vto_ptr, VTO_AUX_PARM, aux_ptr)

		return(YES)


	case VTO_APPEND:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	    # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)

		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_LONG ){
			call eerror(VT_BADDTYP)
			return(NO)
		}

	   # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_LONG)

	   # copy data to new memory

		do i = 1, cvi
			ARRYL(tmp_ptr,i) = ARRYL(vct_ptr,i)

		do i = 1, lngth
			ARRYL(tmp_ptr,i+cvi) = vct_ary(i)

		do i = cvi+1, nelms
			ARRYL(tmp_ptr,i+lngth) = ARRYL(vct_ptr,i)

	   # free old vector memory

		call mfree(vct_ptr, TY_LONG)

	   # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, nelms+lngth)

		return(YES)


	case VTO_INSERT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_LONG ){
			call eerror(VT_BADDTYP)
			return(NO)

		}

	    # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_LONG)

	    # copy data to new memory

		do i = 1, cvi-1
			ARRYL(tmp_ptr,i) = ARRYL(vct_ptr,i)

		do i = 1, lngth
			ARRYL(tmp_ptr,i+cvi-1) = vct_ary(i)

		do i = cvi, nelms
			ARRYL(tmp_ptr,i+lngth) = ARRYL(vct_ptr,i)

	    # free old vector memory

		call mfree(vct_ptr, TY_LONG)

	    # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, cvi+lngth)

		return(YES)

	case VTO_OVRWRT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_LONG ){
			call eerror(VT_BADDTYP)
			return(NO)
		}


	    # Two cases of overwrite.
	    # One, overwriting passed the nelms currently defined for the VTO.
	    # Two, overwriting within the nelms currently defined for the VTO.


		if(cvi-1+lngth > nelms) {

		    # allocate enough memory for all the data

			call malloc(tmp_ptr, cvi-1+lngth, TY_LONG)

		    # copy data to new memory

			do i = 1, cvi-1
				ARRYL(tmp_ptr,i) = ARRYL(vct_ptr,i)

			do i = 1, lngth
				ARRYL(tmp_ptr,i+cvi-1) = vct_ary(i)

		    # free old vector memory

			call mfree(vct_ptr, TY_LONG)

		    # reset the vto

			call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
			call vto_seti(vto_ptr, VTO_NELMS_PARM, cvi-1+lngth)
			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		} else {

			do i = 1, lngth
				VTO_ARYL(vto_ptr,cvi-1+i) = vct_ary(i)

			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		}

		return(YES)

	}

end


#
# vto_pvct[silrd] stores an array of data values in a vto within memory.
#

int	procedure	vto_pvctr (vto_ptr, vct_ary, lngth)

pointer vto_ptr				#I pointer to vector table object
real	vct_ary[lngth]			#I vector data array
int	lngth				#I length of data array

int	i
int	nelms				# number of vector elements
int	cvi				# current vector index

pointer	vct_ptr				# vector data pointer
pointer	aux_ptr				# auxiliary data pointer
pointer	tmp_ptr				# tmp vector data pointer

bool	vto_statb()			# vto_stat functions
int	vto_stati()
pointer	vto_statp()

begin


	switch( vto_stati(vto_ptr, VTO_MODE_PARM) ){

	case VTO_NEW:

	   # Check that memory has not been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) ) {
			call eerror(VT_MEMSET)
			return(NO)
		}

	   # allocate memory

		call malloc(vct_ptr, lngth, TY_REAL)
		call malloc(aux_ptr, VTO_AUX_LEN, TY_REAL)

	   # copy data into vector array

		call amovr(vct_ary, ARRYR(vct_ptr,1), lngth)

	   # set the vector table object parameters

		call vto_setp(vto_ptr, VTO_VCT_PARM, vct_ptr)
		call vto_setb(vto_ptr, VTO_SET_PARM, TRUE)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, lngth)
		call vto_seti(vto_ptr, VTO_MODE_PARM, VTO_APPEND)
		call vto_seti(vto_ptr, VTO_DTYPE_PARM, TY_REAL)
		call vto_seti(vto_ptr, VTO_SPEC_PARM, VTO_ARRAY)
		call vto_setp(vto_ptr, VTO_AUX_PARM, aux_ptr)

		return(YES)


	case VTO_APPEND:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	    # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)

		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_REAL ){
			call eerror(VT_BADDTYP)
			return(NO)
		}

	   # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_REAL)

	   # copy data to new memory

		do i = 1, cvi
			ARRYR(tmp_ptr,i) = ARRYR(vct_ptr,i)

		do i = 1, lngth
			ARRYR(tmp_ptr,i+cvi) = vct_ary(i)

		do i = cvi+1, nelms
			ARRYR(tmp_ptr,i+lngth) = ARRYR(vct_ptr,i)

	   # free old vector memory

		call mfree(vct_ptr, TY_REAL)

	   # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, nelms+lngth)

		return(YES)


	case VTO_INSERT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_REAL ){
			call eerror(VT_BADDTYP)
			return(NO)

		}

	    # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_REAL)

	    # copy data to new memory

		do i = 1, cvi-1
			ARRYR(tmp_ptr,i) = ARRYR(vct_ptr,i)

		do i = 1, lngth
			ARRYR(tmp_ptr,i+cvi-1) = vct_ary(i)

		do i = cvi, nelms
			ARRYR(tmp_ptr,i+lngth) = ARRYR(vct_ptr,i)

	    # free old vector memory

		call mfree(vct_ptr, TY_REAL)

	    # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, cvi+lngth)

		return(YES)

	case VTO_OVRWRT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_REAL ){
			call eerror(VT_BADDTYP)
			return(NO)
		}


	    # Two cases of overwrite.
	    # One, overwriting passed the nelms currently defined for the VTO.
	    # Two, overwriting within the nelms currently defined for the VTO.


		if(cvi-1+lngth > nelms) {

		    # allocate enough memory for all the data

			call malloc(tmp_ptr, cvi-1+lngth, TY_REAL)

		    # copy data to new memory

			do i = 1, cvi-1
				ARRYR(tmp_ptr,i) = ARRYR(vct_ptr,i)

			do i = 1, lngth
				ARRYR(tmp_ptr,i+cvi-1) = vct_ary(i)

		    # free old vector memory

			call mfree(vct_ptr, TY_REAL)

		    # reset the vto

			call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
			call vto_seti(vto_ptr, VTO_NELMS_PARM, cvi-1+lngth)
			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		} else {

			do i = 1, lngth
				VTO_ARYR(vto_ptr,cvi-1+i) = vct_ary(i)

			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		}

		return(YES)

	}

end


#
# vto_pvct[silrd] stores an array of data values in a vto within memory.
#

int	procedure	vto_pvcts (vto_ptr, vct_ary, lngth)

pointer vto_ptr				#I pointer to vector table object
short	vct_ary[lngth]			#I vector data array
int	lngth				#I length of data array

int	i
int	nelms				# number of vector elements
int	cvi				# current vector index

pointer	vct_ptr				# vector data pointer
pointer	aux_ptr				# auxiliary data pointer
pointer	tmp_ptr				# tmp vector data pointer

bool	vto_statb()			# vto_stat functions
int	vto_stati()
pointer	vto_statp()

begin


	switch( vto_stati(vto_ptr, VTO_MODE_PARM) ){

	case VTO_NEW:

	   # Check that memory has not been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) ) {
			call eerror(VT_MEMSET)
			return(NO)
		}

	   # allocate memory

		call malloc(vct_ptr, lngth, TY_SHORT)
		call malloc(aux_ptr, VTO_AUX_LEN, TY_SHORT)

	   # copy data into vector array

		call amovs(vct_ary, ARRYS(vct_ptr,1), lngth)

	   # set the vector table object parameters

		call vto_setp(vto_ptr, VTO_VCT_PARM, vct_ptr)
		call vto_setb(vto_ptr, VTO_SET_PARM, TRUE)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, lngth)
		call vto_seti(vto_ptr, VTO_MODE_PARM, VTO_APPEND)
		call vto_seti(vto_ptr, VTO_DTYPE_PARM, TY_SHORT)
		call vto_seti(vto_ptr, VTO_SPEC_PARM, VTO_ARRAY)
		call vto_setp(vto_ptr, VTO_AUX_PARM, aux_ptr)

		return(YES)


	case VTO_APPEND:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	    # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)

		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_SHORT ){
			call eerror(VT_BADDTYP)
			return(NO)
		}

	   # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_SHORT)

	   # copy data to new memory

		do i = 1, cvi
			ARRYS(tmp_ptr,i) = ARRYS(vct_ptr,i)

		do i = 1, lngth
			ARRYS(tmp_ptr,i+cvi) = vct_ary(i)

		do i = cvi+1, nelms
			ARRYS(tmp_ptr,i+lngth) = ARRYS(vct_ptr,i)

	   # free old vector memory

		call mfree(vct_ptr, TY_SHORT)

	   # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, nelms+lngth)

		return(YES)


	case VTO_INSERT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_SHORT ){
			call eerror(VT_BADDTYP)
			return(NO)

		}

	    # allocate enough memory for all the data

		call malloc(tmp_ptr, nelms+lngth, TY_SHORT)

	    # copy data to new memory

		do i = 1, cvi-1
			ARRYS(tmp_ptr,i) = ARRYS(vct_ptr,i)

		do i = 1, lngth
			ARRYS(tmp_ptr,i+cvi-1) = vct_ary(i)

		do i = cvi, nelms
			ARRYS(tmp_ptr,i+lngth) = ARRYS(vct_ptr,i)

	    # free old vector memory

		call mfree(vct_ptr, TY_SHORT)

	    # reset the vto

		call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
		call vto_seti(vto_ptr, VTO_NELMS_PARM, nelms+lngth)
		call vto_seti(vto_ptr, VTO_CVI_PARM, cvi+lngth)

		return(YES)

	case VTO_OVRWRT:

		nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)
		cvi = vto_stati(vto_ptr, VTO_CVI_PARM)
		vct_ptr = vto_statp(vto_ptr, VTO_VCT_PARM)

	   # Check that memory has been allocate.

		if( vto_statb(vto_ptr, VTO_SET_PARM) == FALSE){
			call eerror(VT_MEMSET)
			return(NO)
		}

	    # Check that the CVI is within the NELMS.

		if( cvi > nelms ){
			call eerror(VT_BADCVI)
			return(NO)
		}

	    # Check that the data types are the same.

		if( vto_stati(vto_ptr, VTO_DTYPE_PARM) != TY_SHORT ){
			call eerror(VT_BADDTYP)
			return(NO)
		}


	    # Two cases of overwrite.
	    # One, overwriting passed the nelms currently defined for the VTO.
	    # Two, overwriting within the nelms currently defined for the VTO.


		if(cvi-1+lngth > nelms) {

		    # allocate enough memory for all the data

			call malloc(tmp_ptr, cvi-1+lngth, TY_SHORT)

		    # copy data to new memory

			do i = 1, cvi-1
				ARRYS(tmp_ptr,i) = ARRYS(vct_ptr,i)

			do i = 1, lngth
				ARRYS(tmp_ptr,i+cvi-1) = vct_ary(i)

		    # free old vector memory

			call mfree(vct_ptr, TY_SHORT)

		    # reset the vto

			call vto_setp(vto_ptr, VTO_VCT_PARM, tmp_ptr)
			call vto_seti(vto_ptr, VTO_NELMS_PARM, cvi-1+lngth)
			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		} else {

			do i = 1, lngth
				VTO_ARYS(vto_ptr,cvi-1+i) = vct_ary(i)

			call vto_seti(vto_ptr, VTO_CVI_PARM, cvi-1+lngth)

		}

		return(YES)

	}

end



