# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vtoset.x
# 	Author	:  akeith
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) vtoset.x -r1.1 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/13/92   akeith	date and time created 92/04/13 15:34:43 by akeith
# H-
# 
#

#       Last revised: 4/13/92
#
include <vtl.h>
include <eerror.h>
include "vto.h"

#
# vto_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table object.
#

procedure	vto_setb (vto_ptr, vto_param, value)

pointer vto_ptr				#I pointer to vector table
int	vto_param			#I parameter to be set
bool	value				#I new value for parameter

begin

	switch	(vto_param) {

	case VTO_ORDER_PARM:

		VTO_ORDER(vto_ptr) = value

	case VTO_SET_PARM:

		VTO_SET(vto_ptr) = value

	default: call eerror(VT_NOPARM)

	}

end


#
# vto_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table object.
#

procedure	vto_setd (vto_ptr, vto_param, value)

pointer vto_ptr				#I pointer to vector table
int	vto_param			#I parameter to be set
double	value				#I new value for parameter

begin

	switch	(vto_param) {

	default: call eerror(VT_NOPARM)

	}

end


#
# vto_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table object.
#
#                       vto_seti ()
#
#
#
#

procedure	vto_seti (vto_ptr, vto_param, value)

pointer vto_ptr				#I pointer to vector table
int	vto_param			#I parameter to be set
int	value				#I new value for parameter

begin

	switch	(vto_param) {

	case VTO_NELMS_PARM:

		VTO_NELMS(vto_ptr) = value

	case VTO_VTIND_PARM:

		VTO_VTIND(vto_ptr) = value

	case VTO_SPEC_PARM:

		VTO_SPEC(vto_ptr) = value

	case VTO_DTYPE_PARM:

		VTO_DTYPE(vto_ptr) = value

	case VTO_MODE_PARM:

		VTO_MODE(vto_ptr) = value

	case VTO_CVI_PARM:

		VTO_CVI(vto_ptr) = value

	default: call eerror(VT_NOPARM)

	}

end


#
# vto_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table object.
#

procedure	vto_setl (vto_ptr, vto_param, value)

pointer vto_ptr				#I pointer to vector table
int	vto_param			#I parameter to be set
long	value				#I new value for parameter

begin

	switch	(vto_param) {

	default:  call eerror(VT_NOPARM)

	}

end


#
# vto_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table object.
#

procedure	vto_setp (vto_ptr, vto_param, value)

pointer vto_ptr				#I pointer to vector table
int	vto_param			#I parameter to be set
pointer	value				#I new value for parameter

begin

	switch	(vto_param) {

	case VTO_VTPTR_PARM:

		VTO_VTPTR(vto_ptr) = value

	case VTO_VCT_PARM:

		VTO_VCT(vto_ptr) = value

	case VTO_AUX_PARM:

		VTO_AUX(vto_ptr) = value

	default:  call eerror(VT_NOPARM)

	}

end


#
# vto_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table object.
#

procedure	vto_setr (vto_ptr, vto_param, value)

pointer vto_ptr				#I pointer to vector table
int	vto_param			#I parameter to be set
real	value				#I new value for parameter

begin

	switch	(vto_param) {

	default:  call eerror(VT_NOPARM)

	}

end


#
# vto_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table object.
#

procedure	vto_sets (vto_ptr, vto_param, value)

pointer vto_ptr				#I pointer to vector table
int	vto_param			#I parameter to be set
short	value				#I new value for parameter

begin

	switch	(vto_param) {

	default:  call eerror(VT_NOPARM)

	}

end

