# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vtostat.x
# 	Author	:  akeith
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) vtostat.x -r1.4 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/17/93   akeith	fixed the indef datatype mismatch
# 	09/16/93   akeith	fixed default case statment
# 	07/16/93   akeith	corrected the YES/NO TRUE/FALSE problem
# 	04/13/92   akeith	date and time created 92/04/13 15:34:44 by akeith
# H-
# 
#

#       Last revised: 9/17/93
#
include <vtl.h>
include <eerror.h>
include "vto.h"

define	DEFAULT		-897

#
# vto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table object.
#

bool	procedure	vto_statb (vto, vto_param)

pointer vto				#I pointer to vector table
int	vto_param			#I parameter to inquire

bool	value				# output value for parameter

begin

	switch	(vto_param) {

	case VTO_ORDER_PARM:

		value = VTO_ORDER(vto)

	case VTO_SET_PARM:

		value = VTO_SET(vto)

	default:

		call eerror(VT_NOPARM)
		value = FALSE

	}

	return(value)

end


#
# vto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table object.
#

double	procedure	vto_statd (vto, vto_param)

pointer vto				#I pointer to vector table
int	vto_param			#I parameter to inquire

double	value				# output value for parameter

begin

	switch	(vto_param) {

	case DEFAULT:

		call eerror(VT_NOPARM)
		value = INDEFD

	default:

		call eerror(VT_NOPARM)
		value = INDEFD

	}

	return(value)

end


#
# vto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table object.
#

int	procedure	vto_stati (vto, vto_param)

pointer vto				#I pointer to vector table
int	vto_param			#I parameter to inquire

int	value				# output value for parameter

begin

	switch	(vto_param) {

	case VTO_NELMS_PARM:

		value = VTO_NELMS(vto)

	case VTO_VTIND_PARM:

		value = VTO_VTIND(vto)

	case VTO_SPEC_PARM:

		value = VTO_SPEC(vto)

	case VTO_DTYPE_PARM:

		value = VTO_DTYPE(vto)

	case VTO_MODE_PARM:

		value = VTO_MODE(vto)

	case VTO_CVI_PARM:

		value = VTO_CVI(vto)

	default:

		call eerror(VT_NOPARM)
		value = INDEFI

	}

	return(value)

end


#
# vto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table object.
#

long	procedure	vto_statl (vto, vto_param)

pointer vto				#I pointer to vector table
int	vto_param			#I parameter to inquire

long	value				# output value for parameter

begin

	switch	(vto_param) {

	case DEFAULT:

		call eerror(VT_NOPARM)
		value = INDEFL

	default:

		call eerror(VT_NOPARM)
		value = INDEFL

	}

	return(value)

end


#
# vto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table object.
#

pointer	procedure	vto_statp (vto, vto_param)

pointer vto				#I pointer to vector table
int	vto_param			#I parameter to inquire

pointer	value				# output value for parameter

begin

	switch	(vto_param) {


	case VTO_VTPTR_PARM:

		value = VTO_VTPTR(vto)

	case VTO_VCT_PARM:

		value = VTO_VCT(vto)

	case VTO_AUX_PARM:

		value = VTO_AUX(vto)

	default:

		call eerror(VT_NOPARM)
		value = NULL

	}

	return(value)

end


#
# vto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table object.
#

real	procedure	vto_statr (vto, vto_param)

pointer vto				#I pointer to vector table
int	vto_param			#I parameter to inquire

real	value				# output value for parameter

begin

	switch	(vto_param) {

	case DEFAULT:

		call eerror(VT_NOPARM)
		value = INDEFR

	default:

		call eerror(VT_NOPARM)
		value = INDEFR

	}

	return(value)

end


#
# vto_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table object.
#

short	procedure	vto_stats (vto, vto_param)

pointer vto				#I pointer to vector table
int	vto_param			#I parameter to inquire

short	value				# output value for parameter

begin

	switch	(vto_param) {

	case DEFAULT:

		call eerror(VT_NOPARM)
		value = INDEFS

	default:

		call eerror(VT_NOPARM)
		value = INDEFS

	}

	return(value)

end

