# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vtset.x
# 	Author	:  akeith
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) vtset.x -r1.2 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/13/92   akeith	date and time created 92/04/13 15:34:57 by akeith
# H-
# 
#

#       Last revised: 5/14/92
#
include <vtl.h>
include <eerror.h>
include "vt.h"

#
# vt_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table.
#


procedure	vt_setb (vt_ptr, vt_param, value)

pointer vt_ptr				#I pointer to vector table
int	vt_param			#I parameter to be set
bool	value				#I new value for parameter

begin

	switch	(vt_param) {

	case VT_IDSFLG_PARM:

		VT_IDSFLG(vt_ptr) = value

	case VT_DDSFLG_PARM:

		VT_DDSFLG(vt_ptr) = value

	default:  call eerror(VT_NOPARM)

	}

end


#
# vt_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table.
#

procedure	vt_setd (vt_ptr, vt_param, value)

pointer vt_ptr				#I pointer to vector table
int	vt_param			#I parameter to be set
double	value				#I new value for parameter

begin

	switch	(vt_param) {

	default:  call eerror(VT_NOPARM)

	}

end


#
# vt_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table.
#

procedure       vt_seti (vt_ptr, vt_param, value)

pointer vt_ptr				#I pointer to vector table
int	vt_param			#I parameter to be set
int	value				#I new value for parameter

begin

	switch	(vt_param) {

	case VT_NVTO_PARM:

		VT_NVTO(vt_ptr) = value

	case VT_IDS_PARM:

		VT_IDS(vt_ptr) = value

	case VT_DDS_PARM:

		VT_DDS(vt_ptr) = value

	case VT_VTOIND_PARM:

		VT_VTOIND(vt_ptr) = value

	case VT_VCTTYP_PARM:

		VT_VCTTYP(vt_ptr) = value

	default:  call eerror(VT_NOPARM)

	}

end


#
# vt_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table.
#

procedure	vt_setl (vt_ptr, vt_param, value)

pointer vt_ptr				#I pointer to vector table
int	vt_param			#I parameter to be set
long	value				#I new value for parameter

begin

	switch	(vt_param) {

	case VT_VTOLEN_PARM:

		VT_VTO_LEN(vt_ptr) = value

	default:  call eerror(VT_NOPARM)

	}

end


#
# vt_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table.
#

procedure	vt_setp (vt_ptr, vt_param, value)

pointer vt_ptr				#I pointer to vector table
int	vt_param			#I parameter to be set
pointer	value				#I new value for parameter

begin

	switch	(vt_param) {

        case VT_VTOHDR_PARM:

		VT_VTO_PTR(vt_ptr) = value

	default:  call eerror(VT_NOPARM)

	}

end


#
# vt_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table.
#

procedure	vt_setr (vt_ptr, vt_param, value)

pointer vt_ptr				#I pointer to vector table
int	vt_param			#I parameter to be set
real	value				#I new value for parameter

begin

	switch	(vt_param) {

	default:  call eerror(VT_NOPARM)

	}

end


#
# vt_set[bdilrsp] sets the value of a particular parameter stored within
#       the vector table.
#

procedure	vt_sets (vt_ptr, vt_param, value)

pointer vt_ptr				#I pointer to vector table
int	vt_param			#I parameter to be set
short	value				#I new value for parameter

begin

	switch	(vt_param) {

	default:  call eerror(VT_NOPARM)

	}

end

