# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vtstat.x
# 	Author	:  akeith
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) vtstat.x -r1.4 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/17/93   akeith	fixed the indef datatype mismatch
# 	09/16/93   akeith	fixed default case statment
# 	07/16/93   akeith	default now returns a FALSE
# 	04/13/92   akeith	date and time created 92/04/13 15:34:59 by akeith
# H-
# 
#

#       Last revised: 9/17/93
#
include <vtl.h>
include <eerror.h>
include "vt.h"

define	DEFAULT		-897

#
# vt_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table.
#

bool	procedure	vt_statb (vt, vt_param)

pointer vt				#I pointer to vector table
int	vt_param			#I parameter to inquire

bool	value				# output value for parameter

begin

	switch	(vt_param) {

	case VT_IDSFLG_PARM:

		value = VT_IDSFLG(vt)

	case VT_DDSFLG_PARM:

		value = VT_DDSFLG(vt)

	default:

		call eerror(VT_NOPARM)
		value = FALSE

	}

	return(value)

end


#
# vt_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table.
#

double	procedure	vt_statd (vt, vt_param)

pointer vt				#I pointer to vector table
int	vt_param			#I parameter to inquire

double	value				# output value for parameter

begin

	switch	(vt_param) {

	case DEFAULT:

		call eerror(VT_NOPARM)
		value = INDEFD

	default:
		call eerror(VT_NOPARM)
		value = INDEFD
	}

	return(value)

end


#
# vt_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table.
#

int	procedure	vt_stati (vt, vt_param)

pointer vt				#I pointer to vector table
int	vt_param			#I parameter to inquire

int	value				# output value for parameter

begin

	switch	(vt_param) {

	case VT_NVTO_PARM:

		value = VT_NVTO(vt)

	case VT_IDS_PARM:

		value = VT_IDS(vt)

	case VT_DDS_PARM:

		value = VT_DDS(vt)

	case VT_VTOIND_PARM:

		value = VT_VTOIND(vt)

	case VT_VCTTYP_PARM:

		value = VT_VCTTYP(vt)

	default:

		call eerror(VT_NOPARM)
		value = INDEFI

	}

	return(value)

end


#
# vt_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table.
#

long	procedure	vt_statl (vt, vt_param)

pointer vt				#I pointer to vector table
int	vt_param			#I parameter to inquire

long	value				# output value for parameter

begin

	switch	(vt_param) {

	case VT_VTOLEN_PARM:

		value = VT_VTO_LEN(vt)

	default:

		call eerror(VT_NOPARM)
		value = INDEFL

	}

	return(value)

end


#
# vt_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table.
#

pointer	procedure	vt_statp (vt, vt_param)

pointer vt				#I pointer to vector table
int	vt_param			#I parameter to inquire

pointer	value				# output value for parameter

begin

	switch	(vt_param) {

	case VT_VTOHDR_PARM:

		value = VT_VTO_PTR(vt)

	default:

		call eerror(VT_NOPARM)
		value = NULL

	}

	return(value)

end


#
# vt_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table.
#

real	procedure	vt_statr (vt, vt_param)

pointer vt				#I pointer to vector table
int	vt_param			#I parameter to inquire

real	value				# output value for parameter

begin

	switch	(vt_param) {

	case DEFAULT:

		call eerror(VT_NOPARM)
		value = INDEFR

	default:

		call eerror(VT_NOPARM)
		value = INDEFR

	}

	return(value)

end


#
# vt_stat[bdilrsp] returns the value of a particular parameter stored within
#	the vector table.
#

short	procedure	vt_stats (vt, vt_param)

pointer vt				#I pointer to vector table
int	vt_param			#I parameter to inquire

short	value				# output value for parameter

begin

	switch	(vt_param) {

	case DEFAULT:

		call eerror(VT_NOPARM)
		value = INDEFS

	default:

		call eerror(VT_NOPARM)
		value = INDEFS

	}

	return(value)

end

