# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  vttest.x
# 	Author	:  akeith
# 	Date	:  04/13/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) vttest.x -r1.3 04/13/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/14/92   akeith	documentation
# 	05/14/92   akeith	documentation
# 	04/13/92   akeith	date and time created 92/04/13 15:35:01 by akeith
# H-
# 
#


# This is a test program designed to test the vector table library.

include <vtl.h>
include "vto.h"

define	TST_NPTS	20

task	vt_test

#
# vt_test() is a code test procedure, not used in general.
#

procedure	vt_test()

int	i
int	stat
int	dat_ary[TST_NPTS]
real	dat_aryr[TST_NPTS]

pointer vt_ptr
pointer vto_ptr[6]

int	vto_pvcti()
int	vto_pvctr()

pointer	vt_create()
pointer	vto_create()

begin

	call printf("\n\n Hello, World. \n\n")

	vt_ptr = vt_create()

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	vto_ptr[1] = vto_create(vt_ptr)

	do i = 1, TST_NPTS {
		dat_ary[i] = i
	}

	stat = vto_pvcti(vto_ptr[1], dat_ary, TST_NPTS)

	call ary_prnti(vto_ptr[1])
	call vt_prnt(vt_ptr, "After storing vector 1")
	call vto_prnt(vto_ptr[1], "After storing vector 1")

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	vto_ptr[2] = vto_create(vt_ptr)

	do i = 1, TST_NPTS {
		dat_aryr[i] = real(i)
	}

	stat = vto_pvctr(vto_ptr[2], dat_aryr, TST_NPTS)

	call ary_prntr(vto_ptr[2])
	call vt_prnt(vt_ptr, "After storing vector 2")
	call vto_prnt(vto_ptr[2], "After storing vector 2")

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	vto_ptr[3] = vto_create(vt_ptr)

	do i = 1, TST_NPTS {
		dat_aryr[i] = real(i)
	}

	stat = vto_pvctr(vto_ptr[3], dat_aryr, TST_NPTS)

	call ary_prntr(vto_ptr[3])
	call vt_prnt(vt_ptr, "After storing vector 3")
	call vto_prnt(vto_ptr[3], "After storing vector 3")

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	call vto_destroy(vto_ptr[2])
	call vt_prnt(vt_ptr, "After killing vector 2")
	call vto_prnt(vto_ptr[2], "After killing vector 2")

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	vto_ptr[2] = vto_create(vt_ptr)

	do i = 1, TST_NPTS {
		dat_aryr[i] = real(i)
	}

	stat = vto_pvctr(vto_ptr[2], dat_aryr, TST_NPTS)

	call ary_prntr(vto_ptr[2])
	call vt_prnt(vt_ptr, "After recreate vector 2")
	call vto_prnt(vto_ptr[2], "After recreate vector 2")

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	do i = 1, TST_NPTS {
		dat_aryr[i] = real(i)
	}

	stat = vto_pvctr(vto_ptr[3], dat_aryr, TST_NPTS)

	call ary_prntr(vto_ptr[3])
	call vt_prnt(vt_ptr, "After adding to vector 3")
	call vto_prnt(vto_ptr[3], "After adding to vector 3")

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	do i = 1, TST_NPTS {
		dat_aryr[i] = real(i)
	}

	call vto_seti(vto_ptr[2], VTO_MODE_PARM, VTO_OVRWRT)
	call vto_seti(vto_ptr[2], VTO_CVI_PARM, 10)

	stat = vto_pvctr(vto_ptr[2], dat_aryr, TST_NPTS)

	call ary_prntr(vto_ptr[2])
	call vt_prnt(vt_ptr, "After overwrting to vector 2")
	call vto_prnt(vto_ptr[2], "After overwrting to vector 2")

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	call vt_destroy(vt_ptr)

	call printf("\n\n Hello, World. \n\n")


end


#
# ary_prntr() prints some array elements for testing ONLY.
#

procedure	ary_prntr(vto_ptr)

pointer vto_ptr				#I

int	i
int	nelms

int	vto_stati()

begin

	call printf("\n\n")

	nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)

	do i = 1, nelms {
		call printf(" array val %d = %e \n")
		call pargi(i)
		call pargr(VTO_ARYR(vto_ptr,i))
	}
end

#
# ary_prnti() prints some array elements for testing ONLY.
#

procedure	ary_prnti(vto_ptr)

pointer vto_ptr				#I

int	i
int	nelms

int	vto_stati()

begin

	call printf("\n\n")

	nelms = vto_stati(vto_ptr, VTO_NELMS_PARM)

	do i = 1, nelms {
		call printf(" array val %d = %d \n")
		call pargi(i)
		call pargi(VTO_ARYI(vto_ptr,i))
	}
end

