# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  match_val.gx
# 	Author	:  tnk
# 	Date	:  06/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) match_val.gx -r1.2 06/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/12/96   tnk	now ignores INDEF values
# 	06/28/94   tnk	date and time created 94/06/28 11:50:56 by tnk
# H-
# 
#

# DATE 6/23/94
# PROCEDURE NAME 
# INCLUDE FILES

# @(#)match_val.gx	1.2 11/12/96

include <tbset.h>
include <dbg.h>


# DESCRIPTION OF PROCEDURE
#




procedure match_val_i( intab, outtab, colptr, lowval, highval, 
   inrange, result )

#
#IMPORT VARIABLES :
pointer intab                     #I table pointer
pointer outtab                    #I table pointer
pointer colptr                    #I col pointer
int   lowval                    #I value to be marched
int   highval                   #I value to be marched
bool    inrange                   #I in range or out of range

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int j                             # loop counter
int nrows                         # num of rows in table
int colval                      # contents of column
bool nullflag                     # flags for the buffer values
int  outrow                       # output row counter

#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  nrows = tbpsta( intab, TBL_NROWS )
  result = 0
  outrow = 1

  if ( inrange )
  {
    for ( j=1; j<=nrows; j=j+1 )
    {
      call tbcgti( intab, colptr, colval, nullflag, j, j)
      if (!IS_INDEFI(colval) && colval >= lowval && colval <= highval )
      {
	  result = result + 1
	  call tbrcpy (intab, outtab, j, outrow)
          outrow=outrow+1
      }
    }
  }
  else
  {
    for ( j=1; j<=nrows; j=j+1 )
    {
      call tbcgti( intab, colptr, colval, nullflag, j, j)
      if ( !IS_INDEFI(colval) && (colval < lowval ||  colval > highval) )
      {
	  result = result + 1
	  call tbrcpy (intab, outtab, j, outrow)
          outrow=outrow+1
      }
    }

  }

end

#------------------------------------------


procedure match_val_s( intab, outtab, colptr, lowval, highval, 
   inrange, result )

#
#IMPORT VARIABLES :
pointer intab                     #I table pointer
pointer outtab                    #I table pointer
pointer colptr                    #I col pointer
short   lowval                    #I value to be marched
short   highval                   #I value to be marched
bool    inrange                   #I in range or out of range

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int j                             # loop counter
int nrows                         # num of rows in table
short colval                      # contents of column
bool nullflag                     # flags for the buffer values
int  outrow                       # output row counter

#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  nrows = tbpsta( intab, TBL_NROWS )
  result = 0
  outrow = 1

  if ( inrange )
  {
    for ( j=1; j<=nrows; j=j+1 )
    {
      call tbcgts( intab, colptr, colval, nullflag, j, j)
      if (!IS_INDEFS(colval) && colval >= lowval && colval <= highval )
      {
	  result = result + 1
	  call tbrcpy (intab, outtab, j, outrow)
          outrow=outrow+1
      }
    }
  }
  else
  {
    for ( j=1; j<=nrows; j=j+1 )
    {
      call tbcgts( intab, colptr, colval, nullflag, j, j)
      if ( !IS_INDEFS(colval) && (colval < lowval ||  colval > highval) )
      {
	  result = result + 1
	  call tbrcpy (intab, outtab, j, outrow)
          outrow=outrow+1
      }
    }

  }

end

#------------------------------------------


procedure match_val_r( intab, outtab, colptr, lowval, highval, 
   inrange, result )

#
#IMPORT VARIABLES :
pointer intab                     #I table pointer
pointer outtab                    #I table pointer
pointer colptr                    #I col pointer
real   lowval                    #I value to be marched
real   highval                   #I value to be marched
bool    inrange                   #I in range or out of range

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int j                             # loop counter
int nrows                         # num of rows in table
real colval                      # contents of column
bool nullflag                     # flags for the buffer values
int  outrow                       # output row counter

#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  nrows = tbpsta( intab, TBL_NROWS )
  result = 0
  outrow = 1

  if ( inrange )
  {
    for ( j=1; j<=nrows; j=j+1 )
    {
      call tbcgtr( intab, colptr, colval, nullflag, j, j)
      if (!IS_INDEFR(colval) && colval >= lowval && colval <= highval )
      {
	  result = result + 1
	  call tbrcpy (intab, outtab, j, outrow)
          outrow=outrow+1
      }
    }
  }
  else
  {
    for ( j=1; j<=nrows; j=j+1 )
    {
      call tbcgtr( intab, colptr, colval, nullflag, j, j)
      if ( !IS_INDEFR(colval) && (colval < lowval ||  colval > highval) )
      {
	  result = result + 1
	  call tbrcpy (intab, outtab, j, outrow)
          outrow=outrow+1
      }
    }

  }

end

#------------------------------------------


procedure match_val_d( intab, outtab, colptr, lowval, highval, 
   inrange, result )

#
#IMPORT VARIABLES :
pointer intab                     #I table pointer
pointer outtab                    #I table pointer
pointer colptr                    #I col pointer
double   lowval                    #I value to be marched
double   highval                   #I value to be marched
bool    inrange                   #I in range or out of range

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int j                             # loop counter
int nrows                         # num of rows in table
double colval                      # contents of column
bool nullflag                     # flags for the buffer values
int  outrow                       # output row counter

#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  nrows = tbpsta( intab, TBL_NROWS )
  result = 0
  outrow = 1

  if ( inrange )
  {
    for ( j=1; j<=nrows; j=j+1 )
    {
      call tbcgtd( intab, colptr, colval, nullflag, j, j)
      if (!IS_INDEFD(colval) && colval >= lowval && colval <= highval )
      {
	  result = result + 1
	  call tbrcpy (intab, outtab, j, outrow)
          outrow=outrow+1
      }
    }
  }
  else
  {
    for ( j=1; j<=nrows; j=j+1 )
    {
      call tbcgtd( intab, colptr, colval, nullflag, j, j)
      if ( !IS_INDEFD(colval) && (colval < lowval ||  colval > highval) )
      {
	  result = result + 1
	  call tbrcpy (intab, outtab, j, outrow)
          outrow=outrow+1
      }
    }

  }

end

#------------------------------------------

