# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_colval.gx
# 	Author	:  tnk
# 	Date	:  06/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_colval.gx -r1.1 06/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/28/94   tnk	date and time created 94/06/28 11:50:56 by tnk
# H-
# 
#

# DATE 24 Jun 94
# PROCEDURE NAME 
# INCLUDE FILES

include <tbset.h>
include <dbg.h>
include <mach.h>

# DESCRIPTION OF PROCEDURE
#

# copy rows from one table to another that match the
# value in a particular column

# @(#)t_colval.gx	1.1 6/28/94


procedure t_colval()

#AUTHOR : GARETH BEVAN
#
#IMPORT VARIABLES :
#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
#LOCAL VARIABLES :

pointer inp                   # input file name
pointer outp                  # output file name
pointer col                   # col name
pointer lowval                # col value
pointer highval               # col value
pointer name                  # col name
pointer units                 # col units
pointer fmt                   # col format string
pointer intab                   # table pointre
pointer outtab                   # table pointer
pointer colptr[1]             # col pointer

int i_lowval
short s_lowval
double d_lowval
real r_lowval
int i_highval
short s_highval
double d_highval
real r_highval

bool inrange                  # true if keep the data between low/hi

int colnum                    # column number
int dummy
int datatype                  # the col datatype

long result                    # number of rows matching condition
pointer matchmsg
pointer sp

#FUNCTIONS :
bool clgetb()
pointer tbtopn()


       
#############################################################################

begin

  call smark(sp)

  call salloc( inp, SZ_LINE, TY_CHAR )
  call salloc( outp, SZ_LINE, TY_CHAR )
  call salloc( col, SZ_LINE, TY_CHAR )
  call salloc( lowval, SZ_LINE, TY_CHAR )
  call salloc( highval, SZ_LINE, TY_CHAR )
  call salloc( name, SZ_COLNAME, TY_CHAR )
  call salloc( units, SZ_COLUNITS, TY_CHAR )
  call salloc( fmt, SZ_COLFMT, TY_CHAR )
  call salloc( matchmsg, SZ_LINE, TY_CHAR )

  # read parameter file

  call clgstr("intable", Memc[inp], SZ_LINE)
  call clgstr("outtable", Memc[outp], SZ_LINE)
  call clgstr("column", Memc[col], SZ_LINE)
  call clgstr("lowvalue", Memc[lowval], SZ_LINE)
  call clgstr("highvalue", Memc[highval], SZ_LINE)
  inrange = clgetb("inrange")

  if (inrange)
     call strcpy("in range",Memc[matchmsg],SZ_LINE)
  else
     call strcpy("out of range",Memc[matchmsg],SZ_LINE) 

  # get table info

  intab = tbtopn( Memc[inp], READ_ONLY, 0 )
  call tbcfnd( intab, Memc[col], colptr, 1)
  if ( colptr[1] == NULL )
  {
    call eprintf("ERROR: Column %s does not exist in table %s.\n")
    call pargstr( Memc[col] )
    call pargstr( Memc[inp] )
  }
  else
  {


    #open output table
    outtab = tbtopn (Memc[outp], NEW_COPY, intab)
    if (outtab == NULL)
       call error(100,"cannot open output table")

    call tbtcre (outtab)
    call tbhcal (intab, outtab)

    call tbcinf( colptr[1], colnum, Memc[name], Memc[units], Memc[fmt],
	       datatype, dummy, dummy )
  

  
  # convertdata type

    switch ( datatype )
    {

    case TY_INT :

      call sscan( Memc[lowval] )
      call gargi( i_lowval )
      call sscan( Memc[highval] )
      call gargi( i_highval )

      call match_val_i( intab, outtab, colptr, i_lowval, i_highval, 
         inrange, result )

    case TY_SHORT :

      # This code here to fix bug in gargs
      call sscan( Memc[lowval] )
      call gargd( d_lowval )
      s_lowval = d_lowval
      call sscan( Memc[highval] )
      call gargd( d_highval )
      s_highval = d_highval

      call match_val_s( intab, outtab, colptr, s_lowval, s_highval, 
         inrange, result )

    case TY_REAL :

      call sscan( Memc[lowval] )
      call gargr( r_lowval )
      call sscan( Memc[highval] )
      call gargr( r_highval )

      call match_val_r( intab, outtab, colptr, r_lowval, r_highval, 
         inrange, result )

    case TY_DOUBLE :

      call sscan( Memc[lowval] )
      call gargd( d_lowval )
      call sscan( Memc[highval] )
      call gargd( d_highval )

      call match_val_d( intab, outtab, colptr, d_lowval, d_highval, 
         inrange, result )


      
    }
    
      # print results
    
      call printf("\nThere were %d rows in column %s which were %s.\n")
      call pargl( result )
      call pargstr( Memc[name] )
      call pargstr( Memc[matchmsg])
      


  }  

  call tbtclo( intab )
  call tbtclo( outtab )

  call sfree(sp)

end  # OF PROCEDURE colval


