# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_trownum.x
# 	Author	:  tnk
# 	Date	:  06/24/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_trownum.x -r1.1 06/24/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/24/94   tnk	date and time created 94/06/24 15:20:05 by tnk
# H-
# 
#

#	@(#)t_trownum.x	1.1 6/24/94 UCB CEA EGO

include <tbset.h>

# copy a table, selecting rows by row number

define MAX_RANGES 200

procedure	t_trownum()

# input params
pointer	intab	
pointer outtab  
pointer rangestr

#local vars
pointer 	in_tp
pointer		out_tp
pointer		sp
int             num_trows
int             out_row
int             number
int		nvalues
int		ranges[3, MAX_RANGES]   # Range array

# FUNCTIONS 
pointer tbtopn()                # table initialization
int     tbpsta()
int     decode_ranges()
int	get_next_number()

begin


  call smark(sp)

  call eu_clstr(intab,   "intable")   
  call eu_clstr(outtab,  "outtable")  
  call eu_clstr(rangestr,"rangelist")  

  # open input table
  in_tp = tbtopn(Memc[intab],READ_ONLY, 0)

  if (in_tp == NULL)
     call error(100,"cannot open input table")

  #open output table
  out_tp = tbtopn (Memc[outtab], NEW_COPY, in_tp)
  if (out_tp == NULL)
     call error(100,"cannot open output table")

  call tbtcre (out_tp)
  call tbhcal (in_tp, out_tp)

  # parse range list
  if (decode_ranges(Memc[rangestr], ranges, MAX_RANGES, nvalues) != OK)
     call error(101,"Invalid range list")

  if (nvalues == 0)
     call error(102,"Range list resulted in no rows selected")

  # get each value out of range list, til end of list
  # or end of input table

  num_trows = tbpsta(in_tp, TBL_NROWS )

  number = 0
  out_row = 1
  while (get_next_number (ranges, number) != EOF) {
     if (number > num_trows)
        break
     else {
        call tbrcpy (in_tp, out_tp, number, out_row)
        out_row = out_row + 1
     }
  }

  # Clean up
  call tbtclo(in_tp)
  call tbtclo(out_tp)

  call sfree(sp)
end




