# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_editwcs.x
# 	Author	:  akeith
# 	Date	:  03/24/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_editwcs.x -r1.6 03/24/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/04/95   tnk	changed yes/no to true/false
# 	11/17/93   ericco	logical/int error fix
# 	09/16/93   akeith	corrected the name of the mwcs include file
# 	07/16/93   akeith	fixed YES/NO TRUE/FALSE problem
# 	04/28/93   akeith	fix a bug
# 	03/24/93   akeith	date and time created 93/03/24 16:06:33 by akeith
# H-
# 
#

#       Version: @(#)t_editwcs.x	1.6 10/4/95 UCB CEA EGO

include	"ew.h"
include "mwcs$mwcs.h"
include <tbset.h>
include <ctype.h>

procedure	t_editwcs()

pointer	ew			#I/O edit wcs structure

bool	ans
bool	response()

begin

	ans = TRUE

	call ew_open(ew)		#   Open data structure

	call ew_rparm(ew)		#   Read parameters

	call ew_imopen(ew)		#   Open image

	switch(EW_OP(ew)) {

	  case DELETE_EW:
		call printf("\n Unable to delete systems as of yet.\n")

	  case PRINT_EW:

		if(EW_VERIFY(ew) == TRUE) {
			call printf("\n Print %s from %s (yes)? ")
			call pargstr (EW_SYSTEM(ew))
			call pargstr (EW_IMAGE(ew))
			call flush(STDOUT)
			ans = response()
		}

		if(ans == TRUE) {

			if(EW_SHOW(ew) == TRUE) {
				call printf("\n Printing %s from %s.\n")
				call pargstr (EW_SYSTEM(ew))
				call pargstr (EW_IMAGE(ew))
			}

			call ew_mwopen(ew)	#   Open the MWCS
			call ew_mwprint(ew)	#   Close MWCS
			call ew_mwclose(ew)	#   Close MWCS

		}

	  case ADD_EW:

		if(EW_VERIFY(ew) == TRUE) {
			call printf("\n Add %s to %s from %s (yes)? ")
			call pargstr (EW_SYSTEM(ew))
			call pargstr (EW_IMAGE(ew))
			call pargstr (EW_TABLE(ew))
			call flush(STDOUT)
			ans = response()
		}

		if(ans == TRUE) {

			if(EW_SHOW(ew) == TRUE) {
				call printf("\n Adding %s to %s from %s.\n")
				call pargstr (EW_SYSTEM(ew))
				call pargstr (EW_IMAGE(ew))
				call pargstr (EW_TABLE(ew))
			}

			call ew_ifopen(ew)	#   Open Import file
			call ew_mwopen(ew)	#   Open the MWCS
			call ew_import(ew)	#   Import information
			call ew_mwinit(ew)	#   Initialize new WCS
			call ew_insert(ew)	#   Put info in WCS
			call ew_mwclose(ew)	#   Close MWCS
			call ew_ifclose(ew)	#   Close Import file
		}

	  case MOD_EW:


		if(EW_IMPORT(ew) != TRUE) {

			if(EW_VERIFY(ew) == TRUE) {
				call printf("\n Import %s into %s of %s (yes)? ")
				call pargstr (EW_TABLE(ew))
				call pargstr (EW_SYSTEM(ew))
				call pargstr (EW_IMAGE(ew))
				call flush(STDOUT)
				ans = response()
			}

			if(ans == TRUE) {

				if(EW_SHOW(ew) == TRUE) {
					call printf("\n Importing %s into %s of %s.\n")
					call pargstr (EW_SYSTEM(ew))
					call pargstr (EW_IMAGE(ew))
					call pargstr (EW_TABLE(ew))
				}

				call ew_ifopen(ew)	#   Open Import file
				call ew_mwopen(ew)	#   Open the MWCS
				call ew_mwget(ew)	#   Get mw system
				call ew_export(ew)	#   Export info to table
				call ew_mwclose(ew)	#   Close MWCS
				call ew_ifclose(ew)	#   Close Import file
			}

		} else {

			if(EW_VERIFY(ew) == TRUE) {
				call printf("\n Modify %s in %s with %s (yes)? ")
				call pargstr (EW_SYSTEM(ew))
				call pargstr (EW_IMAGE(ew))
				call pargstr (EW_TABLE(ew))
				call flush(STDOUT)
				ans = response()
			}

			if(ans == TRUE) {

				if(EW_SHOW(ew) == TRUE) {
					call printf("\nModifing %s in %s with %s.\n")
					call pargstr (EW_SYSTEM(ew))
					call pargstr (EW_IMAGE(ew))
					call pargstr (EW_TABLE(ew))
				}

				call ew_ifopen(ew)	#   Open Import file
				call ew_mwopen(ew)	#   Open the MWCS
				call ew_import(ew)	#   Import information
				call ew_mwinit(ew)	#   Initialize new WCS
				call ew_insert(ew)	#   Put info in WCS
				call ew_mwclose(ew)	#   Close MWCS
				call ew_ifclose(ew)	#   Close Import file
			}

		}
	}

	call ew_imclose(ew)		#   Close image

	call ew_close(ew)		#   Close data structure
	
end


#
# ew_open()
#

procedure	ew_open(ew)

pointer	ew			#I/O edit wcs structure

begin
	call ew_malloc(ew)		
	call ew_init(ew)
end


#
# ew_init()
#

procedure	ew_init(ew)

pointer	ew			#I/O edit wcs structure

begin

	EW_IMAGE_PTR(ew) = NULL
	EW_SYSTEM_PTR(ew) = NULL
	EW_TABLE_PTR(ew) = NULL
	EW_XNAME_PTR(ew) = NULL
	EW_YNAME_PTR(ew) = NULL
	EW_UNITS_PTR(ew) = NULL
	EW_LABEL_PTR(ew) = NULL
	EW_ADD(ew) = FALSE
	EW_IMPORT(ew) = FALSE
	EW_DELETE(ew) = FALSE
	EW_VERIFY(ew) = FALSE
	EW_SHOW(ew) = FALSE
	EW_UPDATE(ew) = FALSE
	EW_MW(ew) = NULL
	EW_IM(ew) = NULL
	EW_FD(ew) = NULL
	EW_NROWS(ew) = 0
	EW_OP(ew) = 0
	EW_XBUF_LEN(ew) = 0
	EW_XBUF_PTR(ew) = NULL
	EW_YBUF_LEN(ew) = 0
	EW_YBUF_PTR(ew) = NULL

end


#
# ew_rparm()
#

procedure	ew_rparm(ew)

pointer	ew			#I/O edit wcs structure

bool	ew_clgetb()
bool	streq()

begin
	call malloc(EW_IMAGE_PTR(ew), SZ_FNAME, TY_CHAR)
	call malloc(EW_TABLE_PTR(ew), SZ_FNAME, TY_CHAR)
	call malloc(EW_SYSTEM_PTR(ew), SZ_FNAME, TY_CHAR)
	call malloc(EW_XNAME_PTR(ew), SZ_FNAME, TY_CHAR)
	call malloc(EW_YNAME_PTR(ew), SZ_FNAME, TY_CHAR)

	call clgstr("image",  EW_IMAGE(ew), SZ_FNAME)
	call clgstr("field", EW_SYSTEM(ew), SZ_FNAME)
	call clgstr("value",  EW_TABLE(ew), SZ_FNAME)

	EW_IMPORT(ew) = ew_clgetb("import")
	call clgstr("domain",  EW_XNAME(ew), SZ_FNAME)
	call clgstr("range",  EW_YNAME(ew), SZ_FNAME)

	EW_ADD(ew) = ew_clgetb("add")
	EW_DELETE(ew) = ew_clgetb("delete")
	EW_VERIFY(ew) = ew_clgetb("verify")
	EW_SHOW(ew) = ew_clgetb("show")
	EW_UPDATE(ew) = ew_clgetb("update")

	# figure out the operation

	if(EW_DELETE(ew) == TRUE) {
		EW_OP(ew) = DELETE_EW
	} else {
		if(streq(EW_TABLE(ew), "."))
			EW_OP(ew) = PRINT_EW
		else
			if(EW_ADD(ew) == TRUE)
				EW_OP(ew) = ADD_EW
			else
				EW_OP(ew) = MOD_EW
	}

end


#
# ew_clgetb()
#

bool	procedure	ew_clgetb(param)

char	param[ARB]

bool	clgetb()

begin

	if(clgetb(param)) return(TRUE)
	else return(FALSE)

end


#
# ew_imopen()
#

procedure	ew_imopen(ew)

pointer	ew			#I/O edit wcs structure

pointer qp_open()

begin
		EW_IM(ew) = qp_open(EW_IMAGE(ew), READ_WRITE, NULL)
end


#
# ew_ifopen()
#

procedure	ew_ifopen(ew)

pointer	ew			#I/O edit wcs structure

pointer cptr
pointer tbtopen()

begin
	if(EW_IMPORT(ew) == TRUE) {
		EW_FD(ew) = tbtopen(EW_TABLE(ew), READ_ONLY, NULL)
	} else {
		EW_FD(ew) = tbtopen(EW_TABLE(ew), NEW_FILE, NULL)
		call tbcdef(EW_FD(ew), cptr, EW_XNAME(ew), "", "%f", TY_DOUBLE, 1, 1)
		call tbcdef(EW_FD(ew), cptr, EW_YNAME(ew), "", "%f", TY_DOUBLE, 1, 1)
		call tbtcre(EW_FD(ew))
	}
end


#
# ew_mwopen()
#

procedure	ew_mwopen(ew)

pointer	ew			#I/O edit wcs structure

pointer qp_loadwcs()

begin
		EW_MW(ew) = qp_loadwcs(EW_IM(ew))
end


#
# ew_mwinit()
#

procedure	ew_mwinit(ew)

pointer	ew			#I/O edit wcs structure

begin
	call mw_newsystem(EW_MW(ew), EW_SYSTEM(ew), 1)
	call mw_swattrs(EW_MW(ew), 1, "label", EW_LABEL(ew))
	call mw_swattrs(EW_MW(ew), 1, "units", EW_UNITS(ew))
	call mw_swtype(EW_MW(ew), 1, 1, "sampled", "")
end


#
# ew_mwprint()
#

procedure	ew_mwprint(ew)

pointer	ew			#I/O edit wcs structure

begin

	call printf("\n Printing mwcs. \n")
end


#
# ew_mwget()
#

procedure	ew_mwget(ew)

pointer	ew			#I/O edit wcs structure

begin
	call mw_show(EW_MW(ew), STDOUT, NULL)
	call mw_ssystem(EW_MW(ew), EW_SYSTEM(ew))

	EW_NROWS(ew) = WCS_NPTS(MI_WCS(EW_MW(ew)), 1)   # This is not legal
	EW_XBUF_LEN(ew) = EW_NROWS(ew)
	EW_YBUF_LEN(ew) = EW_NROWS(ew)

	call malloc(EW_LABEL_PTR(ew), SZ_FNAME, TY_CHAR)
	call malloc(EW_UNITS_PTR(ew), SZ_FNAME, TY_CHAR)
	call mw_gwattrs(EW_MW(ew), 1, "label", EW_LABEL(ew))
	call mw_gwattrs(EW_MW(ew), 1, "units", EW_UNITS(ew))

	call malloc(EW_XBUF_PTR(ew), EW_XBUF_LEN(ew), TY_DOUBLE)
	call malloc(EW_YBUF_PTR(ew), EW_YBUF_LEN(ew), TY_DOUBLE)

	call mw_gwsampd(EW_MW(ew), 1, Memd[EW_XBUF_PTR(ew)],
				      Memd[EW_YBUF_PTR(ew)], EW_NROWS(ew))
end


#
# ew_export()
#

procedure	ew_export(ew)

pointer	ew			#I/O edit wcs structure

pointer	colptr

begin
	call tbcfnd(EW_FD(ew), EW_XNAME(ew), colptr, 1)
	call tbcptd(EW_FD(ew), colptr, Memd[EW_XBUF_PTR(ew)], 1, EW_NROWS(ew))

	call tbcfnd(EW_FD(ew), EW_YNAME(ew), colptr, 1)
	call tbcptd(EW_FD(ew), colptr, Memd[EW_YBUF_PTR(ew)], 1, EW_NROWS(ew))
end


#
# ew_import()
#

procedure	ew_import(ew)

pointer	ew			#I/O edit wcs structure

pointer sp
pointer nullflg, colfmt
pointer xcol, ycol

int	colnum, type
int	lend, lenf

int	tbpsta()

begin

	EW_NROWS(ew) = tbpsta(EW_FD(ew), TBL_NROWS)
	EW_XBUF_LEN(ew) = EW_NROWS(ew)
	EW_YBUF_LEN(ew) = EW_NROWS(ew)

	call smark(sp)
	call salloc(nullflg, EW_NROWS(ew), TY_BOOL)
	call salloc(colfmt, SZ_LINE, TY_CHAR)

	call malloc(EW_XBUF_PTR(ew), EW_XBUF_LEN(ew), TY_DOUBLE)
	call malloc(EW_YBUF_PTR(ew), EW_YBUF_LEN(ew), TY_DOUBLE)

	call tbcfnd(EW_FD(ew), EW_XNAME(ew), xcol, 1)
	if(xcol == NULL) call eu_error(1,"No such column, ",EW_XNAME(ew))
	call tbcgtd(EW_FD(ew), xcol, Memd[EW_XBUF_PTR(ew)],
				     Memb[nullflg], 1, EW_NROWS(ew))

	call tbcfnd(EW_FD(ew), EW_YNAME(ew), ycol, 1)
	if(ycol == NULL) call eu_error(1,"No such column, ",EW_YNAME(ew))
	call tbcgtd(EW_FD(ew), ycol, Memd[EW_YBUF_PTR(ew)],
				     Memb[nullflg], 1, EW_NROWS(ew))

	call malloc(EW_LABEL_PTR(ew), SZ_FNAME, TY_CHAR)
	call malloc(EW_UNITS_PTR(ew), SZ_FNAME, TY_CHAR)
	call tbcinf(ycol, colnum, EW_LABEL(ew), EW_UNITS(ew), Memc[colfmt],
			  type, lend, lenf)

	call sfree(sp)

end


#
# ew_insert()
#

procedure	ew_insert(ew)

pointer	ew			#I/O edit wcs structure

begin
	call mw_swsampd(EW_MW(ew), 1, Memd[EW_XBUF_PTR(ew)],
				      Memd[EW_YBUF_PTR(ew)], EW_NROWS(ew))
	call mw_show(EW_MW(ew), STDOUT, NULL)
	if(EW_UPDATE(ew) == TRUE)
		call qp_savewcs(EW_IM(ew), EW_MW(ew))
end


#
# response()
#

bool	procedure	response()

pointer	sp
pointer ip
pointer resp

int	nl
bool	goahead

int	getline()
int	strldxs()
bool	streq()

begin

	call smark(sp)
	call salloc(resp, SZ_LINE, TY_CHAR)

	if (getline (STDIN, Memc[resp]) != EOF) {

		ip = resp
		while(IS_WHITE(Memc[ip])) ip = ip + 1

		# Strip trailing newline since it is an artifact of getline.

		nl = strldxs ("\n", Memc[ip]) 
		if (nl > 0)
		    Memc[ip+nl-1] = EOS

		# Decode user response.

		if (Memc[ip] == '\\') {
		    ip = ip + 1
		    goahead = TRUE
		} else if (streq(Memc[ip],"n") || streq(Memc[ip],"no")) {
		    goahead = FALSE
		} else if (streq(Memc[ip],"y") || streq(Memc[ip],"yes")) {
		    goahead = TRUE
		} else {
		    goahead = TRUE
		}

		call flush (STDOUT)
	    }

	call sfree(sp)

	return goahead
end


#
# ew_mwclose()
#

procedure	ew_mwclose(ew)

pointer	ew			#I/O edit wcs structure

begin
	if(EW_MW(ew) != NULL) call mw_close(EW_MW(ew))
end


#
# ew_ifclose()
#

procedure	ew_ifclose(ew)

pointer	ew			#I/O edit wcs structure

begin
	if(EW_FD(ew) != NULL) call tbtclo(EW_FD(ew))
end


#
# ew_imclose()
#

procedure	ew_imclose(ew)

pointer	ew			#I/O edit wcs structure

begin
	if(EW_DELETE(ew) == TRUE)
		call imunmap(EW_IM(ew))
	else
		call qp_close(EW_IM(ew))
end


#
# ew_close()
#

procedure	ew_close(ew)

pointer	ew			#I/O edit wcs structure

begin

	if(EW_XBUF_PTR(ew) != NULL)
		call mfree(EW_XBUF_PTR(ew), TY_DOUBLE)
	if(EW_YBUF_PTR(ew) != NULL)
		call mfree(EW_YBUF_PTR(ew), TY_DOUBLE)

	if(EW_IMAGE_PTR(ew) != NULL)
		call mfree(EW_IMAGE_PTR(ew), TY_CHAR)
	if(EW_TABLE_PTR(ew) != NULL)
		call mfree(EW_TABLE_PTR(ew), TY_CHAR)
	if(EW_XNAME_PTR(ew) != NULL)
		call mfree(EW_XNAME_PTR(ew), TY_CHAR)
	if(EW_YNAME_PTR(ew) != NULL)
		call mfree(EW_YNAME_PTR(ew), TY_CHAR)
	if(EW_SYSTEM_PTR(ew) != NULL)
		call mfree(EW_SYSTEM_PTR(ew), TY_CHAR)
	if(EW_LABEL_PTR(ew) != NULL)
		call mfree(EW_LABEL_PTR(ew), TY_CHAR)
	if(EW_UNITS_PTR(ew) != NULL)
		call mfree(EW_UNITS_PTR(ew), TY_CHAR)

	call ew_free(ew)

end


