# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_listspec.x
# 	Author	:  akeith
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_listspec.x -r1.5 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/04/93   tnk	changed X1,DX to lowercase
# 	04/29/93   gareth	added DX and D1
# 	10/05/92   gareth	removed used variable
# 	09/30/92   gareth	added the mwcs and removed the w0 and wpc
# 	04/30/92   akeith	date and time created 92/04/30 14:09:32 by akeith
# H-
# 
#

include	<imhdr.h>
include <mwset.h>

#	Convert spectral images into a list.

procedure t_listspec()

int	i, j, npix, ndim

long	v[IM_MAXDIM], last_v[IM_MAXDIM]

pointer	im, line, imlist
pointer	sp, image
pointer mw                  # the mwcs for the image

real	w0, wpc 
real	gw0, gwpc

real cd[1]                # wcs definition variables
real w[1]
real r[1]

bool	average
bool	verbose

#functions:
bool	clgetb()
int	imgnlr(), imtgetim()

pointer	imtopenp(), immap()
pointer mw_openim()


real clgetr()

#############################################################
begin
  call smark(sp)
  call salloc(image, SZ_FNAME, TY_CHAR)
  imlist = imtopenp ("images")
  gw0 = clgetr("x1")
  gwpc = clgetr("dx")
  verbose = clgetb("verbose")
  average = clgetb("average")

  w0 = gw0
  wpc = gwpc
  while (imtgetim (imlist, Memc[image], SZ_FNAME) != EOF) {
    if (verbose) {
      call printf ("\n#Image: %s\n\n")
      call pargstr (Memc[image])
    }

    # Open the input image.
    im = immap (Memc[image], READ_ONLY, 0)
    call amovkl (long (1), v, IM_MAXDIM)
    call amovl (v, last_v, IM_MAXDIM)
    npix = IM_LEN(im,1)
    ndim = IM_NDIM(im)

    # open the mwcs.
    mw = mw_openim(im)
    call mw_gwtermr( mw, r, w, cd, 1 )
    
    if (gw0 == INDEFR)
    {
      w0 = w[1]
    }
    if (gwpc == INDEFR)
    {
      wpc = cd[1]
    }
    call mw_close( mw )

    call malloc( line, npix, TY_REAL )

    while (imgnlr (im, line, v) != EOF) {
      do i = 1, npix {
	call printf ("%g")		    # X
	call pargr (w0 + (i - 1) * wpc)
	call pargi (i)
	do j = 2, ndim {		    # Y, Z, etc.
	  call printf (" %3d")
	  call pargl (last_v[j])
	}
	call printf ("  %g\n")		    # pixel value
	if (average)	call pargr (Memr[line+i-1])
	else		call pargr (Memr[line+i-1] / wpc)
      }
      call amovl (v, last_v, IM_MAXDIM)
    }

    call mfree( line, TY_REAL )


    call imunmap (im)
  }

  call imtclose (imlist)
  call sfree(sp)
end
