# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_mkeuvspec.x
# 	Author	:  akeith
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_mkeuvspec.x -r1.8 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/03/93   tnk	changed x1,x2,dx to lowercase
# 	04/30/93   gareth	added X1
# 	09/30/92   gareth	added mwcs calls to replace w0 and wpc
# 	05/14/92   ericco	added documentation
# 	05/13/92   gareth	corrected for new plf libarary
# 	04/30/92   akeith	date and time created 92/04/30 17:09:33 by akeith
# H-
# 
#

include	<imhdr.h>


#	Make a spectra from an ASCII file

procedure	t_mkeuvspec ()

int	clgeti()
int	xcol
int	ycol

pointer	list
pointer	clpopnu()

pointer	sp
pointer	input
pointer	output
pointer	prefix
pointer	im
pointer	immap()
pointer	out
pointer	impl1r()
pointer	xs, ys
pointer mw              # pointer to the wcs of the image

real	wpc
real	w0
real	clgetr()
real cd[2,2]            # wcs rotation matrix
real w[2]               # wcs start value
real r[2]               # wcs reference pixel

int	col
int	i
int	nscan()
int	fscan()

int	cnt
int	clgfil()
int	fd
int	open()
real	junk
int	len
real	wn
real	hx, lx
pointer	ol
int	is_dir
int	clplen()
bool	integrate
bool	clgetb()
bool	llp

#functions
pointer mw_open()


######################################################################
begin
  call smark(sp)
  call salloc(input, SZ_LINE, TY_CHAR)
  call salloc(output, SZ_LINE, TY_CHAR)
  call salloc(prefix, SZ_LINE, TY_CHAR)

  list = clpopnu("inputs")
  ol = clpopnu("outputs")
  if (clplen(ol) == clplen(list)) {
    is_dir = 0
  } else if (clplen(ol) == 1) {
    is_dir = 1
    len = clgfil(ol, Memc[prefix], SZ_LINE)
  } else {
    call error(0, "input and output list length mismatch")
  }

  xcol = clgeti("xcol")
  ycol = clgeti("ycol")
  if (xcol == ycol) {
    call error(0, "xcol must not equal ycol")
  }

  w0 = clgetr("x1")
  wn = clgetr("x2")
  wpc = clgetr("dx")
  if (wpc <= 0) {
    call error(0, "dx must be positive")
  }
  col = max(xcol,ycol)
  llp = clgetb("linelist")
  integrate = clgetb("integrate")

  while (clgfil(list, Memc[input], SZ_LINE) != EOF) {
    fd = open(Memc[input], READ_ONLY, TEXT_FILE)

    cnt = 1
    call malloc(xs, cnt, TY_REAL)
    call malloc(ys, cnt, TY_REAL)
    while (fscan(fd) != EOF) {
      do i = 1, col {
	if (i == xcol) {
	  call gargr(Memr[xs+cnt-1])
	} else if (i == ycol) {
	  call gargr(Memr[ys+cnt-1])
	} else {
	  call gargr(junk)
	}
	if (i > nscan(fd)) break
      }
      if (i > col) {
	cnt = cnt + 1
	call realloc(xs, cnt, TY_REAL)
	call realloc(ys, cnt, TY_REAL)
      }
    }

    if (cnt > 1) {
      if (wn != INDEFR) hx = wn; else hx = Memr[xs+cnt-1-1]
      if (w0 != INDEFR) lx = w0; else lx = Memr[xs]
      
      if (is_dir == 0) {
	len = clgfil(ol, Memc[output], SZ_LINE)
      } else {
	call sprintf(Memc[output], SZ_LINE, "%s/%s")
	call pargstr(Memc[prefix])
	call pargstr(Memc[input])
      }
      len = (hx - lx) / wpc + 1
      im = immap(Memc[output], NEW_FILE, 0)
      IM_NDIM(im) = 1
      IM_LEN(im,1) = len

 
      out = impl1r(im)
      if (llp) {
	call ll_to_array(Memr[xs], Memr[ys], cnt-1, lx, wpc, Memr[out], len)
      } else {
	call plf_to_array(Memr[xs], Memr[ys], cnt-1, lx, wpc, Memr[out], len)
      }
      
      if ( integrate ) {
	call amulkr(Memr[out], wpc, Memr[out], len )
      }
 

      # set up the image header
      mw = mw_open( NULL, 1 )
      call mw_newsystem( mw, "linear", 1 )
      call mw_swattrs( mw, 1, "label", "wavelength" )
      call imaddi( im, "DISPAXIS", 1 )
      call imaddi( im, "DC-FLAG", 0 )
      cd[1,1] = wpc
      cd[1,2] = 0
      cd[2,1] = 0
      cd[2,2] = 1
      r[1] = 1
      r[2] = 0
      w[1] = lx
      w[2] = 0

      call mw_swtermr( mw, r, w, cd, 1 )


      call mw_saveim( mw, im )
      call mw_close( mw )
      
      call imunmap(im)
    }

    call mfree(xs, TY_REAL)
    call mfree(ys, TY_REAL)
  }

  call clpcls(list)
  call sfree(sp)
end

#	convert a line list into an array

procedure	ll_to_array(xs, ys, cnts, w0, wpc, out, len)
real		xs[cnts]	#I x value of line list
real		ys[cnts]	#I y value of line list
int		cnts		#I number of lines
real		w0		#I w0 of array
real		wpc		#I wpc of array
real		out[len]	#I/O output array
int		len		#I size of output array

int		i
real		x
real		y
int		pixel
real		lx

begin
  call aclrr(out, len)
  lx = w0 - (wpc / 2)
  do i = 1, cnts {
    x = xs[i]
    y = ys[i]
    pixel = (x - lx) / wpc + 1
    if (pixel >= 1 && pixel <= len) {
      out[pixel] = out[pixel] + y
    }
  }
end
