# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ccops.x
# 	Author	:  akeith
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) ccops.x -r1.3 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/14/92   ericco	added documentation
# 	04/30/92   akeith	date and time created 92/04/30 12:35:41 by akeith
# H-
# 
#

#	ccops

include	"cep.h"

#	Create a new cep structure
procedure	cep_new(cep)
pointer	cep		#O

begin
  call cep_malloc(cep)
  CEP_LOADPATH_PTR(cep) = 0
  call cc_loadpath(cep,"./")
end

#	process end command
procedure	cc_end (cep)
pointer		cep		#I

begin
  call printf("end of command sequence\n")
end

#	process pipeline command
procedure	cc_pipeline (cep)
pointer		cep		#I

begin
  call printf("start of pipeline command sequence\n")
end

#	release cep resources
procedure	cc_close(cep)
pointer		cep			#I/O

pointer		lp
pointer		ek

begin
  ek = CEP_EK(cep)
  if (ek != 0) call ek_close(ek)
  lp = CEP_LOADPATH_PTR(cep)
  if (lp != 0) call mfree(lp, TY_CHAR)
  call cep_free(cep)
end


#	The path is stored as a series of null terminated
#	strings.  The last string is doubly null terminated.
procedure	cc_loadpath (cep, path)
pointer		cep		#I
char		path[ARB]	#I include path

int		len
int		strlen()
pointer		lp

begin
  len = strlen(path)
  
  lp = CEP_LOADPATH_PTR(cep)
  if (lp != 0) call mfree(lp, TY_CHAR)
  lp = 0
  if (len != 0) {
    call malloc(lp, len+2, TY_CHAR)
    call strcpy(path, Memc[lp], len)
  }
  CEP_LOADPATH_PTR(cep) = lp
  for (; Memc[lp] != EOS; lp = lp + 1) {
    if (Memc[lp] == ':') {
      Memc[lp] = EOS
    }
  }
  Memc[lp+1] = EOS
end

#	look for a file in a loadpath, like access()
pointer	procedure	cc_access(path, name, mode, type)
char	path[ARB]		#I
char	name[ARB]		#I
int	mode			#I
int	type			#I

int	access()
int	ip
int	len
int	nlen
int	strlen()
pointer	buf

begin
  if (access(name, mode, type) == YES) {
    call ds_strcpy(name, buf)
  } else {
    nlen = strlen(name)
    for (ip = 1; path[ip] != EOS; ip = ip + len + 1) {
      len = strlen(path[ip])
      call malloc(buf, len + nlen + 2, TY_CHAR)
      call sprintf(Memc[buf], ARB, "%s%s")
      call pargstr(path[ip])
      call pargstr(name[ip])
      if (access(Memc[buf], mode, type) == YES) break
      call mfree(buf, TY_CHAR)
      buf = 0
    }
  }
  return buf
end

#	process include command
procedure	cc_include (state, cep, name)
pointer		state			#I intr state
pointer		cep			#I cep state
char		name[ARB]		#I include file

pointer		buf
pointer		cc_access()

begin
  buf = cc_access(CEP_LOADPATH(cep), name, READ_ONLY, TEXT_FILE)
  if (buf != 0)	{
    call ii_include(state, Memc[buf])
    call mfree(buf, TY_CHAR)
  }
  else {
    call ii_include(state, name)
  }
end
