# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_cep.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_cep.x -r1.6 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/27/96   tnk	added ra_units & unit conversion code
# 	12/27/96   mabbott	added new override parameters and override and srcpos strctures
# 	06/29/94   akeith	removed debug statements
# 	09/28/92   akeith	put in debug statements
# 	10/29/91   ericco	fixed keyword
# 	05/07/91   ericco	date and time created 91/05/07 08:45:16 by ericco
# H-
# 
#

#	Center for EUV Astrophysics Event Pipeline
#	@(#)t_cep.x	1.6 12/27/96

#	This is the high level drive for the event pipeline.
#	Using the CL interface, the processing database is
#	located, and the system is initialized from there.
#	The descrbed pipeline is processed and its resources
#	released.

include	<dbg.h>
include <override.h>

procedure	t_cep ()

pointer		sp

pointer		state
pointer		runfile
pointer		record
pointer		override
pointer		srcpos
pointer         ra_units        # units for RA

double	clgetd()

begin
  call smark (sp)

  call eu_clstr (runfile, "database")
  call eu_clstr (record, "pipeline")

  # Allocate and fill structures containing parameter values
  # which are used to override values encoded in the text db
  # hierarchy.
  call eu_salloc (override, SZ_OVERRIDE, TY_STRUCT)
  call eu_clfile (REFERENCE_PTR(override), "reference")
  call eu_clfile (TABLEINDEX_PTR(override), "tableindex")
  call eu_clfile (EVENTS_PTR(override), "events")
  call eu_clfile (ASPECT_PTR(override), "aspect")

  call eu_salloc(srcpos, SZ_SRCPOS, TY_STRUCT)
  SRCPOS(override) = srcpos
  SRC_RA(srcpos) = clgetd("ra")
  SRC_DEC(srcpos) = clgetd("dec")


  if (! IS_INDEFD(SRC_RA(srcpos)) )
  {
     call eu_clstr(ra_units, "raunits")

     # convert RA to degrees
     if(Memc[ra_units] == 'h' || Memc[ra_units] == 'H')
	SRC_RA(srcpos) = SRC_RA(srcpos) * 15
     else if(Memc[ra_units] == 'd' || Memc[ra_units] == 'D')
	; # no action
     else
     {
	call eprintf("invalid ra_units: %s\n")
	call pargstr(Memc[ra_units])
	call error(1,"Ra units must be hours (H/h) or Degrees (D/d)")
     }
  }

DEBUG(call dbg_open())

  call er_open (Memc[runfile], Memc[record], override, state)
  call er_process (state)
  call er_close (state)

DEBUG(call dbg_close())

  call sfree(sp)
end
