# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqavg2vto.gx
# 	Author	:  akeith
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqavg2vto.gx -r1.6 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/20/93   ericco	added short support
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	put in generic prep. for loop over enter procedure.
# 	05/14/92   akeith	documentation
# 	04/30/92   akeith	date and time created 92/04/30 17:01:19 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"


# dq_avg2vto[sird] reads in segments of the ST table column, averages over
#		each segment and stores those values within a vector table
#		object. The segments are of length TLS_SRATE (see dq_tbinfo).
#
#


procedure	dq_avg2vtos(cls_ptr)

pointer	cls_ptr					#I cls structure pointer

int	i					# counter

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
pointer tb_cptr					# table column pointer

int	srate					# sample rate of table column
int	nrows					# number of rows in table
bool	extra					# do we need an extra element
int	nelms					# number of vector elements

int	frst_row				# first row of table read
int	last_row				# last row of table read
int	last_elm				# last element of calculation

pointer sp					# stack pointer
pointer	buff_ptr				# buffer pointer
pointer	null_ptr				# null pointer
pointer	vct_ptr					# vector pointer

short	mean, sigma

pointer	vto_ptr					# vector table object pointer
pointer	vt_vtoptr()

int	vto_pvcts()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	srate = TLS_SRATE(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)
	nelms = TLS_NELMS(tls_ptr)
	extra = TLS_EXTRA(tls_ptr)

	if(extra) last_elm = TLS_NELMS(tls_ptr) - 1

	call smark(sp)
	call salloc(buff_ptr, srate, TY_SHORT)
	call salloc(null_ptr, srate, TY_BOOL)
	call salloc(vct_ptr, nelms, TY_SHORT)

	do i = 1, last_elm {
		frst_row = srate*(i-1)+1
		last_row = srate*i
		call tbcgts(tb_ptr, tb_cptr, Mems[buff_ptr],
				Memb[null_ptr], frst_row, last_row)
		call aavgs(Mems[buff_ptr], srate, mean, sigma)
		ARRYS(vct_ptr, i) = short(mean)
	}

	if(extra) {
		frst_row = srate*(nelms-1)+1
		last_row = nrows
		call tbcgts(tb_ptr, tb_cptr, Mems[buff_ptr],
				Memb[null_ptr], frst_row, last_row)
		call aavgs(Mems[buff_ptr], last_row-frst_row+1, mean, sigma)
		ARRYS(vct_ptr, nelms) = short(mean)
	}

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))
	stat = vto_pvcts(vto_ptr, Mems[vct_ptr], nelms)

	call sfree(sp)

end



# dq_avg2vto[sird] reads in segments of the ST table column, averages over
#		each segment and stores those values within a vector table
#		object. The segments are of length TLS_SRATE (see dq_tbinfo).
#
#


procedure	dq_avg2vtoi(cls_ptr)

pointer	cls_ptr					#I cls structure pointer

int	i					# counter

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
pointer tb_cptr					# table column pointer

int	srate					# sample rate of table column
int	nrows					# number of rows in table
bool	extra					# do we need an extra element
int	nelms					# number of vector elements

int	frst_row				# first row of table read
int	last_row				# last row of table read
int	last_elm				# last element of calculation

pointer sp					# stack pointer
pointer	buff_ptr				# buffer pointer
pointer	null_ptr				# null pointer
pointer	vct_ptr					# vector pointer

int	mean, sigma

pointer	vto_ptr					# vector table object pointer
pointer	vt_vtoptr()

int	vto_pvcti()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	srate = TLS_SRATE(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)
	nelms = TLS_NELMS(tls_ptr)
	extra = TLS_EXTRA(tls_ptr)

	if(extra) last_elm = TLS_NELMS(tls_ptr) - 1

	call smark(sp)
	call salloc(buff_ptr, srate, TY_INT)
	call salloc(null_ptr, srate, TY_BOOL)
	call salloc(vct_ptr, nelms, TY_INT)

	do i = 1, last_elm {
		frst_row = srate*(i-1)+1
		last_row = srate*i
		call tbcgti(tb_ptr, tb_cptr, Memi[buff_ptr],
				Memb[null_ptr], frst_row, last_row)
		call aavgi(Memi[buff_ptr], srate, mean, sigma)
		ARRYI(vct_ptr, i) = int(mean)
	}

	if(extra) {
		frst_row = srate*(nelms-1)+1
		last_row = nrows
		call tbcgti(tb_ptr, tb_cptr, Memi[buff_ptr],
				Memb[null_ptr], frst_row, last_row)
		call aavgi(Memi[buff_ptr], last_row-frst_row+1, mean, sigma)
		ARRYI(vct_ptr, nelms) = int(mean)
	}

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))
	stat = vto_pvcti(vto_ptr, Memi[vct_ptr], nelms)

	call sfree(sp)

end



# dq_avg2vto[sird] reads in segments of the ST table column, averages over
#		each segment and stores those values within a vector table
#		object. The segments are of length TLS_SRATE (see dq_tbinfo).
#
#


procedure	dq_avg2vtor(cls_ptr)

pointer	cls_ptr					#I cls structure pointer

int	i					# counter

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
pointer tb_cptr					# table column pointer

int	srate					# sample rate of table column
int	nrows					# number of rows in table
bool	extra					# do we need an extra element
int	nelms					# number of vector elements

int	frst_row				# first row of table read
int	last_row				# last row of table read
int	last_elm				# last element of calculation

pointer sp					# stack pointer
pointer	buff_ptr				# buffer pointer
pointer	null_ptr				# null pointer
pointer	vct_ptr					# vector pointer

real	mean, sigma

pointer	vto_ptr					# vector table object pointer
pointer	vt_vtoptr()

int	vto_pvctr()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	srate = TLS_SRATE(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)
	nelms = TLS_NELMS(tls_ptr)
	extra = TLS_EXTRA(tls_ptr)

	if(extra) last_elm = TLS_NELMS(tls_ptr) - 1

	call smark(sp)
	call salloc(buff_ptr, srate, TY_REAL)
	call salloc(null_ptr, srate, TY_BOOL)
	call salloc(vct_ptr, nelms, TY_REAL)

	do i = 1, last_elm {
		frst_row = srate*(i-1)+1
		last_row = srate*i
		call tbcgtr(tb_ptr, tb_cptr, Memr[buff_ptr],
				Memb[null_ptr], frst_row, last_row)
		call aavgr(Memr[buff_ptr], srate, mean, sigma)
		ARRYR(vct_ptr, i) = real(mean)
	}

	if(extra) {
		frst_row = srate*(nelms-1)+1
		last_row = nrows
		call tbcgtr(tb_ptr, tb_cptr, Memr[buff_ptr],
				Memb[null_ptr], frst_row, last_row)
		call aavgr(Memr[buff_ptr], last_row-frst_row+1, mean, sigma)
		ARRYR(vct_ptr, nelms) = real(mean)
	}

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))
	stat = vto_pvctr(vto_ptr, Memr[vct_ptr], nelms)

	call sfree(sp)

end



# dq_avg2vto[sird] reads in segments of the ST table column, averages over
#		each segment and stores those values within a vector table
#		object. The segments are of length TLS_SRATE (see dq_tbinfo).
#
#


procedure	dq_avg2vtod(cls_ptr)

pointer	cls_ptr					#I cls structure pointer

int	i					# counter

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
pointer tb_cptr					# table column pointer

int	srate					# sample rate of table column
int	nrows					# number of rows in table
bool	extra					# do we need an extra element
int	nelms					# number of vector elements

int	frst_row				# first row of table read
int	last_row				# last row of table read
int	last_elm				# last element of calculation

pointer sp					# stack pointer
pointer	buff_ptr				# buffer pointer
pointer	null_ptr				# null pointer
pointer	vct_ptr					# vector pointer

double	mean, sigma

pointer	vto_ptr					# vector table object pointer
pointer	vt_vtoptr()

int	vto_pvctd()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	srate = TLS_SRATE(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)
	nelms = TLS_NELMS(tls_ptr)
	extra = TLS_EXTRA(tls_ptr)

	if(extra) last_elm = TLS_NELMS(tls_ptr) - 1

	call smark(sp)
	call salloc(buff_ptr, srate, TY_DOUBLE)
	call salloc(null_ptr, srate, TY_BOOL)
	call salloc(vct_ptr, nelms, TY_DOUBLE)

	do i = 1, last_elm {
		frst_row = srate*(i-1)+1
		last_row = srate*i
		call tbcgtd(tb_ptr, tb_cptr, Memd[buff_ptr],
				Memb[null_ptr], frst_row, last_row)
		call aavgd(Memd[buff_ptr], srate, mean, sigma)
		ARRYD(vct_ptr, i) = double(mean)
	}

	if(extra) {
		frst_row = srate*(nelms-1)+1
		last_row = nrows
		call tbcgtd(tb_ptr, tb_cptr, Memd[buff_ptr],
				Memb[null_ptr], frst_row, last_row)
		call aavgd(Memd[buff_ptr], last_row-frst_row+1, mean, sigma)
		ARRYD(vct_ptr, nelms) = double(mean)
	}

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))
	stat = vto_pvctd(vto_ptr, Memd[vct_ptr], nelms)

	call sfree(sp)

end



