# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqcdraw.gx
# 	Author	:  akeith
# 	Date	:  11/22/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqcdraw.gx -r1.2 11/22/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/22/93   akeith	date and time created 93/11/22 15:13:56 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"
include <gset.h>

#
# dq_cdraw is the last step in actually display a column. 
#	First, set a bunch of varibles to make life easier, then
#	do the actual drawing of the column and last draw the limit
#	markers if so desired.
#

procedure	dq_cdraw(gp, dq_ptr, cls_indx)

pointer	gp					#I graphics pointer
pointer dq_ptr					#I dq structure pointer
int	cls_indx				#I wcs index

int	nelms					# number of elements in vectors
int	ids_indx				# vto index to ids
int	ids_type				# ids type
int	dds_indx				# vto index to dds
int	dds_type				# dds type

int	length

int	inclus					# inclusive limits?
real	hi_lim, lo_lim				# high and low limits

double	time_tol				# time tol.

pointer cls_ptr					# cls structure pointer
pointer vt_ptr					# vector table pointer

pointer ids_ptr					# independent data set pointer
pointer ids_vto					# ids vector table object

pointer dds_ptr					# dependent data set pointer
pointer dds_vto					# dds vector table object

pointer tls_ptr					# table list structure

pointer	sp
pointer x_ptr, y_ptr

int	vt_gidsi()
int	vto_gnelms()
int	vto_gdtype()

pointer vto_vctptr()
pointer vt_vtoptr()

begin

#    Sets needed info to simple vars.


	cls_ptr = DQ_CLS(dq_ptr, cls_indx)

	vt_ptr = CLS_VTPTR(cls_ptr)

	ids_indx = vt_gidsi(vt_ptr)
	ids_vto = vt_vtoptr(vt_ptr, ids_indx)
	ids_ptr = vto_vctptr(ids_vto)
	ids_type = vto_gdtype(ids_vto)

	dds_indx = CLS_VTOINDX(cls_ptr)
	dds_vto = vt_vtoptr(vt_ptr, dds_indx)
	dds_ptr = vto_vctptr(dds_vto)
	dds_type = vto_gdtype(dds_vto)

	nelms = vto_gnelms(dds_vto)

	call smark(sp)
	call salloc(x_ptr, nelms, TY_REAL)
	call salloc(y_ptr, nelms, TY_REAL)

	switch(ids_type) {

	case TY_SHORT:
		call dq_idss(x_ptr, ids_ptr, nelms)

	case TY_INT:
		call dq_idsi(x_ptr, ids_ptr, nelms)

	case TY_REAL:
		call dq_idsr(x_ptr, ids_ptr, nelms)

	case TY_DOUBLE:
		call dq_idsd(x_ptr, ids_ptr, nelms)

	default:
	}

	switch(dds_type) {

	case TY_SHORT:
		call dq_stor(Mems[dds_ptr], Memr[y_ptr], nelms)

	case TY_INT:
		call dq_itor(Memi[dds_ptr], Memr[y_ptr], nelms)

	case TY_REAL:
		call dq_rtor(Memr[dds_ptr], Memr[y_ptr], nelms)

	case TY_DOUBLE:
		call dq_dtor(Memd[dds_ptr], Memr[y_ptr], nelms)

	default:
	}

	tls_ptr = CLS_TLSPTR(cls_ptr)
	time_tol = TLS_DELT(tls_ptr)*TLS_SRATE(tls_ptr)*DQ_GAP(dq_ptr)

	call dq_draw(gp, Memr[x_ptr], Memr[y_ptr], nelms, time_tol)

	call sfree(sp)

#   If the limits are marked to be display, it is done here.


	if(CLS_DSPLIM(cls_ptr) == TRUE && DQ_MLS(dq_ptr) != NULL) {

		length = 1
		call mls_limits(DQ_MLS(dq_ptr), CLS_CNAME(cls_ptr),
					lo_lim, hi_lim, inclus, length)

		if(length != 0)
			call dq_limdraw(gp, lo_lim, hi_lim, inclus)

	}

end




procedure	dq_stor(a, b, npix)

short	a[ARB]
real	b[ARB]
int	i, npix

begin
	do i = 1, npix {
		if(IS_INDEFS(a[i])) b[i] = INDEFR
		else b[i] = real(a[i])
	}
end

procedure	dq_itor(a, b, npix)

int	a[ARB]
real	b[ARB]
int	i, npix

begin
	do i = 1, npix {
		if(IS_INDEFI(a[i])) b[i] = INDEFR
		else b[i] = real(a[i])
	}
end

procedure	dq_rtor(a, b, npix)

real	a[ARB]
real	b[ARB]
int	i, npix

begin
	do i = 1, npix {
		if(IS_INDEFR(a[i])) b[i] = INDEFR
		else b[i] = real(a[i])
	}
end

procedure	dq_dtor(a, b, npix)

double	a[ARB]
real	b[ARB]
int	i, npix

begin
	do i = 1, npix {
		if(IS_INDEFD(a[i])) b[i] = INDEFR
		else b[i] = real(a[i])
	}
end


