# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqcidsload.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqcidsload.x -r1.6 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/26/97   mabbott	added support for multiple "time" columns
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	06/26/92   akeith	Now calls dq_mkdict() to create the column name dictionary instead of dq_addstrg().
# 	04/27/92   akeith	date and time created 92/04/27 16:28:20 by akeith
# H-
# 
#

#  Date last modified: 2/26/97

include "dq.h"
include <tbset.h>

#
# dq_cidsload() loads a column as the independent data set (ids) for
#	the table using dq_cload() and vt_pidsp().
#
#
#  MJA notes - I added a pass through tls_ptr parameter to dq_cload.
#    This lets us load columns with the same name from more than one
#    table for the ids.  

int	procedure	dq_cidsload(dq_ptr, tls_ptr, col_name, str_len, stype)

pointer	dq_ptr					#O dq structure pointer
pointer	tls_ptr					#I tls structure pointer
char	col_name[str_len]			#I table name
int	str_len					#I string length
int	stype					#I sample type

int	cls_indx
pointer cls_ptr
pointer	dq_cload()

pointer vto_ptr					# vector table object pointer
pointer vt_vtoptr()

begin

	call strlwr(col_name)

	cls_indx = dq_cload(dq_ptr, tls_ptr, col_name, str_len, stype)
	cls_ptr = DQ_CLS(dq_ptr, cls_indx)

	vto_ptr = vt_vtoptr(CLS_VTPTR(cls_ptr), CLS_VTOINDX(cls_ptr))
	call vt_pidsp(vto_ptr)

	return(cls_indx)

end

