# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqclsadd.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqclsadd.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	06/26/92   akeith	Fixed the ever expanding cls pointer list. Now cls structure can be distroyed
# 	04/27/92   akeith	date and time created 92/04/27 16:28:26 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_clsadd() adds another cls structure to the array list of cls
#	structures stored in the DQ_CLS array. The new cls structure
#	is initialized by dq_clsinit().
#

pointer	procedure	dq_clsadd(dq_ptr, cls_indx)

pointer	dq_ptr					#O dq structure pointer
int	cls_indx				#O dq cls index

int	indx
bool	done

pointer	cls_ptr					# cls structure pointer

pointer dq_clsinit()

begin


#  If the list of cls structure pointers has never been allocated, then
#	do that now and store the new cls in the first spot.

	if(DQ_CLS_LEN(dq_ptr) == 0) {
		DQ_CLS_LEN(dq_ptr) = 1
		call malloc(DQ_CLS_PTR(dq_ptr), DQ_CLS_LEN(dq_ptr), TY_STRUCT)
		cls_indx = DQ_CLS_LEN(dq_ptr)
	} else {

#  Else, look through the list for a null spot and store the new cls there.

		indx = 1
		done = FALSE
		repeat {

			if(DQ_CLS(dq_ptr, indx) == NULL) {
				cls_indx = indx
				done = TRUE
			}
			indx = indx + 1

		} until(indx > DQ_CLS_LEN(dq_ptr) || done)

#  If we don't find a null spot, then increase the length of the list by one
#	and store the new cls in the last spot.

		if(indx > DQ_CLS_LEN(dq_ptr) && !done) {
			DQ_CLS_LEN(dq_ptr) = DQ_CLS_LEN(dq_ptr) + 1
			call realloc(DQ_CLS_PTR(dq_ptr), DQ_CLS_LEN(dq_ptr), TY_STRUCT)
			cls_indx = DQ_CLS_LEN(dq_ptr)
		}
	}

	cls_ptr = dq_clsinit(dq_ptr)
	DQ_CLS(dq_ptr, cls_indx) = cls_ptr

	return(cls_ptr)

end

