# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqcmd.cmd
# 	Author	:  akeith
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqcmd.cmd -r1.8 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	05/05/93   akeith	added quit
# 	12/10/92   akeith	put in the help messages.
# 	10/30/92   akeith	added commands window, delete, list and redraw
# 	07/29/92   akeith	added the gtnew command
# 	07/27/92   akeith	added the filter command
# 	06/26/92   akeith	gap command was added
# 	04/30/92   akeith	date and time created 92/04/30 13:16:35 by akeith
# H-
# 
#


procedure	display	dq_dispmon

requires	private
inputs
string		monitor
help
	Display plots the named monitor against the time column of the
	corresponding ST table. In those cases where the number of rows
	of the ST table exceeds what can be displayed by the graphics
	device, a sampling of the data is
	plotted representing every N'th point of the real data.
	Up to four monitors may be displayed
	at any one time with repeated calls to display.

procedure	hide	dq_hidemon

requires	private
inputs
string		monitor
help
	Removes the specified monitor from the display. If the monitor name is
	given as "all", the screen will be cleared of all monitors.


procedure	window	dq_window

requires	private
inputs
help
	Window is an interactive command allowing the user to resize the selected
	window. As an interactive command, the window command must be quit by issuing
	a "q" command. This returns the user to the current input mode.
	When more then one window is displayed, a window must be selected
	by placing the graphics cursor over the desired window and pressing a key
	or mouse button. All subsequent window commands will be directed toward
	the selected window.

procedure	mode	dq_chngmode

requires	private
inputs
string		imode
help
	Mode changes the input mode to either "line", for typing commands in
	a text window  or "gcur" for using the cursor in a graphics
	display. In "gcur" mode, each command is executed as a colon command.
	For example, ":mode line" would return the input mode back to the text
	window.

procedure	limload	dq_limload

requires	private
inputs
string		limit_file
help
	Loads an existing ST table containing limits that is of the same format as
	those produced by the "limsave" command.

procedure	edit	dq_editlim

requires	private
inputs
string		monitor
help
	Edits the specified monitor's limits. Once this command is given, dqselect
	enters "gcur" mode and waits for
	two graphics cursor entries, for the new upper and lower limits.
	The limits may be entered in either order. Both cursor commands and/or
	colon commands such as, ":y limit_value"
	are excepted. The cursor x-position is not used.
	Any combination of the two entry methods is allowed.


procedure	delete	dq_limdel

requires	private
inputs
string		monitor
help
	Deletes a monitor's limits. However, if "gtgen" was previously executed,
	the previously computed good times still exist. In order to remove the
	good times produced by with these limits, "gtnew" should be executed.


procedure	limsave	dq_limsave

requires	private
inputs
string		limit_file
help
	Saves the current limits in an ST table which consists of three columns,
	name, low and high. The name column holds the monitor name, low holds the
	low limit value and high the high limit value.


procedure       gtload dq_gtload

requires        private
inputs
string          gt_file
help
	Loads an ST table containing good time intervals of the same
	format as those saved by "gtsave".


procedure       gtgen dq_gengt

requires        private
inputs
help
	Generates "good time" intervals. For each monitor for which limits have been
	defined, "gtgen" generates a set of good time intervals. The set of
	good time intervals are defined by start and end times where the values
	of the monitor are within the set limits. Each value in the current column
	is tested to be within the defined limits. If two successive values go from
	being outside the limits to within the limits, the time of the second value
	defines a start time of a new good time interval. On the other hand, if
	two successive values go from being within the limits to outside the limits,
	then the time of the first value defines the end
	time of the current good time interval.

	Once this set of intervals is defined, the intersection between this set and
	the compliment of the set of "day gap" intervals is taken.
	The day gap intervals are defined using the time difference between two
	consecutive times. If the difference is greater then the nominal time interval
	multiplied by the number of allowed gaps set by the command "gap", the two
	times are considered the beginning and ending times for a day gap.

	The interval set for each monitor is then intersected with each other to
	produce a single set of good time intervals.


procedure       gtnew dq_gtnew

requires        private
inputs
help
	Clears the list of good times intervals.


procedure       gtsave dq_gtsave

requires        private
inputs
string          gt_file
help
	Save internally stored good time intervals to an ST table.
	The ST table has a start time column, "stime" and an
	end time column, "etime". Each row consists of a single
	good time interval.

procedure       showlim dq_shwlimit

requires        private
inputs
string          mon_name
help
	Show the limit markers of the displayed monitor.


procedure       hidelim dq_hidlimit

requires        private
inputs
string          mon_name
help
	Hide the limit markers of the displayed monitor.


procedure       gap dq_gap

requires        private
inputs
int             gap_size
help
	Gap sets the allowed integer number of missing nominal time intervals
	before considering the gap in reported data as a day gap.
	A nominal time interval is defined for each table from the
	difference of the first two values of the time column unless
	specified in the ST table by the header keyword "DELTIME".
	In either case, a day gap is an extended period of time in which
	no information is reported. Setting the gap number allows the
	user to define what is meant by an extended period of time. Day
	gaps are identified in plotted monitors as gaps between connected
	line segments. Day gaps are also excluded time intervals in the
	generation of good time filters.


procedure       filter dq_qpaddfltr

requires        private
inputs
string          qpoe_file
string          filter_name
help
	Stores a filter in the named qpoe file under the filter name.
	The filter is stored as a qpoe macro of the form (1023.34:1090.60,
	2178.43:2218.75). One restriction made by qpoe is the length of the
	macro can be no longer then 8192. Therefore, if the macro is greater then
	this length, dqselect will not create the filter and will print
	a warning message to the user.


procedure	list	dq_list

requires	private
inputs
string		table
help
	Lists the column names of the named ST table.


procedure	redraw	dq_redraw

requires	private
inputs
help
	Redraws the screen.


procedure	quit	dq_quit

requires	private
inputs
help
	Quits dqselect.


procedure       help    dq_help

requires state
requires private
inputs
string          topic
help
	Gives help on the specified command.

