# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqcmd.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqcmd.x -r1.10 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	05/05/93   akeith	auto made
# 	10/30/92   akeith	changed by cmd2spp
# 	07/29/92   akeith	added the gtnew command
# 	07/23/92   akeith	added the filter command.
# 	06/26/92   akeith	Mainly, the command gap was inserted by eric's cmd2spp code.
# 	04/27/92   akeith	added id keyword
# 	04/27/92   akeith	date and time created 92/04/27 16:28:34 by akeith
# H-
# 
#

define KEY_GAP              1
define KEY_HIDE             2
define KEY_MODE             3
define KEY_EDIT             4
define KEY_LIST             5
define KEY_QUIT             6
define KEY_HELP             7
define KEY_GTGEN            8
define KEY_GTNEW            9
define KEY_WINDOW           10
define KEY_DELETE           11
define KEY_GTLOAD           12
define KEY_GTSAVE           13
define KEY_FILTER           14
define KEY_REDRAW           15
define KEY_DISPLAY          16
define KEY_LIMLOAD          17
define KEY_LIMSAVE          18
define KEY_SHOWLIM          19
define KEY_HIDELIM          20

define KEYWORDS 20

procedure dq_eval (state, command)
pointer	state
char	command[ARB]

int	argc
int	key
pointer	rcmd
int	i1
pointer	t1, t2

pointer	private


string	keydict ",gap,hide,mode,edit,list,quit,help,gtgen,gtnew,window,delete,gtload,gtsave,filter,redraw,display,limload,limsave,showlim,hidelim,"
pointer	sp
define	redo_	10
define	finish_	20
begin
	call smark(sp)
	call ii_error(state,YES)
	call ii_parse(state, command)
redo_
	call ii_args(state, argc)
	if (argc == 0) goto finish_
	call ii_lookup(state, keydict, key)
	if (key <= 0) {
		call ii_not_found(state)
		call ii_post_process(state, 1)
		goto finish_
	}
	if (key > KEYWORDS) goto finish_

	switch(key) {
		case KEY_DISPLAY:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_dispmon(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_HIDE:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_hidemon(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_WINDOW:
			if (argc != 1) goto finish_
			call ii_pre_process(state)
			call ii_private(state, private)
			call dq_window(private)
			call ii_post_process(state, 0)
		case KEY_MODE:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_chngmode(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_LIMLOAD:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_limload(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_EDIT:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_editlim(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_DELETE:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_limdel(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_LIMSAVE:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_limsave(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_GTLOAD:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_gtload(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_GTGEN:
			if (argc != 1) goto finish_
			call ii_pre_process(state)
			call ii_private(state, private)
			call dq_gengt(private)
			call ii_post_process(state, 0)
		case KEY_GTNEW:
			if (argc != 1) goto finish_
			call ii_pre_process(state)
			call ii_private(state, private)
			call dq_gtnew(private)
			call ii_post_process(state, 0)
		case KEY_GTSAVE:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_gtsave(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_SHOWLIM:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_shwlimit(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_HIDELIM:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_hidlimit(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_GAP:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_i (state, 2, i1)
			call ii_private(state, private)
			call dq_gap(private,i1)
			call ii_post_process(state, 0)
		case KEY_FILTER:
			if (argc != 3) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_get_t (state, 3, t2)
			call ii_private(state, private)
			call dq_qpaddfltr(private,Memc[t1],Memc[t2])
			call ii_post_process(state, 0)
		case KEY_LIST:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_list(private,Memc[t1])
			call ii_post_process(state, 0)
		case KEY_REDRAW:
			if (argc != 1) goto finish_
			call ii_pre_process(state)
			call ii_private(state, private)
			call dq_redraw(private)
			call ii_post_process(state, 0)
		case KEY_QUIT:
			if (argc != 1) goto finish_
			call ii_pre_process(state)
			call ii_private(state, private)
			call dq_quit(private)
			call ii_post_process(state, 0)
		case KEY_HELP:
			if (argc != 2) goto finish_
			call ii_pre_process(state)
			call ii_get_t (state, 2, t1)
			call ii_private(state, private)
			call dq_help(state,private,Memc[t1])
			call ii_post_process(state, 0)
	}
	call ii_error(state,NO)
	repeat {
		call ii_redo(state,rcmd)
		if (rcmd == 0) break
		call ii_parse(state, Memc[rcmd])
		call ii_args(state, argc)
		if (argc > 0) goto redo_
	}
finish_
	call ii_clean_include(state)
	call smark(sp)
end

procedure	dq_release(ptr, dtype)
pointer	ptr
int	dtype

begin
	switch(dtype) {
	default: call mfree(ptr, dtype)
	}
	ptr = 0
end
