# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqcol2vto.gx
# 	Author	:  akeith
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqcol2vto.gx -r1.7 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/20/93   ericco	added short support
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	put in generic prep. for loop over enter procedure.
# 	05/14/92   akeith	documentation
# 	05/14/92   akeith	documentation
# 	04/30/92   akeith	date and time created 92/04/30 17:01:20 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"


#
# dq_col2vto[sird]() reads all the data from the column of a ST table into a
#	vector table object.
#


procedure	dq_col2vtos(cls_ptr)

pointer cls_ptr					#I cls structure pointer

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
int	tb_nrows				# number of rows in table
pointer tb_cptr					# table column pointer

pointer sp					# stack pointer
pointer	buff_ptr				# buffer pointer
pointer	null_ptr				# null flag pointer

pointer	vto_ptr					# vector table object pointer

pointer vt_vtoptr()
int	vto_pvcts()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	tb_nrows = TLS_NROWS(tls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))

	call smark(sp)
	call salloc(buff_ptr, tb_nrows, TY_SHORT)
	call salloc(null_ptr, tb_nrows, TY_BOOL)

	call tbcgts(tb_ptr, tb_cptr, Mems[buff_ptr],
			Memb[null_ptr], 1, tb_nrows)

	stat = vto_pvcts(vto_ptr, Mems[buff_ptr], tb_nrows)

	if(stat == NO)
		call printf("\n We had a problem here. \n")

	call sfree(sp)

end



#
# dq_col2vto[sird]() reads all the data from the column of a ST table into a
#	vector table object.
#


procedure	dq_col2vtoi(cls_ptr)

pointer cls_ptr					#I cls structure pointer

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
int	tb_nrows				# number of rows in table
pointer tb_cptr					# table column pointer

pointer sp					# stack pointer
pointer	buff_ptr				# buffer pointer
pointer	null_ptr				# null flag pointer

pointer	vto_ptr					# vector table object pointer

pointer vt_vtoptr()
int	vto_pvcti()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	tb_nrows = TLS_NROWS(tls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))

	call smark(sp)
	call salloc(buff_ptr, tb_nrows, TY_INT)
	call salloc(null_ptr, tb_nrows, TY_BOOL)

	call tbcgti(tb_ptr, tb_cptr, Memi[buff_ptr],
			Memb[null_ptr], 1, tb_nrows)

	stat = vto_pvcti(vto_ptr, Memi[buff_ptr], tb_nrows)

	if(stat == NO)
		call printf("\n We had a problem here. \n")

	call sfree(sp)

end



#
# dq_col2vto[sird]() reads all the data from the column of a ST table into a
#	vector table object.
#


procedure	dq_col2vtor(cls_ptr)

pointer cls_ptr					#I cls structure pointer

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
int	tb_nrows				# number of rows in table
pointer tb_cptr					# table column pointer

pointer sp					# stack pointer
pointer	buff_ptr				# buffer pointer
pointer	null_ptr				# null flag pointer

pointer	vto_ptr					# vector table object pointer

pointer vt_vtoptr()
int	vto_pvctr()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	tb_nrows = TLS_NROWS(tls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))

	call smark(sp)
	call salloc(buff_ptr, tb_nrows, TY_REAL)
	call salloc(null_ptr, tb_nrows, TY_BOOL)

	call tbcgtr(tb_ptr, tb_cptr, Memr[buff_ptr],
			Memb[null_ptr], 1, tb_nrows)

	stat = vto_pvctr(vto_ptr, Memr[buff_ptr], tb_nrows)

	if(stat == NO)
		call printf("\n We had a problem here. \n")

	call sfree(sp)

end



#
# dq_col2vto[sird]() reads all the data from the column of a ST table into a
#	vector table object.
#


procedure	dq_col2vtod(cls_ptr)

pointer cls_ptr					#I cls structure pointer

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
int	tb_nrows				# number of rows in table
pointer tb_cptr					# table column pointer

pointer sp					# stack pointer
pointer	buff_ptr				# buffer pointer
pointer	null_ptr				# null flag pointer

pointer	vto_ptr					# vector table object pointer

pointer vt_vtoptr()
int	vto_pvctd()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	tb_nrows = TLS_NROWS(tls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))

	call smark(sp)
	call salloc(buff_ptr, tb_nrows, TY_DOUBLE)
	call salloc(null_ptr, tb_nrows, TY_BOOL)

	call tbcgtd(tb_ptr, tb_cptr, Memd[buff_ptr],
			Memb[null_ptr], 1, tb_nrows)

	stat = vto_pvctd(vto_ptr, Memd[buff_ptr], tb_nrows)

	if(stat == NO)
		call printf("\n We had a problem here. \n")

	call sfree(sp)

end



