# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqcopen.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqcopen.x -r1.7 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	01/21/97   tnk	fixed typo in error message
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	05/05/93   akeith	added dq_otbclm()
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	06/26/92   akeith	Now checks that the tls structure pointer is not null before using it. If tables are allowed to be unloaded this would be a concern.
# 	04/27/92   akeith	date and time created 92/04/27 16:28:36 by akeith
# H-
# 
#

#  Date last modified: 1/21/97

include "dq.h"

#
# dq_copen() look through all the tables currently loaded for the
#	given column name. If found the ST table pointer is
#	returned, otherwise NULL is return.
#

procedure	dq_copen(dq_ptr, col_name, col_ptr, tls_indx)

pointer	dq_ptr					#I dq structure pointer
char	col_name[ARB]				#I table name
pointer col_ptr					#O column pointer
int	tls_indx				#O dq tls structure indx

int	i
pointer tb_ptr					# table pointer

pointer tls_ptr					# tls structure pointer

begin

#   Look through all the tables currently opened for this column name.

	col_ptr = NULL
	tls_indx = INDEFI

	i = 0
	repeat {

		i = i + 1

		tls_ptr = DQ_TLS(dq_ptr, i)

		if(tls_ptr != NULL) {
			tb_ptr = TLS_TBPTR(tls_ptr)
			call tbcfnd(tb_ptr, col_name, col_ptr, 1)
		}

	} until (i == DQ_TLS_LEN(dq_ptr) || col_ptr != NULL)

#    If the column pointer comes up NULL, no such column exists.

	if(col_ptr == NULL) {
		call fprintf(STDERR,"\n\n The column, %s")
		call pargstr(col_name)
		call fprintf(STDERR,", does not exist! \n\n")
		return
	} else tls_indx = i

end


#
# dq_otbclm() looks through specified table currently loaded for the
#	given column name. If found the ST table pointer is
#	returned, otherwise NULL is return.
#

procedure	dq_otbclm(dq_ptr, col_name, col_ptr, tls_indx)

pointer	dq_ptr					#I dq structure pointer
char	col_name[ARB]				#I table name
pointer col_ptr					#O column pointer
int	tls_indx				#I dq tls structure indx

pointer tb_ptr					# table pointer
pointer tls_ptr					# tls structure pointer

begin

	col_ptr = NULL
	if(tls_indx > DQ_TLS_LEN(dq_ptr)) return

	tls_ptr = DQ_TLS(dq_ptr, tls_indx)

	if(tls_ptr != NULL) {
		tb_ptr = TLS_TBPTR(tls_ptr)
		call tbcfnd(tb_ptr, col_name, col_ptr, 1)
	}

end
