# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqdelclsindx.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqdelclsindx.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/14/94   akeith	got rid of unused var
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	04/27/92   akeith	date and time created 92/04/27 16:28:38 by akeith
# H-
# 
#

#  Date last modified: 9/14/94

include "dq.h"

#
# dq_delclsindx() deletes a cls index from the list of displayed cls's
#	held for each wcs displayed.
#

procedure	dq_delclsindx(wcs_ptr, wcs_clsindx)

pointer	wcs_ptr					#O wcs structure pointer
int	wcs_clsindx				#I wcs clsindx index

int	cls_indx				# cls structure index

long	wcs_clsindx_len

pointer	dq_ptr					# dq structure pointer
pointer	cls_ptr					# cls structure pointer

begin

	wcs_clsindx_len = WCS_CLSINDX_LEN(wcs_ptr)

	if(wcs_clsindx < 1 || wcs_clsindx > wcs_clsindx_len) {
		call fprintf(STDERR, "\n dq_delclsindx: wcs index out of bounds.\n")
		return
	}

    # Tell the CLS structure column is no longer being desplayed.

	cls_indx = WCS_CLSINDX(wcs_ptr, wcs_clsindx)
	if(cls_indx == INDEFI) return

	dq_ptr = WCS_DQ(wcs_ptr)

	cls_ptr = DQ_CLS(dq_ptr, cls_indx)
	CLS_DSPD(cls_ptr) = FALSE
	CLS_WCSINDX(cls_ptr) = INDEFI


	WCS_CLSINDX(wcs_ptr, wcs_clsindx) = INDEFI
	WCS_NCLSINDX(wcs_ptr) = WCS_NCLSINDX(wcs_ptr) - 1

end

