# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqdisplay.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqdisplay.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	fixed to write out the x axis for the base wcs only.
# 	06/26/92   akeith	gio is now completely reset on every display. (my untrust of gio)
# 	04/27/92   akeith	date and time created 92/04/27 16:28:39 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"
include <gset.h>

#
# dq_display() is the first step in displaying the contents of each wcs.
#

procedure	dq_display(dsp_ptr)

pointer	dsp_ptr					#I dsp structure pointer

int	i

bool	wcs_base

pointer gp					# graphics pointer
pointer wcs_ptr					# wcs structure pointer

begin

	wcs_base = TRUE
	gp = DSP_GPPTR(dsp_ptr)

	call greactivate(gp, AW_CLEAR)

	DSP_ACTVD(dsp_ptr) = TRUE

	call gclear(gp)

	call gseti(gp, G_DRAWAXES, 1)
	call gseti(gp, G_YNMINOR, 0)
	call gseti(gp, G_XLABELAXIS, YES)
	call gseti(gp, G_XLABELTICKS, YES)

	do i = 1, DSP_WCS_LEN(dsp_ptr) {
		wcs_ptr = DSP_WCS(dsp_ptr, i)
		if(wcs_ptr != NULL) {
			WCS_BASE(wcs_ptr) = FALSE
			if(wcs_base == TRUE) {
				WCS_BASE(wcs_ptr) = TRUE
				wcs_base = FALSE
			}
			call dq_plotc(gp, wcs_ptr, i)
		}
	}

	call gflush(gp)
	call flush(STDERR)
	call flush(STDOUT)

	DSP_ACTVD(dsp_ptr) = FALSE

	call gdeactivate(gp, AW_CLEAR)
end

