# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqdqclos.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqdqclos.x -r1.6 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	05/05/93   akeith	added closing format
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	06/26/92   akeith	Everthing is undisplayed to clean up on exit.
# 	04/27/92   akeith	date and time created 92/04/27 16:28:42 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_dqclos() closes the data quality structure, freeing memory and cleaning up.
#

procedure	dq_dqclos(dq_ptr)

pointer	dq_ptr					#O dq structure pointer

int	i

pointer	dsp_ptr					# display structure pointer
pointer	cnam_ptr				# column name string pointer
pointer	imode_ptr				# input mode string pointer
pointer	fmt_ptr					# format string pointer
pointer	dq_tls_ptr				# dq table list pointer
pointer	dq_cls_ptr				# dq column list pointer

begin

	dsp_ptr = DQ_DSP(dq_ptr)
	if(dsp_ptr != NULL) {
		call dq_undispall(dq_ptr)
		call dq_dspclos(dq_ptr)
	}

	dq_cls_ptr = DQ_CLS_PTR(dq_ptr)
	if(dq_cls_ptr != NULL) {
		do i = 1, DQ_CLS_LEN(dq_ptr)
			call dq_clsdel(dq_ptr, i)
	}

	dq_tls_ptr = DQ_TLS_PTR(dq_ptr)
	if(dq_tls_ptr != NULL) {
		do i = 1, DQ_TLS_LEN(dq_ptr)
			call dq_tlsdel(dq_ptr, i)
	}

	cnam_ptr = DQ_CNAMES_PTR(dq_ptr)
	if(cnam_ptr != NULL) {
		call mfree(cnam_ptr, TY_CHAR)
		DQ_CNAMES_PTR(dq_ptr) = NULL
	}

	imode_ptr = DQ_IMODE_PTR(dq_ptr)
	if(imode_ptr != NULL) {
		call mfree(imode_ptr, TY_CHAR)
		DQ_IMODE_PTR(dq_ptr) = NULL
	}

	fmt_ptr = DQ_FMT_PTR(dq_ptr)
	if(fmt_ptr != NULL) {
		call mfree(fmt_ptr, TY_CHAR)
		DQ_FMT_PTR(dq_ptr) = NULL
	}

	call mfree(dq_ptr, TY_STRUCT)

	dq_ptr = NULL

end

