# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqdraw.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqdraw.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	skips drawing INDEF values
# 	06/26/92   akeith	Now draws dots when it's supposed to.
# 	04/27/92   akeith	date and time created 92/04/27 16:28:44 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"
include <gset.h>

#
# dq_draw() performs the actual drawing of data by calling the gio library
#	calls gamove and gadraw.
#

procedure	dq_draw(gp, x, y, nelms, time_tol)

pointer	gp					#I graphics pointer
real	x[nelms]				#I independent data set pointer
real	y[nelms]				#I dependent data set pointer
int	nelms					#I number of elements in vectors
double	time_tol				#I time tol.

int	i
int	strt
real	t_old, t_new				# old and new times

begin

#   The actual drawing of the column is done here.

	t_old = -time_tol

	strt = 1
	while(IS_INDEFR(y[strt]) && strt <= nelms) strt = strt + 1

	call gamove(gp, x[strt], y[strt])
	do i = strt, nelms {


		if(!IS_INDEFR(y[i])) {

			t_new = x[i]

			if(t_new - t_old > time_tol) {
				call gamove(gp, x[i], y[i])
				call gadraw(gp, x[i], y[i])
			} else {
				call gadraw(gp, x[i], y[i])
			}
	
			t_old = x[i]
		}

	}


end

