# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqeditlim.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqeditlim.x -r1.6 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	keeps the current wcs of displayed column when editing
# 	06/26/92   akeith	the wcs_copy is now allocated here and freed here. Correctly deals with the new interface of dq_cpywcs().
# 	04/27/92   akeith	date and time created 92/04/27 16:28:49 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include	"dq.h"
include <gio.h>

# dq_editlim() allows the user to change the current limits set on a given
#	monitor using eric`s ek_gcur(). So the indicated monitor may be
#	displayed using the full screen, a copy of all of the wcs's is made,
#	the current list of wcs's is deleted and a new wcs is made using
#	the indicated monitor. This is the only wcs and so will be display
#	using the whole screen. After the limits are set, the copied wcs is
#	replaced and the original displayed monitors are redisplayed.
#

procedure	dq_editlim (dq_ptr, monitor)

pointer	dq_ptr						# dq structure pointer
char	monitor[ARB]					# monitor name

int	cls_indx					# dq's cls index
pointer cls_ptr						# cls structure pointer
pointer wcs_copy					# copy of wcs strct. pointer
pointer ek_ptr						# eric's pointer
pointer mls_ptr						# mls pointer

int	stat
int	wcs						# world coord. sys.
int	length
int	inclus
real	wx, wy1, wy2					# world x and y val.'s
real	low_lim, high_lim				# limits

pointer sp, cmd

int	wcs_indx
bool	paste
real	x1, x2, y1, y2

int     ek_gcur()
pointer dq_gclsptr()

begin

	call strlwr(monitor)		# Changes the input string to lower case.

	call smark(sp)
	call salloc(cmd, SZ_LINE, TY_CHAR)
	call salloc(wcs_copy, WCS_ARY_LEN, TY_LONG)

	ek_ptr = DQ_EK(dq_ptr)
	mls_ptr = DQ_MLS(dq_ptr)
	if(mls_ptr == NULL) {
		call mls_open(mls_ptr)
		DQ_MLS(dq_ptr) = mls_ptr
	}

	cls_ptr = dq_gclsptr(dq_ptr, monitor, DQ_SAMPLE, cls_indx)
	if(cls_ptr == NULL) return

	paste = FALSE
	if(CLS_DSPD(cls_ptr) == TRUE) {
		wcs_indx = CLS_WCSINDX(cls_ptr)
		call dq_gwcs(dq_ptr, wcs_indx, x1, x2, y1, y2)
		paste = TRUE
	}

	if(DQ_DSP(dq_ptr) == NULL) call dq_grphinit(dq_ptr)

	call dq_cpywcs(DQ_DSP(dq_ptr), wcs_copy)

	call dq_undispall(dq_ptr)

	call dq_setdisp(dq_ptr, DQ_WCS_NEW, cls_indx)

	if(paste == TRUE) {
		wcs_indx = CLS_WCSINDX(cls_ptr)
		call dq_pwcs(dq_ptr, wcs_indx, x1, x2, y1, y2)
	}

	call dq_display(DQ_DSP(dq_ptr))

	call fprintf(STDERR, "\n Please pick the first limit value ...\n")
        stat = ek_gcur("gcur", ek_ptr, wx, wy1, wcs, Memc[cmd], SZ_LINE)

	call fprintf(STDERR, "\n and again:\n")
        stat = ek_gcur("gcur", ek_ptr, wx, wy2, wcs, Memc[cmd], SZ_LINE)

	low_lim = min(wy1, wy2)
	high_lim = max(wy1, wy2)

	length = 1
	inclus = YES
	call mls_set(mls_ptr, CLS_CNAME(cls_ptr), 
			low_lim, high_lim, inclus, length)


	call dq_undispall(dq_ptr)

	call dq_rstrwcs(dq_ptr, wcs_copy)

	call dq_display(DQ_DSP(dq_ptr))

	call sfree(sp)

end




procedure	dq_gwcs(dq_ptr, wcs_indx, x1, x2, y1, y2)

pointer	dq_ptr					#I dq structure pointer
int	wcs_indx				#I wcs index
real	x1, x2					#O world coord of wcs_indx
real	y1, y2					#O world coord of wcs_indx

pointer	dsp_ptr
pointer	wcs_ptr

begin

	dsp_ptr = DQ_DSP(dq_ptr)
	wcs_ptr	= DSP_WCS(dsp_ptr, wcs_indx)

	x1 = WCS_WRLDX1(wcs_ptr)
	x2 = WCS_WRLDX2(wcs_ptr)
	y1 = WCS_WRLDY1(wcs_ptr)
	y2 = WCS_WRLDY2(wcs_ptr)

end



procedure	dq_pwcs(dq_ptr, wcs_indx, x1, x2, y1, y2)

pointer	dq_ptr					#I dq structure pointer
int	wcs_indx				#I wcs index
real	x1, x2					#I world coord of wcs_indx
real	y1, y2					#I world coord of wcs_indx

pointer	dsp_ptr
pointer	wcs_ptr

begin

	dsp_ptr = DQ_DSP(dq_ptr)
	wcs_ptr	= DSP_WCS(dsp_ptr, wcs_indx)

	WCS_WRLDX1(wcs_ptr) = x1
	WCS_WRLDX2(wcs_ptr) = x2
	WCS_WRLDY1(wcs_ptr) = y1
	WCS_WRLDY2(wcs_ptr) = y2

end

