# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqfnddaygap.x
# 	Author	:  akeith
# 	Date	:  07/29/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqfnddaygap.x -r1.7 07/29/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/20/94   akeith	fixed indef times
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	12/10/92   akeith	The basic structure of the function is the same, just the names have been changed from good times to night times.
# 	10/30/92   akeith	uses new function dq_freeclsgt() and takes out null intervals
# 	07/29/92   akeith	took out the debug fprintf statements.
# 	07/29/92   akeith	date and time created 92/07/29 12:08:05 by akeith
# H-
# 
#

#  Date last modified: 9/20/94

include "dq.h"

#
#	dq_fnddaygap ()
#

procedure	dq_fnddaygap (tls_ptr, time_tol)

pointer tls_ptr				#I/O table list structure
double	time_tol			#I time tol.

int	i, k

int	nrows				# number of row in table
int	first_row			# first row to grab from table
int	last_row			# last row to grab from table
int	snt_indx			# start night time index
int	ent_indx			# end night time index

bool	done				# are we done yet?

double	t_new				# new time from table
double	t_old				# old time from table

pointer sp				# stack pointer
pointer t_buff				# time data buffer
pointer	null_buff			# null indicator buffer

pointer tb_ptr				# table pointer
pointer tb_tptr				# table time colomn pointer

begin

	first_row = 0
	last_row = 0
	snt_indx = 0
	ent_indx = 0

	tb_tptr = CLS_COLPTR( DQ_CLS( TLS_DQ(tls_ptr), TLS_IDSCLS(tls_ptr) ) )
	tb_ptr = TLS_TBPTR(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)

	call smark(sp)
	call salloc(t_buff, DQ_APAGE, TY_DOUBLE)
	call salloc(null_buff, DQ_APAGE, TY_BOOL)

#		  Clear any previously allocate memory
#			for the good time list.

	call dq_freetlsnt(tls_ptr)

#			   Allocate memory for the
#				good time list.

	call dq_nttlsmalloc(tls_ptr, DQ_MEM_LEN)


	call tbegtd(tb_ptr, tb_tptr, 1, t_old)
	TLS_SNT(tls_ptr, 1) = t_old
	snt_indx = snt_indx + 1
	
	done = FALSE

	repeat {

		first_row = last_row + 1
		last_row = first_row + DQ_APAGE - 1

		if(last_row >= nrows) {
			last_row = nrows
			done = TRUE
		}

		call tbcgtd(tb_ptr, tb_tptr, Memd[t_buff],
				Memb[null_buff], first_row, last_row)

		do k = first_row, last_row {

			i = k - first_row + 1

			t_new = ARRYD(t_buff, i)
			if(IS_INDEFD(t_new)) next

			if(t_new - t_old > time_tol) {

				ent_indx = ent_indx + 1
				TLS_ENT(tls_ptr, ent_indx) = t_old

				if( TLS_SNT(tls_ptr, snt_indx) ==
				    TLS_ENT(tls_ptr, ent_indx) ) {
					snt_indx = snt_indx - 1
					ent_indx = ent_indx - 1
				}

				snt_indx = snt_indx + 1
				TLS_SNT(tls_ptr, snt_indx) = t_new

			}

			if(snt_indx == TLS_SNT_LEN(tls_ptr)) {
				call dq_nttlsmalloc(tls_ptr, snt_indx+DQ_MEM_LEN)
			}

			t_old = t_new

		}

	} until(done)

	ent_indx = ent_indx + 1
	TLS_ENT(tls_ptr, ent_indx) = t_old

	call dq_nttlsmalloc(tls_ptr, snt_indx)

	call sfree(sp)

end

