# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqfndexposure.x
# 	Author	:  akeith
# 	Date	:  06/24/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqfndexposure.x -r1.4 06/24/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	06/24/92   akeith	date and time created 92/06/24 20:49:30 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
#	dq_fndexposure ()
#

procedure	dq_fndexposure (cls_ptr, time_tol)

pointer	cls_ptr				#I dq structure pointer
double	time_tol			#I time tol.

int	i, k

int	nrows				# number of row in table
int	first_row			# first row to grab from table
int	last_row			# last row to grab from table
int	sgt_indx			# start good time index
int	egt_indx			# end good time index

bool	done				# are we done yet?

double	t_new				# new time from table
double	t_old				# old time from table

pointer sp				# stack pointer
pointer t_buff				# time data buffer
pointer	null_buff			# null indicator buffer

pointer tls_ptr				# tls structure pointer
pointer tb_ptr				# table pointer
pointer tb_tptr				# table time colomn pointer

begin

	first_row = 0
	last_row = 0
	sgt_indx = 0
	egt_indx = 0

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_tptr = CLS_COLPTR(cls_ptr)
	tb_ptr = TLS_TBPTR(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)

	call smark(sp)
	call salloc(t_buff, DQ_APAGE, TY_DOUBLE)
	call salloc(null_buff, DQ_APAGE, TY_BOOL)

#		  Clear any previously allocate memory
#			for the good time list.

	if(CLS_SGT_LEN(cls_ptr) > 0) {

		call mfree(CLS_SGT_PTR(cls_ptr), TY_DOUBLE)
		CLS_SGT_PTR(cls_ptr) = NULL
		CLS_SGT_LEN(cls_ptr) = 0

		call mfree(CLS_EGT_PTR(cls_ptr), TY_DOUBLE)
		CLS_EGT_PTR(cls_ptr) = NULL
		CLS_EGT_LEN(cls_ptr) = 0

	}

#			   Allocate memory for the
#				good time list.

	call dq_gtclsmalloc(cls_ptr, DQ_MEM_LEN)


	call tbegtd(tb_ptr, tb_tptr, 1, t_old)
	CLS_SGT(cls_ptr, 1) = t_old
	call fprintf(STDERR, "\n START TIME = %25.15f  ")
	call pargd(t_old)
	sgt_indx = sgt_indx + 1
	
	done = FALSE

	repeat {

		first_row = last_row + 1
		last_row = first_row + DQ_APAGE - 1

		if(last_row >= nrows) {
			last_row = nrows
			done = TRUE
		}

		call tbcgtd(tb_ptr, tb_tptr, Memd[t_buff],
				Memb[null_buff], first_row, last_row)

		do k = first_row, last_row {

			i = k - first_row + 1

			t_new = ARRYD(t_buff, i)

			if(t_new - t_old > time_tol) {
				egt_indx = egt_indx + 1
				CLS_EGT(cls_ptr, egt_indx) = t_old
				sgt_indx = sgt_indx + 1
				CLS_SGT(cls_ptr, sgt_indx) = t_new

        call fprintf(STDERR, " END TIME = %25.15f  Null = %d\n")
        call pargd(t_old)
        call pargi(ARRYB(null_buff, i))
	call fprintf(STDERR, " START TIME = %25.15f  ")
        call pargd(t_new)

			}

			if(sgt_indx == CLS_SGT_LEN(cls_ptr)) {
				call dq_gtclsmalloc(cls_ptr, sgt_indx+DQ_MEM_LEN)
			}

			t_old = t_new

		}

	} until(done)

	egt_indx = egt_indx + 1
	CLS_EGT(cls_ptr, egt_indx) = t_old
        call fprintf(STDERR, " END TIME = %25.15f \n")
        call pargd(t_old)

	call dq_gtclsmalloc(cls_ptr, sgt_indx)

	call sfree(sp)

end

