# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqgclsptr.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqgclsptr.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/26/97   mabbott	added support for multiple "time" columns
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	04/27/92   akeith	date and time created 92/04/27 16:28:57 by akeith
# H-
# 
#

#  Date last modified: 2/26/97

include "dq.h"

#
# dq_gclsptr() returns the pointer to the cls and the cls index of the
#	column list structure pertaining to the given column name.
#	If the column has not been loaded, then it is loaded with
#	dq_cload().
#

pointer	procedure	dq_gclsptr(dq_ptr, col_name, stype, cls_indx)

pointer dq_ptr					#O dq structure pointer
char	col_name[ARB]				#I table name
int	stype					#I sample type
int	cls_indx				#O cls array index

int	str_len					# length of column name
pointer cls_ptr					# cls structure pointer

int	strlen()				# finds string length
int	dq_fndclsindx()				# finds cls index
int	dq_cload()				# loads a column

begin

	cls_indx = INDEFI

	str_len = strlen(col_name)
	cls_indx = dq_fndclsindx(dq_ptr, col_name, str_len)

	if(cls_indx == INDEFI) {
		cls_indx = dq_cload(dq_ptr, NULL, col_name, str_len, stype)
		if(IS_INDEFI(cls_indx)) return(NULL)
		cls_ptr = DQ_CLS(dq_ptr, cls_indx)
	} else {
		cls_ptr = DQ_CLS(dq_ptr, cls_indx)
	}

	return(cls_ptr)

end
