# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqgengt.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqgengt.x -r1.7 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	07/29/92   akeith	No longer calls dq_exposure().
# 	07/27/92   akeith	added some helpful comments to send the user
# 	06/26/92   akeith	changed warning statement
# 	04/27/92   akeith	date and time created 92/04/27 16:28:59 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_gengt() generates the good time intervals for each monitor with limits
#	set within the opened mls file. If no mls has been opened and loaded,
#	control is returned to the parent routine.
#

procedure	dq_gengt (dq_ptr)

pointer	dq_ptr						# dq structure pointer

int	i

int	nmonitors					# number of monitors

pointer sp						# stack pointer
pointer mon_name					# monitor name
pointer mls_ptr						# eric's pointer

begin

	call smark(sp)
	call salloc(mon_name, SZ_LINE, TY_CHAR)

	mls_ptr = DQ_MLS(dq_ptr)
	if(mls_ptr == NULL) {
		call fprintf(STDERR, "\n Warning: No limits were set. \n")
		return
	}

	mon_name = NULL

	call mls_number_monitors(mls_ptr, nmonitors)
	if(nmonitors == 0) call fprintf(STDERR, "\n No limits loaded. \n")

	do i = 1, nmonitors {

		call mls_monitor(mls_ptr, i, mon_name)

		call fprintf(STDERR, "\n Generating good times for monitor, %s.\n")
		call pargstr(Memc[mon_name])

		call strlwr(Memc[mon_name])	# Changes the string to lower case.

		call dq_gtmon(dq_ptr, Memc[mon_name])

	}

	call sfree(sp)

end

