# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqgtclsmalloc.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqgtclsmalloc.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	12/10/92   akeith	Now contains a malloc function for the night time intervals.
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	04/27/92   akeith	date and time created 92/04/27 16:29:06 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_gtclsmalloc() allocates memory for the start and end good time
#	intervals array for the particular cls.
#

procedure	dq_gtclsmalloc(cls_ptr, gt_len)

pointer	cls_ptr					#I column list structure
int	gt_len					#I good time array length

pointer	sgt_ptr					# start good time pointer
pointer	egt_ptr					# end good time pointer

begin

	sgt_ptr = CLS_SGT_PTR(cls_ptr)
	CLS_SGT_LEN(cls_ptr) = gt_len
	egt_ptr = CLS_EGT_PTR(cls_ptr)
	CLS_EGT_LEN(cls_ptr) = gt_len

	call realloc(sgt_ptr, gt_len, TY_DOUBLE)
	call realloc(egt_ptr, gt_len, TY_DOUBLE)

	CLS_SGT_PTR(cls_ptr) = sgt_ptr
	CLS_EGT_PTR(cls_ptr) = egt_ptr

end


#
# dq_nttlsmalloc() allocates memory for the start and end night time
#	intervals array for the particular tls.
#

procedure	dq_nttlsmalloc(tls_ptr, gt_len)

pointer	tls_ptr					#I table list structure
int	gt_len					#I good time array length

pointer	snt_ptr					# start night time pointer
pointer	ent_ptr					# end night time pointer

begin

	snt_ptr = TLS_SNT_PTR(tls_ptr)
	TLS_SNT_LEN(tls_ptr) = gt_len
	ent_ptr = TLS_ENT_PTR(tls_ptr)
	TLS_ENT_LEN(tls_ptr) = gt_len

	call realloc(snt_ptr, gt_len, TY_DOUBLE)
	call realloc(ent_ptr, gt_len, TY_DOUBLE)

	TLS_SNT_PTR(tls_ptr) = snt_ptr
	TLS_ENT_PTR(tls_ptr) = ent_ptr

end

