# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqhilo.gx
# 	Author	:  akeith
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqhilo.gx -r1.7 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	put in generic prep. for loop over enter procedure.
# 	05/14/92   akeith	documentation
# 	04/30/92   akeith	date and time created 92/04/30 17:01:21 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include <mach.h>


#                       dq_hilo ()
#
#
#
#

procedure	dq_hilos(a, nelms, lo_val, hi_val)

short	a[nelms]				#I array
int	nelms					#I number of elements
real	hi_val					#O high value
real	lo_val					#O low value

int	i

short	high_val, low_val

short	min()
short	max()

begin

	low_val = MAX_SHORT
	high_val = -MAX_SHORT

	do i = 1, nelms {
		if(!IS_INDEFS(a[i])) {
			low_val = min(low_val, a[i])
			high_val = max(high_val, a[i])
		}
	}

	if(low_val == MAX_SHORT) {
		low_val = short(0)
		high_val = short(0)
	}

	hi_val = real(high_val)
	lo_val = real(low_val)

end



#                       dq_hilo ()
#
#
#
#

procedure	dq_hiloi(a, nelms, lo_val, hi_val)

int	a[nelms]				#I array
int	nelms					#I number of elements
real	hi_val					#O high value
real	lo_val					#O low value

int	i

int	high_val, low_val

int	min()
int	max()

begin

	low_val = MAX_INT
	high_val = -MAX_INT

	do i = 1, nelms {
		if(!IS_INDEFI(a[i])) {
			low_val = min(low_val, a[i])
			high_val = max(high_val, a[i])
		}
	}

	if(low_val == MAX_INT) {
		low_val = int(0)
		high_val = int(0)
	}

	hi_val = real(high_val)
	lo_val = real(low_val)

end



#                       dq_hilo ()
#
#
#
#

procedure	dq_hilor(a, nelms, lo_val, hi_val)

real	a[nelms]				#I array
int	nelms					#I number of elements
real	hi_val					#O high value
real	lo_val					#O low value

int	i

real	high_val, low_val

real	min()
real	max()

begin

	low_val = MAX_REAL
	high_val = -MAX_REAL

	do i = 1, nelms {
		if(!IS_INDEFR(a[i])) {
			low_val = min(low_val, a[i])
			high_val = max(high_val, a[i])
		}
	}

	if(low_val == MAX_REAL) {
		low_val = real(0)
		high_val = real(0)
	}

	hi_val = real(high_val)
	lo_val = real(low_val)

end



#                       dq_hilo ()
#
#
#
#

procedure	dq_hilod(a, nelms, lo_val, hi_val)

double	a[nelms]				#I array
int	nelms					#I number of elements
real	hi_val					#O high value
real	lo_val					#O low value

int	i

double	high_val, low_val

double	min()
double	max()

begin

	low_val = MAX_DOUBLE
	high_val = -MAX_DOUBLE

	do i = 1, nelms {
		if(!IS_INDEFD(a[i])) {
			low_val = min(low_val, a[i])
			high_val = max(high_val, a[i])
		}
	}

	if(low_val == MAX_DOUBLE) {
		low_val = double(0)
		high_val = double(0)
	}

	hi_val = real(high_val)
	lo_val = real(low_val)

end



