# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqlimdel.x
# 	Author	:  akeith
# 	Date	:  10/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqlimdel.x -r1.3 10/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	date and time created 92/10/30 15:55:40 by akeith
# H-
# 
#


#  Date last modified: 11/23/93

include	"dq.h"

#
# dq_limdel() deletes the limits set on the given monitor and redisplays the
#	plot if monitor is currently being displayed.
#

procedure	dq_limdel (dq_ptr, monitor)

pointer	dq_ptr						# dq structure pointer
char	monitor[ARB]					# monitor name

pointer mls_ptr						# mls pointer

int	cls_indx					# dq's cls index
int	str_len

real	low
real	high
int	inclus
int	length

int	strlen()
int	dq_fndclsindx()

begin

	call strlwr(monitor)		# Changes the input string to lower case.

#  Check for the existence of any limits stored in Eric's mls.

	mls_ptr = DQ_MLS(dq_ptr)
	if(mls_ptr == NULL) {
		call fprintf(STDERR, "\n No limits exist to be deleted. \n")
		return
	}

#  Check for the existence of limits stored for this particular monitor.

	length = 1
	call mls_limits(mls_ptr, monitor, low, high, inclus, length)

	if(length == 0) {
		call fprintf(STDERR, "\n No limits have been set on %s.\n")
		call pargstr(monitor)
		return
	}

#  Delete the existing limits from the mls.

	call mls_delete(mls_ptr, monitor)

#  Check if the particular monitor is being displayed and redisplay if true.

	str_len = strlen(monitor)
	cls_indx = dq_fndclsindx(dq_ptr, monitor, str_len)

	if(cls_indx != INDEFI) {
		if(IS_DSPD(dq_ptr, cls_indx) == TRUE)
			call dq_display(DQ_DSP(dq_ptr))
	}

end

