# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqlimdraw.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqlimdraw.x -r1.4 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	better drawing of limit markers.
# 	04/27/92   akeith	date and time created 92/04/27 16:29:19 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"
include <gset.h>

#
# dq_limdraw() draws the limits on the plot by drawing two horz. markers
#	and three vertical lines to indicate the region.
#

procedure	dq_limdraw(gp, lo_lim, hi_lim, inclus)

pointer	gp					#I graphics pointer
real	hi_lim, lo_lim				# high and low limits
int	inclus					# inclusive limits?

real	wx1, wx2, wy1, wy2

real	t_diff					# used for drawing limit lines
real	mark_len
real	indc1,indc2,indc3

begin

	call ggwind(gp, wx1, wx2, wy1, wy2)

	t_diff = wx2 - wx1
	mark_len = t_diff*DQ_MARK_LEN
	indc1 = mark_len*0.15 + wx1
	indc2 = mark_len*0.10 + wx1
	indc3 = mark_len*0.05 + wx1

    # Draw two horz. markers for the hi and low limits.

	call gamove(gp, wx1, hi_lim)
	call gadraw(gp, mark_len+wx1, hi_lim)

	call gamove(gp, wx1, lo_lim)
	call gadraw(gp, mark_len+wx1, lo_lim)

	if(inclus == YES) {
		call gamove(gp, indc1, lo_lim)
		call gadraw(gp, indc1, hi_lim)
		call gamove(gp, indc2, lo_lim)
		call gadraw(gp, indc2, hi_lim)
		call gamove(gp, indc3, lo_lim)
		call gadraw(gp, indc3, hi_lim)
	} else {
		call gamove(gp, indc1, wy1)
		call gadraw(gp, indc1, lo_lim)
		call gamove(gp, indc1, hi_lim)
		call gadraw(gp, indc1, wy2)
		call gamove(gp, indc2, wy1)
		call gadraw(gp, indc2, lo_lim)
		call gamove(gp, indc2, hi_lim)
		call gadraw(gp, indc2, wy2)
		call gamove(gp, indc3, wy1)
		call gadraw(gp, indc3, lo_lim)
		call gamove(gp, indc3, hi_lim)
		call gadraw(gp, indc3, wy2)
	}

end

