# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqmerge.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqmerge.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	12/10/92   akeith	Now merges the night time intervals with the good times.
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	04/27/92   akeith	date and time created 92/04/27 16:29:30 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_merge() merges the good time intervals of the monitor pointer to by
#	cls_ptr with those held in the overall good time interval pointed
#	to by the gt_ptr. This is done using gt_merge() of the gt library
#	which takes the intersection to the two sets of intervals.
#

procedure	dq_merge(dq_ptr, cls_ptr)

pointer dq_ptr						#O dq structure pointer
pointer cls_ptr						#I cls structure pointer

int	gt_len						# memory length
pointer sgt, egt					# start and end pointers

pointer gt_ptr						# good time pointer

begin

	sgt = CLS_SGT_PTR(cls_ptr)
	egt = CLS_EGT_PTR(cls_ptr)
	gt_len = CLS_SGT_LEN(cls_ptr)

	gt_ptr = DQ_GT(dq_ptr)

	if(gt_ptr == NULL) {
		call gt_open(gt_ptr)
		DQ_GT(dq_ptr) = gt_ptr
	}

	call gt_merge(gt_ptr, Memd[sgt], Memd[egt], gt_len)

end


#
# dq_mergedaygap() merges the night time intervals with those held in the
#	overall good time interval pointed to by the gt_ptr. This is done
#	using gt_merge() of the gt library which takes the intersection to
#	the two sets of intervals.
#

procedure	dq_mergedaygap(dq_ptr, tls_ptr)

pointer dq_ptr						#O dq structure pointer
pointer tls_ptr						#I table list structure

int	nt_len						# night time length
pointer snt, ent					# start, end night time

pointer gt_ptr						# good time pointer

begin

	snt = TLS_SNT_PTR(tls_ptr)
	ent = TLS_ENT_PTR(tls_ptr)
	nt_len = TLS_SNT_LEN(tls_ptr)

	gt_ptr = DQ_GT(dq_ptr)

	if(gt_ptr == NULL) {
		call gt_open(gt_ptr)
		DQ_GT(dq_ptr) = gt_ptr
	}

	call gt_merge(gt_ptr, Memd[snt], Memd[ent], nt_len)

end

