# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqmon2vto.gx
# 	Author	:  akeith
# 	Date	:  11/22/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqmon2vto.gx -r1.2 11/22/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/22/93   akeith	date and time created 93/11/22 15:07:37 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_mon2vto() reads in and stores an ST table column in a vto if TLS_SRATE
#	equals 1 otherwise the job is passed onto on of dq_sam2vto,
#	dq_avg2vto, dq_max2vto or dq_min2vto depending of CLS_STYPE.
#


procedure	dq_mon2vto(cls_ptr)

pointer cls_ptr					#I cls structure pointer

pointer tls_ptr					# tls structure pointer

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)

	if(TLS_SRATE(tls_ptr) == 1) {

		switch(CLS_DTYPE(cls_ptr)) {

		case TY_SHORT:	call dq_col2vtos(cls_ptr)

		case TY_INT:	call dq_col2vtoi(cls_ptr)

		case TY_REAL:	call dq_col2vtor(cls_ptr)

		case TY_DOUBLE:	call dq_col2vtod(cls_ptr)

		default:
		}

	} else {

		switch(CLS_DTYPE(cls_ptr)) {

		case TY_SHORT:

			switch ( CLS_STYPE(cls_ptr) ) {
			case DQ_SAMPLE:	call dq_sam2vtos(cls_ptr)
			case DQ_AVG:	call dq_avg2vtos(cls_ptr)
			case DQ_MIN:	call dq_min2vtos(cls_ptr)
			case DQ_MAX:	call dq_max2vtos(cls_ptr)
			default:

			}

		case TY_INT:

			switch ( CLS_STYPE(cls_ptr) ) {
			case DQ_SAMPLE:	call dq_sam2vtoi(cls_ptr)
			case DQ_AVG:	call dq_avg2vtoi(cls_ptr)
			case DQ_MIN:	call dq_min2vtoi(cls_ptr)
			case DQ_MAX:	call dq_max2vtoi(cls_ptr)
			default:

			}

		case TY_REAL:

			switch ( CLS_STYPE(cls_ptr) ) {
			case DQ_SAMPLE:	call dq_sam2vtor(cls_ptr)
			case DQ_AVG:	call dq_avg2vtor(cls_ptr)
			case DQ_MIN:	call dq_min2vtor(cls_ptr)
			case DQ_MAX:	call dq_max2vtor(cls_ptr)
			default:

			}

		case TY_DOUBLE:

			switch ( CLS_STYPE(cls_ptr) ) {
			case DQ_SAMPLE:	call dq_sam2vtod(cls_ptr)
			case DQ_AVG:	call dq_avg2vtod(cls_ptr)
			case DQ_MIN:	call dq_min2vtod(cls_ptr)
			case DQ_MAX:	call dq_max2vtod(cls_ptr)
			default:

			}

		default:

		}

	}

end

