# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqplotc.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqplotc.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	only writes the name for the x axis for the base wcs only.
# 	06/26/92   akeith	Now sets the window and view coord's in gio now that gio is reset in 
# 	04/27/92   akeith	date and time created 92/04/27 16:29:37 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"
include <gset.h>

#
# dq_plotc() plots all columns under the given wcs indicated by the wcs index
#	and pointer. The actual drawing of the column is done by dq_cdraw().
#

procedure	dq_plotc(gp, wcs_ptr, wcs_indx)

pointer	gp					#I graphics pointer
pointer	wcs_ptr					#I wcs structure pointer
int	wcs_indx				#I wcs index

int	i
int	cls_indx				# dq cls structure index

bool	done_base
pointer dq_ptr					# dq structure index
pointer cls_ptr					# cls strurcture pointer

begin

	done_base = FALSE
	dq_ptr = WCS_DQ(wcs_ptr)

	call gseti(gp, G_WCS, wcs_indx)

	call gsview(gp, WCS_VIEWX1(wcs_ptr),
			WCS_VIEWX2(wcs_ptr),
			WCS_VIEWY1(wcs_ptr),
			WCS_VIEWY2(wcs_ptr))

	call gswind(gp, WCS_WRLDX1(wcs_ptr),
			WCS_WRLDX2(wcs_ptr),
			WCS_WRLDY1(wcs_ptr),
			WCS_WRLDY2(wcs_ptr))

	do i = 1, WCS_CLSINDX_LEN(wcs_ptr) {

		cls_indx = WCS_CLSINDX(wcs_ptr, i)

		if(cls_indx != INDEF) {
			if(done_base == FALSE) {

				cls_ptr = DQ_CLS(dq_ptr, cls_indx)

				if(WCS_BASE(wcs_ptr) == TRUE)
					call glabax(gp, "", "time", CLS_CNAME(cls_ptr))
				else
					call glabax(gp, "", "", CLS_CNAME(cls_ptr))
				done_base = TRUE

			}
			call dq_cdraw(gp, dq_ptr, cls_indx)
		}

	}
	
end

