# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqqpaddfltr.x
# 	Author	:  akeith
# 	Date	:  07/23/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqqpaddfltr.x -r1.7 07/23/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/14/94   akeith	init len
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	05/05/93   akeith	fixed up filter creation
# 	12/18/92   akeith	changed BIG_FLTR from 8000 to 8000000
# 	10/30/92   akeith	now uses eric's qp_add_macro() check that the string isn't too large.
# 	07/23/92   akeith	date and time created 92/07/23 17:18:40 by akeith
# H-
# 
#

#  Date last modified: 9/14/94

include "dq.h"

#
#

procedure	dq_qpaddfltr(dq_ptr, qpoe_file, fltr_name)

pointer	dq_ptr					#I dq structure pointer
char	qpoe_file[ARB]				#I qpoe file name
char	fltr_name[ARB]				#I filter name

int	str_len

pointer	qp
pointer gt_ptr

pointer	sp
pointer str_ptr

int	gt_length()
bool	qp_access()
pointer	qp_open()

begin

	if(qp_access(qpoe_file, READ_WRITE) == TRUE) {
		qp = qp_open(qpoe_file, READ_WRITE, 0)
	} else {
		call fprintf(STDERR, "\n Sorry, unable to access file, %s.\n")
		call pargstr(qpoe_file)
		return
	}

	gt_ptr = DQ_GT(dq_ptr)
	if(gt_ptr == NULL) {
		call fprintf(STDERR, "\n Sorry, no good times have been generated.\n")
		call qp_close(qp)
		return
	}

	str_len = 40*2*gt_length(gt_ptr)

	if(str_len == 0) {
		call fprintf(STDERR, "\n Sorry, but the length of your filter is 0.\n")
		call qp_close(qp)
		return
	}

	call smark(sp)
	call salloc(str_ptr, str_len, TY_CHAR)

	Memc[str_ptr] = EOS
	call dq_fltrstr(dq_ptr, gt_ptr, Memc[str_ptr], str_len)

	call dq_fltradd(qp, fltr_name, Memc[str_ptr])

	call qp_close(qp)
	call sfree(sp)

end


#
#

procedure	dq_fltrstr(dq_ptr, gt_ptr, fltr, str_len)

pointer	dq_ptr					#I dq structure pointer
pointer	gt_ptr					#I gt structure pointer
char	fltr[str_len]				#O filter string
int	str_len					#I string length

int	i
int	length

pointer sp
pointer sgt
pointer egt
pointer	tmp_str
pointer	fmt_str

int	gt_length()

begin

	length = gt_length(gt_ptr)

	call fprintf(STDERR, "\n Creating the filter string. \n")
	if(length > 128)
		call fprintf(STDERR, " This will take some time.\n")

	call smark(sp)
	call salloc(sgt, length, TY_DOUBLE)
	call salloc(egt, length, TY_DOUBLE)
	call salloc(tmp_str, 100, TY_CHAR)
	call salloc(fmt_str, 100, TY_CHAR)
	
	call sprintf(Memc[fmt_str], ARB, "%%%s:%%%s")
	call pargstr(DQ_FMT(dq_ptr))
	call pargstr(DQ_FMT(dq_ptr))

	call gt_gtimes(gt_ptr, Memd[sgt], Memd[egt], 1, length)

	do i = 1, length-1 {

		call sprintf(Memc[tmp_str], SZ_LINE, Memc[fmt_str])
		call pargd(Memd[sgt+i-1])
		call pargd(Memd[egt+i-1])
		call strcat(Memc[tmp_str], fltr, str_len)
		call strcat(",", fltr, str_len)
		Memc[tmp_str] = EOS

	}

	call sprintf(Memc[tmp_str], SZ_LINE, Memc[fmt_str])
	call pargd(Memd[sgt+i-1])
	call pargd(Memd[egt+i-1])
	call strcat(Memc[tmp_str], fltr, str_len)

	call sfree(sp)

end

#
#
#       Add a QPOE file macro
#

define	BIG_FLTR	8000000

procedure	dq_fltradd (qp, symbol, value) # add macro

pointer	qp                      #I QPOE file
char	symbol[ARB]             #I macro name
char	value[ARB]              #I macro value

int	len
int	strlen()

begin

	len = strlen(value) + 10

	if(len >= BIG_FLTR) {
		call fprintf(STDERR, "\n I'm sorry, but this filter is too large\n")
		call fprintf(STDERR, " to be useful as a macro. It would only\n")
		call fprintf(STDERR, " distroy the qpoe file. Your best bet is\n")
		call fprintf(STDERR, " is to write it to a ST table using the\n")
		call fprintf(STDERR, " gtsave command.\n\n")
		return
	}

	call qp_add_macro(qp, symbol, value)

end

