# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqresetwcs.gx
# 	Author	:  akeith
# 	Date	:  11/22/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqresetwcs.gx -r1.3 11/22/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/21/94   akeith	fixed a generic problem
# 	11/22/93   akeith	date and time created 93/11/22 15:21:32 by akeith
# H-
# 
#

#  Date last modified: 4/21/94

include "dq.h"
include <gset.h>

#
# dq_resetwcs() resets the world coordinate system of an existing wcs to
#	fit a new column. This is done by first getting the existing world
#	coordinates. The domain of the plot will remain the same, however,
#	the range may need to be extended, therefore the maximum and 
#	minimum of the column is found and compared with the existing range.
#

procedure	dq_resetwcs(dsp_ptr, wcs_indx, cls_indx)

pointer dsp_ptr					#I dsp structure pointer
int	wcs_indx				#I wcs index
int	cls_indx				#I cls index

real	x1, x2, y1, y2

int	nelms
int	vto_type

pointer wcs_ptr					# world coord. sys. structure
pointer cls_ptr					# cls structure pointer
pointer vt_ptr					# vector table pointer
pointer vto_ptr					# vector table object pointer
pointer vct_ptr					# vector pointer

int	vto_gnelms()
int	vto_gdtype()
pointer vt_vtoptr()
pointer vt_vctptr()


short	y1s, ahivs()
short	y2s, alovs()

int	y1i, ahivi()
int	y2i, alovi()

real	y1r, ahivr()
real	y2r, alovr()

double	y1d, ahivd()
double	y2d, alovd()


real	min()
real	max()

begin

	cls_ptr = DQ_CLS(DSP_DQ(dsp_ptr), cls_indx)

	wcs_ptr = DSP_WCS(dsp_ptr, wcs_indx)

	vt_ptr = CLS_VTPTR(cls_ptr)

	x1 = WCS_WRLDX1(wcs_ptr)
	x2 = WCS_WRLDX2(wcs_ptr)
	y1 = WCS_WRLDY1(wcs_ptr)
	y2 = WCS_WRLDY2(wcs_ptr)

    # Reset the y axis scale.

	vto_ptr = vt_vtoptr(vt_ptr, CLS_VTOINDX(cls_ptr))
	vct_ptr = vt_vctptr(vt_ptr, CLS_VTOINDX(cls_ptr))
	vto_type = vto_gdtype(vto_ptr)

	nelms = vto_gnelms(vto_ptr)

	switch(vto_type) {

		case TY_SHORT:
			y1s = alovs(Mems[vct_ptr], nelms)
			y1r = real(y1s)
			y2s = ahivs(Mems[vct_ptr], nelms)
			y2r = real(y2s)

		case TY_INT:
			y1i = alovi(Memi[vct_ptr], nelms)
			y1r = real(y1i)
			y2i = ahivi(Memi[vct_ptr], nelms)
			y2r = real(y2i)

		case TY_REAL:
			y1r = alovr(Memr[vct_ptr], nelms)
			y1r = real(y1r)
			y2r = ahivr(Memr[vct_ptr], nelms)
			y2r = real(y2r)

		case TY_DOUBLE:
			y1d = alovd(Memd[vct_ptr], nelms)
			y1r = real(y1d)
			y2d = ahivd(Memd[vct_ptr], nelms)
			y2r = real(y2d)

	}

	y1 = min(y1, y1r)
	y2 = max(y2, y2r)

	WCS_WRLDX1(wcs_ptr) = x1
	WCS_WRLDX2(wcs_ptr) = x2
	WCS_WRLDY1(wcs_ptr) = y1
	WCS_WRLDY2(wcs_ptr) = y2

	WCS_ORG_WRLDX1(wcs_ptr) = WCS_WRLDX1(wcs_ptr) 
	WCS_ORG_WRLDX2(wcs_ptr) = WCS_WRLDX2(wcs_ptr)
	WCS_ORG_WRLDY1(wcs_ptr) = WCS_WRLDY1(wcs_ptr)
	WCS_ORG_WRLDY2(wcs_ptr) = WCS_WRLDY2(wcs_ptr)

end

