# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqsam2vto.gx
# 	Author	:  akeith
# 	Date	:  04/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqsam2vto.gx -r1.7 04/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/20/93   ericco	added short support
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	put in generic prep. for loop over enter procedure.
# 	05/14/92   akeith	documentation
# 	05/14/92   akeith	documentation
# 	04/30/92   akeith	date and time created 92/04/30 17:01:24 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"




#
# dq_sam2vto[sird]() read a column in an ST table which has far to much data
#       to be stored in memory, therefore it only reads only a sample of the
#       points. Depending on the maximum number of points to be read in, set
#       by DQ_MAXELMS, one point in every "srate" is used to represent the
#       actual data.
#

procedure	dq_sam2vtos(cls_ptr)

pointer	cls_ptr					#I cls structure pointer

int	i					# counter
int	k					# array index

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
pointer tb_cptr					# table column pointer

int	srate					# sample rate of table column
int	nrows					# number of rows in table
bool	extra					# do we need an extra element
int	nelms					# number of vector elements

short	b_val					# buff of length one

pointer sp					# stack pointer
pointer	vct_ptr					# vector pointer

pointer vt_vtoptr()
pointer	vto_ptr					# vector table object pointer

int	vto_pvcts()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	srate = TLS_SRATE(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)
	nelms = TLS_NELMS(tls_ptr)
	extra = TLS_EXTRA(tls_ptr)

	call smark(sp)
	call salloc(vct_ptr, nelms, TY_SHORT)

	k = 1
	do i = srate, nrows, srate {
		call tbegts(tb_ptr, tb_cptr, i, b_val)
		ARRYS(vct_ptr,k) = b_val
		k = k + 1
	}

	if(extra) {
		call tbegts(tb_ptr, tb_cptr, nrows, b_val)
		ARRYS(vct_ptr,k) = b_val
	}

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))
	stat = vto_pvcts(vto_ptr, Mems[vct_ptr], nelms)

	if(stat == NO) call printf("\n\n We had a problem here.\n\n")

	call sfree(sp)

end




#
# dq_sam2vto[sird]() read a column in an ST table which has far to much data
#       to be stored in memory, therefore it only reads only a sample of the
#       points. Depending on the maximum number of points to be read in, set
#       by DQ_MAXELMS, one point in every "srate" is used to represent the
#       actual data.
#

procedure	dq_sam2vtoi(cls_ptr)

pointer	cls_ptr					#I cls structure pointer

int	i					# counter
int	k					# array index

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
pointer tb_cptr					# table column pointer

int	srate					# sample rate of table column
int	nrows					# number of rows in table
bool	extra					# do we need an extra element
int	nelms					# number of vector elements

int	b_val					# buff of length one

pointer sp					# stack pointer
pointer	vct_ptr					# vector pointer

pointer vt_vtoptr()
pointer	vto_ptr					# vector table object pointer

int	vto_pvcti()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	srate = TLS_SRATE(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)
	nelms = TLS_NELMS(tls_ptr)
	extra = TLS_EXTRA(tls_ptr)

	call smark(sp)
	call salloc(vct_ptr, nelms, TY_INT)

	k = 1
	do i = srate, nrows, srate {
		call tbegti(tb_ptr, tb_cptr, i, b_val)
		ARRYI(vct_ptr,k) = b_val
		k = k + 1
	}

	if(extra) {
		call tbegti(tb_ptr, tb_cptr, nrows, b_val)
		ARRYI(vct_ptr,k) = b_val
	}

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))
	stat = vto_pvcti(vto_ptr, Memi[vct_ptr], nelms)

	if(stat == NO) call printf("\n\n We had a problem here.\n\n")

	call sfree(sp)

end




#
# dq_sam2vto[sird]() read a column in an ST table which has far to much data
#       to be stored in memory, therefore it only reads only a sample of the
#       points. Depending on the maximum number of points to be read in, set
#       by DQ_MAXELMS, one point in every "srate" is used to represent the
#       actual data.
#

procedure	dq_sam2vtor(cls_ptr)

pointer	cls_ptr					#I cls structure pointer

int	i					# counter
int	k					# array index

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
pointer tb_cptr					# table column pointer

int	srate					# sample rate of table column
int	nrows					# number of rows in table
bool	extra					# do we need an extra element
int	nelms					# number of vector elements

real	b_val					# buff of length one

pointer sp					# stack pointer
pointer	vct_ptr					# vector pointer

pointer vt_vtoptr()
pointer	vto_ptr					# vector table object pointer

int	vto_pvctr()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	srate = TLS_SRATE(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)
	nelms = TLS_NELMS(tls_ptr)
	extra = TLS_EXTRA(tls_ptr)

	call smark(sp)
	call salloc(vct_ptr, nelms, TY_REAL)

	k = 1
	do i = srate, nrows, srate {
		call tbegtr(tb_ptr, tb_cptr, i, b_val)
		ARRYR(vct_ptr,k) = b_val
		k = k + 1
	}

	if(extra) {
		call tbegtr(tb_ptr, tb_cptr, nrows, b_val)
		ARRYR(vct_ptr,k) = b_val
	}

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))
	stat = vto_pvctr(vto_ptr, Memr[vct_ptr], nelms)

	if(stat == NO) call printf("\n\n We had a problem here.\n\n")

	call sfree(sp)

end




#
# dq_sam2vto[sird]() read a column in an ST table which has far to much data
#       to be stored in memory, therefore it only reads only a sample of the
#       points. Depending on the maximum number of points to be read in, set
#       by DQ_MAXELMS, one point in every "srate" is used to represent the
#       actual data.
#

procedure	dq_sam2vtod(cls_ptr)

pointer	cls_ptr					#I cls structure pointer

int	i					# counter
int	k					# array index

pointer tls_ptr					# tls structure pointer
pointer tb_ptr					# table pointer
pointer tb_cptr					# table column pointer

int	srate					# sample rate of table column
int	nrows					# number of rows in table
bool	extra					# do we need an extra element
int	nelms					# number of vector elements

double	b_val					# buff of length one

pointer sp					# stack pointer
pointer	vct_ptr					# vector pointer

pointer vt_vtoptr()
pointer	vto_ptr					# vector table object pointer

int	vto_pvctd()
int	stat

begin

	tls_ptr = CLS_TLSPTR(cls_ptr)
	tb_cptr = CLS_COLPTR(cls_ptr)

	tb_ptr = TLS_TBPTR(tls_ptr)
	srate = TLS_SRATE(tls_ptr)
	nrows = TLS_NROWS(tls_ptr)
	nelms = TLS_NELMS(tls_ptr)
	extra = TLS_EXTRA(tls_ptr)

	call smark(sp)
	call salloc(vct_ptr, nelms, TY_DOUBLE)

	k = 1
	do i = srate, nrows, srate {
		call tbegtd(tb_ptr, tb_cptr, i, b_val)
		ARRYD(vct_ptr,k) = b_val
		k = k + 1
	}

	if(extra) {
		call tbegtd(tb_ptr, tb_cptr, nrows, b_val)
		ARRYD(vct_ptr,k) = b_val
	}

	vto_ptr = vt_vtoptr(TLS_VTPTR(tls_ptr), CLS_VTOINDX(cls_ptr))
	stat = vto_pvctd(vto_ptr, Memd[vct_ptr], nelms)

	if(stat == NO) call printf("\n\n We had a problem here.\n\n")

	call sfree(sp)

end



