# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqsetwrld.gx
# 	Author	:  akeith
# 	Date	:  11/22/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqsetwrld.gx -r1.2 11/22/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/22/93   akeith	date and time created 93/11/22 15:10:09 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"
include <gset.h>

#
# dq_setwrld() sets the world coordinents of a newly created wcs used to
#	display the column indicated by cls_indx.
#

procedure	dq_setwrld(dsp_ptr, wcs_indx, cls_indx)

pointer dsp_ptr					#I dsp structure pointer
int	wcs_indx				#I wcs index
int	cls_indx				#I cls index

int	nelms

real	y1, y2
real	smidgen

pointer dq_ptr					# dq structure pointer
pointer wcs_ptr					# wcs structure pointer
pointer cls_ptr					# cls structure pointer
pointer vt_ptr					# vector table pointer
pointer vto_ptr					# vector table object pointer
pointer vct_ptr					# vector pointer

int	vto_type

int	vto_gnelms()
int	vto_gdtype()

pointer vt_vtoptr()
pointer vt_vctptr()

double	diff
double	dq_tlsmin()
double	dq_tlsmax()

begin

	dq_ptr  = DSP_DQ(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, wcs_indx)

    # Set the x axis scale.

	diff = dq_tlsmax(dq_ptr) - dq_tlsmin(dq_ptr)
	WCS_WRLDX1(wcs_ptr) = 0.0
	WCS_WRLDX2(wcs_ptr) = real(diff)

    # Set the y axis scale.

	cls_ptr = DQ_CLS(dq_ptr, cls_indx)
	vt_ptr = CLS_VTPTR(cls_ptr)

	vto_ptr = vt_vtoptr(vt_ptr, CLS_VTOINDX(cls_ptr))
	vct_ptr = vt_vctptr(vt_ptr, CLS_VTOINDX(cls_ptr))
	vto_type = vto_gdtype(vto_ptr)
	nelms = vto_gnelms(vto_ptr)

	switch(vto_type) {

		case TY_SHORT:
			call dq_hilos(Mems[vct_ptr], nelms, y1, y2)

		case TY_INT:
			call dq_hiloi(Memi[vct_ptr], nelms, y1, y2)

		case TY_REAL:
			call dq_hilor(Memr[vct_ptr], nelms, y1, y2)

		case TY_DOUBLE:
			call dq_hilod(Memd[vct_ptr], nelms, y1, y2)

	}

	smidgen = ((y2 - y1)*DQ_EXPAND_WINDOW)/2.0
	WCS_WRLDY1(wcs_ptr) = y1 - smidgen
	WCS_WRLDY2(wcs_ptr) = y2 + smidgen

    # Keep a copy of these original world coordinates.

	WCS_ORG_WRLDX1(wcs_ptr) = WCS_WRLDX1(wcs_ptr) 
	WCS_ORG_WRLDX2(wcs_ptr) = WCS_WRLDX2(wcs_ptr)
	WCS_ORG_WRLDY1(wcs_ptr) = WCS_WRLDY1(wcs_ptr)
	WCS_ORG_WRLDY2(wcs_ptr) = WCS_WRLDY2(wcs_ptr)

end

