# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqtbdelt.x
# 	Author	:  akeith
# 	Date	:  06/24/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqtbdelt.x -r1.6 06/24/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/22/96   tnk	added primary & alternate deltime header card processing
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	set the min and max of the time column of each table
# 	07/29/92   akeith	init the TLS_DELTFLG when the delt is gotten from the table header.
# 	06/24/92   akeith	date and time created 92/06/24 20:50:02 by akeith
# H-
# 
#

#  Date last modified: 10/22/96

include "dq.h"
include <tbset.h>

#
# dq_tbdelt() finds the delta t to use from either a header parameter in the
#	the table or from the first two values of the ids. The delta t is used
#	in figuring out when to break the line drawing when drawing the curve.
#	If the time between data points changes by N*delt, we can indicate that
#	gap in data by breaking the line drawing. (see dq_draw())
#

procedure	dq_tbdelt(tls_ptr)

pointer	tls_ptr					#I table structure pointer

double	del_t					# delta time
double	t0, t1					# first two times in ST table

double	tbhgtd()

begin

	iferr( del_t = tbhgtd(TLS_TBPTR(tls_ptr), DQ_PDELT_KWRD) ) {
	    iferr( del_t = tbhgtd(TLS_TBPTR(tls_ptr), DQ_ADELT_KWRD) ) {
		del_t = INDEFD
            }
        }
	
        if (del_t != INDEFD) {
		TLS_DELT(tls_ptr) = del_t
		TLS_DELTFLG(tls_ptr) = TRUE
		call tbegtd(TLS_TBPTR(tls_ptr), TLS_IDSPTR(tls_ptr), 1, t0)
		TLS_MINT(tls_ptr) = t0
	} else {
		call tbegtd(TLS_TBPTR(tls_ptr), TLS_IDSPTR(tls_ptr), 1, t0)
		call tbegtd(TLS_TBPTR(tls_ptr), TLS_IDSPTR(tls_ptr), 2, t1)
		TLS_DELT(tls_ptr) = t1 - t0
		TLS_DELTFLG(tls_ptr) = FALSE
		TLS_MINT(tls_ptr) = t0
	}

	call tbegtd(TLS_TBPTR(tls_ptr), TLS_IDSPTR(tls_ptr), TLS_NROWS(tls_ptr), t0)
	TLS_MAXT(tls_ptr) = t0

end

