# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqtbfndtime.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqtbfndtime.x -r1.8 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/26/97   mabbott	added support for multiple "time" columns
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	04/07/93   akeith	fixed header time param problem
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	06/26/92   akeith	interface change! dq_cidsload() now return the pointer to the indicated ids
# 	05/14/92   akeith	documented flows for procedure parameters
# 	04/27/92   akeith	date and time created 92/04/27 16:29:46 by akeith
# H-
# 
#

#  Date last modified: 2/26/97

include "dq.h"
include <tbset.h>

#
# dq_tbfndtime() looks through the ST table for a user parameter which indicates
#	which column to use as the domain for all other columns.
#
#

procedure	dq_tbfndtime(tls_ptr)

pointer	tls_ptr					#I table structure pointer

pointer	tb_ptr					# table pointer
pointer dq_ptr					# dq pointer

pointer col_ptr					# column pointer

int	str_len					# string length
pointer sp
pointer col_name				# column name string

pointer tbcnum()
int	tbhgtu()
int	strlen()
int	dq_cidsload()

begin

	tb_ptr = TLS_TBPTR(tls_ptr)
	dq_ptr = TLS_DQ(tls_ptr)

    # Look for the time parameter within the table, if it doesn't exist, just
    #	grap the first column. 

	call smark(sp)
	call salloc(col_name, SZ_LINE, TY_CHAR)

	if(tbhgtu(tb_ptr, DQ_TIME_KWRD, Memc[col_name], SZ_LINE) == YES) {

		call tbcfnd(tb_ptr, Memc[col_name], col_ptr, 1)
		TLS_IDSPTR(tls_ptr) = col_ptr
	}

	if(TLS_IDSPTR(tls_ptr) == NULL) {
		TLS_IDSPTR(tls_ptr) = tbcnum(tb_ptr, DQ_DEFAULT_TIME_COL)
		call tbcigt(TLS_IDSPTR(tls_ptr), TBL_COL_NAME, Memc[col_name], SZ_LINE)
	}

	str_len = strlen(Memc[col_name])
	TLS_IDSCLS(tls_ptr) = dq_cidsload(dq_ptr, tls_ptr, Memc[col_name], str_len, DQ_SAMPLE)
	call dq_tbdelt(tls_ptr)

	call sfree(sp)
end


