# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqtbinfo.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqtbinfo.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	05/14/92   akeith	documented flows for procedure parameters
# 	04/27/92   akeith	date and time created 92/04/27 16:29:47 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"
include <tbset.h>

#
# dq_tbinfo() gathers some relevent information about the table being loaded.
#

procedure	dq_tbinfo(tls_ptr)

pointer	tls_ptr					#I table structure pointer

pointer	tb_ptr					# table pointer

bool	extra					# do we need an extra element
int	ncols					# number of columns in table
int	nrows					# number of rows in table
int	nelms					# number of vector elements
int	srate					# sample rate of table column
real	r_srate					# real sample rate

int	tbpsta()				# table get stat

begin

	tb_ptr = TLS_TBPTR(tls_ptr)

	ncols = tbpsta(tb_ptr, TBL_NCOLS)
	nrows = tbpsta(tb_ptr, TBL_NROWS)

	r_srate = real(nrows)/DQ_MAXELMS
	srate = int(r_srate)

	if( (r_srate - srate) > 0.0 )
		srate = srate + 1

	nelms = int(real(nrows)/srate)

	extra = mod(nrows, srate) > 0

	if(extra) nelms = nelms + 1

	TLS_NCOLS(tls_ptr) = ncols
	TLS_NROWS(tls_ptr) = nrows
	TLS_NELMS(tls_ptr) = nelms
	TLS_SRATE(tls_ptr) = srate
	TLS_EXTRA(tls_ptr) = extra

end

