# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqtbload.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqtbload.x -r1.6 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	02/26/97   mabbott	added support for multiple "time" columns
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	created dq_mkclist()
# 	06/26/92   akeith	now prints that tables are being loaded.
# 	04/27/92   akeith	date and time created 92/04/27 16:29:49 by akeith
# H-
# 
#

#  Date last modified: 2/26/97

include "dq.h"

#
# dq_tbload() loads a named table into a table list structure (tls).
#

int	procedure	dq_tbload(dq_ptr, tb_name)

pointer	dq_ptr					#O dq structure pointer
char	tb_name[ARB]				#I table name

pointer	tb_ptr					# table pointer

pointer tls_ptr					# table structure pointer

int	str_len
int	strlen()
pointer	str_ptr

pointer dq_tbopen()
pointer dq_tlsadd()
pointer vt_create()

begin

	tb_ptr = dq_tbopen(tb_name)

	if(tb_ptr == NULL) return(NO)

	tls_ptr = dq_tlsadd(dq_ptr)

	TLS_TBPTR(tls_ptr) = tb_ptr

	TLS_VTPTR(tls_ptr) = vt_create()

    # Store the table name.

	str_len = strlen(tb_name)

	call fprintf(STDERR,"\n Loading table: %s. \n")
	call pargstr(tb_name)

        call malloc(str_ptr, str_len+1, TY_CHAR)
        TLS_TNAME_PTR(tls_ptr) = str_ptr
        TLS_TNAME_LEN(tls_ptr) = str_len+1
        call strcpy(tb_name, TLS_TNAME(tls_ptr), str_len)

   # Get the table information.

	call dq_tbinfo(tls_ptr)

	call dq_tbfndtime(tls_ptr)

	call dq_mkclist(tls_ptr)

	return(YES)

end


#
#	dq_mkclist()
#
#  MJA notes -  when I added support for multiple ids columns with the
#    same name, this introduced several problems with the column list
#    such as formatting (names can be very long), getting the right name, etc.
#    Therefore we decided to simply omit the ids columns from the list 
#    of columns.
#

procedure	dq_mkclist(tls_ptr)

pointer	tls_ptr			#I table list structure

int	dtype
int	col_num
int	str_len
int	len, len_fmt
int	strlen()

pointer	sp
pointer fname
pointer col_name
pointer col_unts
pointer col_fmt

pointer	tb_ptr
pointer col_ptr

int	mod()
long	open()
pointer tbcnum()

begin

	tb_ptr = TLS_TBPTR(tls_ptr)
	if(tb_ptr == NULL) return

	call smark(sp)
	call salloc(fname, SZ_LINE, TY_CHAR)
	call salloc(col_name, SZ_LINE, TY_CHAR)
	call salloc(col_unts, SZ_LINE, TY_CHAR)
	call salloc(col_fmt, SZ_LINE, TY_CHAR)

	call mktemp("tmp$clist", Memc[fname], SZ_LINE)

	str_len = strlen(Memc[fname])
        call malloc(TLS_CLFILE_PTR(tls_ptr), str_len+1, TY_CHAR)

        TLS_TNAME_LEN(tls_ptr) = str_len+1
	call strcpy(Memc[fname], TLS_CLFILE(tls_ptr), TLS_TNAME_LEN(tls_ptr))

   # Open and store the column list file descriptor.

	TLS_CLFD(tls_ptr) = open(Memc[fname], TEMP_FILE, TEXT_FILE)

	call sfree(sp)

	do col_num = 1, TLS_NCOLS(tls_ptr) {

		Memc[col_name] = EOS
		Memc[col_unts] = EOS
		Memc[col_fmt]  = EOS

		col_ptr = tbcnum(tb_ptr, col_num)

		# skip ids columns
		if (col_ptr == TLS_IDSPTR(tls_ptr)) next

		call tbcinf(col_ptr, col_num, Memc[col_name], Memc[col_unts],
				Memc[col_fmt], dtype, len, len_fmt)

		# note: extra -1 because ids column is omitted
		if(mod(col_num-1-1, 5) == 0) call fprintf(TLS_CLFD(tls_ptr), "\n")

		str_len = strlen(Memc[col_name])
		call dq_filestr(tls_ptr, Memc[col_name], str_len)

	}

	call fprintf(TLS_CLFD(tls_ptr), "\n")

	call close(TLS_CLFD(tls_ptr))

end



procedure	dq_filestr(tls_ptr, name, len)

pointer	tls_ptr					#I table list structure
char	name[ARB]				#I column name
int	len					#I string length

pointer fd					# file descriptor

begin

	fd = TLS_CLFD(tls_ptr)
	call fprintf(fd, "%-15.14s")
	call pargstr(name)

end


