# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqtlsclos.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqtlsclos.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	12/10/92   akeith	Now frees the night time intervals stored in the table list structure.
# 	10/30/92   akeith	makes sure column list file is closed and frees the filename string
# 	04/27/92   akeith	date and time created 92/04/27 16:29:53 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_tlsclos() destroys the associated vector table and frees the tls structure.
#	It does nothing to free any associated cls structures, that is handled by
#	dq_tlsdel().
#

procedure	dq_tlsclos(tls_ptr)

pointer	tls_ptr					#I tls structure pointer

pointer	vt_ptr					# vector table pointer

begin

	if(tls_ptr == NULL) return

	vt_ptr = TLS_VTPTR(tls_ptr)
	call vt_destroy(vt_ptr)

	if(TLS_CLFD(tls_ptr) != NULL) {
		call close(TLS_CLFD(tls_ptr))
		TLS_CLFD(tls_ptr) = NULL
	}

	if(TLS_TNAME_LEN(tls_ptr) > 0)
		call mfree(TLS_TNAME_PTR(tls_ptr), TY_CHAR)

	if(TLS_CLFILE_LEN(tls_ptr) > 0)
		call mfree(TLS_CLFILE_PTR(tls_ptr), TY_CHAR)

	call dq_freetlsnt(tls_ptr)

	call mfree(tls_ptr, TY_STRUCT)

end

