# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqtlsdel.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqtlsdel.x -r1.4 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	now closes the tables
# 	04/27/92   akeith	date and time created 92/04/27 16:29:54 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_tlsdel() is the first step in removing a tls structure by first removing
#	all associated cls structures and then closing the tls with dq_tlsclos().
#

procedure	dq_tlsdel(dq_ptr, tls_indx)

pointer	dq_ptr					#O dq structure pointer
int	tls_indx				#I dq tls index

int	i

pointer tls_ptr					# table structure pointer
pointer cls_ptr					# column list structure pointer

begin

	if(tls_indx < 1 || tls_indx > DQ_TLS_LEN(dq_ptr)) {
		call fprintf(STDERR, "\n dq_tlsdel: tls index out of bounds.\n")
		return
	}

	tls_ptr = DQ_TLS(dq_ptr, tls_indx)

   # Find all the columns associated with this table and get rid of them.

	do i = 1, DQ_CLS_LEN(dq_ptr) {

		cls_ptr = DQ_CLS(dq_ptr, i)

		if(cls_ptr != NULL) {
			if(CLS_TLSINDX(cls_ptr) == tls_indx)
				call dq_clsdel(dq_ptr, i)
		}

	}

	if(TLS_TBPTR(tls_ptr) != NULL) {
		call tbtclo(TLS_TBPTR(tls_ptr))
		TLS_TBPTR(tls_ptr) = NULL
	}

	call dq_tlsclos(tls_ptr)

	DQ_TLS(dq_ptr, tls_indx) = NULL

end

