# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqundisp.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqundisp.x -r1.5 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	Only put in debug print statement of function name.
# 	06/26/92   akeith	no changes were made
# 	04/27/92   akeith	date and time created 92/04/27 16:29:56 by akeith
# H-
# 
#

#  Date last modified: 11/23/93

include "dq.h"

#
# dq_undisp() undisplays a currently displayed column by changing the cls
#	display status to false and removing the cls index from the list
#	of cls indices for the wcs it is displayed under. If no more columns
#	are displayed under that wcs then the wcs is deleted using dq_wcsdel().
#

procedure	dq_undisp(dq_ptr, cls_indx)

pointer	dq_ptr					#O dq structure pointer
int	cls_indx				#I dq cls list index

int	i
int	indx_wcs				# dq wcs list index

pointer	dsp_ptr					# dsp structure pointer
pointer wcs_ptr
pointer cls_ptr

begin

	if(cls_indx == INDEFI) return

	cls_ptr = DQ_CLS(dq_ptr, cls_indx)

	if(cls_ptr == NULL) return

	if(CLS_DSPD(cls_ptr) == FALSE) return
	CLS_DSPD(cls_ptr) = FALSE

	dsp_ptr = DQ_DSP(dq_ptr)

	indx_wcs = CLS_WCSINDX(cls_ptr)

	wcs_ptr = DSP_WCS(dsp_ptr, indx_wcs)

	do i = 1, WCS_CLSINDX_LEN(wcs_ptr) {
		if(WCS_CLSINDX(wcs_ptr, i) == cls_indx)
			call dq_delclsindx(wcs_ptr, i)
	}

	if(WCS_NCLSINDX(wcs_ptr) == 0)
		call dq_wcsdel(dsp_ptr, indx_wcs)

end

