# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  dqwindow.x
# 	Author	:  akeith
# 	Date	:  10/30/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) dqwindow.x -r1.3 10/30/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	10/30/92   akeith	date and time created 92/10/30 15:55:01 by akeith
# H-
# 
#


#  Date last modified: 11/23/93

include	"dq.h"

#
# dq_window()
#

procedure	dq_window (dq_ptr)

pointer	dq_ptr						# dq structure pointer

pointer sp
pointer cmd
pointer mode
pointer	dsp_ptr						# dsp structure pointer
pointer	ek_ptr

real	wx, wy
int	wcs, main_wcs
int	stat

int	ek_gcur()

begin

	dsp_ptr = DQ_DSP(dq_ptr)
	if(dsp_ptr == NULL) {
		call fprintf(STDERR, "\n You're not displaying anything!\n")
		return
	}

	if(DSP_NWCS(dsp_ptr) < 1) {
		call fprintf(STDERR, "\n You're not displaying anything!\n")
		return
	}

	call smark(sp)
	call salloc(cmd, SZ_LINE, TY_CHAR)
	call salloc(mode, SZ_LINE, TY_CHAR)

	call strcpy("gcur", Memc[mode], SZ_LINE)

	ek_ptr = DQ_EK(dq_ptr)

	if(DSP_NWCS(dsp_ptr) > 1) {

		call fprintf(STDOUT, "\n Choose a window.\n")
		stat = ek_gcur(Memc[mode], ek_ptr, wx, wy, main_wcs, Memc[cmd], SZ_LINE)

	} else {

		main_wcs = 1
		while(DSP_WCS(dsp_ptr, main_wcs) == NULL && main_wcs <= WCS_ARY_LEN)
			main_wcs = main_wcs + 1

		if(DSP_WCS(dsp_ptr, main_wcs) == NULL) {
			call fprintf(STDERR, "\n ERROR: dq_window() main_wcs = NULL\n")
			call sfree(sp)
			return
		}
	}

	call dq_valcmds()
	call fprintf(STDOUT, "\n\nWindow> ")
	call flush(STDOUT)

	while(ek_gcur(Memc[mode], ek_ptr, wx, wy, wcs, Memc[cmd], SZ_LINE) != EOF) {

		call dq_windowcmd(dq_ptr, main_wcs, wx, wy, wcs, Memc[cmd])

		call fprintf(STDOUT, "\nWindow> ")
		call flush(STDOUT)

	}

	call fprintf(STDOUT, "\n")
	call flush(STDOUT)

	call sfree(sp)

end




procedure	dq_windowcmd(dq_ptr, main_wcs, wx, wy, wcs, cmd)

pointer	dq_ptr
int	main_wcs
real	wx, wy
int	wcs
char	cmd[ARB]

pointer dsp_ptr
bool	bad_case

begin

	dsp_ptr = DQ_DSP(dq_ptr)

	bad_case = FALSE

	switch(cmd[1]) {
	  case 'a':
		call dq_wcmda(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'b':
		call dq_wcmdb(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'c':
		call dq_wcmdc(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'd':
		call dq_wcmdd(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'e':
		call dq_wcmde(dq_ptr,  main_wcs, wcs, wx, wy)
	  case 'f':
		call dq_wcmdf(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'g':
		call dq_wcmdg(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'j':
		call dq_wcmdj(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'k':
		call dq_wcmdk(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'l':
		call dq_wcmdl(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'm':
		call dq_wcmdm(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'n':
		call dq_wcmdn(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'p':
		call dq_wcmdp(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'r':
		call dq_wcmdr(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 't':
		call dq_wcmdt(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'u':
		call dq_wcmdu(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'x':
		call dq_wcmdx(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'y':
		call dq_wcmdy(dsp_ptr, main_wcs, wcs, wx, wy)
	  case 'z':
		call dq_wcmdz(dsp_ptr, main_wcs, wcs, wx, wy)
	  default:
		bad_case = TRUE
	}

	if(!bad_case) {
		call dq_display(dsp_ptr)
		call dq_valcmds()
	}

end


procedure	dq_valcmds()

begin

	call fprintf(STDOUT, "\n")
	call fprintf(STDOUT, "\tGRAPH WINDOW COMMANDS\n")
	call fprintf(STDOUT, "\n")
	call fprintf(STDOUT, "a  Autoscale x and y axes\n")
	call fprintf(STDOUT, "b  Set bottom edge of window\n")
	call fprintf(STDOUT, "c  Center window at cursor position\n")
	call fprintf(STDOUT, "d  Shift window down\n")
	call fprintf(STDOUT, "e  Expand window (mark lower left and upper")
	call fprintf(STDOUT, " right of new window)\n")
	call fprintf(STDOUT, "f  Flip x axis\n")
	call fprintf(STDOUT, "g  Flip y axis\n")
	call fprintf(STDOUT, "j  Set left edge of window\n")
	call fprintf(STDOUT, "k  Set right edge of window\n")
	call fprintf(STDOUT, "l  Shift window left\n")
	call fprintf(STDOUT, "m  Autoscale x axis\n")
	call fprintf(STDOUT, "n  Autoscale y axis\n")
	call fprintf(STDOUT, "p  Pan x and y axes about cursor\n")
	call fprintf(STDOUT, "r  Shift window right\n")
	call fprintf(STDOUT, "t  Set top edge of window\n")
	call fprintf(STDOUT, "u  Shift window up\n")
	call fprintf(STDOUT, "x  Zoom x axis about cursor\n")
	call fprintf(STDOUT, "y  Zoom y axis about cursor\n")
	call fprintf(STDOUT, "z  Zoom x and y axes about cursor\n")
	call fprintf(STDOUT, "\n")
	call flush(STDOUT)

end


procedure	dq_wcmda(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	wcs_ptr

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)
	WCS_WRLDX1(wcs_ptr) = WCS_ORG_WRLDX1(wcs_ptr)
	WCS_WRLDX2(wcs_ptr) = WCS_ORG_WRLDX2(wcs_ptr)
	WCS_WRLDY1(wcs_ptr) = WCS_ORG_WRLDY1(wcs_ptr)
	WCS_WRLDY2(wcs_ptr) = WCS_ORG_WRLDY2(wcs_ptr)

end

procedure	dq_wcmdb(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	WCS_WRLDY1(wcs_ptr) = m_wy

end

procedure	dq_wcmdc(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy
real	cntr_x, cntr_y
real	dif_x, dif_y

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	cntr_x = (WCS_WRLDX2(wcs_ptr) - WCS_WRLDX1(wcs_ptr))/2.0 + WCS_WRLDX1(wcs_ptr)
	cntr_y = (WCS_WRLDY2(wcs_ptr) - WCS_WRLDY1(wcs_ptr))/2.0 + WCS_WRLDY1(wcs_ptr)

	dif_x = cntr_x - m_wx
	dif_y = cntr_y - m_wy

	WCS_WRLDX1(wcs_ptr) = WCS_WRLDX1(wcs_ptr) - dif_x
	WCS_WRLDX2(wcs_ptr) = WCS_WRLDX2(wcs_ptr) - dif_x
	WCS_WRLDY1(wcs_ptr) = WCS_WRLDY1(wcs_ptr) - dif_y
	WCS_WRLDY2(wcs_ptr) = WCS_WRLDY2(wcs_ptr) - dif_y

end

procedure	dq_wcmdd(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	wcs_ptr
real	cntr_y
real	dif_y

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	cntr_y = (WCS_WRLDY2(wcs_ptr) - WCS_WRLDY1(wcs_ptr))/2.0 + WCS_WRLDY1(wcs_ptr)
	dif_y = cntr_y - WCS_WRLDY1(wcs_ptr)

	WCS_WRLDY1(wcs_ptr) = WCS_WRLDY1(wcs_ptr) - dif_y
	WCS_WRLDY2(wcs_ptr) = WCS_WRLDY2(wcs_ptr) - dif_y

end

procedure	dq_wcmde(dq_ptr, main_wcs, wcs, wx, wy)

pointer	dq_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	ek_ptr
pointer	wcs_ptr
pointer dsp_ptr
real	m_wx, m_wy

pointer	sp
pointer cmd

int	stat
int	ek_gcur()

begin

	ek_ptr  = DQ_EK(dq_ptr)
	dsp_ptr = DQ_DSP(dq_ptr)
	gp_ptr  = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	WCS_WRLDX1(wcs_ptr) = m_wx
	WCS_WRLDY1(wcs_ptr) = m_wy


	call fprintf(STDOUT, "again:\n")
	call flush(STDOUT)

	call smark(sp)
	call salloc(cmd, SZ_LINE, TY_CHAR)

	stat = ek_gcur("gcur", ek_ptr, wx, wy, wcs, Memc[cmd], SZ_LINE)

	call sfree(sp)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	WCS_WRLDX2(wcs_ptr) = m_wx
	WCS_WRLDY2(wcs_ptr) = m_wy

end

procedure	dq_wcmdf(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer wcs_ptr
real	tmp_x

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)
	tmp_x = WCS_WRLDX1(wcs_ptr)
	WCS_WRLDX1(wcs_ptr) = WCS_WRLDX2(wcs_ptr)
	WCS_WRLDX2(wcs_ptr) = tmp_x

end

procedure	dq_wcmdg(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer wcs_ptr
real	tmp_y

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)
	tmp_y = WCS_WRLDY1(wcs_ptr)
	WCS_WRLDY1(wcs_ptr) = WCS_WRLDY2(wcs_ptr)
	WCS_WRLDY2(wcs_ptr) = tmp_y

end

procedure	dq_wcmdj(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	WCS_WRLDX1(wcs_ptr) = m_wx

end

procedure	dq_wcmdk(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	WCS_WRLDX2(wcs_ptr) = m_wx

end

procedure	dq_wcmdl(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	wcs_ptr
real	cntr_x
real	dif_x

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	cntr_x = (WCS_WRLDX2(wcs_ptr) - WCS_WRLDX1(wcs_ptr))/2.0 + WCS_WRLDX1(wcs_ptr)
	dif_x = cntr_x - WCS_WRLDX1(wcs_ptr)

	WCS_WRLDX1(wcs_ptr) = WCS_WRLDX1(wcs_ptr) - dif_x
	WCS_WRLDX2(wcs_ptr) = WCS_WRLDX2(wcs_ptr) - dif_x

end

procedure	dq_wcmdm(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	wcs_ptr

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)
	WCS_WRLDX1(wcs_ptr) = WCS_ORG_WRLDX1(wcs_ptr)
	WCS_WRLDX2(wcs_ptr) = WCS_ORG_WRLDX2(wcs_ptr)

end

procedure	dq_wcmdn(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	wcs_ptr

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)
	WCS_WRLDY1(wcs_ptr) = WCS_ORG_WRLDY1(wcs_ptr)
	WCS_WRLDY2(wcs_ptr) = WCS_ORG_WRLDY2(wcs_ptr)

end

procedure	dq_wcmdp(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy
real	half_width_x, half_width_y
real	cntr_x, cntr_y
real	dif_x, dif_y

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	half_width_x = (WCS_WRLDX2(wcs_ptr) - WCS_WRLDX1(wcs_ptr))/2.0
	half_width_y = (WCS_WRLDY2(wcs_ptr) - WCS_WRLDY1(wcs_ptr))/2.0

	cntr_x = half_width_x + WCS_WRLDX1(wcs_ptr)
	cntr_y = half_width_y + WCS_WRLDY1(wcs_ptr)

	dif_x = cntr_x - m_wx
	dif_y = cntr_y - m_wy

	WCS_WRLDX1(wcs_ptr) = WCS_WRLDX1(wcs_ptr) - dif_x - half_width_x/2
	WCS_WRLDX2(wcs_ptr) = WCS_WRLDX2(wcs_ptr) - dif_x + half_width_x/2
	WCS_WRLDY1(wcs_ptr) = WCS_WRLDY1(wcs_ptr) - dif_y - half_width_y/2
	WCS_WRLDY2(wcs_ptr) = WCS_WRLDY2(wcs_ptr) - dif_y + half_width_y/2

end

procedure	dq_wcmdr(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	wcs_ptr
real	cntr_x
real	dif_x

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	cntr_x = (WCS_WRLDX2(wcs_ptr) - WCS_WRLDX1(wcs_ptr))/2.0 + WCS_WRLDX1(wcs_ptr)
	dif_x = cntr_x - WCS_WRLDX2(wcs_ptr)

	WCS_WRLDX1(wcs_ptr) = WCS_WRLDX1(wcs_ptr) - dif_x
	WCS_WRLDX2(wcs_ptr) = WCS_WRLDX2(wcs_ptr) - dif_x

end

procedure	dq_wcmdt(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	WCS_WRLDY2(wcs_ptr) = m_wy

end

procedure	dq_wcmdu(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	wcs_ptr
real	cntr_y
real	dif_y

begin

	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	cntr_y = (WCS_WRLDY2(wcs_ptr) - WCS_WRLDY1(wcs_ptr))/2.0 + WCS_WRLDY1(wcs_ptr)
	dif_y = cntr_y - WCS_WRLDY2(wcs_ptr)

	WCS_WRLDY1(wcs_ptr) = WCS_WRLDY1(wcs_ptr) - dif_y
	WCS_WRLDY2(wcs_ptr) = WCS_WRLDY2(wcs_ptr) - dif_y

end

procedure	dq_wcmdx(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy
real	half_width_x
real	cntr_x
real	dif_x

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	half_width_x = (WCS_WRLDX2(wcs_ptr) - WCS_WRLDX1(wcs_ptr))/2.0

	cntr_x = half_width_x + WCS_WRLDX1(wcs_ptr)

	dif_x = cntr_x - m_wx

	WCS_WRLDX1(wcs_ptr) = WCS_WRLDX1(wcs_ptr) - dif_x + half_width_x/2
	WCS_WRLDX2(wcs_ptr) = WCS_WRLDX2(wcs_ptr) - dif_x - half_width_x/2

end

procedure	dq_wcmdy(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy
real	half_width_y
real	cntr_y
real	dif_y

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	half_width_y = (WCS_WRLDY2(wcs_ptr) - WCS_WRLDY1(wcs_ptr))/2.0

	cntr_y = half_width_y + WCS_WRLDY1(wcs_ptr)

	dif_y = cntr_y - m_wy

	WCS_WRLDY1(wcs_ptr) = WCS_WRLDY1(wcs_ptr) - dif_y + half_width_y/2
	WCS_WRLDY2(wcs_ptr) = WCS_WRLDY2(wcs_ptr) - dif_y - half_width_y/2

end

procedure	dq_wcmdz(dsp_ptr, main_wcs, wcs, wx, wy)

pointer	dsp_ptr				#I display structure pointer
int	main_wcs			#I indicated world coordinate system
int	wcs				#I picked world coordinate system
real	wx, wy				#I x and y world coordinates

pointer	gp_ptr
pointer	wcs_ptr
real	m_wx, m_wy
real	half_width_x, half_width_y
real	cntr_x, cntr_y
real	dif_x, dif_y

begin

	gp_ptr = DSP_GPPTR(dsp_ptr)
	wcs_ptr = DSP_WCS(dsp_ptr, main_wcs)

	if(main_wcs == wcs) {
		m_wx = wx
		m_wy = wy
	} else call gctran(gp_ptr, wx, wy, m_wx, m_wy, wcs, main_wcs)

	half_width_x = (WCS_WRLDX2(wcs_ptr) - WCS_WRLDX1(wcs_ptr))/2.0
	half_width_y = (WCS_WRLDY2(wcs_ptr) - WCS_WRLDY1(wcs_ptr))/2.0

	cntr_x = half_width_x + WCS_WRLDX1(wcs_ptr)
	cntr_y = half_width_y + WCS_WRLDY1(wcs_ptr)

	dif_x = cntr_x - m_wx
	dif_y = cntr_y - m_wy

	WCS_WRLDX1(wcs_ptr) = WCS_WRLDX1(wcs_ptr) - dif_x + half_width_x/2
	WCS_WRLDX2(wcs_ptr) = WCS_WRLDX2(wcs_ptr) - dif_x - half_width_x/2
	WCS_WRLDY1(wcs_ptr) = WCS_WRLDY1(wcs_ptr) - dif_y + half_width_y/2
	WCS_WRLDY2(wcs_ptr) = WCS_WRLDY2(wcs_ptr) - dif_y - half_width_y/2

end

