# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_dqselect.x
# 	Author	:  akeith
# 	Date	:  04/27/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_dqselect.x -r1.11 04/27/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/15/95   akeith	fixed cursor mode
# 	07/16/93   akeith	fixed any YES/NO TRUE/FALSE problems and removed all the DEBUG stuff
# 	05/05/93   akeith	put in format
# 	10/30/92   akeith	mostly changed the valid commands list
# 	07/29/92   akeith	added the gtnew to the valid command list.
# 	07/27/92   akeith	added the valid command list
# 	06/26/92   akeith	updated
# 	05/14/92   akeith	documentation
# 	04/27/92   akeith	date and time created 92/04/27 16:30:39 by akeith
# H-
# 
#

#  Date last modified: 3/15/95

include <tbset.h>
include <vtl.h>
include <gset.h>
include "dq.h"

#
#  t_dqselect() is the task call. It's main functions are to allocate
#	memory for dq structure, open the tty, inquire about the limit
#	files and the tables to load, set up eric's interp functions
#	and go into a command loop calling ek_gcur to recieve commands.
#	In the end it calls ii_close to clean up.
#

procedure	t_dqselect()


pointer	sp
pointer	cmd
pointer	mode
pointer format

pointer dq_ptr

pointer	ek

pointer	intr
extern	dq_eval()
extern	dq_release()
extern	dq_clos()

pointer dq_dqinit()
pointer ttyodes()

real	wx, wy
int	wcs
int	dq_tbinq()
int	ek_gcur()
long	clgetl()

bool	strne()
bool	streq()

begin

	call smark(sp)

#   Allocate stack memory for local strings

	call salloc(cmd, SZ_LINE, TY_CHAR)

#   Allocate memory for dq structure.

	dq_ptr = dq_dqinit()

#   Open the tty.

	DQ_TTY(dq_ptr) = ttyodes("terminal")

	call ek_key_file(ek, "", 0)
	DQ_EK(dq_ptr) = ek

	if(dq_tbinq(dq_ptr) == NO) {
		call fprintf(STDERR, "\n\n Sorry, but no tables were loaded.\n\n")
		call dq_clos(dq_ptr)
		return
	}

	call dq_liminq(dq_ptr)

	DQ_GAP(dq_ptr) = clgetl("gap") + 0.5

	call eu_clstr(mode, "imode")
	call dq_chngmode(dq_ptr, Memc[mode])

	call eu_clstr(format, "format")
	if(Memc[format] == '%') format = format + 1
	call strcpy(Memc[format], DQ_FMT(dq_ptr), DQ_FMT_LEN(dq_ptr))

#   Eric's command interp.

	call ii_open (intr, dq_eval, dq_release)
	call ii_help_open (intr, "euvred$doc/dqcmd.hlp")
	call ii_post_private (intr, dq_ptr, dq_clos)

	if(strne(DQ_IMODE(dq_ptr), "gcur")) {
		call dq_comline()
		call fprintf(STDOUT, "\nCommand> ")
		call flush(STDOUT)
	}

	while (ek_gcur(DQ_IMODE(dq_ptr), ek, wx, wy, wcs,
				Memc[cmd], SZ_LINE) != EOF) {

		if(streq(Memc[cmd], "quit")) break

		call ii_evaluate (intr, Memc[cmd])

		if(strne(DQ_IMODE(dq_ptr), "gcur")) {
			call dq_comline()
			call fprintf(STDOUT, "\nCommand> ")
			call flush(STDOUT)
		}

	}

	call ii_close(intr)

	call sfree(sp)

end


procedure	dq_comline()

begin

call fprintf(STDOUT, "\n")
call fprintf(STDOUT, " Valid Commands:\n")
call fprintf(STDOUT, "\t display <monitor>                 hide <monitor|all>\n")
call fprintf(STDOUT, "\t list <table>                      mode <line|cursor>\n")
call fprintf(STDOUT, "\t edit <monitor>                    delete <monitor>\n")
call fprintf(STDOUT, "\t limload <file_name>               limsave <file_name>\n")
call fprintf(STDOUT, "\t showlim <monitor>                 hidelim <monitor>\n")
call fprintf(STDOUT, "\t gtgen                             gtnew \n")
call fprintf(STDOUT, "\t gtload <file_name>                gtsave <file_name>\n")
call fprintf(STDOUT, "\t redraw                            gap <width>\n")
call fprintf(STDOUT, "\t filter <qpoe_file> <filter_name>  window\n")
call fprintf(STDOUT, "\t q,quit                            help <command>\n")

end


