# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  fmtenv.x
# 	Author	:  ericco
# 	Date	:  04/26/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) fmtenv.x -r1.7 04/26/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/03/95   tnk	made if (strncmp) a proper logical test
# 	08/30/94   ericco	added long line support
# 	04/27/94   ericco	adjusted tm record format
# 	04/26/94   ericco	added \n to format!
# 	04/26/94   ericco	added formating
# 	04/26/94   ericco	date and time created 94/04/26 19:56:47 by ericco
# H-
# 
#

#	Read a pset into a string suitable for gettm
# @(#)fmtenv.x	1.7 10/3/95

include <pkg/dttext.h>

#	Given a pointer to a string, advance it until it
#	pointers to a non-space character.

procedure	skip_space (ptr)	# skip spaces in string
pointer		ptr			# I/O string pointer

begin
	while (Memc[ptr] != EOS)
		if (Memc[ptr] == ' ' || Memc[ptr] == '\t')
			ptr = ptr + 1
		else
			break
end

#	Given a pointer to a string, advance it until it
#	pointers to a space character.

procedure	skip_word (ptr)		# skip non-space characters
pointer		ptr			# I/O string pointer

begin
	while (Memc[ptr] != EOS)
		if (Memc[ptr] == ' ' || Memc[ptr] == '\t')
			break
		else
			ptr = ptr + 1
end


#	Formats a series of environment records from a text database
#	record.  The formatted environment records are return as a NULL
#	terminated list of strings (each string containing a single
#	formatted environment variable record).

procedure fmtenv (tdb, record, strs) # format environment record
char	tdb[ARB]		#I text db name
char	record[ARB]		#I record name
pointer strs			#O array of strings

int	len
pointer	sp
pointer	buf
pointer	dt, dtmap()
pointer	rc, dtlocate()
int	l
int	strlen()
int	strncmp()
pointer	n, p, str
pointer	val, key

begin
	len = 0

	call smark(sp)
	call malloc(strs, 1, TY_LONG)
	call salloc(key, 100, TY_CHAR)
	call salloc(val, 100, TY_CHAR)

	dt = dtmap(tdb, READ_ONLY)
	rc = dtlocate(dt, record)
	call seek(DT(dt), DT_OFFSET(dt, rc))

	repeat {
		call vlline(DT(dt), buf)
		if (buf == NULL) break
		p = buf
		call skip_space(p)
		if (strncmp(Memc[p], "set", 3) != 0) break
		p = p + 3
		val = p
		call skip_space(val)
		if (val == p) break
		p = val
		call skip_word(p)
		if (Memc[p] == EOS)
			str = p
		else {
			Memc[p] = EOS
			p = p + 1
			call skip_space(p)
			str = p
			call skip_word(p)
			Memc[p] = EOS
		}
		l = strlen(Memc[val]) + strlen(Memc[str])

		len = len + 1
		call realloc(strs, len+1, TY_LONG)
		call malloc(n, l+5, TY_CHAR)
		Meml[strs+len-1] = n
#		call sprintf(Memc[n], ARB, "set %s=%s\n")
#		call pargstr(Memc[val])
#		call pargstr(Memc[str])
		call strcpy("set ", Memc[n], ARB)
		call strcat(Memc[val],Memc[n], ARB)
		call strcat("=",Memc[n], ARB)
		call strcat(Memc[str],Memc[n], ARB)
		call strcat("\n",Memc[n], ARB)
		call mfree(buf, TY_CHAR)
	}
	call dtunmap(dt)

#	call printf("read in %d environment parameters\n")
#	call pargi(len)

	Meml[strs+len] = 0
	call sfree(sp)
end
