# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_prcelm.x
# 	Author	:  ericco
# 	Date	:  05/07/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_prcelm.x -r1.3 05/07/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/29/91   ericco	removed old root parameter
# 	05/07/91   ericco	date and time created 91/05/07 09:54:24 by ericco
# H-
# 
#

#	Revised: 4/30/92

include <edata.h>

#	Print out information about an observation.
#	requires the full path to the observation text
#	database.

procedure	t_prcelm ()	# print observation information

pointer		sp
pointer		procname

int		dt, dtmap()
pointer		ptr
string		format "%10s %10s %10s\n"

begin
  call smark(sp)
  call euclstr(procname, "input")

  dt = dtmap(Memc[procname], READ_ONLY)
  call ed_read (dt, ptr)

  if (ptr != 0) {
    call pe_source (ED_SOURCE(ptr))
    call pe_dump(format, ptr)
  }

  call dtunmap(dt)
  call sfree(sp)
end

#	Print information found in the source record on
#	standard output.

procedure	pe_source (ptr)		# print source information
pointer		ptr			#I source data pointer

begin
#  call printf("Root:\t%s\n")
#  call pargstr(VEC_STRING(ptr, ED_ROOT_ID))
  call printf("Directory:\t%s\n")
  call pargstr(VEC_STRING(ptr, ED_DIR_ID))
  call printf("SubClass:\t%s\n")
  call pargstr(VEC_STRING(ptr, ED_SUBCL_ID))
  call printf("Class:\t%s\n")
  call pargstr(VEC_STRING(ptr, ED_CL_ID))
  call printf("Label:\t%s\n")
  call pargstr(VEC_STRING(ptr, ED_LABEL_ID))
  call printf("Name:\t%s\n")
  call pargstr(VEC_STRING(ptr, ED_NAME_ID))
end

#	Print information on the type of data collected during
#	an observation.

procedure	pe_dump (form, ptr)	# print observation columns
char		form[ARB]		#I formating string
pointer		ptr			#I data pointer

int		index
pointer		cols, tbls, refs, spcs
int		len, tbl, slen
int		specp, offset

begin
  call printf(form)
  call pargstr("Element")
  call pargstr("Table")
  call pargstr("Special")
  call printf(form)
  call pargstr("-------")
  call pargstr("-----")
  call pargstr("-------")
  cols = ED_COLUMN(ptr)
  tbls = ED_TABLES(ptr)
  refs = ED_TBL_REF(ptr)
  spcs = ED_SPC_COL(ptr)
  len = VEC_SIZE(cols)
  do index = 1, len {
    call printf(form)
    call pargstr(VEC_STRING(cols, index))
    tbl = VEC_ELEMENT(refs, index)
    call pargstr(VEC_STRING(tbls, tbl))
    # check the special list
    slen = VEC_SIZE(spcs)
    specp = 0
    do offset = 1, slen {
      if (VEC_ELEMENT(spcs, offset) == index) {
	specp = 1
      }
    }
    if (specp == 0) {
      call pargstr("NO")
    } else {
      call pargstr("YES")
    }
  }
end
