# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  detinfo.x
# 	Author	:  tnk
# 	Date	:  03/31/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) detinfo.x -r1.2 03/31/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/28/94   tnk	corrected error message
# 	03/31/94   tnk	date and time created 94/03/31 13:59:27 by tnk
# H-
# 
#

# @(#)detinfo.x	1.2 7/28/94 UCB CEA EGO

include <tbset.h>

# from "detector" reference table
define DETNAME_COLNAME        "name"
define DETNUM_COLNAME         "tif_number"
define SRCREG_COLNAME         "source_region"

#------------------------------------------------------
# lookup detector name in detector table, return detector number
#  and source region
# name search is case insensitive
# returns det_num as -1 if fails to find name
#
procedure detinfo(tp,det_name,det_num,src_region)
pointer tp               #I   table pointer
char    det_name[ARB]    #I   detector name
int     det_num          #O   detector number
int     src_region       #O   source region (quadrant)

# LOCAL VARS
pointer detname_cp       # detector name column pointer
pointer detnum_cp        # detector number column pointer
pointer srcreg_cp        # detector number column pointer
int     nrows            # number of rows
int     row              # current row no.
pointer text
pointer sp
pointer uc_detname

# FUNCTIONS
int     tbpsta()
bool    streq()

begin

  call smark(sp)
  det_num = -1

  # convert incoming detector name to uppercase
  call salloc(uc_detname, SZ_LINE, TY_CHAR)
  call strcpy(det_name, Memc[uc_detname], SZ_LINE)
  call strupr(Memc[uc_detname])

  # get column pointers
  call tbcfnd (tp, DETNAME_COLNAME, detname_cp, 1) 
  call tbcfnd (tp, DETNUM_COLNAME,  detnum_cp, 1)  
  call tbcfnd (tp, SRCREG_COLNAME,  srcreg_cp, 1)  
  if (detname_cp == NULL || detnum_cp == NULL || srcreg_cp == NULL) {
    call error(650,"detinfo: Could not find columns in detector file")
  }

  # go down each row in table, look for detector name
  call salloc(text, SZ_LINE, TY_CHAR)
  n_rows = tbpsta (tp, TBL_NROWS)
  for (row=1; row <=n_rows; row=row+1) {

     # get detector name
     call tbegttn(tp, detname_cp, row, Memc[text], SZ_LINE)
     call strupr(Memc[text])

     # if match, get detector number & get out
     if (streq(Memc[uc_detname],Memc[text])) {
        call tbegti(tp, detnum_cp, row, det_num)
        call tbegti(tp, srcreg_cp, row, src_region)
        break
     }
  }

  call sfree(sp)

end


