# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  rd_qbounds.x
# 	Author	:  tnk
# 	Date	:  03/23/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) rd_qbounds.x -r1.2 03/23/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	03/25/94   tnk	converted effexp to use df
# 	03/23/94   tnk	date and time created 94/03/23 17:08:05 by tnk
# H-
# 
#

# @(#)rd_qbounds.x	1.2 3/25/94 UCB CEA EGO

include <tbset.h>

# from "detector" reference table
define  TIFNUM_COLNAME         "tif_number"
define  PRIMB_TYPE_COLNAME     "primbsch_type"
define  PRIMB_X_Y1_COLNAME     "primbsch_x_y1"
define  PRIMB_Y_Y2_COLNAME     "primbsch_y_y2"
define  PRIMB_Y3_COLNAME       "primbsch_y3"

#------------------------------------------------------
# reads primbsch quadrant boundaries from detector ref table
#
bool procedure rd_qbounds(tp,det_num,bound_type,bound_x_y1,bound_y_y2,
bound_y3)      #LOCAL

pointer tp               #I   table pointer
int det_num              #I   detector number
int bound_type           #O   boundary type
int bound_x_y1           #O   boundaries
int bound_y_y2           #O
int bound_y3             #O

#returns true on success

# LOCAL VARS
pointer detnum_cp        # detector number column pointer
pointer x_y1_cp          # x/y1 boundary column pointer
pointer y_y2_cp          # y/y2 boundary column pointer
pointer y3_cp            # y3 boundary column pointer
pointer type_cp          # type of boundary column ptr
int     nrows            # number of rows
int     row              # current row no.
int     tab_det          # detector number from table
bool    found            # flag

# FUNCTIONS
int     tbpsta()

begin

  n_rows = tbpsta (tp, TBL_NROWS)

  # get column pointers
  call tbcfnd (tp, TIFNUM_COLNAME,     detnum_cp, 1)  # use this as det number
  call tbcfnd (tp, PRIMB_TYPE_COLNAME, type_cp,   1)
  call tbcfnd (tp, PRIMB_X_Y1_COLNAME, x_y1_cp,   1)
  call tbcfnd (tp, PRIMB_Y_Y2_COLNAME, y_y2_cp,   1)
  call tbcfnd (tp, PRIMB_Y3_COLNAME,   y3_cp,     1)

  if (detnum_cp == NULL || 
      type_cp == NULL   || x_y1_cp == NULL ||
      y_y2_cp == NULL   || y3_cp == NULL ) {
    call error(650,"Could not find ref columns for detector quadrants")
  }

     # go down each row in table, see if it matches a detector in our
     # list
     found = false

     for (row=1; row <=n_rows; row=row+1) {
        # get detector number of each row
        call tbegti(tp, detnum_cp, row, tab_det)

        if (tab_det == det_num) {

           found = true

           # get the quadrant type & boundaries
           call tbegti(tp, type_cp,  row,   bound_type)
           call tbegti(tp, x_y1_cp,  row,   bound_x_y1)
           call tbegti(tp, y_y2_cp,  row,   bound_y_y2)
           call tbegti(tp, y3_cp,    row,   bound_y3)
           break
        }
     }

     if (! found) {
        call eprintf("Error:  could not find primb quad bounds for det %d\n")
        call pargi(det_num)
     }

return(found)

end


