# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  comp_counts.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) comp_counts.x -r1.1 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/28/94   tnk	date and time created 94/04/28 14:48:01 by tnk
# H-
# 
#

include <dfset.h>

# @(#)comp_counts.x	1.1 4/28/94 UCB CEA EGO

# multiply model by effective areas to produce counts
#
procedure comp_counts(order_list,model_df,ea_df,n_ea_orders,counts_df)
int     order_list    #I  list of user requested orders (clp list)
pointer model_df      #I  model DF
pointer ea_df[ARB]    #I  array of effective area DF`s
int     n_ea_orders   #I  number of actual orders (length of ea_df)
pointer counts_df     #I/O output DF containing counts

pointer temp_df
pointer order_str           # order list as a string
pointer sp
int     i,j
int     ip
int     n_chars
int     order
int     mod_dftype

# FUNCTIONS
pointer df_open()
int     ctoi()
int     clgfil()
int     clplen()
int     df_type()

begin

   call smark(sp)
   mod_dftype = df_type(model_df)

   temp_df = df_open(mod_dftype,TY_DOUBLE,TY_DOUBLE)
   call df_pedge(temp_df,0.0d0,0.0d0)

   call salloc(order_str,SZ_LINE,TY_CHAR)

   # go thru user's order list
   for (i=1; i<= clplen(order_list); i=i+1) {
      j = clgfil(order_list,Memc[order_str],SZ_LINE)
      ip=1
      n_chars = ctoi(Memc[order_str],ip,order)

      if (n_chars == 0) {
          call eprintf("warning: invalid order number: '%s'\n")
          call pargstr(Memc[order_str])
      }
      else if (order < 1 || order > n_ea_orders) {
          call eprintf("warning: order '%d' not a valid effective area order\n")
          call pargi(order)
      }
      else {

         # multiply model flux by eff area 
         call df_rewind(model_df)
         call df_mul(model_df,ea_df[order],temp_df)

         # multiply the resulting domain by the order to determine where
         # to put counts
         call df_stretch(temp_df,double(order),temp_df)

         # divide range by order to preserve DF areas
         call df_divk(temp_df,double(order),temp_df)

         # accumulate the counts 
         if (i == 1)
            call df_mov(temp_df,counts_df)
         else
            call df_add(counts_df,temp_df,counts_df) 

         call df_reset(temp_df)
         call df_pedge(temp_df,0.0d0,0.d0)
      }
   }

   call df_free(temp_df)
   call sfree(sp)

end

