# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  llpf2pf.x
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) llpf2pf.x -r1.1 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/28/94   tnk	date and time created 94/04/28 14:48:02 by tnk
# H-
# 
#


# @(#)llpf2pf.x	1.1 4/28/94 UCB CEA EGO

include <mach.h>

# Convert linelist read in as "PF" (for convenience) into a new PF.
# Changes each line (delta fn) into a triangle function with a specified FWHM.
#
# out_pf must already exist

procedure llpf2pf(in_pf,out_pf,line_fwhm)
pointer in_pf      # input linelist as "PF"
pointer out_pf     # ouput linelist as PF
double  line_fwhm  # FWHM value of lines

double x,y

# FUNCTIONS
int    df_dgetd()

begin

   # loop thru the lines
   while ( df_dgetd(in_pf,x,y,1) != 0 ) {

      # make a triangle whose area is the same as the height of
      # the original line, by adjusting the triangle height.
      # i.e., Area=0.5*base*height, then height = 2*Area/base

      y = 2 * y / (2 * line_fwhm)

      call df_dputd(out_pf,x-line_fwhm,0.0d0,1)
      call df_dputd(out_pf,x,y,1)
      call df_dputd(out_pf,x+line_fwhm,0.0d0,1)

   }

end
