# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  specmod.cl
# 	Author	:  tnk
# 	Date	:  04/28/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) specmod.cl -r1.4 04/28/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/30/94   tnk	changed wavecol, fluxcol defaults
# 	08/30/94   tnk	fixed procedure name
# 	04/28/94   tnk	installed new specmod in place of old one
# 	04/28/94   tnk	date and time created 94/04/28 14:29:48 by tnk
# H-
# 
#


# wrapper around new specmod task

# @(#)specmod.cl	1.4 8/30/94 UCB CEA EGO

procedure specmod()

string model     {prompt="Input model"}
string wavecol   {"", prompt="Input model wavelength column"}
string fluxcol   {"", prompt="Input model flux column"}
string output    {"specmod",prompt="Basename of output files"}
bool   outtable  {no,  prompt="Produce ST table as output?"}
string detpars   {"euv$lib/swdetpars.par,euv$lib/mwdetpars.par,euv$lib/lwdetpars.par",prompt="List of detector psets"}
string refdata   {"reference/detector", prompt="Reference dataset"}
bool   linelist  {no, prompt="Is input model a linelist?"}
real   linefwhm  {1.0e-5, min=1.0e-10, prompt="FWHM of lines in linelist (angstroms)"}
bool   sampled   {yes, prompt="Is input model sampled?"}
bool   convolve  {yes, prompt="Apply convolution?"}
bool   psf       {yes, prompt="Use point spread function for convolution?"}
real   nsigma    {6, min=2, max=10, prompt="Number of sigma for convolution gaussian"}
bool   addnoise  {no, prompt="Add poisson noise?"}
int    seed      {1,  min=1, prompt="Seed for random number generator"}

begin

   string dpset
   string dlist
   int i

   dlist = detpars

   if (strlen(dlist) == 0) {
      print("Must supply detector parameter set(s)")
      bye
   }


   # pull off each element of comma separated list
   # (i.e., step thru each detector pset name)
   while (strlen(dlist) != 0) {

      # look for comma
      i = stridx(",",dlist)

      if (i == 0) {
         dpset = dlist  # grab whatever's left
         dlist = ""
      }
      else {
         dpset = substr(dlist,1,i-1)    # get first substr
         dlist = substr(dlist,i+1,strlen(dlist))  #get what's left
      }

      # call specmod main task here

      specmain(model = model,
	      wavecol = wavecol,
              fluxcol = fluxcol,
               output = output,
             outtable = outtable,
              refdata = refdata,
             linelist = linelist,
             linefwhm = linefwhm,
              sampled = sampled,
	     convolve = convolve,
                  psf = psf,
               nsigma = nsigma,
             addnoise = addnoise,
                 seed = seed,
              detpars = dpset)


   }


end

