# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  arcdist.x
# 	Author	:  tnk
# 	Date	:  12/10/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) arcdist.x -r1.1 12/10/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/10/92   tnk	date and time created 92/12/10 11:55:04 by tnk
# H-
# 
#


# T. Kilsdonk
# 8 Dec 1992
# @(#)arcdist.x	1.1 12/10/92

# Synopsis: Compute great circle distance given 2 points

# From:
#	Title	: arcdistance.c
#	Author	: Eric C. Olson
#	Date	: Nov. 30, 1989


include <math.h>

define	THRESHOLD	(10.0D0/60D0)	# * 10 arc minutes *
define	NEAR()		($1 < THRESHOLD || abs ($1 - 180D0) < THRESHOLD)

double procedure arcdist(ra1, dc1, ra2, dc2)
double	ra1  #I right ascension, point 1, in degrees
double  dc1  #I declination, point 1
double  ra2  #I right ascension, point 2, in degrees
double  dc2  #I declination, point 2


# compute arcdistance in degrees between 2 points

#LOCAL VARIABLES

double	tmp1, tmp2
double  r1,d1,r2,d2

begin

   # protect input arguments
   r1 = ra1
   r2 = ra2
   d1 = dc1
   d2 = dc2


   tmp1 = abs (r1 - r2)
   tmp2 = abs (d1 - d2)
   if (NEAR(tmp1) && NEAR(tmp2))
   {
      tmp1 = tmp1 * cos (DEGTORAD(d1))
      return sqrt (tmp1 * tmp1 + tmp2 * tmp2)
   }
   d1 = DEGTORAD(d1)
   r1 = DEGTORAD(r1)
   d2 = DEGTORAD(d2)
   r2 = DEGTORAD(r2)

   return RADTODEG (acos (sin(d1)*sin(d2)+cos(d1)*cos(d2)*cos(r1-r2)))

end


