# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  bore_radec.x
# 	Author	:  tnk
# 	Date	:  12/10/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) bore_radec.x -r1.1 12/10/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/10/92   tnk	date and time created 92/12/10 11:55:06 by tnk
# H-
# 
#


# T. Kilsdonk
# 8 Dec 1992
# @(#)bore_radec.x	1.1 12/10/92

include <math.h>


# given the spacecraft aspect, return the DSS boresight ra/dec

procedure bore_radec(asp,bore_qfor,ra,dec)

double asp[ARB]          #I aspect quaternion (w,x,y,z)
double bore_qfor[ARB]    #I boresight forward quaternion
double ra                #O right ascension (radians)
double dec               #O declination (radians)

#LOCAL VARIABLES

double qfor[4]      # The ACS to detector quaternion
double qdet[4]      # The defn of boresight
double qrev[4]      # reverse quaternion


begin

   # quaternion code stolen from mkaspect.x:
   # ---------------------------------------
   # Converts the aspect that is returned by the space craft into sky
   # coordinates. This is achived by asuming that the boresight is the z
   # axis of the detector.  The quaternion that represents this is then
   # rotated by the inverse of the the quaternion found in the reference
   # dataset. This rotation converts from detector coordinates to ACS
   # cordinates. The resulting quaternion is then rotated by the inverse
   # of the aspect quaternion that is given in the st table (input table).
   # The result is then converted to sky coordinates.
   
   # rotate aspect quaternion by boresite quaternion
   call er_qmult(asp, bore_qfor, qfor)
   call er_qinvert(qfor, qrev)

   # convert detector z into j2000 coordinates
   qdet[1] = 0
   qdet[2] = 0
   qdet[3] = 0
   qdet[4] = 1
   call er_qrotateq (qdet, qrev)

   # convert quaternion into a position in radians
   call er_qtopos (qdet, ra, dec)
   if (ra < 0) ra = ra + TWOPI

end
