# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  carsph.x
# 	Author	:  tnk
# 	Date	:  12/10/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) carsph.x -r1.3 12/10/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/21/99   bboyd	added check for INDEFD values
# 	12/17/92   tnk	added ram angle & velocity vectors
# 	12/10/92   tnk	date and time created 92/12/10 11:55:07 by tnk
# H-
# 
#


# T. Kilsdonk
# 8 Dec 1992
#
# Modified by B. Boyd on 21 Dec 1999 to check for INDEFD values
#
# @(#)carsph.x	1.3 12/21/99

# **********************************************************
# From:  dcarsph.c by John Flanagan,  11 Feb 90
# Cartesian-to-spherical converter
# ***********************************************************

include <math.h>

define EPSILON 1.0d-7

procedure carsph(x, xlong, xlat)
double x[3]    #I position vector  (Cartesian unit 3-vector)
double xlong   #O longitude (radians)
double xlat    #O latitude  (radians)

# LOCAL VARIABLES
double t

begin

if (IS_INDEFD (abs(x[1])) || IS_INDEFD (abs(x[2])))
{
  # one or more x components are INDEFD
  xlat = INDEFD
  xlong = INDEFD
}
else 
{
  t = sqrt(x[1] * x[1] + x[2] * x[2])
  if (t < EPSILON)
    {

    if (x[3] >= 0.0)
       xlat = 1.5707963D0
    else
       xlat = -1.5707693D0

    xlong = 0.0
    }
  else
    {
    xlat = atan(x[3] / t)
    xlong = atan2(x[2],x[1])
    }
}
end



