# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  greenra.x
# 	Author	:  tnk
# 	Date	:  12/10/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) greenra.x -r1.2 12/10/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/18/93   tnk	fixed m_2pi double/single function call problem
# 	12/10/92   tnk	date and time created 92/12/10 11:55:08 by tnk
# H-
# 
#


# T. Kilsdonk
# 8 Dec 1992
# @(#)greenra.x	1.2 6/18/93

# FROM:  ra2long.c by Tom Goddard

# **************************************************************
#*  Compute the ra of the Greenwich meridian for a specified modified
#*  Julian date.  The formula used is taken from The Astronomical Almanac,
#*  1988, p. L2.
#
#*  Synopsis: Compute ra of the Greenwich meridian at a specified time.
#*
#*	Usage	: The terrestial longtitude corresponding to a given right
#*		  ascension at a given time can be calculated by subtracting
#*		  off the Greenwich right ascension returned by this routine.
#*
# **************************************************************
include <math.h>

define SECONDS_PER_DAY 86400.0D0
define DAYS_PER_CENTURY 36525.0D0
define MJD_2000_JAN_1_12H 51544.5D0


double procedure greenra (mjd)
double mjd   #I modified julian date

# *** local variables ***

double day, frac, c, angle
double gmst		    #* Greenwich mean sidereal time at 0h UT on day. *
double old_angle
double M_2PI

begin

  day = double(long(mjd))    # "floor" function
  M_2PI = double(TWOPI)

  frac = mjd - day;
  c = (day - MJD_2000_JAN_1_12H) / DAYS_PER_CENTURY
  gmst = 24110.54841D0 + c * (8640184.812866D0 + c * (0.093104D0 - c * 6.2D-6))
  angle = M_2PI * (gmst / SECONDS_PER_DAY + frac)

#  angle = fmod(angle, M_2PI) + (angle < 0 ? M_2PI : 0)  # orig. C code

  old_angle = angle
  angle = mod(angle, M_2PI)
  if (old_angle < 0) {
     angle = angle + M_2PI
  }

  return(angle)

end

