# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  maglat.x
# 	Author	:  tnk
# 	Date	:  12/10/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) maglat.x -r1.1 12/10/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/10/92   tnk	date and time created 92/12/10 11:55:10 by tnk
# H-
# 
#


# T. Kilsdonk
# 8 Dec 1992
# @(#)maglat.x	1.1 12/10/92

# Convert geographic lat & long to magnetic latitude.
# From: Randy Gladstone's RG/EUVE/0473/92 paper on DS/S background count rates
# (spherical trig formula)

include <math.h>

define NMP_LAT   78.5    # north magnetic pole latitude (degrees North)
define NMP_LONG  69.1    #                     longitude (degrees West)

procedure maglat(geolong,geolat,mlat)
double geolong       #I geographic longitude (degrees)
double geolat        #I geographic latitude (degrees)
double mlat          #O magnetic lat (degrees)

# LOCAL VARIABLES

double geolong_rads  # geolong in radians
double geolat_rads   # geolat in radians
double nmplong_rads  # north mag pole longitude in radians
double nmplat_rads   # north mag pole latitude in radians
double sin_mlat      # sin of mag latitude

begin

   # convert everything to radians
   geolong_rads = DEGTORAD(geolong)
   geolat_rads  = DEGTORAD(geolat)
   nmplong_rads = DEGTORAD(NMP_LONG)
   nmplat_rads  = DEGTORAD(NMP_LAT)

   # find magnetic latitude
   sin_mlat = sin(geolat_rads) * sin(nmplat_rads) +
      cos(geolat_rads)*cos(nmplat_rads)*cos(geolong_rads + nmplong_rads)

   # return in degrees
   mlat = asin(sin_mlat)
   mlat = RADTODEG(mlat)

end
