# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  radec2ll.x
# 	Author	:  tnk
# 	Date	:  12/10/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) radec2ll.x -r1.2 12/10/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/21/99   bboyd	added check for INDEFD for both ra and dec
# 	12/10/92   tnk	date and time created 92/12/10 11:55:12 by tnk
# H-
# 
#

# T. Kilsdonk
# 8 Dec 1992
#
# Modified by B. Boyd,  21 Dec 1999, to check for INDEFD
#
# @(#)radec2ll.x	1.2 12/21/99

include <math.h>

# **********************************************
# From: radec2longlat in eng_ephembg.c
# **********************************************

# Convert ra/dec coords to long/lat

procedure radec2ll(ra,dec,geo_long,geo_lat,green_ra)
double ra        #I right ascension (radians)
double dec       #I declination (radians)
double geo_long  #O geographic longitude (degrees)
double geo_lat   #O geographic latitude (degrees)
double green_ra  #I position of greenwich meridian RA (radians)

begin

if (IS_INDEFD (ra))
{
  geo_long = INDEFD
}
else {
   geo_long = RADTODEG(ra - green_ra)   # longitude = RA - greenwich RA 
}

if (IS_INDEFD (dec))
{
  geo_lat = INDEFD
}
else {
  geo_lat = RADTODEG(dec)
}

   #  Adding in the green_RA could make the range funny. 
   #  Shift to between -180 and 180 

   if (geo_long < -180.0D0) 
      geo_long = geo_long + 360.0D0
   else if (geo_long > 180.0D0) 
      geo_long = geo_long - 360.0D0

   #

end

