# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  sunpos.x
# 	Author	:  tnk
# 	Date	:  12/10/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) sunpos.x -r1.1 12/10/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	12/10/92   tnk	date and time created 92/12/10 11:55:13 by tnk
# H-
# 
#

# T. Kilsdonk
# 8 Dec 1992
# @(#)sunpos.x	1.1  12/10/92

include <math.h>
# ************************************************************
# From:
#	Title	:  sun_position.c
#	Author	:  George C. Kaplan
#	Date	:  25 Sep 1989
#
#	Synopsis:  RA and Dec of sun for given mjd
#
#	Taken from "Low precision formulae for the Sun's coordinates
#	and the equation of time", p. C24, "The Astronomical Almanac"
#	1988
# ************************************************************

define rad    (($1) * 0.01745329251994330D0)

define  ND   (($1) - 51544.5D0)
define  ML   (rad(280.460D0 + 0.9856474D0 * ($1)))
define  MA   (rad(357.528D0 + 0.9856003D0 * ($1)))
define  OBL  (rad(23.439D0 - 0.0000004D0 * ($1)))


procedure sunpos(mjd, ra, dec)

double mjd   #I modified julian date
double ra    #O sun right ascension (radians)
double dec   #O sun declination (radians)

# *** local vars ***
double nn
double lng
double an
double ob
double range()

begin

  nn = ND(mjd)
  lng = range(ML(nn), 2.0D0 * PI)
  an = range(MA(nn), 2.0D0 * PI)
  ob = OBL(nn)

  lng = lng + rad(1.915D0) * sin(an) + rad(0.020D0) * sin(2.0D0 * an);

  ra = atan2(cos(ob) * sin(lng), cos(lng));
  dec = asin(sin(ob) * sin(lng));

end

# ************************************************************ 
# FROM: $eessrc/lib/ephemeris/astro/sex_dex.c 
# ************************************************************ 
double procedure range (v, r)
double v  #I/O
double r  #I

begin
        while (v <  0.0D0) v = v + r
        while (v >= r) v = v - r
        return (v)
end

