# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_cptabhdr.x
# 	Author	:  gareth
# 	Date	:  07/09/96
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_cptabhdr.x -r1.2 07/09/96 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/10/96   tnk	changed SCCS keywords
# 	07/09/96   gareth	date and time created 96/07/09 16:29:42 by gareth
# H-
# 
#

#
# @(#)t_cptabhdr.x	1.2 7/10/96 UCB CEA EGO
#
# T_CPTABHDR - a task to copy the header cards from a source table to
# a destination table. The header carsd are copied by the 
# hdrcpkill routine so a user can define a kill list to select 
# which header carsd not to copy.


include <tbset.h>

define NO_FILES 1

procedure t_cptabhdr ()


# define variables

pointer			sp 	# The stack pointer
pointer			srctab	# The name of the source table
pointer			desttab	# The name of the destination table
pointer			usrklst # The user specified kill list

pointer			srcptr	# The source table pointer
pointer			destptr	# The destination table pointer


# define functions

pointer	tbtopn()

begin

  # read the parameter file
  call smark(sp)
  call euclstr( srctab, "source" )
  call euclstr( desttab, "destination" )
  call euclstr( usrklst, "killlist" )

# open the source and destination tables

  srcptr = tbtopn( Memc[srctab], READ_ONLY, NULL )
  destptr = tbtopn( Memc[desttab], READ_WRITE, NULL )

  if ( srcptr == NULL || destptr == NULL ) {
    call error( NO_FILES, "Error: One or both of the input tables do not exist" )
  }

# pass  the tables to the copy routine
  call hcpkill(srcptr, "TABLE", destptr, "TABLE", Memc[usrklst])

# close all the data files

  call tbtclo( srcptr )
  call tbtclo( destptr )

  call sfree(sp)

end
