# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_cumdist.x
# 	Author	:  gareth
# 	Date	:  04/29/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_cumdist.x -r1.2 04/29/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/29/92   gareth	date and time created 92/04/29 15:20:20 by gareth
# H-
# 
#

# DATE 5/14/92
# t_cumdist
#
# INCLUDE FILES
include <imhdr.h>

# To create a cumulative distrobution image from an input image.
# The input may be 1-3D and the output is of the same dimension as
# the input.
# 1-D output pixels are the sum of the previous input pixels
# 2-D output row is the sum of the previous input rows.
#     output pixel is the sum of the previous input pixels in that 
#     position.

procedure t_cumdist()

# AUTHOR : GARETH BEVAN
# HISTORY :
#
# IMPORT VARIABLES :
# IMPORT/EXPORT VARIABLES :
# EXPORT VARIABLES :
# LOCAL VARIABLES :
pointer imp                        # The input image
pointer outim                      # The output image
pointer row                        # Pointer to a row in the image
pointer prev                       # Pointer to the previous row
pointer image_file                 # Pointer to the name of the input file
pointer output_file                # Pointer to the name of the output file
pointer outrow                     # The output row ( answer )
int num_dim                        # The number of dimensions of the images
int i,j                            # Loop variable

# FUNCTIONS :
pointer immap()
pointer imgl1i()
pointer imgl2i()
pointer impl1i()
pointer impl2i()
#############################################################################

begin
  # allocate memory
  call malloc( image_file, SZ_LINE, TY_CHAR )
  call malloc( output_file, SZ_LINE, TY_CHAR )
  
       
  # Read input parameters
  call clgstr( "input", Memc[image_file], SZ_LINE )
  call clgstr( "output", Memc[output_file], SZ_LINE )

  imp = immap( Memc[image_file], READ_ONLY, 0 )
  outim = immap( Memc[output_file], NEW_COPY, imp )
  IM_PIXTYPE( outim ) = TY_INT
  
  num_dim = IM_NDIM( imp )
  
  # Calculate cumulative distrobution
  switch( num_dim )
  {
  case 1 :
    call malloc( outrow, IM_LEN( imp, 1 ), TY_INT )
    row = imgl1i( imp )
    
    # deal with first element
    Memi[outrow] = Memi[row]

    # deal with the rest of the line
    for ( i=1; i<IM_LEN( imp, 1 ); i=i+1 )
    {
      Memi[outrow+i] = Memi[outrow+i-1] + Memi[row+i]
    }
    call amovi( Memi[outrow], Memi[impl1i( outim )], IM_LEN( imp, 1 ) )
    
  case 2 :
    call malloc( outrow, IM_LEN( imp, 1 ), TY_INT )
    call malloc( prev, IM_LEN( imp, 1 ), TY_INT )
    
    # deal with first line
    row = imgl2i( imp, 1 )
    for ( i=0; i<IM_LEN( imp, 1 ); i=i+1 )
    {
      Memi[outrow+i] = Memi[row+1]
    }
    call amovi( Memi[outrow], Memi[impl2i( outim, 1 )], IM_LEN( imp, 1 ) )

    # deal with the other rows
    prev = row
    for ( j=2; j<=IM_LEN( imp, 2 ); j=j+1 )
    {
      row = imgl2i( imp, j )
      for ( i=0; i<IM_LEN( imp, 1 ); i=i+1 )
      {
	Memi[outrow+i] = Memi[prev+i] + Memi[row+i]
      }
      prev = outrow
      call amovi( Memi[outrow], Memi[impl2i( outim, j )], IM_LEN( imp, 1 ) )
    }	    

  default:
    call printf("Wrong number of dimensions")
    return
      
  }


  call mfree( row, TY_INT )
  call mfree( prev, TY_INT )
  call mfree( outrow, TY_INT )
  call imunmap( imp )
  call imflush( outim )
  call imunmap( outim )

    
    

end  # OF PROCEDURE <>
