# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  ectoeq.x
# 	Author	:  akeith
# 	Date	:  05/15/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) ectoeq.x -r1.2 05/15/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/12/94   tnk	replaced cosd, sind, atand calls with radian equivalents
# 	05/15/92   akeith	date and time created 92/05/15 10:55:53 by akeith
# H-
# 
#

# ECTOEQ -- Convert ecliptic coordinates to equatorial coordinates. -- revised 4/12/94

include	<mach.h>
include <math.h>

procedure ectoeq (ec_long, ec_lat, year, ra, dec)

double	ec_long	# Ecliptic longitude (degrees)
double	ec_lat	# Ecliptic latitude (degrees)
double	year	# Epoch of input coordinates
double	ra		# Right ascension (hours)
double	dec		# Declination (degrees)

double rar, x, y, z, r, phi, obec

begin
  obec = 23.439291D0 - 0.013004D0 * (year - 2000.D0)/100.D0

  x = cos(DEGTORAD(ec_lat)) * cos(DEGTORAD(ec_long))
  y = cos(DEGTORAD(obec)) * cos(DEGTORAD(ec_lat)) * sin(DEGTORAD(ec_long)) - 
      sin(DEGTORAD(obec)) * sin(DEGTORAD(ec_lat))
  z = sin(DEGTORAD(obec)) * cos(DEGTORAD(ec_lat)) * sin(DEGTORAD(ec_long)) + 
      cos(DEGTORAD(obec)) * sin(DEGTORAD(ec_lat))

  r = sqrt(x*x + y*y)
  if (r < EPSILOND) {
    if (abs(z) < EPSILOND) {
      dec = 0.D0
	}
    else if (z > 0.D0) {
	  dec = 90.D0
	}
    else {
	  dec = -90.D0
	}
  }
  else {
	dec = RADTODEG(atan(z/r))
  }

  if (abs(x) < EPSILOND && abs(y) < EPSILOND) {
	rar = 0.D0
  }
  phi = 2.D0 * RADTODEG(atan(y/(abs(x) + r)))
  if (x < 0.D0) {
	rar = 180.D0 - phi
  }
  else if (y < 0.D0) {
	rar = 360.D0 + phi
  }
  else {
	rar = phi
  }

  ra = rar / 15.D0

end






