# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_euvhclean.x
# 	Author	:  tnk
# 	Date	:  04/08/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_euvhclean.x -r1.1 04/08/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	04/08/94   tnk	date and time created 94/04/08 09:59:38 by tnk
# H-
# 
#


include <imhdr.h>
include <imio.h>

# @(#)t_euvhclean.x	1.1 4/8/94 UCB CEA EGO

# EUVE image header cleaner
# kill any header cards whose names match the NAME_LIST,
# or whose value matches the VALUE_LIST

define NAME_LIST "NAXES AXLEN? BLOCKFAC QPFILT?? XS-EVENT XS-SORT DEFATTR? DEFFILT?"

define VALUE_LIST "macro[ opaque[ event[ '] event type'"

#------------------------------------------------------
procedure t_euvhclean()

pointer in_file    # name of input file
pointer sp
pointer in_fp      # input file pointer
pointer immap()

begin

   call smark(sp)

   # input parameters
   call eu_clstr(in_file,  "input")

   in_fp = immap(Memc[in_file], READ_WRITE, 0)
   call hkill(in_fp, NAME_LIST, VALUE_LIST)
   call imunmap(in_fp)

   call sfree(sp)

end


#----------------------------------------------------------------------
# delete those header cards from an IRAF image that
# match the name_kill or value_kill lists
#
procedure hkill(in_fp, name_kill, value_kill)
pointer in_fp           #I/O  opened input file
char    name_kill[ARB]  #I   string of kill patterns (by name)
char    value_kill[ARB] #I   string of kill patterns (by value)

pointer sp
pointer parmname   # parameter name
pointer parmval    # parameter value
pointer list       # list of symbols in image

# FUNCTIONS
pointer im_ofnlu()
int     im_gnfn()
bool    match_list()
bool    match_value()

begin

   call smark(sp)
   call salloc(parmname,   SZ_FNAME, TY_CHAR)
   call salloc(parmval,   SZ_LINE, TY_CHAR)

   list = im_ofnlu (in_fp, "*")
   while (im_gnfn (list, Memc[parmname], SZ_FNAME) != EOF) {

      call imgstr (in_fp, Memc[parmname], Memc[parmval], SZ_LINE)

      # pull each pattern out of kill list & compare against parm_name
      # and parm value
      if ( match_list(name_kill,Memc[parmname]) || 
           match_value(value_kill,Memc[parmval] ) )
      {
         # delete it
         call imdelf(in_fp, Memc[parmname])
      }   
   }

   call sfree(sp)

end


#-------------------------------------------------------------
# Returns true if target matches one of the patterns in list_str.
# Match is case-insensitive.
# This is an unanchored match.
# The patterns in list_str can have single char wildcards (i.e. '?')
#

bool procedure match_value(list_str, target)
char list_str[ARB]     #I space separated list of patterns (including '?')
char target[ARB]       #I target to match to list

bool    match
int     ip
pointer sp
pointer pattern
pointer uc_target  #uppercase

#FUNCTIONS
int ctowrd()
int strmatch()

begin

    call smark(sp)
    call salloc(pattern, SZ_LINE,  TY_CHAR)
    call salloc(uc_target, SZ_LINE,  TY_CHAR)

    call strcpy(target,Memc[uc_target],SZ_LINE)
    call strupr(Memc[uc_target])

    match=false
    ip = 1
    # pull each pattern out of match list
    while (ctowrd (list_str, ip, Memc[pattern], SZ_LINE) > 0)
    {
       # change pattern to uppercase
       call strupr(Memc[pattern])

       # unanchored match
       if (strmatch (Memc[uc_target],Memc[pattern]) != 0)
       {
          match=true
          break
       }
    }  

    call sfree(sp)

    return(match)

end
