# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  prffitbkg.x
# 	Author	:  akeith
# 	Date	:  07/05/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) prffitbkg.x -r1.3 07/05/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/07/94   akeith	new and totally improved
# 	07/05/94   akeith	date and time created 94/07/05 18:11:09 by akeith
# H-
# 
#


#	Version: @(#)prffitbkg.x	1.3 7/7/94 UCB CEA EGO

include	"prf.h"
include	<pkg/gtools.h>

define	R	Memr[($1)+($2)-1]

#
# prf_fit_bkg()
#

pointer	procedure	prf_fit_bkg(prf, dto, prof, peak, fwhm)

pointer	prf			#I
pointer	dto			#I
int	prof			#I
int	peak			#I
int	fwhm			#I

int	i			#
int	len			#
int	hi, lo			#

pointer	cv			#
pointer	sp			#
pointer	str			#
pointer	dat			#
pointer	pix			#
pointer	wgt			#

int	stat, dto_gbufr()
real	med, amedr()		#

begin

	cv = NULL
	len = PRF_HI(prf) - PRF_LO(prf) + 1

	call smark(sp)
	call salloc(str, SZ_LINE, TY_CHAR)
	call salloc(dat, len, TY_REAL)
	call salloc(pix, len, TY_REAL)
	call salloc(wgt, len, TY_REAL)

	stat = dto_gbufr(dto, Memr[dat], len)
	do i = 1, len {
		R(pix, i) = real(i)
		R(wgt, i) = 1.0
	}
	call dto_seekg(dto, 1)

#    Fit background across profile using ICFIT.

	call prf_putic(prf, peak, fwhm)

	if (PRF_INTER(prf)) {

		if(PRF_AXIS(prf) == 1) 
			call sprintf(Memc[str], SZ_LINE, 
			     "Profile %d of %d    columns %d to %d")
		else
			call sprintf(Memc[str], SZ_LINE, 
			     "Profile %d of %d    rows %d to %d")

		call pargi(prof)
		call pargi(PRF_NP(prf))
		call pargi(PRF_X1(prf) + (prof-1)*PRF_NX(prf))
		call pargi(PRF_X1(prf) + prof*PRF_NX(prf) - 1)

		call gt_sets(PRF_GT(prf), GTTITLE, Memc[str])
		call gt_setr(PRF_GT(prf), GTXMIN, 0.0)
		call gt_setr(PRF_GT(prf), GTXMAX, real(len))

		hi = peak - 2*fwhm
		lo = hi - 2*fwhm
		if(hi < 1) hi = 1
		if(lo < 1) lo = 1

		med = amedr(R(dat, lo), hi-lo+1)

		call gt_setr(PRF_GT(prf), GTYMIN, 0.0)
		call gt_setr(PRF_GT(prf), GTYMAX, 3.0*med)

		call icg_fit(PRF_IC(prf), PRF_GP(prf), "cursor", PRF_GT(prf), cv,
			     Memr[pix], Memr[dat], Memr[wgt], len)

		call prf_getic(PRF_IC(prf))

	} else
		call ic_fit(PRF_IC(prf), cv, Memr[pix], Memr[dat], Memr[wgt], len, 
				 YES, YES, YES, YES)

	call sfree(sp)

	return(cv)

end


#
# prf_putic()
#

procedure	prf_putic(prf, peak, fwhm)

pointer	prf				#I
int	peak				#I
int	fwhm				#I

int	len				#
int	left_lo				#
int	left_hi				#
int	right_lo			#
int	right_hi			#

pointer	ic				#
pointer	str				#

int	strcmp()			#
int	clgeti()			#
real	clgetr()			#

begin

	ic = PRF_IC(prf)
	len = PRF_HI(prf) - PRF_LO(prf) + 1

	call eu_clstr(str, "function")
	call ic_pstr(ic, "function", Memc[str])

	call ic_puti(ic, "order",    clgeti("order") )
	call ic_puti(ic, "naverage", clgeti("naverage") )
	call ic_puti(ic, "niterate", clgeti("niterate") )
	call ic_putr(ic, "low",      clgetr("low_reject") )
	call ic_putr(ic, "high",     clgetr("high_reject") )
	call ic_putr(ic, "grow",     clgetr("grow") )

	Memc[str] = EOS
	call eu_clstr(str, "sample")
	if(Memc[str] == EOS || strcmp(Memc[str], "*") == 0) {

		left_lo = fwhm
		left_hi = peak - 5*fwhm
		if(left_hi < left_lo) left_hi = left_lo + fwhm

		right_hi = len - fwhm
		right_lo = peak + 5*fwhm
		if(right_lo > right_hi) right_lo = right_hi - fwhm

		call sprintf(Memc[str], SZ_LINE, "%d:%d,%d:%d")
		call pargi(left_lo)
		call pargi(left_hi)
		call pargi(right_lo)
		call pargi(right_hi)
	}

	call ic_pstr(ic, "sample", Memc[str])
	call ic_putr(ic, "xmin", 0.0)
	call ic_putr(ic, "xmax", real(len))
	call ic_pstr(ic, "xlabel", "Pixel")
	call ic_pstr(ic, "ylabel", "Counts")

end


#
# prf_getic()
#

procedure	prf_getic(ic)

pointer	ic				#I

pointer	str				#

int	ic_geti()
real	ic_getr()

begin

	call salloc(str, SZ_LINE, TY_CHAR)

	call ic_gstr(ic, "function", Memc[str], SZ_LINE)
	call clpstr("function", Memc[str])

	call ic_gstr(ic, "sample", Memc[str], SZ_LINE)
	call clpstr("sample", Memc[str])

	call clputi("order",       ic_geti(ic, "order") )
	call clputi("naverage",    ic_geti(ic, "naverage") )
	call clputi("niterate",    ic_geti(ic, "niterate") )
	call clputr("low_reject",  ic_getr(ic, "low") )
	call clputr("high_reject", ic_getr(ic, "high") )
	call clputr("grow",        ic_getr(ic, "grow") )

end

