# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  prfgband.x
# 	Author	:  akeith
# 	Date	:  07/05/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) prfgband.x -r1.3 07/05/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/07/94   akeith	new and totally improved
# 	07/05/94   akeith	date and time created 94/07/05 18:11:10 by akeith
# H-
# 
#



#	Version: @(#)prfgband.x	1.3 7/7/94 UCB CEA EGO

include	<imhdr.h>
include	<imio.h>
include	<mwset.h>

#
# prf_gband()
#

procedure	prf_gband(im, band)

pointer	im			#I image
int	band			#O logical band number

int	ndim, mw_stati()	#

pointer	sp			#
pointer	wrld, lgcl		#

pointer i_mw, mw_openim()	# mwcs

begin

	if(IM_NDIM(im) == 2) {
		band = 1
		return
	} else if(IM_NDIM(im) != 3)
		call error(1, "Image must be 2 or 3 dimensions.")

	i_mw = mw_openim(im)

	ndim = mw_stati(i_mw, MW_NPHYSDIM)
	if(ndim < 3) {
		call error(1, "Not enough dimensions in mwcs.")
	}

	call smark(sp)
	call salloc(wrld, ndim, TY_REAL)
	call salloc(lgcl, ndim, TY_REAL)

	call amovkr(1.0, Memr[wrld], ndim)
	Memr[wrld+2] = band

	call wl_ctranr(i_mw, "physical", Memr[wrld], Memr[lgcl], ndim)
	band = Memr[lgcl+2]

	call sfree(sp)
	call mw_close(i_mw)

	if(band > 1 && IM_NDIM(im) < 3)
		call error(1, "Bad spectral band number.")
	else if(band > IM_LEN(im, 3))
		call error(1, "Spectral band number out of range.")

end

