# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  prfgbounds.x
# 	Author	:  akeith
# 	Date	:  07/05/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) prfgbounds.x -r1.3 07/05/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/07/94   akeith	new and totally improved
# 	07/05/94   akeith	date and time created 94/07/05 18:11:11 by akeith
# H-
# 
#


#	Version: @(#)prfgbounds.x	1.3 7/7/94 UCB CEA EGO

include	"prf.h"

#
# prf_gbounds() reads the profile boundry parameters.
#	x1 and nx are the only values used.
#

procedure	prf_gbounds(prf, ncol)

pointer	prf				#I
int	ncol				#I

int	x1				#
int	x2				#
int	nx				#
int	nprof				#

int	clgeti()

begin

	nprof = clgeti("nprofiles")
	x1 = clgeti("x1")
	x2 = clgeti("x2")
	nx = clgeti("nx")

	if(nprof < 1)
		call error(1, "nprofiles parameter must be greater then zero.")

	if (IS_INDEFI(x1)) {
		if (IS_INDEFI(x2)) {
			call error(1, " One of x1 or x2 must be set.")
		} else {
			if (IS_INDEFI(nx)) {
				call error(1, " One of x1 or nx must be set.")
			} else {
				x1 = x2 - nprof*nx + 1
			}
		}
	} else {
		if (IS_INDEFI(x2)) {
			if (IS_INDEFI(nx)) {
				call error(1, " One of x2 or nx must be set.")
			}
		} else {
			if (IS_INDEFI(nx)) {
				nx = int(real(x2 - x1 + 1)/nprof)
			}
		}
	}

	if (x1 < 1) call error(1, "x1 parameter is less then 1.")
	if (x1 > ncol) call error(1, "x1 parameter is larger then the image columns.")

	if (nx < 1) call error(1, "nx parameter is less then 1.")
	if (nx > ncol) call error(1, "nx parameter is larger then the image columns.")

	x2 = x1 + nx*nprof - 1
	if (x2 < 1) call error(1, "x2 parameter is less then 1.")
	if (x2 > ncol) call error(1, "x2 parameter is larger then the image columns.")

	PRF_X1(prf) = x1
	PRF_NX(prf) = nx
	PRF_NP(prf) = nprof

end

