# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  prfgpeak.x
# 	Author	:  akeith
# 	Date	:  07/05/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) prfgpeak.x -r1.4 07/05/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/12/94   akeith	enhanced peak detection
# 	07/07/94   akeith	new and totally improved
# 	07/05/94   akeith	date and time created 94/07/05 18:11:12 by akeith
# H-
# 
#


#	Version: @(#)prfgpeak.x	1.4 7/12/94 UCB CEA EGO

include	"prf.h"
include	<dtset.h>

#
# prf_gpeak() gets the pixel index of the peak and the
#	number of pixel in the fwhm between the low and
#	high pixel indecies.
#

bool	procedure	prf_gpeak(prf, dto, peak, fwhm)

pointer	prf			#I
pointer	dto			#I
int	peak			#O peak index
int	fwhm			#O number of pix of fwhm

int	i
real	y			#
real	avg			#
real	max			#
real	half_max		#

int	dto_gbufr()
int	len, dto_stati()

begin

     # find the peak and fwhm

	len = dto_stati(dto, DTO_NELMS_PARM)

	call prf_fnd_peak(prf, dto, avg, max, peak)

	if(peak == 1 || peak == len) return(FALSE)

	half_max = max/2.0
	if(half_max <= avg) return(FALSE)

	i = 1
	call dto_seekg(dto, peak)
	while(dto_gbufr(dto, y, 1) != 0) {
		if(y < half_max) break
		i = i + 1
	}
	call dto_seekg(dto, 1)

	fwhm = 2*i
	if(fwhm <= 4) return(FALSE)

	return(TRUE)

end


#
# prf_fnd_peak()
#

procedure	prf_fnd_peak(prf, dto, avg, max, peak)

pointer	prf			#I
pointer	dto			#I
real	avg			#O
real	max			#O
int	peak			#O

int	i
int	len
real	y

int	dto_gbufr()
int	dto_stati()

begin


	i = 0
	len = dto_stati(dto, DTO_NELMS_PARM)
	avg = 0.0
	max = -1000000000.0
	peak = i

	while(dto_gbufr(dto, y, 1) != 0) {
		i = i + 1
		avg = avg + y
		if(y > max) {
			max = y
			peak = i
		}
	}
	call dto_seekg(dto, 1)

	avg = avg/len

end

