# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  prfinterp.x
# 	Author	:  akeith
# 	Date	:  07/12/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) prfinterp.x -r1.2 07/12/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	11/03/94   akeith	fixed endless loop
# 	07/12/94   akeith	date and time created 94/07/12 17:12:39 by akeith
# H-
# 
#


#	Version: @(#)prfinterp.x	1.2 11/3/94 UCB CEA EGO

include	"prf.h"

#
# prf_interp(prf)
#

procedure	prf_interp(prf)

pointer	prf			#I

int	len
int	i, k
int	si, ei

pointer	sp
pointer	str
pointer	dto, dto1, dto2

real	x
bool	prf_indef()
pointer dt_dto()

begin

	call prf_extend(prf, 1, PRF_NP(prf), 1)
	call prf_extend(prf, PRF_NP(prf), 1, -1)

	call smark(sp)
	call salloc(str, 6, TY_CHAR)

	i = 0
	dto = NULL
	while(TRUE) {

		repeat {
			i = i + 1
			dto1 = dto
			call prf_mkname(i, str)
			dto = dt_dto(PRF_DT(prf), Memc[str])
		} until(prf_indef(dto) || i == PRF_NP(prf))

		if(i == PRF_NP(prf)) break

		si = i - 1
		while(prf_indef(dto)) {
			i = i + 1
			call prf_mkname(i, str)
			dto = dt_dto(PRF_DT(prf), Memc[str])
		}
		ei = i
		dto2 = dto

		len = ei - si
		do k = si+1, ei-1 {
			x = real(k-si)/len
			call prf_mkname(k, str)
			dto = dt_dto(PRF_DT(prf), Memc[str])
			call prf_linear(dto1, dto2, dto, x)
		}

		if(i == PRF_NP(prf)) break

	}

	call sfree(sp)

end


#
# prf_indef()
#

bool	procedure	prf_indef(dto)

pointer	dto			#I

int	stat, dto_gbufr()
real	y

begin
	stat = dto_gbufr(dto, y, 1)
	call dto_seekg(dto, 1)
	return(IS_INDEFR(y))
end


#
# prf_linear()
#

procedure	prf_linear(dto1, dto2, dto3, x)

pointer	dto1			#I
pointer	dto2			#I
pointer	dto3			#I
real	x			#I

int	stat, dto_gbufr()
real	y1, y2, y

begin

	call dto_seek(dto3, 1)
	while(dto_gbufr(dto1, y1, 1) != 0) {
		stat = dto_gbufr(dto2, y2, 1)
		y = (y2 - y1)*x + y1
		call dto_pbufr(dto3, y, 1)
	}
	call dto_seekg(dto1, 1)
	call dto_seekg(dto2, 1)

end


#
# prf_extend()
#

procedure	prf_extend(prf, lo, hi, dir)

pointer	prf			#I
int	lo			#I
int	hi			#I
int	dir			#I

int	i

real	y			#

pointer	sp			#
pointer	str			#
pointer	dt			#
pointer	dto			#
pointer	dto_org			#

int	dto_gbufr()		#
bool	prf_indef()		#
pointer dt_dto()		#

begin

	call smark(sp)
	call salloc(str, 6, TY_CHAR)

	i = lo - dir
	dt = PRF_DT(prf)

	repeat {
		i = i + dir
		call prf_mkname(i, str)
		dto = dt_dto(dt, Memc[str])
	} until(!prf_indef(dto) || i == hi)

	if(i == hi)
		call error(1, "prf_extend(): All profiles are INDEF")

	dto_org = dto
	while(i != lo) {
		i = i - dir
		call prf_mkname(i, str)
		dto = dt_dto(dt, Memc[str])
		call dto_seek(dto, 1)
		while(dto_gbufr(dto_org, y, 1) != 0)
			call dto_pbufr(dto, y, 1)
		call dto_seekg(dto_org, 1)
	}

	call sfree(sp)
end

