# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  prfmwcopy.x
# 	Author	:  akeith
# 	Date	:  07/05/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) prfmwcopy.x -r1.3 07/05/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/07/94   akeith	new and totally improved
# 	07/05/94   akeith	date and time created 94/07/05 18:11:15 by akeith
# H-
# 
#



#	Version: @(#)prfmwcopy.x	1.3 7/7/94 UCB CEA EGO

include	<mwset.h>

#
# prf_mwcopy()
#

pointer	procedure	prf_mwcopy(mw, out, low, axis, band)

pointer	mw			#I input mwcs
pointer	out			#I output image
int	low			#I lower aperture
int	axis			#I spectral dispersion axis
int	band			#I spectral band

double	tmp_d			#
double	w1, w2

pointer sp			# stack
pointer	r, w, cd		# mwcs elements

int	ndim, mw_stati()
pointer	o_mw, mw_openim()	#

begin

	if(mw == NULL) return(NULL)
	if(out == NULL) return(NULL)

	call lw_c2trand(mw, "world", double(low), double(low), w1, w2)

	ndim = mw_stati(mw, MW_NPHYSDIM)

	call smark(sp)
	call salloc(r,  ndim, TY_DOUBLE)
	call salloc(w,  ndim, TY_DOUBLE)
	call salloc(cd, ndim*ndim, TY_DOUBLE)

	o_mw = mw_openim(out)
	call mw_newsystem(o_mw, "world", 2)

	if(axis == 1) {

		call mw_gwtermd(mw, Memd[r], Memd[w], Memd[cd], ndim)
		Memd[cd] = Memd[cd]; Memd[cd+1] = Memd[cd+1];
		Memd[cd+2] = Memd[cd+ndim]; Memd[cd+3] = Memd[cd+ndim+1];
		Memd[w+1] = w2
		call mw_swtermd(o_mw, Memd[r], Memd[w], Memd[cd], 2)

		call prf_attrs_cpy(mw, o_mw, "label", 1, 1)
		call prf_attrs_cpy(mw, o_mw, "label", 2, 2)
		call prf_attrs_cpy(mw, o_mw, "wtype", 1, 1)
		call prf_attrs_cpy(mw, o_mw, "wtype", 2, 2)
		call prf_attrs_cpy(mw, o_mw, "units", 1, 1)
		call prf_attrs_cpy(mw, o_mw, "units", 2, 2)

	} else {

		call mw_gwtermd(mw, Memd[r], Memd[w], Memd[cd], ndim)
		tmp_d = Memd[r];  Memd[r]  = Memd[r+1];  Memd[r+1]  = tmp_d
		tmp_d = Memd[w];  Memd[w]  = Memd[w+1];  Memd[w+1]  = tmp_d

		Memd[cd] = Memd[cd]; Memd[cd+1] = Memd[cd+1];
		Memd[cd+2] = Memd[cd+ndim]; Memd[cd+3] = Memd[cd+ndim+1];

		tmp_d = Memd[cd]; Memd[cd] = Memd[cd+3]; Memd[cd+3] = tmp_d
		Memd[w+1] = w1
		call mw_swtermd(o_mw, Memd[r], Memd[w], Memd[cd], 2)

		call prf_attrs_cpy(mw, o_mw, "label", 1, 2)
		call prf_attrs_cpy(mw, o_mw, "label", 2, 1)
		call prf_attrs_cpy(mw, o_mw, "wtype", 1, 2)
		call prf_attrs_cpy(mw, o_mw, "wtype", 2, 1)
		call prf_attrs_cpy(mw, o_mw, "units", 1, 2)
		call prf_attrs_cpy(mw, o_mw, "units", 2, 1)

	}

	call mw_saveim(o_mw, out)
	call mw_close(o_mw)

	call sfree(sp)

	o_mw = mw_openim(out)
	return(o_mw)

end


#
# prf_attrs_cpy()
#

procedure	prf_attrs_cpy(i_mw, o_mw, attr, i_ax, o_ax)

pointer	i_mw			#I input mwcs
pointer	o_mw			#I output mwcs
char	attr[ARB]		#I attribute
int	i_ax			#I input axis
int	o_ax			#I output axis

pointer sp, str

begin
	call smark(sp)
	call salloc(str, SZ_LINE, TY_CHAR)
	iferr(call mw_gwattrs(i_mw, i_ax, attr, Memc[str], SZ_LINE)) {
		call sfree(sp)
		return
	}
	call mw_swattrs(o_mw, o_ax, attr, Memc[str])
	call sfree(sp)
end

