# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  prfmwcs.x
# 	Author	:  akeith
# 	Date	:  07/05/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) prfmwcs.x -r1.3 07/05/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	07/07/94   akeith	new and totally improved
# 	07/05/94   akeith	date and time created 94/07/05 18:11:16 by akeith
# H-
# 
#



#	Version: @(#)prfmwcs.x	1.3 7/7/94 UCB CEA EGO

include	"prf.h"
include	<imhdr.h>
include	<imio.h>

#
#    Construct WCS for output image.
#
#      axis 1 - logical coords are adjusted for scale factor
#               extraction prog. will look up profile by world coord.
#
#      axis 2 - phys = logical, world coord. are reset to a system with
#               zero at the center of the input image.  Extraction routine
#               will look up by line relative to aperture center.
#

procedure	prf_mwcs(prf, in, out, band, name)

pointer	prf			#I mkprofile structure
pointer	in			#I input image
pointer	out			#I output image
int	band			#I spectral band
char	name[ARB]		#I input filename

real	scale			# scale of profile mwcs to org. image 

pointer	i_mw, mw_openim()
pointer	mw, prf_mwcopy()

begin

	scale = 1.0/PRF_NX(prf)

	i_mw = mw_openim(in)
	mw = prf_mwcopy(i_mw, out, PRF_LO(prf), PRF_AXIS(prf), band)
	call mw_close(i_mw)

	call mw_shift(mw, real(-PRF_X1(prf)+1), 1)
	call mw_scale(mw, scale, 1)
	call mw_shift(mw, 0.5-scale/2.0, 1)

	call mw_saveim(mw, out)
	call mw_close(mw)

	call strcat("Created by mkprofile from ", IM_HISTORY(out), SZ_IMHIST)
	call strcat(name, IM_HISTORY(out), SZ_IMHIST)
	call strcat("\n", IM_HISTORY(out), SZ_IMHIST)

end

