# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_qpdup.x
# 	Author	:  tnk
# 	Date	:  10/02/95
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_qpdup.x -r1.10 10/02/95 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/08/97   bboyd	commented out unused private include files
# 	02/22/97   tnk	added addhist boolean param
# 	01/13/97   tnk	pulled out add_qp_hist routine
# 	01/13/97   tnk	changed from qpl_open_filtered to qpofilt
# 	12/12/96   tnk	took out newline separator from history
# 	10/03/95   tnk	rm mkindex, added auto index check
# 	10/03/95   tnk	added mkindex
# 	10/02/95   tnk	adjusted bucket length
# 	10/02/95   tnk	changed param names, put in "" for the event list
# 	10/02/95   tnk	date and time created 95/10/02 16:22:07 by tnk
# H-
# 
#

#	@(#)t_qpdup.x	1.10 9/8/97 UCB CEA EGO

include	<qpioset.h>
# unused private include files
# include <qpoe$qpoe.h>
# include <qpoe$qpio.h>
include <qpset.h>

# duplicate a qpoe, filtering as requested

define BUFFSIZE 8192

procedure	t_qpdup()

# input params
pointer	infile		 # input filename
pointer outfile		 # output filename
bool    addhist		 # add history (yes/no)

#local vars
pointer		inqp, inqpio	# QPOE pointers
pointer		outqp, outqpio	# QPOE pointers
int		maskval
pointer		ev[BUFFSIZE]	# event pointer
pointer		sp
int		nev
pointer		mwcs
int		bucketlen
int		indexlen
pointer 	hist

int		qpio_getevents()
pointer		qp_open()
pointer		qpio_open()
pointer		qp_loadwcs()
int		qpio_stati()
bool		clgetb()

begin

  call smark(sp)

  call eu_clstr(infile,     "input")    # get qpoe filename 
  call eu_clstr(outfile,     "output")    # get qpoe filename 
  addhist = clgetb("addhist")

  # open input QPOE file, filtered
  call qpofilt(inqp, inqpio, Memc[infile])

  # open output QPOE as new copy of input qpoe
  outqp = qp_open (Memc[outfile], NEW_COPY, inqp)

  # set bucket length (QPOE only, not QPIO)
  bucketlen =  qpio_stati(inqpio, QPIO_BUCKETLEN)
  bucketlen = bucketlen + 2   # adjust for QPOE/QPIO bucketlen offset
  call qp_seti(outqp, QPOE_BUCKETLEN, bucketlen)
  
  # open for qpio, note that the event list name is the default
  outqpio = qpio_open(outqp, "", NEW_FILE)

  # copy wcs
  mwcs = qp_loadwcs(inqp)
  call qp_savewcs(outqp, mwcs)
  call mw_close(mwcs)


  # add history comment
  if (addhist)
  {
     call salloc(hist, SZ_LINE, TY_CHAR)
     call strcpy("qpdup: copy of ", Memc[hist], SZ_LINE)
     call strcat(Memc[infile], Memc[hist], SZ_LINE)
     call add_qp_hist(outqp, Memc[hist])  
  }

  # copy events
  maskval = 0
  while (qpio_getevents(inqpio, ev, maskval, BUFFSIZE, nev) != EOF) {

     call qpio_putevents(outqpio, ev, nev)

  }

  # if input qpoe has an index, make one in the output qpoe
  indexlen=qpio_stati(inqpio, QPIO_INDEXLEN)
  if (indexlen > 0)
      call qpio_mkindex(outqpio, "")

  # Clean up
  call qpio_close(inqpio)
  call qp_close(inqp)

  call qpio_close(outqpio)
  call qp_close(outqp)

  call sfree(sp)
end


