# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpl_batch.x
# 	Author	:  ericco
# 	Date	:  06/17/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpl_batch.x -r1.4 06/17/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/14/97   mabbott	remove illegal QPOE private data and function dependencies
# 	07/16/93   akeith	corrected the TRUE/FALSE YES/NO problem
# 	03/24/93   akeith	changed version string
# 	06/17/92   ericco	date and time created 92/06/17 20:43:39 by ericco
# H-
# 
#

#       Version: @(#)qpl_batch.x	1.4 10/14/97 UCB CEA EGO
#	QPL_BATCH

include <qpeuv.h>
include "qpl.h"

procedure	qpl_batch(file, first)
char		file[ARB]
int		first

pointer	qp, qp_open()
pointer	qpio, qpio_open()
pointer	clmn, qpl_gclmn()

pointer	sp
pointer	ev
pointer	dd

int	maskval
int	nev
int	qpio_getevents()
int	num
char	number[20]
pointer	format
pointer	ptr
int	i
int	ip

begin
  for (ip=1; file[ip] != EOS; ip = ip + 1)
    if (file[ip] == '[')
      break
  call smark(sp)

  maskval = 0
  num = 0

  if (file[ip] == EOS) {
    qp = qp_open(file, READ_ONLY, 0)
    qpio = qpio_open(qp, "", READ_ONLY)
  } else {
    file[ip] = EOS
    qp = qp_open(file, READ_ONLY, 0)
    file[ip] = '['
    qpio = qpio_open(qp, file[ip], READ_ONLY)
  }

  call salloc(dd, LEN_EUVDDDES, TY_STRUCT)
  call qp_acquirefields (qpio, dd)

  call salloc(format, 10 + EUVDD_NFIELDS(dd) * 10, TY_CHAR)
  Memc[format] = EOS

  clmn = qpl_gclmn(dd)
  call dd_gfrmt(dd, clmn)

  do i = 0, EUVDD_NFIELDS(dd) {
    ptr = CLM_PTR(clmn+i)
    if (CLM_ON(ptr) == YES) {
      call strcat(CLM_FMT_STR(ptr), Memc[format], ARB)
    }
  }

  call strcat("\n", Memc[format], ARB)

  while (qpio_getevents(qpio, ev, maskval, 1, nev) != EOF) {
    num = num + 1
    if (num >= first) {
      call sprintf(number, ARB, "%d")
      call pargi(num)

      call printf(Memc[format])

      if(CLM_ON(CLM_PTR(clmn)) == YES) {
	call pargstr(number)
      }

      call dd_format(dd, clmn, ev)
    }
  }

  call qpio_close(qpio)
  call qp_close(qp)
  call sfree(sp)
end

