# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpl_format.x
# 	Author	:  ericco
# 	Date	:  10/29/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpl_format.x -r1.10 10/29/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/14/97   mabbott	remove illegal QPOE private data and function dependencies
# 	07/16/93   akeith	corrected the TRUE/FALSE YES/NO problem
# 	03/24/93   akeith	changed version string
# 	06/17/92   ericco	create dd_format routine
# 	04/07/92   akeith	Changed the help page to coorsp. to the commands.
# 	04/03/92   akeith	Nothing was changed.
# 	12/12/91   akeith	no
# 	10/30/91   akeith	documentation was added
# 	10/29/91   ericco	date and time created 91/10/29 15:09:52 by ericco
# H-
# 
#

#       Version: @(#)qpl_format.x	1.10 10/14/97 UCB CEA EGO


include <qpeuv.h>
include "qpl.h"

#	Obtains the format for each column of the data field.
#

procedure	qpl_format(qpl, clmn, ev)

pointer		qpl			#I The main structure
pointer		clmn			#I structure column info
pointer		ev			#I event pointer

begin
  call dd_format(QPL_DD(qpl), clmn, ev)
end

procedure	dd_format(dd, clmn, ev)

pointer		dd			#I data descriptor
pointer		clmn			#I structure column info
pointer		ev			#I event pointer

int		i			# index
int		offset			# data descriptor offset
int		dtype			# data type

pointer		coerce()

begin

	do i = 1, EUVDD_NFIELDS(dd) {

		offset = EUVDD_FOFFSET(dd,i)
		dtype = EUVDD_FTYPE(dd,i)

		if(CLM_ON(CLM_PTR(clmn+i)) == YES){

			switch (dtype) {

			  case TY_SHORT:
				call pargs(Mems[coerce(ev,TY_SHORT,dtype)+offset])
			  case TY_INT:
				call pargi(Memi[coerce(ev,TY_SHORT,dtype)+offset])
			  case TY_LONG:
				call pargl(Meml[coerce(ev,TY_SHORT,dtype)+offset])
			  case TY_REAL:
				call pargr(Memr[coerce(ev,TY_SHORT,dtype)+offset])
			  case TY_DOUBLE:
				call pargd(Memd[coerce(ev,TY_SHORT,dtype)+offset])
			}
		}
	}

end

