# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpl_gbckt.x
# 	Author	:  ericco
# 	Date	:  10/29/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpl_gbckt.x -r1.8 10/29/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/14/97   mabbott	remove illegal QPOE private data and function dependencies
# 	03/24/93   akeith	changed version string
# 	04/07/92   akeith	Changed the help page to coorsp. to the commands.
# 	04/03/92   akeith	All debug fprintf statements where removed.
# 	12/12/91   akeith	no
# 	10/30/91   akeith	documentation was added
# 	10/29/91   ericco	date and time created 91/10/29 15:09:53 by ericco
# H-
# 
#

#       Version: @(#)qpl_gbckt.x	1.8 10/14/97 UCB CEA EGO


include "qpoe$qpio.h"
include "qpl.h"

#	Reads in a new bckt into memory and sets the evs (event structure)
#		array. 
#	This is done by:
#	1) Init's qpio_getevents by calling it once.
#	2) Calls qpio_rbucket to read in the bucket containing current event.
#	3) Checks if the bucket number is EOF when current event doesn't exist.
#	4) Init's the evs array zero
#	5) Reads in events one by one from the top of the bucket placing 
#		the event pointer in its respective place in the evs array
#		corresponding the its place in the bucket. This leaves zeros
# 		in the evs array for those events filtered out.
#
#	  qpl_gbckt() return the current bucket number.
#

int procedure   qpl_gbckt(qpl)

pointer		qpl				#I/O The main structure

pointer		io				# file ptr
pointer         evs                             # stack ptr
int             evi                             # event index

int		nev_red				# number of events read
bool		done

pointer		ev				# event pointer assigned by
						#   qpio_getevents()
int		maskval

int		qpio_rbucket()

begin

	io = QPL_IO(qpl)	# set for convenence.
	evi = QPL_EVI(qpl)
	evs = QPL_EVS(qpl)

	done = false

#   init qpio_getevents()

	call qpio_getevents(io, ev, maskval, 1, nev_red)

	QPL_CURBK(qpl) = qpio_rbucket(io,evi)

	if(QPL_CURBK(qpl) == EOF)
		return QPL_CURBK(qpl)

#   clear evs to zeros

	call aclri(Memi[evs], QPL_EVSLN(qpl))

#   fill the evs array

	IO_EVI(io) = IO_BKFIRSTEV(io)

	repeat{

		# Read in one event at a time.

		call qpio_getevents(io, ev, maskval, 1, nev_red)

		# If we haven't read passed the current bucket, put the event
		#	in its place in evs which corresponds to its
		#	place in the bucket.

		if(QPL_CURBK(qpl) == IO_BKNO(io) && nev_red == 1){
			Memi[evs + IO_EVI(io) - 1 - IO_BKFIRSTEV(io)] = ev
		} else {
			QPL_CURBK(qpl) = qpio_rbucket(io, evi)
			done = TRUE
		}

	} until(done)

	return QPL_CURBK(qpl)

end

