# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpl_ghead.x
# 	Author	:  akeith
# 	Date	:  04/03/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpl_ghead.x -r1.8 04/03/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/14/97   mabbott	remove illegal QPOE private data and function dependencies
# 	05/18/94   tnk	fixed macro buffer size problem
# 	03/24/93   akeith	changed version string and the way matches are made between the macros and the column names.
# 	04/07/92   akeith	put in the revision line at the top of the file.
# 	04/07/92   akeith	Changed the help page to coorsp. to the commands.
# 	04/03/92   akeith	date and time created 92/04/03 15:57:40 by akeith
# H-
# 
#

#       Version: @(#)qpl_ghead.x	1.8 10/14/97 UCB CEA EGO

include <qpset.h>
include <qpeuv.h>
include "qpl.h"

#	This procedure opens and reads the qpoe file's field name
#		list. In the process, it gets the number of parameters
#		in the list and gets, one after the other, each of the
#		parameters using qp_quaryf() which returns the datatype, 
#		the maxelem, the comment, some flag and the vector length
#		of the parameter which I don't care about. I'm only concerned
#		with the data type. If it is of TY_MACRO, I want to know what
#		that macro represents in terms of a char string. This is then
#		compaired with each of the column names, so the column names
#		may be replaced with their macro names in the header.
#
#	This is done by getting parameter name, parmstr, then 
# 		getting all the info about the param, i.e., the
#		vctlen, datatype, maxelem, comment, flag. Then
#		ask is the datatype a macro? If it is get the
#		buffer and the number of elements in the buffer,
#		i.e. buf and nelem. The buf should hold the name
#		of the column. Now look for a match between what's
#		in the buf and all names of the columns. If we
#		get a match, store the paramstr as the columns
#		macro name.
#
 
procedure	qpl_ghdr(qpl,clmn)

pointer         qpl                             #I The main structure
pointer		clmn				#I/O The column structure

pointer		qp				# reference file pointer
pointer		fl				# ptr to field name list struct.
pointer		ptr

pointer		qp_ofnlu()			# opens field name list
pointer		qp_gnfn()			# gets next param in list
pointer		qp_lenfnl()			# gets number of param list

int		qp_queryf()			# gets info describ param
int		qp_read()			# read elem. from a param
int		qp_dtypeeuv()			# trans symb datatype to type code 

int		qpl_match()			# match param with column

char		parmstr[MAXCHARS]		# param name str
char		buf[MAXCHARS]			# data buffer for param. read

char		datatype[SZ_DATATYPE]		# parameter data type
int		maxelem				# allocated length of parameter
char		comment[SZ_COMMENT]		# comment describing parameter
int		flags				# parameter flag word

int		i
int		indx
int		fnllen				# num of params
int		numchar				# num char in param name
int		nelem				# num elem. in param
int		vctlen				# vect lngth of param

begin

	qp = QPL_QP(qpl)

	fl = qp_ofnlu(qp, EOS)		# get file list descriptor

	fnllen = qp_lenfnl(fl)		# get the number of parameters

	do i = 1, fnllen {

		numchar = qp_gnfn(fl, parmstr, MAXCHARS)    

		vctlen = qp_queryf(qp, parmstr, datatype, maxelem, comment, flags)

		if(qp_dtypeeuv(qp, datatype) == TY_MACRO){

			maxelem = min(maxelem,MAXCHARS)

			nelem = qp_read(qp, parmstr, buf, maxelem, 1, datatype)

			buf[nelem+1] = EOS

			indx = qpl_match(qpl, clmn, buf, nelem)
			if(indx > 0) {
				ptr = CLM_PTR(clmn+indx)
				call strcpy(parmstr, CLM_MAC_STR(ptr), numchar)
				CLM_MAC_LNG(ptr) = numchar
			} 

		}

	}

	call qp_cfnl(fl)	# closes field name list, includes mfree()

end


#	Contained within buf is the char. string which the macro
#		represents. We want to compare this string to each
#		of the true names of the columns to see if we get
#		a match. This results in a return value of TRUE.
#


int procedure qpl_match(qpl, clmn, buf, nelem)

pointer		qpl				#I The main structure
pointer		clmn				#I/O The column structure
char		buf[SZ_LINE]			#I macro name string for param.
int		nelem				#I number of chars.

int		i
int		retval				# return value
bool		done
pointer		dd				# data descriptor

bool		streq()				# string equal

begin

	dd = QPL_DD(qpl)
	done = FALSE
	i = 1

	retval = -1

	while(!done){

		if( nelem == CLM_NAM_LNG( CLM_PTR(clmn+i) ) ){

			done = streq( buf, CLM_NAM_STR( CLM_PTR(clmn+i) ) )

			retval = i
		}

		i = i + 1

		if(i > EUVDD_NFIELDS(dd)) done = TRUE

	}

	return retval

end

