# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpl_move.x
# 	Author	:  ericco
# 	Date	:  10/29/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpl_move.x -r1.9 10/29/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/09/97   mabbott	changed use of IO_NEVENTS to QPL_NEVENTS; removed illegal include
# 	03/24/93   akeith	changed version string
# 	04/07/92   akeith	Changed the help page to coorsp. to the commands.
# 	04/03/92   akeith	Took out debug statements.
# 	12/12/91   akeith	no
# 	10/30/91   akeith	documentation was added
# 	10/29/91   ericco	date and time created 91/10/29 15:09:55 by ericco
# H-
# 
#

#       Version: @(#)qpl_move.x	1.9 10/9/97 UCB CEA EGO


include "qpl.h"

#	Moves the top event index the number of lines specified by how_much.
#		It takes care of situations when a new bucket needs to be read
#		in. All qpl_move() has to do is change the evs index, QPL_TPEV
#		and the correspoinding event index, QPL_EVI, the number of 
#		lines specified by how_much. However, we may cross bucket
#		boundries, in which case, we must read a new bckt, set the 
#		evs array and reset QPL_TPEV. So within the repeat-until
#		loop there are three cases, we've gone above the current bckt,
#		we've gone below the current bckt and we are within the
#		current bckt.
#

int procedure	qpl_move(qpl, how_much, maxlines, dir)

pointer		qpl			#I/O The main structure
int		how_much		#I how many lines to move
int		maxlines		#I max lines in a screen page
int		dir			#I direction UP or DOWN

#
#  QPL_TPEV:	event index of the evs structure which marks the 
#			array index shown at the top of page.
#  QPL_EVI:	actual event index shown at the top of the page.
#  QPL_EVS:	pointer to head of evs structure which contains the pointers
#			to the events which made it though the filter for the 
#			current bucket. If an event did not make it though the
#			filter a zero is put in place of the event's address. 
#			See qpl_gbck().
#
#  dir:		+1 or -1 depending on the direction of scroll
#
  
int		count 			#  counts number of unfiltered events
					#     we've gone though in the process 
					#     to compare with how_much
bool		done			#  Are we done yet?

pointer		io			# convenance
int		evs_len			# convenance

pointer		sp			# stack pointer
pointer		qpl_tmp			# tmp. copy of the structure


begin

	count = 0
	done = FALSE

	io = QPL_IO(qpl)
	evs_len = QPL_EVSLN(qpl)

#  make a temp copy of the main stucture to play with.

	call smark(sp)
	call salloc(qpl_tmp, LEN_QPLSTR, TY_STRUCT)

	QPL_IO(qpl_tmp) = QPL_IO(qpl)
	QPL_DD(qpl_tmp) = QPL_DD(qpl)
	QPL_EVS(qpl_tmp) = QPL_EVS(qpl)
	QPL_EVSLN(qpl_tmp) = QPL_EVSLN(qpl)
	QPL_EVI(qpl_tmp) = QPL_EVI(qpl) + dir
	QPL_TPEV(qpl_tmp) = QPL_TPEV(qpl) + dir
	QPL_CURBK(qpl_tmp) = QPL_CURBK(qpl)

	repeat {

	# QPL_TPEV(qpl_tmp) has gone above the current bckt.

		if(QPL_TPEV(qpl_tmp) == -1) {

			if(count == 0) {

			    if(QPL_EVI(qpl_tmp) >= 1){
				call qpl_mov_bckt(qpl, qpl_tmp, UP)
			    } else done = TRUE

			} else done = TRUE

	# QPL_TPEV(qpl_tmp) has gone below the current bckt.

		} else if(QPL_TPEV(qpl_tmp) == evs_len){

			if( QPL_EVI(qpl_tmp) <= QPL_NEVENTS(qpl) )
				call qpl_mov_bckt(qpl, qpl_tmp, DOWN)

			done = TRUE

	# QPL_TPEV(qpl_tmp) is within the current bckt.

		} else {

			if( Memi[ QPL_EVS(qpl_tmp) + QPL_TPEV(qpl_tmp) ] != 0 ){

				if(count != how_much){
				   count = count + 1
				   QPL_EVI(qpl) = QPL_EVI(qpl_tmp)
				   QPL_TPEV(qpl) = QPL_TPEV(qpl_tmp)
				   QPL_CURBK(qpl) = QPL_CURBK(qpl_tmp)

				   QPL_TPEV(qpl_tmp) = QPL_TPEV(qpl_tmp) + dir
				   QPL_EVI(qpl_tmp) = QPL_EVI(qpl_tmp) + dir
				}
				else done = TRUE
			}
			else {
				QPL_TPEV(qpl_tmp) = QPL_TPEV(qpl_tmp) + dir
				QPL_EVI(qpl_tmp) = QPL_EVI(qpl_tmp) + dir
			}

		} 

	} until (done)

	call sfree(sp)

	return QPL_CURBK(qpl)

end


#	Basically deals with moving into a new bucket by using
#	qpl_topevi() to read the new bucket, set the top event
#	index and set the event number. It also deals with EOF.
#


procedure qpl_mov_bckt(qpl, qpl_tmp, dir)

pointer		qpl			#I/O The main structure
pointer		qpl_tmp			#I/O tmp. copy of the structure
int		dir			#I direction of search

int		qpl_gbckt()		# gets new bucket, ret. bckt. number
int		qpl_topevi()		# finds next unfiltered event in list
					#    ret. bckt. number
begin

	QPL_CURBK(qpl_tmp) = qpl_topevi(qpl_tmp, dir)

	if(QPL_CURBK(qpl_tmp) != EOF){

		QPL_EVI(qpl) = QPL_EVI(qpl_tmp)
		QPL_TPEV(qpl) = QPL_TPEV(qpl_tmp)
		QPL_EVS(qpl) = QPL_EVS(qpl_tmp)
		QPL_CURBK(qpl) = QPL_CURBK(qpl_tmp)

	} else QPL_CURBK(qpl) = qpl_gbckt(qpl)

end

