# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpl_topevi.x
# 	Author	:  ericco
# 	Date	:  10/29/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpl_topevi.x -r1.8 10/29/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/14/97   mabbott	remove illegal QPOE private data and function dependencies
# 	03/24/93   akeith	changed version string
# 	04/07/92   akeith	Changed the help page to coorsp. to the commands.
# 	04/03/92   akeith	All debug fprintf statements where removed.
# 	12/12/91   akeith	no
# 	10/30/91   akeith	documentation was added
# 	10/29/91   ericco	date and time created 91/10/29 15:09:55 by ericco
# H-
# 
#

#       Version: @(#)qpl_topevi.x	1.8 10/14/97 UCB CEA EGO


include "qpoe$qpio.h"
include "qpl.h"

#	This will set evi, if evi makes it through the filter or the
#		first event above or below evi to make it through the filter,
#		depending on the direction. It also sets top_evi and returns
#		the cur_bckt. If no event is above or below evi, cur_bckt will
#		be EOF and evi and top_evi will be returned unchanged.
#
#	IMPORTANT: evi, stored in QPL_EVI, MUST BE a valid event within the
#		event list!
#
#	Structure values of qpl which may be reset:
#
#	QPL_EVS()	pointer to the event array
#	QPL_EVI()	current event at top of page
#	QPL_TPEV()	current index within bucket at top of page
#	QPL_CURBK()	current bucket number
#

int procedure	qpl_topevi(qpl, dir)

pointer		qpl				#I/O The main structure
int		dir				#I direction of search

pointer		io
int		evs_len				# length of evs array

pointer		sp				# stack ptr
pointer		qpl_tmp				# tmp qpl structer

bool		done				# are we done yet?

int		qpl_gbckt()			# gets bucket containing evi

begin

	done = false				# initialize
	io = QPL_IO(qpl)
	evs_len = QPL_EVSLN(qpl)
                                        # This will get a valid
	QPL_CURBK(qpl) = qpl_gbckt(qpl)		#  bckt w/in event list b/c
						                #  evi is w/in the event list.

  # Init. top event pointer

	QPL_TPEV(qpl) = QPL_EVI(qpl) - IO_BKFIRSTEV(io) 

#  make a temp copy of the main stucture to play with.

	call smark(sp)
	call salloc(qpl_tmp, LEN_QPLSTR, TY_STRUCT)

	QPL_IO(qpl_tmp) = QPL_IO(qpl)
	QPL_DD(qpl_tmp) = QPL_DD(qpl)
	QPL_EVS(qpl_tmp) = QPL_EVS(qpl)
	QPL_EVSLN(qpl_tmp) = QPL_EVSLN(qpl)
	QPL_EVI(qpl_tmp) = QPL_EVI(qpl)
	QPL_TPEV(qpl_tmp) = QPL_TPEV(qpl)
	QPL_CURBK(qpl_tmp) = QPL_CURBK(qpl)


	while(!done){
							# Get the next bckt
		if(QPL_TPEV(qpl_tmp) == evs_len){


			QPL_CURBK(qpl_tmp) = qpl_gbckt(qpl_tmp)

			if(QPL_CURBK(qpl_tmp) == EOF) {	     # EOF condition
				call sfree(sp)
				return QPL_CURBK(qpl_tmp)
			}

			QPL_TPEV(qpl_tmp) = 0

							# Get the previous bckt
		} else if(QPL_TPEV(qpl_tmp) == -1){


			QPL_CURBK(qpl_tmp) = qpl_gbckt(qpl_tmp)

			if(QPL_CURBK(qpl_tmp) == EOF) {	    # EOF condition
				call sfree(sp)
				return QPL_CURBK(qpl_tmp)
			}

			QPL_TPEV(qpl_tmp) = evs_len - 1

		}

#
#		if the value of the event stucture array indexed by the top
#			event index equals zero then increment the top event 
#			index and the event number and continue, otherwise
#			increment the top event index and the event number 
#			and continue.
#
		if( Memi[ QPL_EVS(qpl_tmp) + QPL_TPEV(qpl_tmp) ] == 0 ){

			QPL_TPEV(qpl_tmp) = QPL_TPEV(qpl_tmp) + dir
			QPL_EVI(qpl_tmp) = QPL_EVI(qpl_tmp) + dir

		} else done = TRUE

	}

	QPL_EVS(qpl) = QPL_EVS(qpl_tmp)		# save the changes
	QPL_EVI(qpl) = QPL_EVI(qpl_tmp)
	QPL_TPEV(qpl) = QPL_TPEV(qpl_tmp)
	QPL_CURBK(qpl) = QPL_CURBK(qpl_tmp)

	call sfree(sp)

	return QPL_CURBK(qpl)

end

