# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  qpl_tty.x
# 	Author	:  ericco
# 	Date	:  10/29/91
# 	Synopsis:  
# 	Keywords:
# 		@(#) qpl_tty.x -r1.13 10/29/91 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/14/97   mabbott	remove illegal QPOE private data and function dependencies
# 	07/16/93   akeith	corrected the TRUE/FALSE YES/NO problem
# 	03/24/93   akeith	changed version string and max number of char to copy
# 	06/17/92   ericco	added dd_gfmrt routine
# 	04/07/92   akeith	Changed the help page to coorsp. to the commands.
# 	04/03/92   akeith	All debug fprintf statements where removed.
# 	12/12/91   akeith	no
# 	10/30/91   akeith	documentation was added
# 	10/29/91   ericco	date and time created 91/10/29 15:09:56 by ericco
# H-
# 
#

#       Version: @(#)qpl_tty.x	1.13 10/14/97 UCB CEA EGO


include <mach.h>
include <qpioset.h>
include <qpeuv.h>
include "qpl.h"

#	This sets up the format for the page display of the file
#		along with setting the header string to be displayed
#		at the top of the page.
#	

procedure	qpl_gfrmt(qpl, clmn)

pointer		qpl				#I The main structure
pointer		clmn				#I/O The column structure

begin
  call dd_gfrmt(QPL_DD(qpl), clmn)
end


procedure	dd_gfrmt(dd, clmn)

pointer		dd				#I data descriptor
pointer		clmn				#I/O The column structure


pointer		ptr

int		i
int		offset
int		dtype

int		sizeof()
int		strlen()

begin

	ptr = CLM_PTR(clmn+0)

	call strcpy("%11s", CLM_FMT_STR(ptr), SZ_LINE)
	CLM_FMT_LNG(ptr) = 11

	call strcpy("Event", CLM_NAM_STR(ptr), SZ_LINE)
	CLM_NAM_LNG(ptr) = strlen( CLM_NAM_STR(ptr) )

	call strcpy(CLM_NAM_STR(ptr), CLM_MAC_STR(ptr), SZ_LINE)
	CLM_MAC_LNG(ptr) = CLM_NAM_LNG(ptr)

# Do this for each of the fields.

	do i = 1, EUVDD_NFIELDS(dd) {

		offset = EUVDD_FOFFSET(dd,i)
		dtype = EUVDD_FTYPE(dd,i)

		ptr = CLM_PTR(clmn+i)

		switch (dtype) {

		  case TY_SHORT:

			call strcpy(" %10d", CLM_FMT_STR(ptr), SZ_LINE)
			CLM_FMT_LNG(ptr) = 11
			call sprintf(CLM_NAM_STR(ptr), SZ_LINE, "s%d")

		  case TY_INT:

			call strcpy(" %10d", CLM_FMT_STR(ptr), SZ_LINE)
			CLM_FMT_LNG(ptr) = 11
			call sprintf(CLM_NAM_STR(ptr), SZ_LINE, "i%d")

		  case TY_LONG:

			call strcpy(" %10d", CLM_FMT_STR(ptr), SZ_LINE)
			CLM_FMT_LNG(ptr) = 11
			call sprintf(CLM_NAM_STR(ptr), SZ_LINE, "l%d")

		  case TY_REAL:

			call strcpy(" %15.12g", CLM_FMT_STR(ptr), SZ_LINE)
			CLM_FMT_LNG(ptr) = 16
			call sprintf(CLM_NAM_STR(ptr), SZ_LINE, "r%d")

		  case TY_DOUBLE:

			call strcpy(" %15.12g", CLM_FMT_STR(ptr), SZ_LINE)
			CLM_FMT_LNG(ptr) = 16
			call sprintf(CLM_NAM_STR(ptr), SZ_LINE, "d%d")

		}

		call pargi(offset * sizeof(dtype) * SZB_CHAR)

		CLM_NAM_LNG(ptr) = strlen( CLM_NAM_STR(ptr) )

		call strcpy(CLM_NAM_STR(ptr), CLM_MAC_STR(ptr), SZ_LINE)
		CLM_MAC_LNG(ptr) = CLM_NAM_LNG(ptr)

	}


end

#	This writes both the format and header strings.
#

procedure	qpl_phdr(qpl, clmn, maxcols)

pointer		qpl				#I The main structure
pointer		clmn				#I The column structure
int		maxcols				#I part of screen for a page

pointer		tty				# tty ptr
pointer		io				# file ptr
pointer		dd				# data descriptor
pointer		format				# ptr to format string
int		map_cc				# map_cc

pointer         sp                              # stack ptr
pointer		header				# ptr to header string
pointer		head				# string used to create header
pointer		hform				# small format string
pointer		tmpstr				# tmp string

pointer		ptr				# clmn strct pointer

int		i
int		strg_ln

begin


	io = QPL_IO(qpl)
	tty = QPL_TTY(qpl)
	dd = QPL_DD(qpl)
	map_cc = QPL_MAPCC(qpl)
	format = QPL_FRMT(qpl)

	call smark(sp)
	call salloc(header, 15 + EUVDD_NFIELDS(dd) * 15, TY_CHAR)
	call salloc(head, 10, TY_CHAR)
	call salloc(hform, 10, TY_CHAR)
	call salloc(tmpstr, 10, TY_CHAR)

	Memc[format] = EOS
	Memc[header] = EOS

	strg_ln = 0

	do i = 0, EUVDD_NFIELDS(dd) {

	    ptr = CLM_PTR(clmn+i)

	    if(CLM_ON(ptr) == YES){

								# Calculate the
		strg_ln = strg_ln + CLM_FMT_LNG(ptr)		# length of header
								# string

		if(strg_ln <= maxcols){

				# Create the format string.

			call strcat(CLM_FMT_STR(ptr), Memc[format], ARB)

				# Make the header string.

			call qpl_strset(CLM_MAC_STR(ptr), Memc[head], CLM_FMT_LNG(ptr))
			call strcat(Memc[head], Memc[header], ARB)	# cancatinate


		} else {
			CLM_ON(ptr) = NO			# turn off those columns
		}						# which weren't printed

	    }

	}

	call strcat(" \n", Memc[format], ARB)
	call strcat(" \n", Memc[header], ARB)

	call ttygoto(STDOUT, tty, 1, 1)			# goto col. 1 line 1
	call ttyclearln(STDOUT, tty)
	call ttyputline (STDOUT, tty, Memc[header], map_cc)	# print header
								# to screen
        call sfree(sp)

end


#	This prints the global info to the tty.
#

procedure	qpl_pglob(qpl, clmn)

pointer		qpl				#I The main structure
pointer		clmn				#I The column structure

pointer		tty				# tty ptr
pointer		io				# file ptr
pointer		dd				# data descriptor
pointer		format				# ptr to format string
int		map_cc				# map_cc

pointer         sp                              # stack ptr
pointer		minglobal			# pointer to string
pointer		maxglobal			# pointer to string

int		qpio_stati()

begin

	io = QPL_IO(qpl)
	tty = QPL_TTY(qpl)
	dd = QPL_DD(qpl)
	map_cc = QPL_MAPCC(qpl)
	format = QPL_FRMT(qpl)

	call smark(sp)
	call salloc(minglobal, 15 + EUVDD_NFIELDS(dd) * 15, TY_CHAR)
	call salloc(maxglobal, 15 + EUVDD_NFIELDS(dd) * 15, TY_CHAR)

	call sprintf(Memc[minglobal], ARB, Memc[format])
	if(CLM_ON(CLM_PTR(clmn+0)) == YES) call pargstr("Global Min")
	call qpl_format(qpl, clmn, qpio_stati(io, QPIO_MINEVP))

	call sprintf(Memc[maxglobal], ARB, Memc[format])
	if(CLM_ON(CLM_PTR(clmn+0)) == YES) call pargstr("Global Max")
	call qpl_format(qpl, clmn, qpio_stati(io, QPIO_MAXEVP))

	call ttygoto(STDOUT, tty, 1, 2)				# goto col. 1 line 2

	call ttyso(STDOUT, tty, YES)
	call ttyclearln(STDOUT, tty)
	call ttyputline (STDOUT, tty, Memc[minglobal], map_cc)
	call ttyclearln(STDOUT, tty)
	call ttyputline (STDOUT, tty, Memc[maxglobal], map_cc)
	call ttyso(STDOUT, tty, NO)

        call sfree(sp)

end


#	This sets up the bucket info for the page display and outputs
#		the info to the tty STDOUT.
#	

#procedure	qpl_wbckt(qpl, clmn)

#pointer		qpl				#I The main structure
#pointer		clmn				#I The column structure

#pointer		tty				# tty ptr
#pointer		io				# file ptr
#pointer		dd				# data descriptor
#pointer		format				# ptr to format string
#int		map_cc				# map_cc

#pointer		sp				# stack ptr
#pointer		minbuck				# stack ptr
#pointer		maxbuck				# stack ptr

#begin

#	io = QPL_IO(qpl)
#	tty = QPL_TTY(qpl)
#	dd = QPL_DD(qpl)
#	map_cc = QPL_MAPCC(qpl)
#	format = QPL_FRMT(qpl)

#	call smark(sp)
#	call salloc(minbuck, 15 + EUVDD_NFIELDS(dd) * 15, TY_CHAR)
#	call salloc(maxbuck, 15 + EUVDD_NFIELDS(dd) * 15, TY_CHAR)

#	call ttyso(STDOUT, tty, YES)
#	call ttygoto(STDOUT, tty, 1, 4)		# goto col. 1 line 3

#	call sprintf(Memc[minbuck], ARB, Memc[format])
#	if( CLM_ON(CLM_PTR(clmn+0)) == YES ) call pargstr("Bucket Min")
### ILLEGAL ###
#	call qpl_format(qpl, clmn, IO_MINEVB(io))

#	call ttyclearln(STDOUT, tty)
#	call ttyputline (STDOUT, tty, Memc[minbuck], map_cc)
    
#	call sprintf(Memc[maxbuck], ARB, Memc[format])
#	if( CLM_ON(CLM_PTR(clmn+0)) == YES ) call pargstr("Bucket Max")
### ILLEGAL ###
#	call qpl_format(qpl, clmn, IO_MAXEVB(io))

#	call ttyclearln(STDOUT, tty)
#	call ttyputline (STDOUT, tty, Memc[maxbuck], map_cc)
    
#	call ttyso(STDOUT, tty, NO)

#        call sfree(sp)

#end

