# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  loadparms.x
# 	Author	:  tnk
# 	Date	:  08/24/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) loadparms.x -r1.2 08/24/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/13/97   mabbott	removed unneeded qpoe$ include
# 	08/24/93   tnk	date and time created 93/08/24 15:04:38 by tnk
# H-
# 
#

include <qpset.h>
include <tbset.h>


# @(#)loadparms.x	1.2 10/13/97 UCB CEA EGO

# get QPOE parameters from a special ST table
#
procedure loadparms(qp,srcdir,tabprefix,tabname,warnmsgs)
pointer qp          #I open qpoe file
char srcdir[ARB]    #I directory name
char tabprefix[ARB] #I filename prefix
char tabname[ARB]   #I input table name
bool warnmsgs       #I print warning messages

pointer tp
pointer sp
pointer fullpath
pointer tbtopn()
int     tbtacc()

begin

  call smark(sp)

  call salloc (fullpath, SZ_LINE, TY_CHAR)
  call strcpy (srcdir, Memc[fullpath], SZ_LINE)
  call strcat ("/",    Memc[fullpath], SZ_LINE)
  call strcat (tabprefix, Memc[fullpath], SZ_LINE)
  call strcat (tabname,Memc[fullpath], SZ_LINE)

  if (tbtacc(Memc[fullpath]) == NO) {
     if (warnmsgs) {
        call eprintf("Warning: Can't access QPOE parameter file '%s'\n")
        call pargstr(Memc[fullpath])
     }
  }
  else {

     # open the table
     tp = tbtopn(Memc[fullpath], READ_ONLY, 0)

     # get the QPOE parameters
     call get_parm_col(tp, qp, "QPOE_BLOCKFACTOR", QPOE_BLOCKFACTOR, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_BUCKETLEN",   QPOE_BUCKETLEN, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_CACHESIZE",   QPOE_CACHESIZE, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_DATABUFLEN",  QPOE_DATABUFLEN, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_DEBUGLEVEL",  QPOE_DEBUGLEVEL, warnmsgs) 
     call get_parm_col(tp, qp, "QPOE_DEFLUTLEN",   QPOE_DEFLUTLEN, warnmsgs) 
     call get_parm_col(tp, qp, "QPOE_INDEXLEN",    QPOE_INDEXLEN, warnmsgs)   
     call get_parm_col(tp, qp, "QPOE_LUTMINRANGES",QPOE_LUTMINRANGES, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_LUTSCALE",    QPOE_LUTSCALE, warnmsgs)    
     call get_parm_col(tp, qp, "QPOE_MAXFRLUTLEN", QPOE_MAXFRLUTLEN, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_MAXLFILES",   QPOE_MAXLFILES, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_MAXPUSHBACK", QPOE_MAXPUSHBACK, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_MAXRRLUTLEN", QPOE_MAXRRLUTLEN, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_OPTBUFSIZE",  QPOE_OPTBUFSIZE, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_PAGESIZE",    QPOE_PAGESIZE, warnmsgs) 
     call get_parm_col(tp, qp, "QPOE_PROGBUFLEN",  QPOE_PROGBUFLEN, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_SBUFSIZE",    QPOE_SBUFSIZE, warnmsgs) 
     call get_parm_col(tp, qp, "QPOE_STABLEN",     QPOE_STABLEN, warnmsgs)   
     call get_parm_col(tp, qp, "QPOE_NODEFFILT",   QPOE_NODEFFILT, warnmsgs)
     call get_parm_col(tp, qp, "QPOE_NODEFMASK",   QPOE_NODEFMASK, warnmsgs)   

     # these are read-only, store for documenting purposes
     # call get_parm_col(tp, qp, "QPOE_VERSION",   QPOE_VERSION, warnmsgs)   

     call tbtclo (tp)           # close output file

  }

  call sfree(sp)

end

#***********************************
# get a QPOE "seti" parameter from an ST table column
#
procedure get_parm_col(tp, qp, parmstr, parmnum, warnmsgs)
pointer tp         #I output table pointer
pointer qp         #I qpoe file
char parmstr[ARB]  #I name of parameter
int parmnum        #I parameter number
bool warnmsgs      #I print warning messages

pointer tp_col
int value
int row

begin

   # all values are on row 1
   row=1

   # open a table column, giving it the name of the parameter
   call tbcfnd (tp, parmstr, tp_col, 1)

   if (tp_col == NULL) {
      if (warnmsgs) {
         call eprintf("Warning: Can't find column '%s' in QPOE parameter file\n")
         call pargstr(parmstr)
      }
   }
   else {

      # look up the qpoe parameter & set it
      call tbegti(tp, tp_col, row, value)

      if (value == INDEFI) {
         if (warnmsgs) {
            call printf("Warning: %s field in QPOE parameter file is invalid\n")
            call pargstr(parmstr)
         }
      }
      else {
         call qp_seti(qp, parmnum, value)
      }

   }


end

