# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  cpwcshdrs.x
# 	Author	:  tnk
# 	Date	:  11/11/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) cpwcshdrs.x -r1.2 11/11/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	08/09/94   tnk	corrected WCS header cards
# 	11/11/93   tnk	date and time created 93/11/11 14:19:08 by tnk
# H-
# 
#


include	<error.h>
include	<ctype.h>
include	<imhdr.h>
include	<imio.h>

# copy WCS related info from an image to ST table header cards
#
# anything we don't find, we silently ignore
# @(#)cpwcshdrs.x	1.2 8/9/94 UCB CEA EGO

procedure cp_wcs_hdrs(tp, im)

pointer tp     #I/O output ST table
pointer im     #I input image

begin

   call inthead(tp,im,"WCSDIM")
   call strhead(tp,im,"CTYPE1")
   call strhead(tp,im,"CTYPE2")
   call dblhead(tp,im,"CRVAL1")
   call dblhead(tp,im,"CRVAL2")
   call dblhead(tp,im,"CRPIX1")
   call dblhead(tp,im,"CRPIX2")
   call dblhead(tp,im,"CDELT1")
   call dblhead(tp,im,"CDELT2")
   call dblhead(tp,im,"CD1_1")
   call dblhead(tp,im,"CD2_2")
   call dblhead(tp,im,"CD1_2")
   call dblhead(tp,im,"CD2_1")
   call dblhead(tp,im,"LTM1_1")
   call dblhead(tp,im,"LTM2_2")
   call dblhead(tp,im,"LTM1_2")
   call dblhead(tp,im,"LTM2_1")
   call dblhead(tp,im,"CROTA1")
   call dblhead(tp,im,"CROTA2")
   call strhead(tp,im,"WAT0_001")
   call strhead(tp,im,"WAT1_001")
   call strhead(tp,im,"WAT2_001")

end

#*****************************************
# put out an image string header parameter to an ST table card
procedure strhead(tp,im,card)
pointer tp       #I/O output table  
pointer im       #I   input image   
char card[ARB]   #I   header card   

pointer lbuf     #I   header string 
int buflen       #I   length of lbuf
pointer	sp       # stack pointer

begin

   call smark (sp)

   call salloc (lbuf, SZ_LINE, TY_CHAR)
   buflen = SZ_LINE

   ifnoerr {
        call imgstr(im, card, Memc[lbuf], buflen)
   } then {
        call tbhadt (tp, card, Memc[lbuf])
   }

   call sfree(sp)

end

#*****************************************
# put out an image double header parameter to an ST table card
procedure dblhead(tp,im,card)
pointer tp      #I/O output table  
pointer im	#I   input image   
char card[ARB]	#I   header card   

double d_val	#I   header double value

double imgetd()

begin

    ifnoerr {
        dval = imgetd(im, card)
    } then {
        call tbhadd (tp, card, d_val)
    }
end

#*****************************************
# put out an image int header parameter to an ST table card
procedure inthead(tp,im,card)
pointer tp      #I/O output table  
pointer im	#I   input image   
char card[ARB]	#I   header card   

int ival	#I   header value

int imgeti()

begin

    ifnoerr {
        ival = imgeti(im, card)
    } then {
        call tbhadi (tp, card, ival)
    }
end


