# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  saveparms.x
# 	Author	:  tnk
# 	Date	:  08/24/93
# 	Synopsis:  
# 	Keywords:
# 		@(#) saveparms.x -r1.2 08/24/93 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/13/97   mabbott	removed qpoe$qpoe.h include no longer needed
# 	08/24/93   tnk	date and time created 93/08/24 15:04:04 by tnk
# H-
# 
#

include <qpset.h>
include <tbset.h>

# @(#)saveparms.x	1.2 10/13/97 UCB CEA EGO

# save QP parameters to a special ST table
#
procedure saveparms(qp,destdir,tabprefix,tabname)
pointer qp             #I open qpoe file
char    destdir[ARB]   #I directory name
char    tabprefix[ARB] #I tablename prefix
char    tabname[ARB]   #I output table name

pointer tp

begin

  # open the table
  call open_new_tab(destdir,tabprefix,tabname,tp)

  # make table column ordered
  call tbpset (tp, TBL_WHTYPE, TBL_TYPE_S_COL)   # column ordered

  # create it
  call tbtcre (tp)

  # add the QPOE parameters
  call add_parm_col(tp, qp, "QPOE_BLOCKFACTOR", QPOE_BLOCKFACTOR)
  call add_parm_col(tp, qp, "QPOE_BUCKETLEN",   QPOE_BUCKETLEN)
  call add_parm_col(tp, qp, "QPOE_CACHESIZE",   QPOE_CACHESIZE)
  call add_parm_col(tp, qp, "QPOE_DATABUFLEN",  QPOE_DATABUFLEN)
  call add_parm_col(tp, qp, "QPOE_DEBUGLEVEL",  QPOE_DEBUGLEVEL) 
  call add_parm_col(tp, qp, "QPOE_DEFLUTLEN",   QPOE_DEFLUTLEN) 
  call add_parm_col(tp, qp, "QPOE_INDEXLEN",    QPOE_INDEXLEN)   
  call add_parm_col(tp, qp, "QPOE_LUTMINRANGES",QPOE_LUTMINRANGES)
  call add_parm_col(tp, qp, "QPOE_LUTSCALE",    QPOE_LUTSCALE)    
  call add_parm_col(tp, qp, "QPOE_MAXFRLUTLEN", QPOE_MAXFRLUTLEN)
  call add_parm_col(tp, qp, "QPOE_MAXLFILES",   QPOE_MAXLFILES)
  call add_parm_col(tp, qp, "QPOE_MAXPUSHBACK", QPOE_MAXPUSHBACK)
  call add_parm_col(tp, qp, "QPOE_MAXRRLUTLEN", QPOE_MAXRRLUTLEN)
  call add_parm_col(tp, qp, "QPOE_OPTBUFSIZE",  QPOE_OPTBUFSIZE)
  call add_parm_col(tp, qp, "QPOE_PAGESIZE",    QPOE_PAGESIZE) 
  call add_parm_col(tp, qp, "QPOE_PROGBUFLEN",  QPOE_PROGBUFLEN)
  call add_parm_col(tp, qp, "QPOE_SBUFSIZE",    QPOE_SBUFSIZE) 
  call add_parm_col(tp, qp, "QPOE_STABLEN",     QPOE_STABLEN)   
  call add_parm_col(tp, qp, "QPOE_NODEFFILT",   QPOE_NODEFFILT)
  call add_parm_col(tp, qp, "QPOE_NODEFMASK",   QPOE_NODEFMASK)   

  # these are read-only, store for documenting purposes
  call add_parm_col(tp, qp, "QPOE_VERSION",   QPOE_VERSION)   

  call tbtclo (tp)           # close output file

end
#***********************************
# add a QPOE "stati" parameter to an ST table column
procedure add_parm_col(tp, qp, parmstr, parmnum)
pointer tp            #I output table pointer
pointer qp            #I qpoe file
char    parmstr[ARB]  #I name of parameter
int     parmnum       #I parameter number

# LOCAL VARS
pointer tp_col
int     value
int     qp_stati()
int     row

begin

   # all values go on row 1
   row=1

   # create a table column, giving it the name of the parameter
   call tbcdef (tp, tp_col, parmstr, "", "", TY_INT, 1, 1)

   # look up the qpoe value, stuff it in row 1
   value = qp_stati(qp, parmnum)

   call tbepti(tp, tp_col, row, value)

end
