# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  find_match.gx
# 	Author	:  tnk
# 	Date	:  06/23/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) find_match.gx -r1.1 06/23/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/23/94   tnk	date and time created 94/06/23 17:17:02 by tnk
# H-
# 
#

# DATE 6/23/94
# PROCEDURE NAME 
# INCLUDE FILES

# @(#)find_match.gx	1.1 6/23/94

include <tbset.h>
include <dbg.h>


# DESCRIPTION OF PROCEDURE
#

define BUF_SIZE 10000



procedure find_match_i( tab, colptr, val, equal, err, result )

#AUTHOR : GARETH BEVAN
#
#IMPORT VARIABLES :
pointer tab                       #I table pointer
pointer colptr                    #I col pointer

int val                         #I value to be marched
bool equal                        #I match or not match
int err                           #I accuracy

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int i                             # loop counter
int j                             # loop counter
int nrows                         # num of rows in table

int buf[BUF_SIZE]                 # contents of column
bool nullflags[BUF_SIZE]          # flags for the buffer values


#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  DEBUG(
	call dbg_printf("find_match_$t,func","find_match_$t()\n\n")
)

  nrows = tbpsta( tab, TBL_NROWS )
  result = 0

  DEBUG(
	call dbg_printf("error","nrows = %d, loop = %d \n")
	call pargi( nrows )
	call pargi( BUF_SIZE * (nrows / BUF_SIZE) )
)

  if ( equal )
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgti( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] >= (val-err) && buf[i] <=(val+err) )
	{
	  result = result + 1
	}
      }
    }
    call tbcgti( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] >= (val-err) && buf[i] <=(val+err) )
	{
	  result = result + 1
	}
    }
  }
  else
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgti( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] > (val+err) || buf[i] < (val-err)  )
	{
	  result = result + 1
	}
      }
    }
    call tbcgti( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] > (val+err) || buf[i] < (val-err)  )
	{
	  result = result + 1
	}
    }
  }


end  # OF PROCEDURE find_match_$t



procedure find_match_s( tab, colptr, val, equal, err, result )

#AUTHOR : GARETH BEVAN
#
#IMPORT VARIABLES :
pointer tab                       #I table pointer
pointer colptr                    #I col pointer

short val                         #I value to be marched
bool equal                        #I match or not match
short err                           #I accuracy

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int i                             # loop counter
int j                             # loop counter
int nrows                         # num of rows in table

short buf[BUF_SIZE]                 # contents of column
bool nullflags[BUF_SIZE]          # flags for the buffer values


#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  DEBUG(
	call dbg_printf("find_match_$t,func","find_match_$t()\n\n")
)

  nrows = tbpsta( tab, TBL_NROWS )
  result = 0

  DEBUG(
	call dbg_printf("error","nrows = %d, loop = %d \n")
	call pargi( nrows )
	call pargi( BUF_SIZE * (nrows / BUF_SIZE) )
)

  if ( equal )
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgts( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] >= (val-err) && buf[i] <=(val+err) )
	{
	  result = result + 1
	}
      }
    }
    call tbcgts( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] >= (val-err) && buf[i] <=(val+err) )
	{
	  result = result + 1
	}
    }
  }
  else
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgts( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] > (val+err) || buf[i] < (val-err)  )
	{
	  result = result + 1
	}
      }
    }
    call tbcgts( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] > (val+err) || buf[i] < (val-err)  )
	{
	  result = result + 1
	}
    }
  }


end  # OF PROCEDURE find_match_$t



procedure find_match_r( tab, colptr, val, equal, err, result )

#AUTHOR : GARETH BEVAN
#
#IMPORT VARIABLES :
pointer tab                       #I table pointer
pointer colptr                    #I col pointer

real val                         #I value to be marched
bool equal                        #I match or not match
real err                           #I accuracy

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int i                             # loop counter
int j                             # loop counter
int nrows                         # num of rows in table

real buf[BUF_SIZE]                 # contents of column
bool nullflags[BUF_SIZE]          # flags for the buffer values


#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  DEBUG(
	call dbg_printf("find_match_$t,func","find_match_$t()\n\n")
)

  nrows = tbpsta( tab, TBL_NROWS )
  result = 0

  DEBUG(
	call dbg_printf("error","nrows = %d, loop = %d \n")
	call pargi( nrows )
	call pargi( BUF_SIZE * (nrows / BUF_SIZE) )
)

  if ( equal )
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgtr( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] >= (val-err) && buf[i] <=(val+err) )
	{
	  result = result + 1
	}
      }
    }
    call tbcgtr( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] >= (val-err) && buf[i] <=(val+err) )
	{
	  result = result + 1
	}
    }
  }
  else
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgtr( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] > (val+err) || buf[i] < (val-err)  )
	{
	  result = result + 1
	}
      }
    }
    call tbcgtr( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] > (val+err) || buf[i] < (val-err)  )
	{
	  result = result + 1
	}
    }
  }


end  # OF PROCEDURE find_match_$t



procedure find_match_d( tab, colptr, val, equal, err, result )

#AUTHOR : GARETH BEVAN
#
#IMPORT VARIABLES :
pointer tab                       #I table pointer
pointer colptr                    #I col pointer

double val                         #I value to be marched
bool equal                        #I match or not match
double err                           #I accuracy

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int i                             # loop counter
int j                             # loop counter
int nrows                         # num of rows in table

double buf[BUF_SIZE]                 # contents of column
bool nullflags[BUF_SIZE]          # flags for the buffer values


#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  DEBUG(
	call dbg_printf("find_match_$t,func","find_match_$t()\n\n")
)

  nrows = tbpsta( tab, TBL_NROWS )
  result = 0

  DEBUG(
	call dbg_printf("error","nrows = %d, loop = %d \n")
	call pargi( nrows )
	call pargi( BUF_SIZE * (nrows / BUF_SIZE) )
)

  if ( equal )
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgtd( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] >= (val-err) && buf[i] <=(val+err) )
	{
	  result = result + 1
	}
      }
    }
    call tbcgtd( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] >= (val-err) && buf[i] <=(val+err) )
	{
	  result = result + 1
	}
    }
  }
  else
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgtd( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] > (val+err) || buf[i] < (val-err)  )
	{
	  result = result + 1
	}
      }
    }
    call tbcgtd( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] > (val+err) || buf[i] < (val-err)  )
	{
	  result = result + 1
	}
    }
  }


end  # OF PROCEDURE find_match_$t



procedure find_match_b( tab, colptr, val, equal, err, result )

#AUTHOR : GARETH BEVAN
#
#IMPORT VARIABLES :
pointer tab                       #I table pointer
pointer colptr                    #I col pointer

bool val                         #I value to be marched
bool equal                        #I match or not match
bool err                           #I accuracy

#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
long result                        #O number of rows that meet conditions

#LOCAL VARIABLES :
int i                             # loop counter
int j                             # loop counter
int nrows                         # num of rows in table

bool buf[BUF_SIZE]                 # contents of column
bool nullflags[BUF_SIZE]          # flags for the buffer values


#FUNCTIONS :
int tbpsta()

#############################################################################


begin

  DEBUG(
	call dbg_printf("find_match_$t,func","find_match_$t()\n\n")
)

  nrows = tbpsta( tab, TBL_NROWS )
  result = 0

  DEBUG(
	call dbg_printf("error","nrows = %d, loop = %d \n")
	call pargi( nrows )
	call pargi( BUF_SIZE * (nrows / BUF_SIZE) )
)

  if ( equal )
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgtb( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] == val )
	{
	  result = result + 1
	}
      }
    }
    call tbcgtb( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] == val )
	{
	  result = result + 1
	}
    }
  }
  else
  {
    for ( j=1; j<=nrows/BUF_SIZE; j=j+1 )
    {
      call tbcgtb( tab, colptr, buf, nullflags, (j-1)*(BUF_SIZE)+1, (j*BUF_SIZE) )
      for ( i=1; i<= BUF_SIZE; i=i+1 )
      {
	if ( buf[i] != val  )
	{
	  result = result + 1
	}
      }
    }
    call tbcgtb( tab, colptr, buf, nullflags, ((j-1)*BUF_SIZE)+1, nrows )
    for ( i=1; i<= (nrows - ( (nrows/BUF_SIZE)*BUF_SIZE)); i=i+1 )
    {
	if ( buf[i] != val  )
	{
	  result = result + 1
	}
    }
  }


end  # OF PROCEDURE find_match_$t


