# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_rowcount.x
# 	Author	:  ericco
# 	Date	:  12/18/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_rowcount.x -r1.6 12/18/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/22/96   tnk	added error check for empty input table
# 	06/23/94   tnk	modified printout to be less ambiguous
# 	02/02/94   tnk	fixed short INDEF code
# 	11/22/93   gareth	corrected iraf gargs bug
# 	11/20/93   ericco	added TY_SHORT support
# 	12/18/92   ericco	date and time created 92/12/18 22:57:11 by ericco
# H-
# 
#

# DATE @(#)t_rowcount.x	1.6 10/22/96
# PROCEDURE NAME 
# INCLUDE FILES

include <tbset.h>
include <dbg.h>
include <mach.h>

# DESCRIPTION OF PROCEDURE
#




procedure t_rowcount()

#AUTHOR : GARETH BEVAN
#
#IMPORT VARIABLES :
#IMPORT/EXPORT VARIABLES :
#EXPORT VARIABLES :
#LOCAL VARIABLES :

pointer inp                   # file name
pointer col                   # col name
pointer val                   # col value
pointer name                  # col name
pointer units                 # col units
pointer fmt                   # col format string
pointer tab                   # table pointer
pointer colptr[1]             # col pointer
pointer err                   # pointer to the acuracy col

int i_val                     # converted datatypes
short s_val
double d_val
bool b_val
real r_val
int i_err
short s_err
double d_err
real r_err


bool equal                    # true if the test is for equality

int colnum                    # column number
int dummy
int datatype                  # the col datatype
int nrows                         # num of rows in table

long result                    # number of rows matching condition
pointer matchstr

#FUNCTIONS :
bool clgetb()
pointer tbtopn()
int tbpsta()


       
#############################################################################

begin

  DEBUG( call dbg_open())
  DEBUG(
	call dbg_printf("t_rowcount,function","t_rowcount()\n")
)
       
  call malloc( inp, SZ_LINE, TY_CHAR )
  call malloc( col, SZ_LINE, TY_CHAR )
  call malloc( val, SZ_LINE, TY_CHAR )
  call malloc( name, SZ_COLNAME, TY_CHAR )
  call malloc( units, SZ_COLUNITS, TY_CHAR )
  call malloc( fmt, SZ_COLFMT, TY_CHAR )
  call malloc( err, SZ_LINE, TY_CHAR )
  call malloc( matchstr, SZ_LINE, TY_CHAR )

  # read parameter file

  call clgstr("input", Memc[inp], SZ_LINE)
  call clgstr("col", Memc[col], SZ_LINE)
  call clgstr("value", Memc[val], SZ_LINE)
  equal = clgetb("equal")
  call clgstr("range", Memc[err], SZ_LINE)

  if (equal)
     call strcpy("matched",Memc[matchstr],SZ_LINE)
  else
     call strcpy("did not match",Memc[matchstr],SZ_LINE) 

  # get table info

  tab = tbtopn( Memc[inp], READ_ONLY, 0 )

  nrows = tbpsta( tab, TBL_NROWS )
  if (nrows == 0)
    call error(111,"Input table is empty.")

  call tbcfnd( tab, Memc[col], colptr, 1)
  if ( colptr[1] == NULL )
  {
    call eprintf("ERROR: Column %s does not exist in table %s.\n")
    call pargstr( Memc[col] )
    call pargstr( Memc[inp] )
  }
  else
  {
    
    call tbcinf( colptr[1], colnum, Memc[name], Memc[units], Memc[fmt],
	       datatype, dummy, dummy )
  

  
  # convertdata type



    switch ( datatype )
    {
    case TY_REAL :
      call sscan( Memc[val] )
      call gargr( r_val )
      call sscan( Memc[err] )
      call gargr( r_err )
      if ( IS_INDEFR( r_err ) )
      {
	r_err = EPSILONR
      }
      call find_match_r( tab, colptr, r_val, equal, r_err, result )
      # print results
    
      call printf("\nThere were %d rows in column %s which %s the value %f +- %f\n")
      call pargl( result )
      call pargstr( Memc[name] )
      call pargstr( Memc[matchstr])
      call pargr( r_val )
      call pargr( r_err )
      
    case TY_INT :
      call sscan( Memc[val] )
      call gargi( i_val )
      call sscan( Memc[err] )
      call gargi( i_err )
      if ( IS_INDEFI( i_err ) )
      {
	i_err = 0
      }
      call find_match_i( tab, colptr, i_val, equal, i_err, result )
      # print results
      
      call printf("\nThere were %d rows in column %s which %s the value %d +- %d\n")
      call pargl( result )
      call pargstr( Memc[name] )
      call pargstr( Memc[matchstr])
      call pargi( i_val )
      call pargi( i_err )
      
    case TY_SHORT :
      call sscan( Memc[val] )
# This code here to fix bug in gargs
#      call gargs( s_val )
      call gargd( d_val )
      if (IS_INDEFD (d_val))
        s_val = INDEFS
      else if (abs(d_val) > MAX_SHORT)
        s_val = INDEFS
      else
        s_val = d_val

      call sscan( Memc[err] )
# This code here to fix bug in gargs
#      call gargs( s_err )
      call gargd( d_err )
      if (IS_INDEFD (d_err))
        s_err = INDEFS
      else if (abs(d_err) > MAX_SHORT)
        s_err = INDEFS
      else
        s_err = d_err
      
      if ( IS_INDEFS( s_err ) )
      {
	s_err = 0
      }
      call find_match_s( tab, colptr, s_val, equal, s_err, result )
      # print results
      
      call printf("\nThere were %d rows in column %s which %s the value %d +- %d\n")
      call pargl( result )
      call pargstr( Memc[name] )
      call pargstr( Memc[matchstr])
      call pargs( s_val )
      call pargs( s_err )
      
    case TY_DOUBLE :
      call sscan( Memc[val] )
      call gargd( d_val )
      call sscan( Memc[err] )
      call gargd( d_err )
      if( IS_INDEFD( d_err ) )
      {
	d_err = EPSILOND
      }
      call find_match_d( tab, colptr, d_val, equal, d_err, result )
      # print results
      
      call printf("\nThere were %d rows in column %s which %s the value %f +- %f\n")
      call pargl( result )
      call pargstr( Memc[name] )
      call pargstr( Memc[matchstr])
      call pargd( d_val )
      call pargd( d_err )
      
    case TY_BOOL :
      call sscan( Memc[val] )
      call gargb( b_val )
      call find_match_b( tab, colptr, b_val, equal, result )
      # print results
      
      call printf("\nThere were %d rows in column %s which %s the value %b \n")
      call pargl( result )
      call pargstr( Memc[name] )
      call pargstr( Memc[matchstr])
      call pargb( b_val )
      
    }
    
  }  

  call tbtclo( tab )

  call mfree( name, TY_CHAR )
  call mfree( inp, TY_CHAR )
  call mfree( col, TY_CHAR )
  call mfree( units, TY_CHAR )
  call mfree( fmt, TY_CHAR )
  call mfree( val, TY_CHAR )
  call mfree( err, TY_CHAR )  
  call mfree( matchstr, TY_CHAR )  

  DEBUG( call dbg_close())

end  # OF PROCEDURE rowcount


