# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  soclose.x
# 	Author	:  akeith
# 	Date	:  06/27/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) soclose.x -r1.2 06/27/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/14/94   akeith	closes spectral image
# 	06/27/94   akeith	date and time created 94/06/27 15:01:52 by akeith
# H-
# 
#


#	Version: @(#)soclose.x	1.2 9/14/94 UCB CEA EGO

include	"so.h"
include	"spc.h"


#
# so_close()
#

procedure	so_close(so)

pointer	so			#

int	ispc

begin

	if(SO_GP(so) != NULL)
		call gclose(SO_GP(so))

	if(SO_EK(so) != NULL)
		call ek_close(SO_EK(so))

	do ispc = SW, LW
		call spc_close(SO_SPC(so, ispc))

	call so_free(so)
end


#
# spc_close()
#

procedure	spc_close(spc)

pointer	spc			#

int	i

begin

	if(spc == NULL) return

	if(SPC_IM(spc) != NULL)
		call imunmap(SPC_IM(spc))

	if(SPC_NAME_PTR(spc) != NULL)
		call mfree(SPC_NAME_PTR(spc), TY_CHAR)

	if(ORG(spc) != NULL)
		call df_close(ORG(spc))

	if(ORG_ERR(spc) != NULL)
		call df_close(ORG_ERR(spc))

	if(NEW(spc) != NULL)
		call df_close(NEW(spc))

	if(NEW_ERR(spc) != NULL)
		call df_close(NEW_ERR(spc))

	if(ORD(spc) != NULL)
		call df_close(ORD(spc))

	if(ORD_ERR(spc) != NULL)
		call df_close(ORD_ERR(spc))

	do i = 1, SPC_NORDS(spc)
		call df_close(SPC_EA(spc, i))

	call spc_free(spc)
end

