
include <iierr.h>

define KEY_1                1
define KEY_6                2
define KEY_9                3
define KEY_11               4
define KEY_12               5
define KEY_15               6
define KEY_3                7
define KEY_4                8
define KEY_8                9
define KEY_10               10
define KEY_5                11
define KEY_13               12
define KEY_7                13
define KEY_14               14
define KEY_2                15

define KEYWORDS 15

procedure so_eval (state, command)
pointer	state
char	command[ARB]

int	argc
int	key
pointer	rcmd

pointer	private


string	keydict ",all,last,join,undo,help,auto,only,close,order,ztrim,window,report,current,subtract,continue,"
pointer	sp
define	redo_	10
define	finish_	20
begin
	call smark(sp)
	call ii_error(state, II_ERR_UNKNOWN)
	call ii_parse(state, command)
redo_
	call ii_args(state, argc)
	if (argc == 0) {
		call ii_no_args(state)
		call ii_error(state, II_ERR_NO_ARGS)
		call ii_post_process(state, 1)
		goto finish_
	}
	call ii_lookup(state, keydict, key)
	if (key <= 0 || key > KEYWORDS) {
		call ii_not_found(state)
		call ii_error(state, II_ERR_NOT_FOUND)
		call ii_post_process(state, 1)
		goto finish_
	}

	switch(key) {
		case KEY_1:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_acmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_2:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_ccmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_3:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_lcmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_4:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_mcmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_5:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_wcmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_6:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_scmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_7:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_dcmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_8:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_fcmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_9:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_jcmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_10:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_zcmd(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_11:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_undo(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_12:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_quest(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_13:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_space(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_14:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_xtrct(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
		case KEY_15:
			if (argc != 1) {
				call ii_bad_nargs(state)
				call ii_error(state, II_ERR_BAD_NARGS)
				call ii_post_process(state, 1)
				goto finish_
			}

			call ii_pre_process(state)
			call ii_private(state, private)
			iferr(call so_auto(private)) {
				call ii_usr_err(state)
				call ii_error(state, II_ERR_USER_ERR)
				call ii_post_process(state, 1)
				goto finish_
			}
			call ii_post_process(state, 0)
	}
	call ii_error(state, II_ERR_NONE)
	repeat {
		call ii_redo(state,rcmd)
		if (rcmd == 0) break
		call ii_parse(state, Memc[rcmd])
		call ii_args(state, argc)
		if (argc > 0) goto redo_
	}
finish_
	call ii_clean_include(state)
	call sfree(sp)
end

procedure	so_release(ptr, dtype)
pointer	ptr
int	dtype

begin
	switch(dtype) {
	default: call mfree(ptr, dtype)
	}
	ptr = 0
end
