# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  sodisplay.x
# 	Author	:  akeith
# 	Date	:  06/27/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) sodisplay.x -r1.1 06/27/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/27/94   akeith	date and time created 94/06/27 15:01:53 by akeith
# H-
# 
#


#	Version: @(#)sodisplay.x	1.1 6/27/94 UCB CEA EGO

include	"so.h"
include	"spc.h"
include	<gset.h>

define	XTITLE	"Wavelength (Angstroms)"
define	YTITLE	"Counts/Angstrom"

#
# so_display()
#

procedure	so_display(so)

pointer	so			#I suborder structure

int	i			# index
int	nspc_on			# number of spectra to display

pointer	gp			# graphics structure
pointer sp			# stack
pointer str1			# string
pointer str2			# string
pointer str3			# string
pointer title			# string

begin

	gp = SO_GP(so)
	call gclear(gp)

	call smark(sp)
	call salloc(str1, SZ_LINE, TY_CHAR)
	call salloc(str2, SZ_LINE, TY_CHAR)
	call salloc(str3, SZ_LINE, TY_CHAR)
	call salloc(title, SZ_LINE, TY_CHAR)

	call eu_idxstr(ORDERS, SO_CORD(so), Memc[str1], SZ_LINE)
	call eu_idxstr(WAVE_LEN, SO_CSWL(so), Memc[str2], SZ_LINE)
	call eu_idxstr(WAVE_LEN, SO_CXWL(so), Memc[str3], SZ_LINE)

	call sprintf(Memc[title], SZ_LINE, "%s order of %s in %s")
	call pargstr(Memc[str1])
	call pargstr(Memc[str2])
	call pargstr(Memc[str3])

	nspc_on = 0
	do i = SW, LW
		if(SO_SPC_ON(so, i))
			nspc_on = nspc_on + 1

	switch(nspc_on) {
	  case 1:
		if(SO_SPC_ON(so, SW))
			call so_draw(gp, SO_SW(so), SW, W1V1YL, W1V1YH,
					Memc[title], XTITLE, YTITLE)
		else if(SO_SPC_ON(so, MW))
			call so_draw(gp, SO_MW(so), MW, W1V1YL, W1V1YH,
					Memc[title], XTITLE, YTITLE)
		else
			call so_draw(gp, SO_LW(so), LW, W1V1YL, W1V1YH,
					Memc[title], XTITLE, YTITLE)

	  case 2:
		if(!SO_SPC_ON(so, LW)) {
			call so_draw(gp, SO_SW(so), SW, W2V1YL, W2V1YH,
					Memc[title], "", YTITLE)
			call so_draw(gp, SO_MW(so), MW, W2V2YL, W2V2YH,
					"", XTITLE, YTITLE)

		} else if(!SO_SPC_ON(so, MW)) {
			call so_draw(gp, SO_SW(so), SW, W2V1YL, W2V1YH,
					Memc[title], "", YTITLE)
			call so_draw(gp, SO_LW(so), LW, W2V2YL, W2V2YH,
					"", XTITLE, YTITLE)

		} else {
			call so_draw(gp, SO_MW(so), MW, W2V1YL, W2V1YH,
					Memc[title], "", YTITLE)
			call so_draw(gp, SO_LW(so), LW, W2V2YL, W2V2YH,
					"", XTITLE, YTITLE)
		}

	  case 3:
		call so_draw(gp, SO_SW(so), SW, W3V1YL, W3V1YH,
					Memc[title], "", "")
		call so_draw(gp, SO_MW(so), MW, W3V2YL, W3V2YH,
					"", "", YTITLE)
		call so_draw(gp, SO_LW(so), LW, W3V3YL, W3V3YH,
					"", XTITLE, "")
	}

	call gflush(gp)
	call gflush(gp)

end


#
# so_draw()
#

procedure	so_draw(gp, spc, wcs, y1, y2, title, xlab, ylab)

pointer	gp			#I graphics structure
pointer	spc			#I spectrum structure
int	wcs			#I world coord system
real	y1			#I viewport lower vertical position
real	y2			#I viewport upper vertical position
char	title[ARB]		#I title
char	xlab[ARB]		#I x label
char	ylab[ARB]		#I y label

real	smidgen
real	xl, xh
real	yl, yh

begin

	call gseti(gp, G_WCS, wcs)
	call gsview(gp, VXL, VXH, y1, y2)
	call gseti(gp, G_DRAWAXES, 3)

	smidgen = ((SPC_XH(spc)-SPC_XL(spc))*SO_EXPAND)/2.0
	xl = SPC_XL(spc) - smidgen
	xh = SPC_XH(spc) + smidgen

	smidgen = ((SPC_YH(spc)-SPC_YL(spc))*SO_EXPAND)/2.0
	yl = SPC_YL(spc) - smidgen
	yh = SPC_YH(spc) + smidgen

	call gswind(gp, xl, xh, yl, yh)
	call glabax(gp, title, xlab, ylab)

	call gamove(gp, real(SPC_OL(spc)), yl)
	call gadraw(gp, real(SPC_OL(spc)), yh)
	call gamove(gp, real(SPC_OH(spc)), yl)
	call gadraw(gp, real(SPC_OH(spc)), yh)


	if(SPC_NEW_ON(spc))
		call so_connect(gp, SPC_NEW(spc), real(SPC_DELTA(spc)))

	if(SPC_ORG_ON(spc))
		call so_connect(gp, SPC_ORG(spc), real(SPC_DELTA(spc)))

	if(SPC_ORD_ON(spc))
		call so_dash(gp, SPC_ORD(spc), real(SPC_DELTA(spc)))

end


#
# so_connect()
#

procedure	so_connect(gp, df, delta)

pointer	gp			#I graphics structure
pointer	df			#I discrete function
real	delta			#I bin size

double	x0
real	xo, x, y
int	df_rgetr()

begin

	call df_gx0(df, x0)
	xo = real(x0)

	call gamove(gp, xo, 0.0)

	while(df_rgetr(df, x, y, 1) != 0) {

		if(IS_INDEFR(y)) {
			call gadraw(gp, xo, 0.0)
			call gamove(gp, x, 0.0)
			xo = x
		} else {
#			y = y*delta
			call gadraw(gp, xo, y)
			call gadraw(gp, x, y)
			xo = x
		}
	}

	call gadraw(gp, x, 0.0)

	call df_rewind(df)
end


#
# so_dash()
#

procedure	so_dash(gp, df, delta)

pointer	gp			#I graphics structure
pointer	df			#I discrete function
real	delta			#I bin size

double	x0
real	xo, x, y
int	df_rgetr()

begin

	call df_gx0(df, x0)
	xo = real(x0)
	call gamove(gp, xo, 0.0)

	while(df_rgetr(df, x, y, 1) != 0) {

		if(IS_INDEFR(y)) {
			xo = x
		} else {
#			y = y*delta
			call gamove(gp, xo, y)
			call gadraw(gp, x, y)
			xo = x
		}
	}

	call df_rewind(df)
end


