# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  soincrement.x
# 	Author	:  akeith
# 	Date	:  06/27/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) soincrement.x -r1.1 06/27/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	06/27/94   akeith	date and time created 94/06/27 15:01:54 by akeith
# H-
# 
#


#	Version: @(#)soincrement.x	1.1 6/27/94 UCB CEA EGO

include	"so.h"
include	"spc.h"

#
# so_incr() increment to the next current xtraction wavelength,
#	the next current source wavelength, and the next current
#	order.
#

procedure	so_incr(so, cxwl, cswl, order)

pointer	so			#I suborder structure
int	cxwl			#O current xtraction wave length
int	cswl			#O current source wave length
int	order			#O current order

int	nords			# number of orders
pointer	spc			# spectrum

begin

	spc = SO_SPC(so, cxwl)
	SPC_ORD_ON(spc) = FALSE

	nords = SPC_NORDS(spc)

	order = order + 1
	if(order > nords) {

		order = 2

		repeat {

			cswl = cswl + 1

			if(cswl > cxwl) {

				cswl = SW

				repeat {

					cxwl = cxwl + 1
					if(cxwl > LW) {
						SO_DONE(so) = TRUE
						return
					}

					spc = SO_SPC(so, cxwl)

				} until(SPC_EXISTS(spc))
			}

			spc = SO_SPC(so, cswl)

		} until(SPC_EXISTS(spc))
	}

	spc = SO_SPC(so, cxwl)
	SPC_ORD_ON(spc) = TRUE

end

