# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  soorder.x
# 	Author	:  akeith
# 	Date	:  06/27/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) soorder.x -r1.2 06/27/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/14/94   akeith	moved most of the code to spc library
# 	06/27/94   akeith	date and time created 94/06/27 15:03:07 by akeith
# H-
# 
#


#	Version: @(#)soorder.x	1.2 9/14/94 UCB CEA EGO

include	"so.h"
include	"spc.h"
include	<dfset.h>


#
# so_order()
#

bool	procedure	so_order(so, cxwl, cswl, cord)

pointer	so				#I
int	cxwl				#I
int	cswl				#I
int	cord				#I

pointer	spc				#
pointer	flux, flux_err, df_open()	#
bool	ret, so_gxrng()

double	xl, xh

begin

	ret = so_gxrng(so, cswl, cxwl, cord, xl, xh)
	if(!ret) return(ret)

	flux     = df_open(DF_PD, TY_DOUBLE, TY_DOUBLE)
#	flux_err = df_open(DF_PD, TY_DOUBLE, TY_DOUBLE)

	spc = SO_SPC(so, cswl)
	call spc_gflux(SPC_EA(spc, 1), SPC_EXPT(spc), ORG(spc), flux )
#	call spc_gfluxerr(SPC_EA(spc, 1), SPC_EXPT(spc), ORG_ERR(spc), flux_err)

	call so_mkorder(SO_SPC(so, cxwl), cord, flux, flux_err, xl, xh)

#	call df_close(flux_err)
	call df_close(flux)

	return(ret)
end


#
# so_mkorder()
#

procedure	so_mkorder(spc, order, flux, flux_err, ex_xl, ex_xh)

pointer	spc				#
int	order				#
pointer	flux				#
pointer	flux_err			#
double	ex_xl, ex_xh			#

pointer	ea				#

begin


#    Do the multiplication.

	ea = SPC_EA(spc, order)

	call df_mul(flux, ea, ORD(spc))
	call df_trim(ORD(spc), ex_xl, ex_xh, ORD(spc))

	call df_stretch(ORD(spc), double(order), ORD(spc))
	call df_divk(ORD(spc), double(order), ORD(spc))
	call df_mulk(ORD(spc), SPC_EXPT(spc), ORD(spc))

	call df_trim(ORD(spc), SPC_SL(spc), SPC_SH(spc), ORD(spc))


#   Do the multiplication for the error.
#	tmp_df = df_open(DF_PD, TY_DOUBLE, TY_DOUBLE)
#	call df_mulk(ea, SPC_EXPT(spc), tmp_df)
#	call df_powk(tmp_df, 2, tmp_df)
#	call df_mul(flux_err, tmp_df, ORD_ERR(spc))
#	call df_trim(ORD_ERR(spc), ex_xl, ex_xh, ORD_ERR(spc))
#	call df_stretch(ORD_ERR(spc), double(order), ORD_ERR(spc))
#	call df_divk(ORD_ERR(spc), double(order), ORD_ERR(spc))
#	call df_trim(ORD_ERR(spc), SPC_SL(spc), SPC_SH(spc), ORD_ERR(spc))
#	call df_close(tmp_df)

end


#
# so_gxrng()
#

bool	procedure	so_gxrng(so, cswl, cxwl, order, ex_xl, ex_xh)

pointer	so			#
int	cswl			#
int	cxwl			#
int	order			#
double	ex_xl, ex_xh		#

pointer	s_cswl			#
pointer	s_cxwl			#
pointer ea1, ea			#

double	ea1_xl, ea1_xh		#
double	ea_xl, ea_xh		#
double	f_xl, f_xh		#

begin

#   source and xtraction wavelength pointers

	s_cswl = SO_SPC(so, cswl)
	s_cxwl = SO_SPC(so, cxwl)

#  first order effective area of the source range

	ea1 = SPC_EA(s_cswl, 1)
	call df_gxrng(ea1, ea1_xl, ea1_xh)

#  flux range

	if(SPC_OL(s_cswl) < SPC_SL(s_cswl))
		call error(1, "so_gxrng(): SPC_OL < SPC_SL")

	if(SPC_OH(s_cswl) > SPC_SH(s_cswl))
		call error(1, "so_gxrng(): SPC_OH > SPC_SH")

	if(SPC_OL(s_cswl) > ea1_xl) f_xl = SPC_OL(s_cswl)
	else f_xl = ea1_xl

	if(SPC_OH(s_cswl) < ea1_xh) f_xh = SPC_OH(s_cswl)
	else f_xh = ea1_xh

#  xtraction effective area range

	ea = SPC_EA(s_cxwl, order)
	call df_gxrng(ea, ea_xl, ea_xh)

#  effective xtraction range

	if(f_xl > ea_xl) ex_xl = f_xl
	else ex_xl = ea_xl

	if(f_xh < ea_xh) ex_xh = f_xh
	else ex_xh = ea_xh


	if(ex_xh <= ex_xl) return(FALSE)
	if(ex_xh*order <= SPC_SL(s_cxwl)) return(FALSE)
	if(ex_xl*order >= SPC_SH(s_cxwl)) return(FALSE)

	return(TRUE)
end

