# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  sowrite.x
# 	Author	:  akeith
# 	Date	:  06/27/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) sowrite.x -r1.3 06/27/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/21/94   akeith	now uses eu_clfile()
# 	09/14/94   akeith	moved most of the code to spc library
# 	06/27/94   akeith	date and time created 94/06/27 15:03:12 by akeith
# H-
# 
#


#	Version: @(#)sowrite.x	1.3 9/21/94 UCB CEA EGO

include	"so.h"
include	"spc.h"
include	<dfset.h>
include	<imhdr.h>


#
# so_putout()
#

procedure	so_putout(so, sw, mw, lw)

pointer	so			#I
pointer	sw			#I
pointer	mw			#I
pointer	lw			#I

pointer	spc			#

begin

	spc = SO_SPC(so, SW)
	if(SPC_EXISTS(spc) && sw != NULL) {
		call so_outim(spc, sw)
		call imunmap(sw)
	}

	spc = SO_SPC(so, MW)
	if(SPC_EXISTS(spc) && mw != NULL) {
		call so_outim(spc, mw)
		call imunmap(mw)
	}

	spc = SO_SPC(so, LW)
	if(SPC_EXISTS(spc) && lw != NULL) {
		call so_outim(spc, lw)
		call imunmap(lw)
	}

end


define	SRC_STR		"spectrum - order subtracted flux"

#
# so_outim()
#

procedure	so_outim(spc, out)

pointer	spc			#I
pointer	out			#I

int	npts			#
double	delx			#
double	xl, xh			#
int	imaccf()		#

begin

	xl = SPC_SL(spc); xh = SPC_SH(spc)
	delx = SPC_DELTA(spc)
	npts = int((xh - xl)/delx + 0.5)
	if(npts == 0) {
		delx = xh - xl
		npts = 1
	}

#    Add header cards to the image.

	call strcat("Created by suborder from ", IM_HISTORY(out), SZ_IMHIST)
	call strcat(SPC_NAME(spc), IM_HISTORY(out), SZ_IMHIST)
	call strcat("\n", IM_HISTORY(out), SZ_IMHIST)

	call imastr(out, "BANDID1", SRC_STR)
	if(imaccf(out, "BANDID2") == YES) call imdelf(out, "BANDID2")
	if(imaccf(out, "BANDID3") == YES) call imdelf(out, "BANDID3")

#    Write out spectrum.

	call spc_out(out, xl, delx, npts, SPC_EA(spc, 1),
			SPC_EXPT(spc), NEW(spc), NEW_ERR(spc))

end


#
# so_goutim()
#

pointer	procedure	so_goutim(param, copy)

char	param[ARB]			#I
pointer	copy				#I

pointer	sp, output			#
pointer out, immap()

begin
	out = NULL
	call smark(sp)
	call eu_clfile(output, param)
	if(Memc[output] != EOS)
		out = immap(Memc[output], NEW_COPY, copy)
	call sfree(sp)
	return(out)
end

