# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  soxtrct.x
# 	Author	:  akeith
# 	Date	:  06/27/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) soxtrct.x -r1.2 06/27/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/14/94   akeith	added auto subtraction
# 	06/27/94   akeith	date and time created 94/06/27 15:03:12 by akeith
# H-
# 
#


#	Version: @(#)soxtrct.x	1.2 9/14/94 UCB CEA EGO

include	"so.h"
include	"spc.h"

define	SO_SUBTRACT	1
define	SO_CONTINUE	2

#
# so_xtrct()
#

procedure	so_xtrct(so)

pointer so			#I

begin
	call so_proceed(so, SO_SUBTRACT)
end


#
# so_ccmd()
#

procedure	so_ccmd(so)

pointer so			#I

begin
	call so_proceed(so, SO_CONTINUE)
end


#
# so_auto()
#

procedure	so_auto(so)

pointer so			#I

begin
	SO_AUTO(so) = TRUE
end


#
# so_proceed()
#

procedure	so_proceed(so, type)

pointer	so			#I
int	type			#I

pointer	spc, next_spc		#
bool	so_order()		#

begin

	SO_SET(so) = TRUE

	if(SO_CXWL(so) > LW) {
		SO_DONE(so) = TRUE
		return
	}

	if(type == SO_SUBTRACT) call so_copy(so)

	spc = SO_SPC(so, SO_CXWL(so))

	if(type == SO_SUBTRACT)
		call so_sub(spc, ORG(spc), ORD(spc), NEW(spc))

#	if(type == SO_SUBTRACT)
#		call so_suberr(spc, ORG_ERR(spc), ORD_ERR(spc), NEW_ERR(spc))

	repeat {

		call so_incr(so, SO_CXWL(so), SO_CSWL(so), SO_CORD(so))
		if(SO_CXWL(so) > LW) {
			SO_DONE(so) = TRUE
			return
		}

	} until( so_order(so, SO_CXWL(so), SO_CSWL(so), SO_CORD(so)) )


	next_spc = SO_SPC(so, SO_CXWL(so))
	SPC_ON(next_spc) = TRUE
	SPC_NEW_ON(next_spc) = TRUE


	call so_gwind(spc, SPC_XL(spc), SPC_XH(spc), SPC_YL(spc), SPC_YH(spc))
	if(spc != next_spc)
		call so_gwind(next_spc, SPC_XL(next_spc), SPC_XH(next_spc),
					SPC_YL(next_spc), SPC_YH(next_spc))

	call so_display(so)

end


#
# so_copy()
#

procedure	so_copy(so)

pointer	so			#

pointer	spc			#

begin

	spc = SO_SPC(so, SO_CXWL(so))
	call df_mov(NEW(spc), ORG(spc))
#	call df_mov(NEW_ERR(spc), ORG_ERR(spc))

	SO_LXWL(so) = SO_CXWL(so)
	SO_LSWL(so) = SO_CSWL(so)
	SO_LORD(so) = SO_CORD(so)
	SO_UNDO(so) = TRUE

end


#
# so_sub()
#

procedure	so_sub(spc, old, ord, new)

pointer	spc			#
pointer	old			#
pointer	ord			#
pointer	new			#

int	npts			#

begin
	call df_sub(old, ord, new)

	npts = int((SPC_SH(spc) - SPC_SL(spc))/SPC_DELTA(spc) + 0.5)
	call df_rsdomain(new, SPC_SL(spc), SPC_DELTA(spc), npts, new)

end


#
# so_suberr()
#

procedure	so_suberr(spc, old, ord, new)

pointer	spc			#
pointer	old			#
pointer	ord			#
pointer	new			#

int	npts			#

begin
	call df_add(old, ord, new)

	npts = int((SPC_SH(spc) - SPC_SL(spc))/SPC_DELTA(spc) + 0.5)
	call df_rsdomain(new, SPC_SL(spc), SPC_DELTA(spc), npts, new)

end

