# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_suborder.x
# 	Author	:  akeith
# 	Date	:  06/27/94
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_suborder.x -r1.2 06/27/94 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	09/14/94   akeith	revamped and setup to use spc library
# 	06/27/94   akeith	date and time created 94/06/27 15:04:25 by akeith
# H-
# 
#


#	Version: @(#)t_suborder.x	1.2 9/14/94 UCB CEA EGO

include	"so.h"
include	"spc.h"
include	<dfset.h>
include <gset.h>

procedure	t_suborder()

int	stat			#
int	wcs			#
real	wx, wy			#

pointer	sp			#
pointer	cmd			#
pointer	err			#
pointer	ref			#
pointer	grph			#
pointer	expt			#
pointer ii			#
pointer	out_sw			#
pointer	out_mw			#
pointer	out_lw			#

int	ek_gcur()		#
bool	so_ordinit()		#
bool	putout, clgetb()	#
pointer so, so_open()		#
pointer	spc_open()
pointer	so_goutim()
pointer	gopen()

extern	so_eval
extern	so_release
extern	so_close

begin

	call smark(sp)
	call salloc(cmd, SZ_LINE, TY_CHAR)
	call salloc(err, SZ_LINE, TY_CHAR)
 
	so = so_open()

#    Initialize the spectra.

	call eu_clstr(expt, "exptime")
	call eu_clstr(ref, "refdata")

	SO_SW(so) = spc_open("sw", Memc[ref], Memc[expt])
	SO_MW(so) = spc_open("mw", Memc[ref], Memc[expt])
	SO_LW(so) = spc_open("lw", Memc[ref], Memc[expt])

#    Open the output images.

	putout = clgetb("putout")
	if(putout) {
		out_sw = so_goutim("sw_out", SPC_IM(SO_SW(so)))
		out_mw = so_goutim("mw_out", SPC_IM(SO_MW(so)))
		out_lw = so_goutim("lw_out", SPC_IM(SO_LW(so)))
	}

#    Set the join points.

	call so_gjoin(so)

#    Initialize the orders.

	if(!so_ordinit(so)) {
		if(putout) call so_putout(so, out_sw, out_mw, out_lw)
		call so_close(so)
		call sfree(sp)
		return
	}

#    Open the graphics, the instruction interp. and the macro file.

	call eu_clstr(grph, "graphics")
	SO_GP(so) = gopen(Memc[grph], NEW_FILE, STDGRAPH)

	call ii_open(ii, so_eval, so_release)
	call ii_post_private(ii, so, so_close)
 
	call ek_macro_file(SO_EK(so), MACRO_FILE, NULL)

#    Setup the display and start eval commands.

	call so_wcsinit(so)
	call so_display(so)

	while(ek_gcur("gcur", SO_EK(so), wx, wy, wcs, Memc[cmd], SZ_LINE) != EOF) {
 
		SO_WCS(so) = wcs
		SO_WX(so) = wx
		SO_WY(so) = wy

		call ii_evaluate(ii, Memc[cmd])
		call ii_posteval(ii, stat, Memc[err], SZ_LINE)

		if(SO_AUTO(so)) {
			while(!SO_DONE(so)) {
				call strcpy("subtract", Memc[cmd], SZ_LINE)
				call ii_evaluate(ii, Memc[cmd])
			}
		}

		if(SO_DONE(so)) break
	}
 
#    Close it up.

	if(putout) call so_putout(so, out_sw, out_mw, out_lw)

	call ii_close(ii)
	call sfree(sp)

end

