# Copyright (c) 1991 - 1900.  The Regents of the University of
# California (Regents).  All Rights Reserved.
# H+
# 	Title	:  t_tfilter.x
# 	Author	:  ericco
# 	Date	:  10/20/92
# 	Synopsis:  
# 	Keywords:
# 		@(#) t_tfilter.x -r1.9 10/20/92 UCB SSL CEA EGOCS
# 	Revisions:
# 	mm/dd/yy   name		description
# 	10/13/97   bboyd	replaced qp_rlmerged with qp_rlmergeeuvd and LEFTD RIGHTD with EUVLEFTD and EUVRIGHTD
# 	09/12/95   tnk	added QPF_INHERIT flag to qp_addf call
# 	08/24/94   tnk	added missing args to sprintf, error
# 	04/30/93   gareth	removed ()
# 	12/15/92   ericco	added check to skip '%' in format spec
# 	12/15/92   ericco	fixed indef end points and rlmerge malloc error
# 	12/04/92   ericco	allow multiple input tables
# 	10/21/92   ericco	add comments
# 	10/20/92   ericco	date and time created 92/10/20 18:17:39 by ericco
# H-
# 
#

#	Revised: 10/13/97

include <mach.h>
include <tbset.h>
include <qpset.h>
include <qpeuv.h>

# Reads the start and end columns from a given table and produces a qpoe
# filter on output.

procedure t_tfilter()

pointer inp			# table name
pointer tab			# table pointer
pointer sptr, eptr		# column pointers
pointer col1, col2		# names of columns

int	nrows			# num rows in table
int	i			# loop counter

pointer	sp
pointer	format			# user selected format
pointer	fmt			# output format

pointer	out			# output file name
pointer	name			# output filter name
pointer	qp			# qpoe file descriptor
pointer	buf			# tmp buffer

int	fd			# text file descriptor
int	pos			# macro output position
int	len			# macro output length

bool	textp			# output flag
bool	qpoep			# qpoe output flag

pointer tbtopn()
pointer	qp_open()
int	tbpsta()
int	qp_access()
int	qp_accessf()
bool	clgetb()
int	open()
int	strlen()
int	clpopnu()
int	clplen()
int	clgfil()
int	qp_rlmergeeuvd()

pointer	input
pointer	nulls, starts, ends
int	r
int	glen
pointer	gxs
pointer	gxe
int	nlen
pointer	nxs
pointer	nxe
int	nl

string	qptype	"macro"

begin
  pos = 1

  call smark(sp)
  call salloc(fmt, SZ_LINE, TY_CHAR )
  call salloc(buf, SZ_LINE, TY_CHAR )
  call salloc(input, SZ_LINE, TY_CHAR )

  inp = clpopnu("input")
  if (clplen(inp) < 1) {
    call error(0,"No input tables were specified")
  }
  call eu_clstr(col1, "start")
  call eu_clstr(col2, "end")
  call eu_clstr(format, "format")
  if (Memc[format] == '%') format = format + 1

  textp = clgetb("cmdline")
  qpoep = FALSE

  if (!textp) {
    call eu_clstr(out, "output")
    call eu_clstr(name, "name")

    if (qp_access(Memc[out], APPEND) == YES) {
      qpoep = TRUE
      qp = qp_open(Memc[out], APPEND, 0)
      if (qp == 0) {
	call eprintf("ERROR: couldn't open QPOE file '%s'\n")
	call pargstr(Memc[out])
	return
      }

      if (qp_accessf(qp, Memc[name]) == NO) {
	call qp_addf(qp, Memc[name], qptype, 0, qptype, QPF_INHERIT)
      }
    } else {
      #must be a macro file
      fd = open(Memc[out], APPEND, TEXT_FILE)
      if (fd == 0) {
	call eprintf("ERROR: couldn't open file '%s'\n")
	call pargstr(Memc[out])
	return
      }
      call fprintf(fd, "\ndefine %s ")
      call pargstr(Memc[name])
    }
  }

  # construct formatting string
  call sprintf(Memc[fmt], ARB, "%%%s:%%%s")
  call pargstr(Memc[format])
  call pargstr(Memc[format])

  # initialize the global range
  glen = 1
  call malloc(gxs, glen, TY_DOUBLE)
  call malloc(gxe, glen, TY_DOUBLE)
  Memd[gxs] = EUVLEFTD
  Memd[gxe] = EUVRIGHTD

  # For each table, generate a range list, then merge this
  # into the global range list
  while (clgfil(inp, Memc[input], SZ_LINE) != EOF) {

    # open the table
    tab = tbtopn( Memc[input], READ_ONLY, 0 )
    if (tab == 0) {
      call sprintf(Memc[buf], ARB, "Table %s not found")
      call pargstr(Memc[input])
      call error(0,Memc[buf])
    }

    # find the columns
    call tbcfnd(tab, Memc[col1], sptr, 1)
    call tbcfnd(tab, Memc[col2], eptr, 1)
    if (sptr == 0 || eptr == 0) {
      call sprintf(Memc[buf],ARB,"Column '%s' or '%s'  not found in %s")
      call pargstr(Memc[col1])
      call pargstr(Memc[col2])
      call pargstr(Memc[input])
      call error(0,Memc[buf])
    }

    # allocate space for the number of rows
    nrows = tbpsta( tab, TBL_NROWS )
    call malloc(nulls, nrows, TY_BOOL)
    call malloc(starts, nrows, TY_DOUBLE)
    call malloc(ends, nrows, TY_DOUBLE)

    # convert the starting row
    call tbcgtd(tab, sptr, Memd[starts], Memb[nulls], 1, nrows)
    do r = 2, nrows {
      if (Memb[nulls+r-1]) {
	call sprintf(Memc[buf], ARB, "Null value in column %s row %d table %s")
	call pargstr(Memc[col1])
	call pargi(r)
	call pargstr(Memc[input])
	call error(0,Memc[buf])
      }
    }
    if (Memb[nulls+0]) Memd[starts+0] = EUVLEFTD

    # convert the ending row
    call tbcgtd(tab, eptr, Memd[ends], Memb[nulls], 1, nrows)
    do r = 1, nrows-1 {
      if (Memb[nulls+r-1]) {
	call sprintf(Memc[buf], ARB, "Null value in column %s row %d table %s")
	call pargstr(Memc[col1])
	call pargi(r)
	call pargstr(Memc[input])
	call error(0,Memc[buf])
      }
    }
    if (Memb[nulls+nrows-1]) Memd[ends+nrows-1] = EUVRIGHTD

    # merge global and table into new, then reassign global
    nxs = 0
    nxe = 0
    nl = 0
    nlen = qp_rlmergeeuvd(nxs, nxe, nl,
		       Memd[gxs], Memd[gxe], glen,
		       Memd[starts], Memd[ends], nrows)
    call mfree(gxs, TY_DOUBLE)
    call mfree(gxe, TY_DOUBLE)
    glen = nlen
    gxs = nxs
    gxe = nxe

    call tbtclo(tab)
  }

#  if (textp)	call printf("(")

  do i = 1, glen {
    call sprintf(Memc[buf], ARB, Memc[fmt])
    if (i == 1 && Memd[gxs+i-1] == EUVLEFTD) {
      call pargstr("")
    } else {
      call pargd(Memd[gxs+i-1])
    }

    if (i == glen && Memd[gxe+i-1] == EUVRIGHTD) {
      call pargstr("")
    } else {
      call pargd(Memd[gxe+i-1])
    }

    if (textp) {
      if (i < glen)	call printf("%s,")
      else		call printf("%s")
      call pargstr(Memc[buf])
    } else
    if (qpoep) {
      if (i < glen)	call strcat(",", Memc[buf], ARB)

      len = strlen(Memc[buf])
      call qp_write(qp, Memc[name], Memc[buf], len, pos, qptype)
      pos = pos + len
    } else {
      if (i < glen)	call fprintf(fd, "%s,")
      else		call fprintf(fd, "%s\n")
      call pargstr(Memc[buf])
    }
  }

  if (textp) call printf("\n")
  else if (qpoep) {
    Memc[buf] = EOS
    len = 1
    call qp_write(qp, Memc[name], Memc[buf], len, pos, qptype)
    call qp_close(qp)
  } else call close(fd)

  call sfree(sp)
end
